#include <PA9.h>       // Include for PA_Lib
#include <fat.h>
#include <sys/dir.h>
#include "engine/engine.h"
#include "commonVariables.h"
#include "userConfigFunctions.h"
#include "misc/misc.h"
#include "misc/clock.h"
#define POPUP_DURATION 300

 
/*const unsigned short black_arialAA12_Pal[16] __attribute__ ((aligned (4))) = {0, 60250, 46509, 54965, 51794, 40167, 35939, 32768,PA_RGB(31,31,31),
54966,
50738,
65535,
52852,
57048,
60251,
62366};*/
extern const unsigned short arialAA12_Pal[8] __attribute__ ((aligned (4)));
const unsigned short black_arialAA12_Pal[16] __attribute__ ((aligned (4))) = {
//PA_RGB(31,31,31)
PA_RGB(0,0,0), 60250, 46509, 54965, 51794, 40167, 35939, 32768,PA_RGB(31,31,31),
54966,
50738,
65535,
52852,
57048,
60251,
62366};

char assignList[30][30];
int assignSelected=0;
char assignSelectedSkip=0;
bool assignNavigate=0;
int assignAmount=0;
int longestTextX=0; 	
int scrollx=0;





void assignList_ExtendToText()
{
	if (scrollx<longestTextX) 
	{
		if (scrollx<longestTextX-10) 
		{
		   scrollx+=3;
		}   
		else
		{
	   	scrollx++;
		}  	
	}   
	if (scrollx>longestTextX) 
	{
		if (scrollx>longestTextX+10) 
		{
		   scrollx-=3;
		}   
		else
		{
	   	scrollx--;
		}  	
	}   
	PA_BGScrollXY(0,1,(240-scrollx)*-1,8);
}			
void resetList()
{
   assignAmount=0;
	assignSelectedSkip=0;
	assignSelected=0;
}   
void addList(char* text, ...) 
{
   assignAmount++;
	s16 j, i;
	u16 textcount = 0; // compte le nombre de lettres...
	u8 PAtext[32]; // tableau oEl'on copie les nombres et tout...
	u8 PAtextcount = 0; // Quand on a un nombre, il faut savoir sa longueur
	u8 *PAextext; // Extra text
	s32 PAtextnumber;
	double tempdouble = 0;
	     
	
	va_list varg;           /* Variable identifiant le prochain paramtre. */

   va_start(varg, text);
   
   PAtextcount = 0;
   


	   
	   
	   
	   for (j = 0; text[j]; j++) {
	      if (text[j] == '%') {
				if (text[j+1] == 's') {  // S'il y a %s, c'est une chaine de caractres...
	            PAextext = (u8*)va_arg(varg, const u8 *);  // Pointeur vers la chaine de charactres...
	            for (i = 0; PAextext[i]; i++) {
	               assignList[assignAmount-1][textcount] = PAextext[i];
	               ++textcount;
	            }
	            j += 1;
	         }
	         else if ((text[j+1] == 'x')) {
				u32 test = va_arg(varg, u32);
				u8 temp;
				u8 started = 0;
				for(i = 0; i < 32; i+=4){
				   temp = (test>>(28-i))&15;
				   if(started || temp){
					   if(temp >= 10) assignList[assignAmount-1][textcount] = 'A'+(temp-10); 
					   else assignList[assignAmount-1][textcount] = '0'+(temp); 
						textcount++;
					   started = 1;
					}					   
				}   
				j++;
			}	
	         else if ((text[j+1] == 'd') || (text[j+1] == 'f')) {
				double test = 0;
	            if (text[j+1] == 'd') {
					PAtextnumber = va_arg(varg, s32);
					test = PAtextnumber;
				}
	            else {  // On ne prend que la partie entire pour l'instant, on garde le reste pour plus tard :p
	               tempdouble = va_arg(varg, double);
				   test = tempdouble;
				   PAtextnumber = (s32)tempdouble ;
	               tempdouble -= PAtextnumber;
	            }
	
	            s8 neg = 0; // Si negatif, passe E1...
	            if (test < 0) {
	               PAtextnumber = -PAtextnumber;
				   //tempdouble = -tempdouble;
	               neg = 1;
	            }
	
	            for (i = 0; PAtextnumber || (!PAtextnumber && !i); i++) {  // tant que le nombre ne vaut pas 0 mais que i est positif, on continu Ela convertir...
	               PAtext[i] = '0' + (PAtextnumber%10);
	               PAtextnumber = PAtextnumber / 10; // Nombre de dpart...
	            }
	            if (neg) {
	               PAtext[i] = '-';
	               ++i;
	            }
	            for (i--; i > -1; i--) {
	               	assignList[assignAmount-1][textcount] = PAtext[i];
	               ++ textcount;
	            }
	            j += 1;
	            
	            if (text[j] == 'f') { // Il reste donc la virgule Etraiter...
	               assignList[assignAmount-1][textcount] = '.';
	
	               ++ textcount;
	               i = text[j+1] - 48;  // Nombre de chiffres aprs la virgule...
	               PAtext[1] = 0; // Permet de stopper si c'est vba...
				   if (tempdouble < 0) tempdouble = -tempdouble;
	               while((i-- > 0)) { // Pas plus de 6 chiffres aprs la virgule...
	                  tempdouble *= 10;
					  //if (
	                  PAtextnumber = (s32)tempdouble;
	                  tempdouble -= PAtextnumber;
	                  PAtext[0] = '0' + PAtextnumber;
							assignList[assignAmount-1][textcount] = PAtext[0];
	                  ++ textcount;
	               }
	            j += 1;
	            }
	
	          }
			  else if ((text[j+3] == 'd') && (text[j+1] != ' ')&& (text[j+2] != ' ')){ // C'est plus loin, donc on a genre %02d...
	            PAtextnumber = va_arg(varg, s32);
	            s8 neg = 0; // Si negatif, passe E1...
				u8 amettre = text[j+1]; // Nombre Emettre pour remplir
				s8 nfois = text[j+2] - '0'; // Nombre de caractres Emettre
		
	            if (PAtextnumber < 0) {
	               PAtextnumber = -PAtextnumber;
	               neg = 1;
	            }
	
	            for (i = 0; PAtextnumber || (!PAtextnumber && !i); i++) {  // tant que le nombre ne vaut pas 0 mais que i est positif, on continu Ela convertir...
	               PAtext[i] = 48 + (PAtextnumber%10);
	               PAtextnumber = PAtextnumber / 10; // Nombre de dpart...
				   nfois--; // Un nombre de moins Emettre...
	            }
				
				while(nfois > 0) { // On complte de 0 est tout...
					assignList[assignAmount-1][textcount] = amettre;//'X';
					++textcount;
					--nfois;
				}
				
	            if (neg) {
	               PAtext[i] = '-';
	               ++i;
	            }
	            for (i--; i > -1; i--) {
	     				assignList[assignAmount-1][textcount] = PAtext[i];
	               ++ textcount;
	            }
	            j += 3;
			  
			  }
	          else { // Sinon c'est juste
					assignList[assignAmount-1][textcount] = text[j];
	            ++textcount;
	          }
	      }
		  else if (text[j] == '\n'){
		     textcount = 0;
	
		  }
	      else if ((text[j] == '/') && (text[j+1] == 'n')) {
	         textcount = 0;
	
			 j++;
	      }
	      else{
				assignList[assignAmount-1][textcount] = text[j];
	         ++textcount;
	      }
	   }
	
				assignList[assignAmount-1][textcount] = '\0';
	    va_end(varg);           /* Terminaison. */
	
		
}	
void setList ( int amount, ...)
{
  resetList();
  va_list vl;
  va_start(vl,amount);
  int i;
  for (i=0;i<=amount;i++)
  {
	 sprintf(assignList[i],"%s",va_arg(vl,char*));
  }
  va_end(vl);
  assignAmount= amount+1;
}

void assignList_UpdateHighlight16c()
{
   int x,i;
   int temp;
   for (i=0;i<=assignAmount+2;i++)
   {
	   temp =10+(15*i);
	   if (i==(assignSelected-assignSelectedSkip) || i==(assignSelected-assignSelectedSkip)+1)
	   {
			for(x=0;x<256;x++)
		   PA_16cDeletePixel(0,x,temp);
		}
		else
 		{
	      if (PA_16cGetPixel(0,0,temp)==0)			
	      {
		      PA_16cPutPixel(0,0,temp,11);
		      PA_16cPutPixel(0,1,temp,12);
		      PA_16cPutPixel(0,2,temp,13);
		      PA_16cPutPixel(0,3,temp,14);
	  			for(x=4;x<256;x++) PA_16cPutPixel(0,x,temp,15);
		  }			
		}			   
	}   
// 	if (i <= 10+(15*(	assignSelected)) && i >= 10+(15*assignSelected))
}

void assignList_Update16c()
{
   PA_16cErase(0);
   PA_16cTextLetterSpacing(-1);
   PA_16cPutPixel(0,0,4,13);
   PA_16cPutPixel(0,1,3,15);
   PA_16cPutPixel(0,1,4,14);
   PA_16cPutPixel(0,0,5,14);
   PA_16cPutPixel(0,3,1,13);
   PA_16cPutPixel(0,3,2,14);
   PA_16cPutPixel(0,3,3,9);
   PA_16cPutPixel(0,3,4,13);
   PA_16cPutPixel(0,3,5,14);
   PA_16cPutPixel(0,2,2,15);
   PA_16cPutPixel(0,2,3,9);
   PA_16cPutPixel(0,2,4,9);
   PA_16cPutPixel(0,2,5,9);   
   PA_16cPutPixel(0,1,5,9);   
//reverse
	longestTextX=0;
	int i, x;
	for(i=0;i<=10;i++)
	{
		if (i==(assignAmount-assignSelectedSkip)) 
		{
		   break;
		}   
		PA_16cText(0,7,10+(15*i),240,10+(15*i),assignList[i+assignSelectedSkip],1,5,100);
		if (longestTextX <PA_LetterPos.Letter[PA_LetterPos.NLetters].X) longestTextX = PA_LetterPos.Letter[PA_LetterPos.NLetters].X;
	}		
	if (i<=10) PA_16cText(0,7,10+(15*i),240,10+(15*i),"Cancel",1,5,100);
	if (longestTextX <PA_LetterPos.Letter[PA_LetterPos.NLetters].X) longestTextX = PA_LetterPos.Letter[PA_LetterPos.NLetters].X;
   PA_16cPutPixel(0,0,191-4,13);
   PA_16cPutPixel(0,1,191-3,15);
   PA_16cPutPixel(0,1,191-4,14);
   PA_16cPutPixel(0,0,191-5,14);
//   PA_16cPutPixel(0,3,191-1,13);
   PA_16cPutPixel(0,3,191-2,14);
   PA_16cPutPixel(0,3,191-3,9);
   PA_16cPutPixel(0,3,191-4,13);
   PA_16cPutPixel(0,3,191-5,14);
   PA_16cPutPixel(0,2,191-2,15);
   PA_16cPutPixel(0,2,191-3,9);
   PA_16cPutPixel(0,2,191-4,9);
   PA_16cPutPixel(0,2,191-5,9);   
   PA_16cPutPixel(0,1,191-5,9);   
   for (i=6;i<=185;i++)
   {
	      PA_16cPutPixel(0,0,i,11);
	      PA_16cPutPixel(0,1,i,12);
	      PA_16cPutPixel(0,2,i,13);
	      PA_16cPutPixel(0,3,i,14);
   }   
   i=4;
   PA_16cPutPixel(0,i,0,10);
   PA_16cPutPixel(0,i,1,11);
   PA_16cPutPixel(0,i,2,9);
   PA_16cPutPixel(0,i,3,13);
   PA_16cPutPixel(0,i,4,14);
   PA_16cPutPixel(0,i,5,14);
   for (x=6;x<=185;x++) 
   {
		PA_16cPutPixel(0,i,x,15);
	}			
   PA_16cPutPixel(0,i,191,10);
   PA_16cPutPixel(0,i,190,11);
   PA_16cPutPixel(0,i,189,9);
   PA_16cPutPixel(0,i,188,13);
   PA_16cPutPixel(0,i,187,14);
   PA_16cPutPixel(0,i,186,14);
   for (i=5;i<256;i++)
   {
      PA_16cPutPixel(0,i,0,10);
      PA_16cPutPixel(0,i,1,11);
      PA_16cPutPixel(0,i,2,12);
      PA_16cPutPixel(0,i,3,13);
      PA_16cPutPixel(0,i,4,14);
      for (x=5;x<=186;x++) 
      if (PA_16cGetPixel(0,i,x)==0)	
		{
			PA_16cPutPixel(0,i,x,15);
		}			
      
      
      PA_16cPutPixel(0,i,191,10);
      PA_16cPutPixel(0,i,190,11);
      PA_16cPutPixel(0,i,189,12);
      PA_16cPutPixel(0,i,188,13);
      PA_16cPutPixel(0,i,187,14);
   }   
	assignList_UpdateHighlight16c();
}   

void assignList_menudoCmds()
{
	setList(8,"Navigate Dir"
				,"Execute File"
				,"Run Gba Slot"
				,"File Explorer"
				,"Wireless"
				,"Multimedia"
				,"Pda"
				,"User Settings"
				,"Power Off");
}			
void assignList_ListDirNDS()
{
	struct stat st;
	static char filename[256]; 
	resetList();
	DIR_ITER* dirroot = diropen("fat:/");

	while (dirnext(dirroot, filename, &st) == 0) 
	{
		if (st.st_mode & S_IFDIR && !PA_CompareText(filename,".") && filename[0] != '_') 
		{
         addList(filename);
		}   
	}
	dirclose(dirroot);
}   

void display_AssignList(int menuRunsNumber)
{
   killWindow();
   updateWindow();
	assignSelected=0;
	assignSelectedSkip=0;
	assignNavigate=0;
	assignAmount=0;
	longestTextX=0; 	
	scrollx=0;
   PA_16cErase(1);
   PA_16cErase(0);
   int i;
   for (i=0;i<256;i++)
   {
      PA_16cPutPixel(1,i,178,9);
   }   
   	PA_16cText(1,0,180,200,180,system.menuRuns[menuRunsNumber],1,1,100);
	int x;
   for (i=0;i<256;i++)
   {
   	for (x=178;x<=192;x++) 
    	if (PA_16cGetPixel(1,i,x)==0)	PA_16cPutPixel(1,i,x,10);
   }   	
	assignList_ExtendToText();
	PA_SetBgPrio(0,0,1);
	PA_SetBgPrio(0,1,0);

	assignList_menudoCmds();
	PA_LoadPal16c(PAL_BG0, black_arialAA12_Pal);
//	PA_LoadPal16c(PAL_BG0, arialAA12_Pal);

	PA_SetSFXAlpha(0, 31, 5);


	
	assignList_Update16c();
	bool navigateDirMenu=0;

	while (1)
	{
		assignList_ExtendToText();
		if (Pad.Newpress.Down)
		{
		   if (assignSelected==assignAmount)
		   {
				assignSelected=0;
			   if (assignAmount>10) 
				{
				   assignSelectedSkip=0;
					assignList_Update16c();
				}			
			}   
		   else
		   assignSelected++;
	   	if (assignAmount>10) if (assignSelected>10)
	   	{
	   	   assignSelectedSkip++;
	   		assignList_Update16c();
		  } 		
	   	assignList_UpdateHighlight16c();
		}   
		if (Pad.Newpress.Up)
		{
		   if (assignSelected==0)
		   {
				assignSelected=assignAmount;
			   if (assignAmount>10) 
				{
				   assignSelectedSkip=assignAmount-10;
					assignList_Update16c();
				}			
			}   
		   else
			   assignSelected--;
	   	if (assignAmount>10)// if (assignSelected<assignSelectedSkip)
	   	{
	   	   assignSelectedSkip--;
	   		assignList_Update16c();
		  } 		
	   	assignList_UpdateHighlight16c();		   
		}   
		if (navigateDirMenu)
		{
			if (Pad.Newpress.A && assignSelected<assignAmount)
			{
			   sprintf(system.menuRuns[menuRunsNumber],"%s",assignList[assignSelected]);
			   PA_BGScrollXY(0,1,0,0);
			   PA_16cErase(0);
			   SaveCurrentConfig();
			   PA_16cErase(1);
			   break;
			}   
			if (Pad.Newpress.B || (Pad.Newpress.A && assignSelected==assignAmount))
			{
			   navigateDirMenu=0;
				assignList_menudoCmds();
				assignList_Update16c();
			}   
		}
		else   
		{
			if (Pad.Newpress.B || (Pad.Newpress.A && assignSelected==assignAmount)) 
			{
			   PA_BGScrollXY(0,1,0,0);
			   PA_16cErase(0);
			   PA_16cErase(1);
			   break;
			}
			if (Pad.Newpress.A)
			{
				switch (assignSelected)
				{
				  	case 0: 	navigateDirMenu=1;
							   assignList_ListDirNDS();
								assignList_Update16c();
								break;
					case 2:	sprintf(system.menuRuns[menuRunsNumber],"gba");
								break;
					case 3:	sprintf(system.menuRuns[menuRunsNumber],"mExplore");
								break;
					case 4:	sprintf(system.menuRuns[menuRunsNumber],"mWireless");
								break;
					case 5:	sprintf(system.menuRuns[menuRunsNumber],"mMultimedia");
								break;
					case 6:	sprintf(system.menuRuns[menuRunsNumber],"mPda");
								break;
					case 7:	sprintf(system.menuRuns[menuRunsNumber],"mSettings");
								break;
					case 8:	sprintf(system.menuRuns[menuRunsNumber],"power");
								break;
				}			
												
			   if (!(assignSelected == 0 || assignSelected == 1) )
				{
				   PA_BGScrollXY(0,1,0,0);
				   PA_16cErase(0);
				   SaveCurrentConfig();
				   PA_16cErase(1);
				   break;
				}   
			}			
			

		}			

		updateAmbience();
		ZoomXY_3DProcess(128,0,0);  
		Soul_waitForVBL();
		
		updateClock(0,0,1);   

	}
	initAntiAliasedText(0,1,0);
	PA_SetSFXAlpha(0, 31,31);   
   PA_BGScrollXY(0,1,8,8);
}
