#include <PA9.h>       // Include for PA_Lib
#include <fat.h>
#include <sys/dir.h>  
#include "../loader/loader.h"
#include "../engine/engine.h"
#include "../misc/misc.h"
#include "../misc/transition.h"
#include "../misc/debug.h"
#include "../misc/fat.h"
#include "../userConfigFunctions.h"
#include <fat.h>
//#include "../calendar.h"

#include "select/selectapps.h"
bool AfterSMFIntro;

extern char CurrentTheme[256];
//extern bool IncompleteFiles;

extern FILE* historyFile;
extern FILE* movieJPG;
extern FILE* fileChecker;
bool bootndsCHISHMS(char* filename,bool dldipatch);
bool verifyCommand(char* command)
{
int i=0;
while(command[i]){
  if (command[i]==' ') 
    i++;
  else
  if (command[i]==0) return 0;
  else
  break;
}
if (command[0]==0) return 0;

   if (isFileNameNDS(command)== 1) 
	{
	  	fileChecker = fopen (command, "rb"); //rb = read
		if(fileChecker)
		{
			fclose (fileChecker);
		   return 1;
		}   
		fclose (fileChecker);
	   return 0;
	}   
	   
  	if (PA_CompareText (command, "gba")== 1) 			return 1;
	if (PA_CompareText (command, "power")== 1) 		return 1;
	if (PA_CompareText (command, "mSettings")== 1) 	return 1;
	if (PA_CompareText (command, "mExplore")== 1) 	return 1;
	if (PA_CompareText (command, "mShortcut")== 1) 	return 1;
	if (PA_CompareText (command, "mPda")== 1) 		return 1;
	if (PA_CompareText (command, "mMultimedia")== 1)return 1;
	if (PA_CompareText (command, "mWireless")== 1) 	return 1;
	if (PA_CompareText (command, "debugMode")== 1) return 1;
	if (PA_CompareText (command, "loadLastFile")== 1) return 1;
	return verifyDir(command);


} 

extern bool enableDebugLog;

void executeCommand(char* command)
{
   if (command[0] == 0 || command[1] == 0 || command[2] == 0) return;
   bool menuReturnedValue;
	if ((PA_CompareText (command, "") != 0)){   
   if (isFileNameNDS(command)== 1) menudo_runNDS(command,1,0);
   else
  	if (PA_CompareText (command, "gba")== 1) selectGBA();
	else
	if (PA_CompareText (command, "power")== 1) PA_Shutdown();
	else
	if (PA_CompareText (command, "mSettings")== 1) 
	{
		selectSettings(0);
	}	
	else
	if (PA_CompareText (command, "mExplore")== 1) mExplore(0);
	else
	if (PA_CompareText (command, "mPda")== 1) selectPDA(0);
	else
	if (PA_CompareText (command, "mMultimedia")== 1) selectMultimedia(0);
	else
	if (PA_CompareText (command, "mWireless")== 1) selectWireless(0);
	else
	if (PA_CompareText (command, "debugMode")== 1) enableDebugLog=1;
	else
	if (PA_CompareText (command, "loadLastFile")== 1) loadLastFile();
	else
	{
/*		while(mSelect(command))
		{
		   cleanMemory();
		}*/
		mSelect(command);   
	}		

	}   
	cleanMemory();
}   
	
void loadIntroSMF()
{
   int i;

	setBrightness(0,0);
	setBrightness(1,0);
	char * resourcepath = returnThemeResourcePath("videos/videos.ini",1);
	if (resourcepath !=NULL) 
	{
	   readINI = fopen (resourcepath, "rb"); 
		free(resourcepath);	

		if (readINI)
		{
		   		PA_Init2D();
			 clearbootupLoadScreen();

			cleanMemory();
			i = readIniFileInt("IntroMovieScreen");
			fclose(readINI);
		   PA_Init16bitBg((1-i),3);
			resourcepath = returnThemeResourcePath("videos/intro.jpg",1);
			movieJPG = fopen (resourcepath , "rb");
			if (!movieJPG)
			{
			   free(resourcepath);
			   fclose(movieJPG);
				resourcepath = returnThemeResourcePath("videos/intro.jpeg",1);
			}   
			loadFatBg16bit((1-i), resourcepath);
			if (resourcepath !=NULL) free(resourcepath);
			
		  	char* smfpath =returnThemeResourcePath("videos/intro.smf",1);
			update_clearbootupLoadScreen();
		   if (initSMF(i, smfpath))
		   {
		     PA_Init16bitBg(i, 3);
				while(updateSMF() && !Pad.Held.Anykey && !Pad.Held.Y && !Stylus.Held)Soul_waitForVBL();
		     deinitSMF();
		   }   
		   if (smfpath!=NULL) free(smfpath);
		}	
	}			

}	
void loadHistoryLastTheme()
{
   bool themefound=0;
   if (!system.ShuffleThemes)
   {
		historyFile = fopen ("fat:/_menudo/logs/HISTORY.LASTTHEME", "rb");
		themefound=1;
		if (historyFile)
		{
			fgets(CurrentTheme, 256, historyFile);
			char temp[256];
			return;
			sprintf(temp,"fat:/_menudo/themes/%s",CurrentTheme);
			if (!verifyDir(temp))
			{
			   themefound=0;		   
			   ShowDialogBox(0, 1, 0, "Theme %s not found\nSelecting a random theme", CurrentTheme) ;
			}   
		}	
		fclose(historyFile);
	}			

	if (!themefound)
	{
		struct stat st;
		char filename[256]; 
		DIR_ITER* dir = diropen("fat:/_menudo/themes/");
//		int folderCounter=0;
		int found=0;

		int amount = getThemeAmount();
		if (amount==0)
		{
		   PA_Init16cBg(0,1);
		   ShowDialogBox(0, 1, 0, "No theme found", CurrentTheme);
		}   
		int randomnumber=PA_RandMax(amount);
		while (dirnext(dir, filename, &st) == 0) 
		{
		   if (strcmp(filename,"..") == 0 || strcmp(filename,".") == 0 || stricmp(filename,"_mycreations") == 0) continue;
		   if (st.st_mode & S_IFDIR) 
			{
			   found++;
				if (found==randomnumber) break;
			}   
		}   
		dirclose(dir);
		sprintf(CurrentTheme,"%s",filename);
		historyFile = fopen ("fat:/_menudo/logs/HISTORY.LASTTHEME", "wb");
		fwrite(filename,strlen(filename),1,historyFile);
		fclose(historyFile);
	}		
}

void addLetterPass(char* str, char letter)
{
   int i=strlen(str);
   str[i]=letter;
   str[i+1]=0;
}   
extern bool bootupfinished;
void askPassword()
{
	if (system.Password[0]==0) return;

	char HiddenPass[30];
	char EnteredPass[30];
	memset(HiddenPass,0,30);
	memset(EnteredPass,0,30);

	PA_16cTextAlign(2);
	PA_16cErase(0);
	PA_16cErase(1);
	LoadDefault16c(0);
	LoadDefault16c(1);
	while (1)
	{
	   PA_16cErase(1);
	   PA_16cText(1, 0, 40, 256, 40, "Enter Password", 1, 1, 100);
	   PA_16cText(1, 0, 100, 256, 0, HiddenPass, 1, 1, 100);
//	   PA_16cText(1, 0, 120, 256, 120, EnteredPass, 1, 1, 100);
//	   PA_16cText(1, 0, 140, 256, 140, system.Password, 1, 1, 100);

		PA_WaitForVBL();
	   if (Pad.Newpress.Anykey || Pad.Newpress.Y)
	   {
	      if (strlen(HiddenPass)<30) 
			{
			   addLetterPass(HiddenPass,'x');
	  	      if (Pad.Newpress.Up) addLetterPass(EnteredPass,'^');
		      if (Pad.Newpress.Left) addLetterPass(EnteredPass,'<');
	  	      if (Pad.Newpress.Right) addLetterPass(EnteredPass,'>');
		      if (Pad.Newpress.Down) addLetterPass(EnteredPass,'V');
	  	      if (Pad.Newpress.A) addLetterPass(EnteredPass,'A');
	  	      if (Pad.Newpress.B) addLetterPass(EnteredPass,'B');
	  	      if (Pad.Newpress.X) addLetterPass(EnteredPass,'X');
	  	      if (Pad.Newpress.Y) addLetterPass(EnteredPass,'Y');
	  	      if (Pad.Newpress.L) addLetterPass(EnteredPass,'L');
	  	      if (Pad.Newpress.R) addLetterPass(EnteredPass,'R');
	  	      if (Pad.Newpress.Start) addLetterPass(EnteredPass,'S');
	  	   }   
	      if (Pad.Newpress.Select)
	      {
				memset(EnteredPass,0,30);
				memset(HiddenPass,0,30);
			}	
			if (stricmp(EnteredPass,system.Password)==0) break;
	   }   
	}
	//bootupfinished=1;
   PA_16cErase(1);
   PA_16cText(1, 0, 60, 256, 60, "Password Confirmed", 1, 1, 100);
   int i=0;
	while(Pad.Held.Anykey || Pad.Held.Y) PA_WaitForVBL();
	while (1)
	{
		i++;
		PA_WaitForVBL();
	   if (Pad.Newpress.Anykey || i>=100)  break;
	}

   PA_16cErase(1);
	PA_WaitForVBL();
	PA_16cTextAlign(0);
}	
