#include <PA9.h>       // Include for PA_Lib

extern inline void PA_AddLetterPos(s16 Letter, s16 x, s16 y, u8 size, u16 color){
   PA_LetterPos.Letter[PA_LetterPos.NLetters].Letter = Letter;
	PA_LetterPos.Letter[PA_LetterPos.NLetters].X = x;
	PA_LetterPos.Letter[PA_LetterPos.NLetters].Y = y;
	PA_LetterPos.Letter[PA_LetterPos.NLetters].Size = size;
	PA_LetterPos.Letter[PA_LetterPos.NLetters].Color = color;
	PA_LetterPos.NLetters++;	
}

void Filename_DoLetterPos(s16 basex, s16 basey, s16 maxx, s16 maxy, char* text, u16 color, u8 size, s32 limit){
	s16 x = basex; s16 y = basey;
	s16 letterstart;
	u8 lx, letter = ' ';
	s16 i;
	
	PA_LetterPos.NLetters = 0;
	letterstart = 0;
	
	if((textinfo.align == ALIGN_JUSTIFY)||(textinfo.align == ALIGN_LEFT)) limit += 100; // Pour bien caler la ligne
	
	for(i = 0; (i < limit+100)&&(text[i]); i++){
	   letter = text[i]; 
	   lx = pa_bittextdefaultsize[size][letter]+textinfo.letterspacing;
	   
	   if((letter == '\n') || (letter == '.') || ((x+lx > maxx)&&(letter != ' '))){ // retour ligne, ou on dpasse...
	   break;
   
	   }   
	   else{
	      PA_AddLetterPos(letter, x, y, size, color);
		   x += lx;   
		}		
	}   
	if(text[i-1] == ' ') x-= pa_bittextdefaultsize[size][(u8)(' ')]; // Retirer la largeur de l'espace	 
	PA_DoAlign(letterstart, x, maxx, (letter != '\n') && (text[i] != '\0'));

	// End Position
	PA_LetterPos.Letter[PA_LetterPos.NLetters].X = x;
	PA_LetterPos.Letter[PA_LetterPos.NLetters].Y = y;

}
void pa_16cTextDecompress(u8 size);
s16 Filename_16cText(u8 screen, s16 basex, s16 basey, s16 maxx, s16 maxy, char* text, u8 color, u8 size, s32 limit){
/*   char charTemp[256];
   memset (charTemp,0,256);
	strncpy (charTemp,text,limit);
   return display16cText(screen, basex, basey, maxx, maxy, charTemp, color, size);*/
	s32 i;
	
	pa_16cTextDecompress(size);
		
	Filename_DoLetterPos(basex, basey, maxx, maxy, text, color, size, limit);
	
	if(limit > PA_LetterPos.NLetters) limit = PA_LetterPos.NLetters; // Plus short que prvu
	
	for(i = 0; i < limit; i++) if (PA_LetterPos.Letter[i].X > 0)PA_16cLetter(screen, PA_LetterPos.Letter[i].X, PA_LetterPos.Letter[i].Y, 
										PA_LetterPos.Letter[i].Letter, PA_LetterPos.Letter[i].Size, PA_LetterPos.Letter[i].Color);

//	PA_WaitFor(Stylus.Newpress);
	return limit;
}
  
