  #include <PA9.h>
void loadGuiBackground(bool screen)
{
   fillBitmap(screen,62364);
   int x;
   int y;
	for (y=0;y<192;y++)
	{
		PA_Put16bitPixel(screen,0,y,59193);
		PA_Put16bitPixel(screen,255,y,59193);
		if (y%2)
		for (x=5;x<251;x++)
		PA_Put16bitPixel(screen,x,y,63421);
	}		
}	
unsigned short pal_16c[16] __attribute__ ((aligned (4)));

void select_Load16cBMPtoBG(bool screen, void *bmp)
{
	int bmp_height;
	int bmp_width;	
	int temp=0; 
	int temp1=0; 
	int i=0;
	u16 zero = 0;
	u8 *tempbmp = (u8*)bmp;
	BMPHeader0 *Bmpinfo0 = (BMPHeader0 *) (tempbmp);
	BMP_Headers *Bmpinfo = (BMP_Headers*)(tempbmp+14);

	u8 *gfx = tempbmp+(Bmpinfo0->ImageStart1 + ((Bmpinfo0->ImageStart2)<<16));

	bmp_width = Bmpinfo->Width; 
	bmp_height = Bmpinfo->Height;

	int pos_x=128-(bmp_width/2);
	int pos_y=96-(bmp_height/2);

	
	u8 *colormap = tempbmp+14+Bmpinfo->SizeofHeader;

	DMA_Force(zero, pal_16c, (16)>>1, DMA_16NOW); // Blank out

	int magenta=0; 
 	u16 colors = Bmpinfo->ImportantColors;
	i = 0;

	for(temp=0; temp<colors; temp++)
	{
		pal_16c[15-temp]= PA_RGB(((colormap[(temp<<2)+2])>>3)&31, ((colormap[(temp<<2)+1])>>3)&31, ((colormap[(temp<<2)+0])>>3)&31);
		if(pal_16c[15-temp]==PA_RGB(31,0,31))
		{
		   magenta=15-temp;
		   pal_16c[15-temp]=pal_16c[15];
		}   
	}   
	PA_LoadPal16c(screen? PAL_BG1 : PAL_BG0, (void*)pal_16c);
	Soul_waitForVBL();	
	for(temp=bmp_height-1; temp>=0; temp--)
		for(temp1=0; temp1<bmp_width; temp1++)
		{
			if (PA_16cGetPixel(screen,pos_x+temp1,pos_y+(bmp_height-temp) )==0)PA_16cPutPixel(screen,pos_x+temp1,pos_y+(bmp_height-temp),15-((u32)(gfx[(temp*bmp_width)+temp1])));
		}		
	for (temp=0;temp<256;temp++)
		for (temp1=0;temp1<192;temp1++)
			if (PA_16cGetPixel(screen,temp,temp1)==0)PA_16cPutPixel(screen,temp,temp1,PA_16cGetPixel(screen,pos_x+1,pos_y+1));

}

/*int transiteSelectMenu(int transitionAnimation)
{
   if (transitionAnimation>-124)
	{
      if (transitionAnimation>90)
		   transitionAnimation-=3;
      if (transitionAnimation>70)
		   transitionAnimation-=3;
      if (transitionAnimation>80)
		   transitionAnimation-=3;
      if (transitionAnimation>50)
		   transitionAnimation-=2;
      if (transitionAnimation>20)
		   transitionAnimation-=2;
	   transitionAnimation-=2;
      if (transitionAnimation<-124) transitionAnimation=-124;
      if (transitionAnimation<0)
      {
	      if (transitionAnimation<-31)
		   PA_SetBrightness(0,31+((transitionAnimation+31)/3));
			PA_SetBgRot(1,3,0,0,0,0,0,256);
		}   
	   else
			PA_SetBgRot(1,3,transitionAnimation/-4,0,0,0,0,256);
	}   
	return transitionAnimation;
}			*/

int transiteSelectMenu(int transitionAnimation)
{

   if (transitionAnimation>0)
	{
      if (transitionAnimation>90)
		   transitionAnimation-=3;
      if (transitionAnimation>70)
		   transitionAnimation-=3;
      if (transitionAnimation>80)
		   transitionAnimation-=3;
      if (transitionAnimation>50)
		   transitionAnimation-=2;
      if (transitionAnimation>20)
		   transitionAnimation-=2;
	   transitionAnimation-=2;

      if (transitionAnimation<62)
		   PA_SetBrightness(0,transitionAnimation/2);
	   else
		   PA_SetBrightness(0,31);
      if (transitionAnimation<0)
      {
			PA_SetBgRot(1,3,0,0,0,0,0,256);
		}   
	   else
			PA_SetBgRot(1,3,transitionAnimation/-4,0,0,0,0,256);
	}   
	return transitionAnimation;
}			
