#include <PA9.h>
#include "select_misc.h"
extern int transitionAnimation;
bool topScreenGBA=0;
bool bordersGBA=1;
void updateGBA(u8 subMenu)
{
   PA_Clear16bitBg(1);
   transiteSelectMenu(0,subMenu); 
   switch(subMenu)
   {
      case 0: loadBMPWithResource(1,49,25,"gba/gbaMenu1.bmp");
			     if (topScreenGBA) loadBMPWithResource(1,39+18,25+47,"settings/checkbutton.bmp");
			     if (bordersGBA) loadBMPWithResource(1,39+18,25+77,"settings/checkbutton.bmp");
      			break;
      case 1: loadBMPWithResource(1,49,25,"gba/gbaMenu2.bmp");
      			break;
//      case 5: PA_LoadBmpEx(1,49,25,(void*)customgba);
      case 5: loadBMPWithResource(1,49,25,"custommenus/gba/menu.bmp");

      			break;
   }   
   return;
}   

bool selectGBA(bool initBg)
{
   topScreenGBA=(PersonalData->_user_data.gbaScreen);

   
	int AppsOpened=-1;
	int subMenu=0;
	int i=0;
   while(true)
   {
      hideAll2dSprites();
      PA_DisableSpecialFx(0);
      PA_DisableSpecialFx(1);
      AppsOpened++;
      if (initBg)
      {
	      PA_Init();
			PA_InitVBL();
			PA_Init16bitBg(1, 3);
			PA_Init16cBg(1, 2); 
			PA_Init16cBg(0, 1);
			PA_SetBgPrio(0,0,1);
			PA_SetBgPrio(0,1,0);
		}	

		PA_Screen=0;
		PA_SwitchScreens();
 		PA_SetBrightness(0,31);
 		PA_SetBrightness(1,0);
 		PA_16cErase(0);
 		PA_16cErase(1);
		transitionAnimation=31*5;
		PA_SetBgRot(1,3,transitionAnimation*-1,0,0,0,0,256);
		Settings16cBMP(0,"custommenus/gba/top.16c.bmp");
		load16cBMPWithResource(1,0,0,"gba/gbaBg.16c.bmp");
		PA_Clear16bitBg(1);
		//PA_LoadBmpEx(1,49,25,(void*)pdaMenu1);
		updateGBA(subMenu);
		initSelectMenu();
		PA_SetBgPalCol(1, 0, PA_RGB(171>>3,184>>3,229>>3));
		PA_16cClearZone(1,31,24,255,192);
		

	   while(true)
	   {
			if (Stylus.Newpress)
			{   
				if (PA_StylusInZone(31,24,255,192))
				{
			   
				   if (subMenu==0)
					{
						SUBMENU_ACTION_BUTTON(0,boot_gba());
					   if (PA_StylusInZone(39+18,25+47,39+18+181,25+47+20))
					   {
						   topScreenGBA = !topScreenGBA;
						   updateGBA(subMenu);
					   }
					   if (PA_StylusInZone(39+18,25+77,39+18+181,25+77+20))
					   {
						   bordersGBA = !bordersGBA;
						   updateGBA(subMenu);
					   }

					}			
				}			
			   if (subMenu==1)
			   {

				}
			   if (subMenu==5)
			   {
					customMenuStylusDetect("gba");
				}
  			}		
			if (Stylus.Held)
			{
			   SUBMENU_ICON_BUTTON(5,22,25,42,0,updateGBA);
			   SUBMENU_ICON_BUTTON(5,43,25,63,1,updateGBA);
			   SUBMENU_ICON_BUTTON(5,170,25,190,5,updateGBA);		
			}		
			transitionAnimation = transiteSelectMenu(transitionAnimation);
			if((Stylus.Newpress && PA_StylusInZone(0,0,47,21)) || Pad.Newpress.B || Pad.Newpress.L)	
			{
				PA_SwitchScreens();
				deinitSelectMenu();
				return (AppsOpened>0);  
			} 
	
			updateTopScreenRipple();
	      Soul_waitForVBL();
	   }   
		PA_SwitchScreens();
	}   
	deinitSelectMenu();
	return (AppsOpened>0);  
}   
