#include <PA9.h>
#include "../../userConfigFunctions.h"
int transitionAnimation=0;
void loadGuiBackground(bool screen)
{
   fillBitmap(screen,62364);
   int x;
   int y;
	for (y=0;y<192;y++)
	{
		PA_Put16bitPixel(screen,0,y,59193);
		PA_Put16bitPixel(screen,255,y,59193);
		if (y%2)
		for (x=5;x<251;x++)
		PA_Put16bitPixel(screen,x,y,63421);
	}		
}	
unsigned short pal_16c[16] __attribute__ ((aligned (4)));
extern char imgbuffer[256*1024];
void Settings16cBMP(bool screen,char* themepath)
{
	char* path = returnThemeResourcePath(themepath, 1);
	if (path!=NULL)
	{
		FILE* filename = fopen (path, "rb"); 
		if(filename)
		{ 
			fileToBuffer(filename);
			select_Load16cBMPtoBG(screen, (void *)imgbuffer);
			fclose(filename);
			free(path);
			return 1;
		}
		else
	   {
			return 0;
		}		
	}		
} 

void select_Load16cBMPtoBG(bool screen, void *bmp)
{
	int bmp_height;
	int bmp_width;	
	int temp=0; 
	int temp1=0; 
	int i=0;
	u16 zero = 0;
	u8 *tempbmp = (u8*)bmp;
	BMPHeader0 *Bmpinfo0 = (BMPHeader0 *) (tempbmp);
	BMP_Headers *Bmpinfo = (BMP_Headers*)(tempbmp+14);

	u8 *gfx = tempbmp+(Bmpinfo0->ImageStart1 + ((Bmpinfo0->ImageStart2)<<16));

	bmp_width = Bmpinfo->Width; 
	bmp_height = Bmpinfo->Height;

	int pos_x=128-(bmp_width/2);
	int pos_y=96-(bmp_height/2);

	
	u8 *colormap = tempbmp+14+Bmpinfo->SizeofHeader;

	DMA_Force(zero, pal_16c, (16)>>1, DMA_16NOW); // Blank out

	int magenta=0; 
 	u16 colors = Bmpinfo->ImportantColors;
	i = 0;

	for(temp=0; temp<colors; temp++)
	{
		pal_16c[15-temp]= PA_RGB(((colormap[(temp<<2)+2])>>3)&31, ((colormap[(temp<<2)+1])>>3)&31, ((colormap[(temp<<2)+0])>>3)&31);
		if(pal_16c[15-temp]==PA_RGB(31,0,31))
		{
		   magenta=15-temp;
		   pal_16c[15-temp]=pal_16c[15];
		}   
	}   
	PA_LoadPal16c(screen? PAL_BG1 : PAL_BG0, (void*)pal_16c);
	//Soul_waitForVBL();	
	flushToMemory();
	for(temp=bmp_height-1; temp>=0; temp--)
		for(temp1=0; temp1<bmp_width; temp1++)
		{
			if (PA_16cGetPixel(screen,pos_x+temp1,pos_y+(bmp_height-temp) )==0)PA_16cPutPixel(screen,pos_x+temp1,pos_y+(bmp_height-temp),15-((u32)(gfx[(temp*bmp_width)+temp1])));
		}		
	for (temp=0;temp<256;temp++)
		for (temp1=0;temp1<192;temp1++)
			if (PA_16cGetPixel(screen,temp,temp1)==0)PA_16cPutPixel(screen,temp,temp1,PA_16cGetPixel(screen,pos_x+1,pos_y+1));

}

/*int transiteSelectMenu(int transitionAnimation)
{
   if (transitionAnimation>-124)
	{
      if (transitionAnimation>90)
		   transitionAnimation-=3;
      if (transitionAnimation>70)
		   transitionAnimation-=3;
      if (transitionAnimation>80)
		   transitionAnimation-=3;
      if (transitionAnimation>50)
		   transitionAnimation-=2;
      if (transitionAnimation>20)
		   transitionAnimation-=2;
	   transitionAnimation-=2;
      if (transitionAnimation<-124) transitionAnimation=-124;
      if (transitionAnimation<0)
      {
	      if (transitionAnimation<-31)
		   PA_SetBrightness(0,31+((transitionAnimation+31)/3));
			PA_SetBgRot(1,3,0,0,0,0,0,256);
		}   
	   else
			PA_SetBgRot(1,3,transitionAnimation/-4,0,0,0,0,256);
	}   
	return transitionAnimation;
}			*/
int OldStylusY=10;
bool animateTopScreen=1;

s8 width = 8;

s16 add = 0;

u8 length=0;
int speed=0;
extern int transitionAnimation;
void topScreenRipple(void){
   s16 vcount = PA_GetVcount();
   vcount++;
   if(vcount > 192) vcount = 0; // Get correct vcount
   if(vcount > 32 && vcount < 160) 
//	   PA_BGScrollY(0, 1, 8 + (PA_Sin(((vcount+(395))/10)*8+add)>>4)); // Sin wav, variable width, height, and add to change start point ;)
//	   PA_BGScrollY(0, 1, 8 + (PA_Sin(((vcount+(0))/10)*8+add)>>4)); // Sin wav, variable width, height, and add to change start point ;)
//	   PA_BGScrollY(0, 1, 8 - (PA_Sin(((vcount-60)/10)*8+add)>>4)); // Sin wav, variable width, height, and add to change start point ;)
//	   PA_BGScrollY(0, 1, 8 - (PA_Sin(((vcount-121)/10)*8+add)>>4)); // Sin wav, variable width, height, and add to change start point ;)


	   PA_BGScrollY(0, 1, 8 - (PA_Sin(((vcount+210)/10)*7+add)>>4)); // Sin wav, variable width, height, and add to change start point ;)
	 else
	   PA_BGScrollY(0, 1, 8);
} 
void initSelectMenu()
{
   
//	PA_InitVBL(); // Initializes a standard VBL
   animateTopScreen=1;
	irqSet(IRQ_HBLANK, topScreenRipple);
	irqEnable(IRQ_HBLANK);
}   
void deinitSelectMenu()
{
   setBrightness(0,31);
	setBrightness(1,31);
	irqDisable(IRQ_HBLANK);
   showAll2dSprites();
   PA_16cErase(0);
   PA_16cErase(1);
}	
void updateTopScreenRipple()
{
	add&= 511;
	if (add<0) add+=512;
//	if(Stylus.Released) speed=50;
	if (speed>0) speed--;

	add+=speed>>2;
	if (add!=0)
	{
	   if (add<450) add++;
	   if (add<430) add+=3;
	   add++;
	   if (add+4>512) add=0;
	}   
//	PA_BGScrollY(0, 1, 0);
}   
   
int transiteSelectMenu(int transitionAnimation,int subMenu)
{
   if (PA_StylusInZone(31,22,255,192) && Stylus.Newpress)
   {
      int i=0;
      OldStylusY= Stylus.Y;
	   animateTopScreen=0;
	   PA_SetBrightness(0,0);
      while (i!=0 || Stylus.Held)
      {
//         speed=20;
		   if (Stylus.Held)
		   {
//		      height=i*-1;
//		      add=i*2;
		      add=(i*1);
		      i+=(OldStylusY- Stylus.Y);
		      OldStylusY= Stylus.Y;
		   }
			else   
			{
			   speed-=i-(i*.925);
				i*=.925;
			}			
         if (i>0) i=0;
	      PA_SetBgRot(1,3,0,i,0,0,0,256);
	      
	       updateTopScreenRipple();
	      Soul_waitForVBL();
	      //flushToMemory();
			updateSettings16c(subMenu,i*-1);
	   }   
   }

   if (transitionAnimation>0)
	{
      if (transitionAnimation>90)
		   transitionAnimation-=3;
      if (transitionAnimation>70)
		   transitionAnimation-=3;
      if (transitionAnimation>80)
		   transitionAnimation-=3;
      if (transitionAnimation>50)
		   transitionAnimation-=2;
      if (transitionAnimation>20)
		   transitionAnimation-=2;
	   transitionAnimation-=2;
      if (transitionAnimation<62)
		   PA_SetBrightness(0,transitionAnimation/2);
	   else
	   {
		   PA_SetBrightness(0,31);
		}   
	   if (!animateTopScreen) PA_SetBrightness(0,0);
      if (transitionAnimation<0)
      {
			PA_SetBgRot(1,3,0,0,0,0,0,256);
		}   
	   else
			PA_SetBgRot(1,3,0,transitionAnimation/-4,0,0,0,256);
	}   
   if (transitionAnimation==0)animateTopScreen=0;
	updateSettings16c(subMenu,transitionAnimation/4);
	return transitionAnimation;
}			

void customMenuStylusDetect(char* menu)
{
   if (!Stylus.Newpress) return;
   int i;
   for (i=0;i<4;i++)
   {
		if(PA_StylusInZone(49,25+(i*40),217,65+(i*40)))
		{
		   break;
		}
	}	
		
	if (i==4) 
	{
	   Stylus.Newpress=1;
	   return;
	}   
	
	char temp[256];
	sprintf (temp,"custommenus/%s/custom%d.nds",menu,i+1);
//	logMessage(temp);
	char *path=malloc(256);
//	logMessage("making path");
	path = returnThemeResourcePath(temp, 1);
	if (path!=NULL)
	{
		FILE* rompath=fopen(path,"rb");
		if (rompath)
		{
	
			logMessage("found");
		  	menudo_runNDS(path,0,0);
		}
		fclose(rompath);   
		//if (path!=NULL) 
		free(path);
	}		
		   
}   
