#include <PA9.h>
#include "select_misc.h"



#include "../../userConfigFunctions.h"

#define ACTION_ASSIGN_BUTTON(x1,y1,x2,y2,string)	\
if (PA_StylusInZone(x1,y1,x2,y2))\
{\
   if (selectActionOutput!=NULL) free(selectActionOutput);\
	selectActionOutput= selectAction(string);\
	sprintf(string,"%s",selectActionOutput);\
	if (selectActionOutput!=NULL) free(selectActionOutput);\
   updateSettings(subMenu);\
	PivotScale(128,96); \
	break;\
}		
//	updateSettings(subMenu);
#define CREATE16CMASK()    for(x=0;x<256;x++) for(y=110;y<=192;y++) if (PA_16cGetPixel(1,x,y)==0) PA_16cPutPixel(1,x,y,6);
void popupScreen(char* bmp, int subMenu)
{
   PA_Clear16bitBg(1);
   PA_16cClearZone(1,31,24,255,192);
   loadBMPWithResource(1,39,60,bmp);
   PivotScale(128,96);
   int i;
   for (i=0;i<(60);i++)
   {
		Soul_waitForVBL();	   
   }     
   updateSettings(subMenu);
	PA_SetBgRot(1,3,128,96,128,96,0,(256+96)+(128));
	Soul_waitForVBL();	   
   PivotScale(128,96);
}   
	char HiddenPass[3][14];


void updateSettings(u8 subMenu)
{
   PA_Clear16bitBg(1);
   transiteSelectMenu(0,subMenu);
   switch(subMenu)
   {
      case 0: loadBMPWithResource(1,39,25,"settings/subsettings1.bmp");
			     if (system.EnergySaving) loadBMPWithResource(1,39+8,25+6,"settings/checkbutton.bmp");
			     if (system.ShuffleThemes) loadBMPWithResource(1,39+8,25+36,"settings/checkbutton.bmp");
			     if (system.directToMain) loadBMPWithResource(1,39+8,25+66,"settings/checkbutton.bmp");
//			     if (system.DetectNewFiles) loadBMPWithResource(1,39+8,25+66,"settings/checkbutton.bmp");
      			break;
      case 1: loadBMPWithResource(1,39,25,"settings/subsettings2.bmp");
			     if (system.InvertScroll) loadBMPWithResource(1,39+8,25+6,"settings/checkbutton.bmp");
      			break;
      case 2: loadBMPWithResource(1,39,25,"settings/subsettings3.bmp");
      			break;
      case 3: loadBMPWithResource(1,39,25,"settings/subsettings4.bmp");
      			break;
      case 4: loadBMPWithResource(1,39,25,"settings/subsettings5.bmp");
      			break;
      case 5: loadBMPWithResource(1,39,25,"settings/subsettings6.bmp");
			     if (system.AutoLoginWifi) loadBMPWithResource(1,39+8,25+6,"settings/checkbutton.bmp");

      			break;
   }   


   return;
}   

#define ZoomToPixelScaleY ((256.0/(256+i))*192)
#define ZoomToPixelPositionY (((256.0/-(256+i))*(stylusY))+stylusY)


void PivotScale(int pivotX,int pivotY)
{
   int x,y;
	CREATE16CMASK();
   int stylusX=pivotX;
   int stylusY=pivotY;
	PA_SetBgRot(1,3,stylusX,stylusY,stylusX,stylusY,0,(256+96)+(256));
	Soul_waitForVBL();	   
   int i=0;
   for (i=255;i>0;i*=.7)
   {
		PA_SetBgRot(1,3,stylusX,stylusY,stylusX,stylusY,0,(256+i));
		y=((ZoomToPixelPositionY+ZoomToPixelScaleY)<192?(ZoomToPixelPositionY+ZoomToPixelScaleY):192);
		PA_16cClearZone(1,30,30,256,y-1);
		Soul_waitForVBL();	   
	}	
   PA_SetBgRot(1,3,0,0,0,0,0,256);
}   
int selectSpeed(int currentValue)
{
   PA_Clear16bitBg(1);
   PA_16cClearZone(1,31,24,255,192);
   loadBMPWithResource(1,39,25,"settings/speedSelect.bmp");
	PivotScale(Stylus.X,Stylus.Y);
   while (1)
   {
		if (Stylus.Newpress)
		{   
		   if (PA_StylusInZone(39+6,25+7,39+106,25+27))  	return 0; //very slow 
		   if (PA_StylusInZone(39+113,25+7,39+213,25+27))	return 1; //slow
		   if (PA_StylusInZone(39+6,25+34,39+106,25+54)) 	return 2; //normal
		   if (PA_StylusInZone(39+113,25+34,39+213,25+54)) return 3; // fast
		   if (PA_StylusInZone(39+6,25+61,39+106,25+81)) 	return 4; // very fast
		   if (PA_StylusInZone(39+113,25+141,39+213,25+161)) return currentValue;
		}		
		Soul_waitForVBL();	   
   }   
}   
int selectTime(int currentValue)
{
   PA_Clear16bitBg(1);
   PA_16cClearZone(1,31,24,255,192);
   loadBMPWithResource(1,39,25,"settings/timeSelect.bmp");
   PivotScale(Stylus.X,Stylus.Y);
   while (1)
   {
		if (Stylus.Newpress)
		{   
		   //first column
		   if (PA_StylusInZone(39+6,25+7,39+106,25+27))  return 1*60;
		   if (PA_StylusInZone(39+6,25+34,39+106,25+54)) return 10*60;
		   if (PA_StylusInZone(39+6,25+61,39+106,25+81)) return 1*60*60;
		   if (PA_StylusInZone(39+6,25+88,39+106,25+108)) return 5*60*60;
		   if (PA_StylusInZone(39+6,25+115,39+106,25+135)) return 30*60*60;
		   //second column
		   if (PA_StylusInZone(39+113,25+7,39+213,25+27)) return 5*60;
		   if (PA_StylusInZone(39+113,25+34,39+213,25+54)) return 30*60;
		   if (PA_StylusInZone(39+113,25+61,39+213,25+81)) return 3*60*60;
		   if (PA_StylusInZone(39+113,25+88,39+213,25+108)) return 15*60*60;
		   
		   if (PA_StylusInZone(39+113,25+141,39+213,25+161)) return currentValue;
		}		
		Soul_waitForVBL();	   
   }   
} 
char* returnTimeSelected(int currentValue)
{
	//first column
	if (currentValue==1*60)return "1 Sec";
	if (currentValue==10*60)return "10 Secs";
	if (currentValue==1*60*60)return "1 Mins";
	if (currentValue==5*60*60)return "5 Mins";
	if (currentValue==30*60*60)return "30 Mins";
	//second column
	if (currentValue==5*60)return "5 Secs";
	if (currentValue==30*60)return "30Secs";
	if (currentValue==3*60*60)return "3 Mins";
	if (currentValue==15*60*60) return "15 Mins";
	return "Custom";
}   
char* selectAction(char* currentAction)
{
   PA_Clear16bitBg(1);
   PA_16cClearZone(1,31,24,255,192);
   loadBMPWithResource(1,39,25,"settings/actionSelect.bmp");
   PivotScale(Stylus.X,Stylus.Y);
   char* output= malloc(100);
   
   while (1)
   {
		if (Stylus.Newpress)
		{   
		   //first column
		   if (PA_StylusInZone(39+6,25+7,39+106,25+27))  
			{

			}   
		   if (PA_StylusInZone(39+6,25+34,39+106,25+54))
			{
			   sprintf(output,"gba");
			   return output;
			}
		   if (PA_StylusInZone(39+6,25+61,39+106,25+81))
			{
			   sprintf(output,"mMultimedia");
			   return output;
			}
		   if (PA_StylusInZone(39+6,25+88,39+106,25+108))
		   {
			   sprintf(output,"mWireless");
			   return output;
			}
		   if (PA_StylusInZone(39+6,25+115,39+106,25+135))
		   {
			   sprintf(output,"mSettings");
			   return output;
			}
		   if (PA_StylusInZone(39+6,25+141,39+106,25+161))
		   {
			   sprintf(output,"");
			   return output;
			}
		   //second column
		   if (PA_StylusInZone(39+113,25+7,39+213,25+27)) 
		   {

			}
		   if (PA_StylusInZone(39+113,25+34,39+213,25+54)) 
		   {
			   sprintf(output,"loadLastFile");
			   return output;
			}
		   if (PA_StylusInZone(39+113,25+61,39+213,25+81)) 
		   {
			   sprintf(output,"mPda");
			   return output;
			}
		   if (PA_StylusInZone(39+113,25+88,39+213,25+108)) 
		   {
			   sprintf(output,"mExplore");
			   return output;
			}
		   if (PA_StylusInZone(39+113,25+115,39+213,25+135)) 
		   {
			   sprintf(output,"power");
			   return output;
			}
		   
		   if (PA_StylusInZone(39+113,25+141,39+213,25+161))
		   {
			   sprintf(output,"%s",currentAction);
			   return output;
			}
		}		
		Soul_waitForVBL();	   
   }   

}
char* returnActionSelected(char* currentAction)
{
   if (stricmp(currentAction,"gba")==0) return "Boot Slot-2";
   if (stricmp(currentAction,"mMultimedia")==0) return "Multimedia";
   if (stricmp(currentAction,"mWireless")==0) return "Wifi";
   if (stricmp(currentAction,"mSettings")==0) return "Settings";
   if (stricmp(currentAction,"loadLastFile")==0) return "Load last";
   if (stricmp(currentAction,"mPda")==0) return "Utilities";
   if (stricmp(currentAction,"mExplore")==0) return "Explore";
   if (stricmp(currentAction,"power")==0) return "Power off";
   int x = strlen(currentAction);
   int i=0;
   for (i=x;i>0;i--)
   	if (currentAction[i]=='\\' || currentAction[i]=='/') 
		{
		   i++;
		   break;
		}   
   	
   return currentAction+i;

}

void updateSettings16c(int subMenu,int Yoffset)
{
   PA_16cClearZone(1,31,24,255,192);
	switch(subMenu)
   {
      case 1:
         		break;
      case 2:	PA_16cTextAlign(2);
		   		display16cText(1,39+8,25+10+Yoffset,39+52,25+37,returnTimeSelected(system.SMFCoverDelay),15,3);
				   display16cText(1,39+8,25+41+Yoffset,39+52,25+50,returnTimeSelected(system.ScreenSaverDelay),15,3);   
				   PA_16cTextAlign(0);
				   break;
		case 3: 	if (system.Password[0]==0)
					{
					   display16cText(1,39+72+5,25+4+Yoffset+3,39+72+105,25+4+18,"No Password",15,3);
						display16cText(1,39+72+5,25+72+Yoffset+3,39+72+105,25+72+18,HiddenPass[1],15,3);
						display16cText(1,39+72+5,25+98+Yoffset+3,39+72+105,25+98+18,HiddenPass[2],15,3);					   
					}
					else
						display16cText(1,39+72+5,25+4+Yoffset+3,39+72+105,25+4+18,(HiddenPass[0][0]==0?"----------":HiddenPass[0]),15,3);
					break;
		case 4:  display16cText(1,64+5,29+32+Yoffset,39+5+92,29+32+18+Yoffset,returnActionSelected(system.startup[0]),15,3);   
					display16cText(1,64+5,29+56+Yoffset,39+5+92,29+56+18+Yoffset,returnActionSelected(system.startup[1]),15,3);   
					display16cText(1,64+5,29+82+Yoffset,39+5+92,29+82+18+Yoffset,returnActionSelected(system.startup[2]),15,3);   
					display16cText(1,64+5,29+108+Yoffset,39+5+92,29+108+18+Yoffset,returnActionSelected(system.startup[3]),15,3);   
					display16cText(1,64+116,29+32+Yoffset,39+116+92,29+32+18+Yoffset,returnActionSelected(system.startup[4]),15,3);   
					display16cText(1,64+116,29+56+Yoffset,39+166+92,29+56+18+Yoffset,returnActionSelected(system.startup[5]),15,3);   
					display16cText(1,64+116,29+82+Yoffset,39+116+92,29+82+18+Yoffset,returnActionSelected(system.startup[6]),15,3);   
					display16cText(1,110+24,29+136+Yoffset,39+24+172,29+136+136+Yoffset,returnActionSelected(system.startup[7]),15,3);   
				   break;
	}   

}	 
extern int transitionAnimation;
bool selectSettings(bool initBg)
{
	int AppsOpened=-1;
	int subMenu=0;
	int i=0;
	char EnteredPass[3][14];
	memset(EnteredPass,0,3*14);
	memset(HiddenPass,0,3*14);

	for (i=0;system.Password[i]!=0;i++)
		system.Password[i]=toupper(system.Password[i]);
   while(true)
   {
      hideAll2dSprites();
      PA_DisableSpecialFx(0);
      PA_DisableSpecialFx(1);
      AppsOpened++;
      if (initBg)
      {
	      clearSystem();
			PA_Init16bitBg(1, 3);
			PA_Init16cBg(1, 2); 
			PA_Init16cBg(0, 1);
			PA_SetBgPrio(0,0,1);
			PA_SetBgPrio(0,1,0);
		}	

		PA_Screen=0;
		PA_SwitchScreens();
 		PA_SetBrightness(0,31);
 		PA_SetBrightness(1,0);
 		PA_16cErase(0);
 		PA_16cErase(1);
//		PA_SetBgPrio(1,0,1);
//		PA_SetBgPrio(1,3,0);
		transitionAnimation=31*5;
		PA_SetBgRot(1,3,transitionAnimation*-1,0,0,0,0,256);
		Settings16cBMP(0,"settings/top.16c.bmp");
		load16cBMPWithResource(1,0,0,"appselect/settingsBg.16c.bmp");
		PA_Clear16bitBg(1);
		updateSettings(subMenu);
//		PA_LoadBmpEx(1,39,25,"settings/subsettings1);

//	   Soul_waitForVBL();
		initSelectMenu();
//		PA_16bitText(1,10,10,200,200,"asdfsf",3,3,0,100);
		PA_SetBgPalCol(1, 0, PA_RGB(171>>3,184>>3,229>>3));
		PA_16cClearZone(1,31,24,255,192);
		char* selectActionOutput=NULL;
		char charTemp[256];
	   while(true)
	   {
//			updateSettings16c(subMenu);

			if (Stylus.Newpress)
			{   
				if (PA_StylusInZone(31,24,255,192))
				{
				   switch(subMenu)
				   {
				      case 0:
								   if (PA_StylusInZone(39+8,25+6,39+8+181,25+6+20))
								   {
									   system.EnergySaving = !system.EnergySaving;
									   updateSettings(subMenu);
									   break;
								   }
								   if (PA_StylusInZone(39+8,25+36,39+8+181,25+36+20))
								   {
									   system.ShuffleThemes = !system.ShuffleThemes;
									   updateSettings(subMenu);
									   break;
								   }
								   if (PA_StylusInZone(39+8,25+36+30,39+8+181,25+36+30+20))
								   {
									   system.directToMain = !system.directToMain;
									   updateSettings(subMenu);
									   break;
								   }
								   break;
				      case 1:
								   if (PA_StylusInZone(39+8,25+6,39+8+181,25+6+20))
								   {
									   system.InvertScroll = !system.InvertScroll;
									   updateSettings(subMenu);
									   break;
								   }
								   if (PA_StylusInZone(39+7,25+36,39+7+182,25+36+20))
								   {
								      system.SelectStylusSpeed = selectSpeed(system.SelectStylusSpeed);
								      updateSettings(subMenu);
										PivotScale(128,96);
								      break;
								   }  
								   if (PA_StylusInZone(39+7,25+66,39+7+182,25+66+20))
								   {
								      system.DoubleClickSpeed = selectSpeed(system.DoubleClickSpeed);
								      updateSettings(subMenu);
										PivotScale(128,96);
								      break;
								   }  
				         		break;
				      case 2:
								   if (PA_StylusInZone(39+44,25+6,39+44+182,25+6+20))
								   {
								      system.SMFCoverDelay = selectTime(system.SMFCoverDelay);
								      updateSettings(subMenu);
										PivotScale(128,96);
								      break;
								   }   
								   if (PA_StylusInZone(39+44,25+37,39+44+182,25+37+20))
								   {
								      system.ScreenSaverDelay = selectTime(system.ScreenSaverDelay);
								      updateSettings(subMenu);
										PivotScale(128,96);
								      break;
								   }  
								   break;
						case 3: 	if (system.Password[0]!=0) 
									{
										inputSettingsPassword(EnteredPass[0], HiddenPass[0], 39+72,25+4,39+72+105,25+4+18);
									   if (PA_StylusInZone(39+85,25+30,39+85+115,25+30+20))
									   {
									      if (stricmp(EnteredPass[0],system.Password)==0)
										   {
												popupScreen("settings/passRemoved.bmp",subMenu);	
												memset(system.Password,0,14);
												memset(EnteredPass[0],0,14);
												memset(HiddenPass[0],0,14);
										   }
											else
											{
												popupScreen("settings/wrongPass.bmp",subMenu);
											}   
										}			
									}			
									else
									{
										inputSettingsPassword(EnteredPass[1], HiddenPass[1], 39+72,25+72,39+72+105,25+72+18);
										inputSettingsPassword(EnteredPass[2], HiddenPass[2], 39+72,25+98,39+72+105,25+98+18);
										if (EnteredPass[1][0]!=0 && EnteredPass[2][0]!=0)
									   if (PA_StylusInZone(39+85,25+125,39+85+115,25+125+20))
									   {
									      if (stricmp(EnteredPass[1],EnteredPass[2])==0)
										   {
												popupScreen("settings/passChanged.bmp",subMenu);
												sprintf(system.Password,"%s",EnteredPass[1]);									   
												memset(EnteredPass[1],0,14);
												memset(HiddenPass[1],0,14);
												memset(EnteredPass[2],0,14);
												memset(HiddenPass[2],0,14);
										   }
											else
											{
												popupScreen("settings/wrongPass.bmp",subMenu);
											}   
										}			
									}			

//									
									break;
						case 4:  ACTION_ASSIGN_BUTTON(39+5,25+32,39+5+92,25+32+18,system.startup[0]);
									ACTION_ASSIGN_BUTTON(39+5,25+56,39+5+92,25+56+18,system.startup[1]);
									ACTION_ASSIGN_BUTTON(39+5,25+82,39+5+92,25+82+18,system.startup[2]);
									ACTION_ASSIGN_BUTTON(39+5,25+108,39+5+92,25+108+18,system.startup[3]);
									ACTION_ASSIGN_BUTTON(39+116,25+32,39+116+92,25+32+18,system.startup[4]);
									ACTION_ASSIGN_BUTTON(39+116,25+56,39+166+92,25+56+18,system.startup[5]);
									ACTION_ASSIGN_BUTTON(39+116,25+82,39+116+92,25+82+18,system.startup[6]);
 									ACTION_ASSIGN_BUTTON(39+24,25+136,39+24+172,25+136+136,system.startup[8]);
								   break;
						case 5:
								   if (PA_StylusInZone(39+8,25+6,39+8+181,25+6+20))
								   {
									   system.AutoLoginWifi = !system.AutoLoginWifi;
									   updateSettings(subMenu);
									   break;
								   }

					}   
//					Soul_waitForVBL();
				}
			}			
			if (Stylus.Held)
			{
			   SUBMENU_ICON_BUTTON(5,22,25,42,0,updateSettings);
			   SUBMENU_ICON_BUTTON(5,43,25,63,1,updateSettings);
			   SUBMENU_ICON_BUTTON(5,64,25,84,2,updateSettings);
			   SUBMENU_ICON_BUTTON(5,85,25,105,3,updateSettings);
			   SUBMENU_ICON_BUTTON(5,106,25,126,4,updateSettings);
			   SUBMENU_ICON_BUTTON(5,170,25,190,5,updateSettings);					
			}			 
//		   if (PA_StylusInZone(31,22,255,192) && Stylus.Held)
//		   {
			transitionAnimation = transiteSelectMenu(transitionAnimation,subMenu);
//			}			
			if((Stylus.Newpress && PA_StylusInZone(0,0,47,21)) || Pad.Newpress.B || Pad.Newpress.L)	
			{
				deinitSelectMenu();
				PA_SwitchScreens();
				SaveCurrentConfig();
				return (AppsOpened>0);   
			} 
			updateTopScreenRipple();
	      Soul_waitForVBL();
	   }   
		PA_SwitchScreens();
	   initBg=1;
	}
	deinitSelectMenu();
	SaveCurrentConfig(); 
	return (AppsOpened>0);   
}   
void inputSettingsPassword(char* EnteredPass, char* HiddenPass, int x1, int y1, int x2, int y2)
{
	if (!PA_StylusInZone(x1,y1,x2,y2)) return;
	PA_16cClearZone(1,x1,y1,x2,y2);
	memset(EnteredPass,0,14);
	memset(HiddenPass,0,14);
	int i=0;
	u8 cursorFrameCounter=0;
	while (1)
	{
	   if (cursorFrameCounter<30)
	   {
		   PA_16cText(1, x1+5+(strlen(HiddenPass)*7), y1+3, x2, y2, "|", 15, 3, 100);
		}   
		cursorFrameCounter++;
		if (cursorFrameCounter>=60) cursorFrameCounter=0;
	   PA_16cText(1, x1+5, y1+3, x2, y2, HiddenPass, 15, 3, 100);
	   if (Pad.Newpress.Anykey || Pad.Newpress.Y)
	   {
	      if (Pad.Newpress.Select) break;
	      if (strlen(HiddenPass)<13) 
			{
			   addLetterPass(HiddenPass,'x');
	  	      if (Pad.Newpress.Up) addLetterPass(EnteredPass,'^');
		      if (Pad.Newpress.Left) addLetterPass(EnteredPass,'<');
	  	      if (Pad.Newpress.Right) addLetterPass(EnteredPass,'>');
		      if (Pad.Newpress.Down) addLetterPass(EnteredPass,'V');
	  	      if (Pad.Newpress.A) addLetterPass(EnteredPass,'A');
	  	      if (Pad.Newpress.B) addLetterPass(EnteredPass,'B');
	  	      if (Pad.Newpress.X) addLetterPass(EnteredPass,'X');
	  	      if (Pad.Newpress.Y) addLetterPass(EnteredPass,'Y');
	  	      if (Pad.Newpress.L) addLetterPass(EnteredPass,'L');
	  	      if (Pad.Newpress.R) addLetterPass(EnteredPass,'R');
	  	      if (Pad.Newpress.Start) addLetterPass(EnteredPass,'S');
	  	   }   
			if (strcmp(EnteredPass,system.Password)==0) break;
	   }   
		if (Stylus.Newpress) if (!PA_StylusInZone(x1,y1,x2,y2)) break;
		Soul_waitForVBL();
		PA_16cClearZone(1,x1,y1,x2,y2);
	}
	PA_16cClearZone(1,x1,y1,x2,y2);
   PA_16cText(1, x1+5, y1+3, x2, y2, HiddenPass, 15, 3, 100);

}	
