// Includes
#include <PA9.h>       // Include for PA_Lib

#include "../../userConfigFunctions.h"
//#include "chrlib.h"

#include "../../gfx/all_gfx.h"
#include "../../misc/misc.h"
#include "../../misc/fat.h"
#include "../../misc/debug.h"
#include "../../misc/clock.h"
#include "../../engine/engine.h"
#include "../../misc/transition.h"
//#include "settingsBackground.h"
//#include "ambience.h"
//#include "roundRectangle.h"
//#include "edgeRectangle.h"
//#include "edgeButton.h"
//#include "topScreen.h"

#define DEFAULT_DOUBLECLICK_DURATION 30
#define OPTION_X (-20)
#define OPTION_Y (-10)
/*s32 i;
u32 x,y;
char charTemp[200];*/

u16 edgeButtonTex;
u16 edgeRectangleTex;
bool textBoxTopScreen_Black;
u8 textBoxTopScreen_X1;
u8 textBoxTopScreen_Y1;
u8 textBoxTopScreen_X2;
u8 textBoxTopScreen_Y2;
	
/*
struct  selectedInfo
{
	u8 Menu;
	u8 SubMenu;
	u8 SecondSubMenu;
	bool Confirm;
	bool JustConfirmed;
	u16 ClickTime;
} selected;
*/
struct  selectedInfo
{
	u8 Menu;
	s8 Acceleration;
	u8 SubMenu;
	u8 SecondSubMenu;
	bool Confirm;
	bool JustConfirmed;
	bool wrongclick;
	u16 ClickTime;
} selected;



void updateSettingSubmenu()
{
   int x=0;
   int i=0;
	if (!selected.JustConfirmed|| (Pad.Newpress.B || Pad.Newpress.A || Pad.Newpress.Up || Pad.Newpress.Down))
	for (x=0;x<10;x++) 
	if (PA_3DSpriteTouched(200+(2*x)) || PA_3DSpriteTouched(201+(2*x))|| (Pad.Newpress.B || Pad.Newpress.A || Pad.Newpress.Up || Pad.Newpress.Down))
	{
		if (Pad.Newpress.B) x=5;
		if (Pad.Newpress.A) x=selected.SecondSubMenu;
	   if (Pad.Newpress.Up) x=(selected.SecondSubMenu>0)?selected.SecondSubMenu-1:5;
	   if (Pad.Newpress.Down) x=(selected.SecondSubMenu<9)?selected.SecondSubMenu+1:0;
		for(i=200;i<=219;i++)
			PA_3DSetSpriteAlpha(i,15);
		PA_3DSetSpriteAlpha(200+(2*x)+0,31);
		PA_3DSetSpriteAlpha(200+(2*x)+1,31);
		 if (selected.SecondSubMenu!=x && !Pad.Newpress.B) 
		 {
		   switch (system.Language)
			{
			   case 0: 	switch(x){
									case 0: WriteTopScreenText(0,"Run NDS file\n\nSelect .nds files on your desired folder with MENUdo's mNavigate or directly run a desired file");
											  break;
									case 1: WriteTopScreenText(0,"Navigate Folder\n\n");
											  break;
									case 2: WriteTopScreenText(0,"Run GBA Slot\n\nBoots your slot-2 cart.");
											  break;
									case 3: WriteTopScreenText(0,"PDA\n\n");
											  break;
									case 4: WriteTopScreenText(0,"Multimedia\n\n");
											  break;
									case 5: WriteTopScreenText(0,"Wireless\n\n");
											  break;
									case 6: WriteTopScreenText(0,"mSettings\n\nConfigure your menudo's assigned files and other preferences in with this.");
											  break;
									case 7: WriteTopScreenText(0,"mExplore\n\nManage or load your files with MENUdo's mExplore.");
											  break;
									case 8: WriteTopScreenText(0,"Power Off\n\n");
											  break;
									case 9: WriteTopScreenText(0,"Cancel\n");
											  break;
							}	  
							break;
			}			
	
		}			
		else
		{
			
			if (((Stylus.Newpress && selected.ClickTime!=0) || Pad.Newpress.B|| Pad.Newpress.A )&& x>0) 
			{
				selected.Confirm=0;
	
				selected.ClickTime=0;
				for(i=200;i<=219;i++)
					PA_3DSetSpriteVisible(i,0);		
	
			switch (selected.Menu)								
			{
				case 0:	for(i=18;i<=25;i++)
							{
								PA_3DSetSpriteAlpha(i,15);
								PA_3DSetSpriteVisible(i,1);		
								if (i%2==0) Click3DButton(i);
							}
							switch (x)
							{
								case 2:	sprintf(system.startup[selected.SubMenu],"gba");
											break;
								case 3:	sprintf(system.startup[selected.SubMenu],"mPda");
											break;
								case 4:	sprintf(system.startup[selected.SubMenu],"mMultimedia");
											break;
								case 5:	sprintf(system.startup[selected.SubMenu],"mWireless");
											break;
								case 6:	sprintf(system.startup[selected.SubMenu],"mSettings");
											break;
								case 7:	sprintf(system.startup[selected.SubMenu],"mExplore");
											break;
								case 8:	sprintf(system.startup[selected.SubMenu],"power");
											break;
							}   
							break;			
				case 1:	for(i=26;i<=43;i++)
							{
								PA_3DSetSpriteAlpha(i,15);
								PA_3DSetSpriteVisible(i,1);		
								if (i%2==0) Click3DButton(i);
							}			
							switch (x)
							{
								case 2:	sprintf(system.menuRuns[selected.SubMenu],"gba");
											break;
								case 3:	sprintf(system.menuRuns[selected.SubMenu],"mPda");
											break;
								case 4:	sprintf(system.menuRuns[selected.SubMenu],"mMultimedia");
											break;
								case 5:	sprintf(system.menuRuns[selected.SubMenu],"mWireless");
											break;
								case 6:	sprintf(system.menuRuns[selected.SubMenu],"mSettings");
											break;
								case 7:	sprintf(system.menuRuns[selected.SubMenu],"mExplore");
											break;
								case 8:	sprintf(system.menuRuns[selected.SubMenu],"power");
											break;
							}   
							break;
			}			
				break;
	
			}		
			selected.ClickTime=DEFAULT_DOUBLECLICK_DURATION;
		}			
		
			
		Click3DButton(200+(2*x));
		selected.SecondSubMenu=x;
		break;	
	}   
	
}
void updateSettingSubMenu()
{
	Create3DButtonText(0,200,"Run NDS file"	,selected.SecondSubMenu==0?10:9);
	Create3DButtonText(0,202,"Navigate Folder",selected.SecondSubMenu==1?10:9);
	Create3DButtonText(0,204,"Run Gba Slot"	,selected.SecondSubMenu==2?10:9);
	Create3DButtonText(0,206,"PDA"				,selected.SecondSubMenu==3?10:9);
	Create3DButtonText(0,208,"Multimedia"		,selected.SecondSubMenu==4?10:9);
	Create3DButtonText(0,210,"Wireless"			,selected.SecondSubMenu==5?10:9);
	Create3DButtonText(0,212,"Settings"			,selected.SecondSubMenu==6?10:9);
	Create3DButtonText(0,214,"File Explorer"	,selected.SecondSubMenu==7?10:9);
	Create3DButtonText(0,216,"Power Off"		,selected.SecondSubMenu==8?10:9);
	Create3DButtonText(0,218,"Cancel"			,selected.SecondSubMenu==9?10:9);

}		

void Create3DButton(u16 sprite, u16 x, u16 y,u16 width)
{
	PA_3DCreateSpriteFromTex(sprite,edgeButtonTex,width,16, 6,x+(width/2),y);
	PA_3DCreateSpriteFromTex(sprite+1,edgeButtonTex,8,16,  6,x+(width)+4,y);
	PA_3DSetSpriteHflip(sprite+1,1);
}	
void Create3DButtonText(bool multilangual, u16 sprite, char* string, u8 color)
{
   PA_16cTextAlign(2);		
/*	if (multilangual)
   Sim16cText(0,((pa_3dsprites[sprite].X)-((pa_3dsprites[sprite].Width/2)-4))+2,pa_3dsprites[sprite].Y-10,pa_3dsprites[sprite+1].X,pa_3dsprites[sprite].Y+6,string,color,UTF8,0);
   else*/
	PA_16cText(0,(pa_3dsprites[sprite].X)-((pa_3dsprites[sprite].Width/2)-4),pa_3dsprites[sprite].Y-6,pa_3dsprites[sprite+1].X,pa_3dsprites[sprite].Y-6,string,color,1,100);
}		


void Click3DButton(int sprite)
{
//   PA_16cErase(0);
	if(pa_3dsprites[sprite+1].Width == 8)
	{
	   pa_3dsprites[sprite+1].Width+=8;
	   pa_3dsprites[sprite+1].Height+=8;
	   pa_3dsprites[sprite+1].X+=8;
	   pa_3dsprites[sprite].Width+=8;
	   pa_3dsprites[sprite].Height+=8;
	}   
	else
	if(pa_3dsprites[sprite+1].Width <= 10)
	{
	   pa_3dsprites[sprite+1].Width+=1;
	   pa_3dsprites[sprite+1].Height+=1;
	   pa_3dsprites[sprite+1].X+=1;
	   pa_3dsprites[sprite].Width+=1;
	   pa_3dsprites[sprite].Height+=1;
	}   
}   
void AnimateClick3DButton(int sprite)
{

	if(pa_3dsprites[sprite+1].Width > 8)
	{
	   clear16cZone(0,(pa_3dsprites[sprite].X)-((pa_3dsprites[sprite].Width/2)-4),pa_3dsprites[sprite].Y-10,pa_3dsprites[sprite+1].X,pa_3dsprites[sprite].Y+6);
	   pa_3dsprites[sprite+1].X--;
//		pa_3dsprites[sprite].X--;
	   pa_3dsprites[sprite+1].Width--;
	   pa_3dsprites[sprite+1].Height--;
	   pa_3dsprites[sprite].Width--;
	   pa_3dsprites[sprite].Height--;
	}
}	   




void WriteTopScreenText(bool multilangual,char* text)
{
   spaceLetteringForAAText();   
   PA_TextLineSpacing(-2);
	PA_16cTextAlign(0);
	PA_16cErase(1);
	PA_16cText(1,textBoxTopScreen_X1
					,textBoxTopScreen_Y1
					,textBoxTopScreen_X2
					,textBoxTopScreen_Y2
					,text, 1,5,500);
   PA_TextLineSpacing(0);	
	spaceLetteringForDefault();
//	Sim16cText(1,29,39,29+200,39+131,text, 1,UTF8,0);
}	


void Update3DButtonsAnimation()
{
   int x;
	if (selected.Confirm) for (x=0;x<10;x++) AnimateClick3DButton(200+(2*x));

   switch (selected.Menu)
   {
		case 0:	for (x=0;x<=3;x++) AnimateClick3DButton(18+(2*x));
					break;
		case 1:	for (x=0;x<=8;x++) AnimateClick3DButton(26+(2*x));

					break;
		case 2:	for (x=0;x<=0;x++) AnimateClick3DButton(44+(2*x));
					break;
		case 3:	for (x=0;x<=3;x++) AnimateClick3DButton(46+(2*x));

					break;
		case 4:	for (x=0;x<=1;x++) AnimateClick3DButton(54+(2*x));
					break;
		case 5:	for (x=0;x<=1;x++) AnimateClick3DButton(58+(2*x));
					break;
		case 6:	for (x=0;x<=1;x++) AnimateClick3DButton(62+(2*x));
					break;
	}			
}	
void updateSettings()
{
   int x=0;
   int i=0;
   char charTemp[256];   
	switch (selected.Menu)
	{
	
		case 0:	switch (system.Language)
					{
					   case 0: sprintf(charTemp,"Assign Autorun\n\nHold the button to use the autorun\n\n%s \n\t%s",selected.SubMenu==0?"Up":
					      																														selected.SubMenu==1?"Down":
					      																														selected.SubMenu==2?"Left":
					      																																				  "Right" 
																																				  ,system.startup[selected.SubMenu]);
						   	  WriteTopScreenText(0,charTemp);
								  break;
					   case 1: sprintf(charTemp,"指定自动运行\n\n按住键不放来使用自动运行\n\n%s \n\t%s",selected.SubMenu==0?"上":
					      																														selected.SubMenu==1?"下":
					      																														selected.SubMenu==2?"左":
					      																																				  "右"
																																				  ,system.startup[selected.SubMenu]);
						   	  WriteTopScreenText(1,charTemp);
								  break;
					}	  
	
					for (x=0;x<=3;x++) 
					if (PA_3DSpriteTouched(18+(2*x)) || PA_3DSpriteTouched(19+(2*x)) || (Pad.Newpress.A || Pad.Newpress.Left || Pad.Newpress.Right))
					{
					   if (Pad.Newpress.Left) x=(selected.SubMenu>0)?selected.SubMenu-1:3;
					   if (Pad.Newpress.Right) x=(selected.SubMenu<3)?selected.SubMenu+1:0;
					   if (Pad.Newpress.A) x=selected.SubMenu;
						for(i=18;i<=25;i++)
							PA_3DSetSpriteAlpha(i,15);
					   PA_3DSetSpriteAlpha(18+(2*x)+0,31);
					   PA_3DSetSpriteAlpha(18+(2*x)+1,31);
						 if (selected.SubMenu==x) 
						{
							
							if ((Stylus.Newpress && selected.ClickTime!=0)||Pad.Newpress.A) 
							{
								selected.Confirm=1;
	
								selected.ClickTime=0;
								selected.JustConfirmed=1;
								Click3DButton(18);
								for(i=200;i<=219;i++)
								{
									PA_3DSetSpriteAlpha(i,15);
									PA_3DSetSpriteVisible(i,1);		
									if (i%2==0) Click3DButton(i);
								}			
									selected.SecondSubMenu=0;	
							}			
							selected.ClickTime=DEFAULT_DOUBLECLICK_DURATION;
						}			
						
						Click3DButton(18+(2*x));
						selected.SubMenu=x;
						break;	
					}   
					break;
		case 1:	switch (system.Language)
					{
					   case 0: sprintf(charTemp,"Assign Menu\n\nn\n%s \n\t%s",selected.SubMenu==0?"Power Off":
																								selected.SubMenu==1?"System Settings":
																								selected.SubMenu==2?"mExplore":
																								selected.SubMenu==3?"Wireless":
																								selected.SubMenu==4?"Multimedia":
																								selected.SubMenu==5?"PDA":
																								selected.SubMenu==6?"Applications":
																								selected.SubMenu==7?"Games":
																														  "Run Slot-2"
																								,system.menuRuns[selected.SubMenu]);
						   	  WriteTopScreenText(0,charTemp);
								  break;
					   case 1: sprintf(charTemp,"指定自动运行\n\n按住键不放来使用自动运行\n\n%s \n\t%s",selected.SubMenu==0?"在线浏览":
					      																													selected.SubMenu==1?"系统设置":
					      																													selected.SubMenu==2?"m浏览":
					      																													selected.SubMenu==3?"m快捷方式":
					      																													selected.SubMenu==4?"m注释":
					      																													selected.SubMenu==5?"m播放器":
					      																													selected.SubMenu==6?"应用":
					      																													selected.SubMenu==7?"游戏":
					      																																			  "启动slot-2"
																																				,system.menuRuns[selected.SubMenu]);
						   	  WriteTopScreenText(1,charTemp);
								  break;
					}	  
		   		for (x=0;x<=8;x++) 
					if (PA_3DSpriteTouched(26+(2*x)) || PA_3DSpriteTouched(27+(2*x)) || (Pad.Newpress.A || Pad.Newpress.Left || Pad.Newpress.Right))
					{
					   if (Pad.Newpress.Left) x=(selected.SubMenu>0)?selected.SubMenu-1:8;
					   if (Pad.Newpress.Right) x=(selected.SubMenu<8)?selected.SubMenu+1:0;
					   if (Pad.Newpress.A) x=selected.SubMenu;
						 if (selected.SubMenu==x) 
						{
							
							if ((Stylus.Newpress && selected.ClickTime!=0)||Pad.Newpress.A) 
							{
								selected.Confirm=1;
	
								selected.ClickTime=0;
								selected.JustConfirmed=1;
								Click3DButton(26);
								for(i=200;i<=219;i++)
								{
									PA_3DSetSpriteAlpha(i,15);
									PA_3DSetSpriteVisible(i,1);		
									if (i%2==0) Click3DButton(i);
								}			
									selected.SecondSubMenu=0;	
							}			
							selected.ClickTime=DEFAULT_DOUBLECLICK_DURATION;
						}				
						for(i=26;i<=43;i++)
							PA_3DSetSpriteAlpha(i,15);
					   PA_3DSetSpriteAlpha(26+(2*x)+0,31);
					   PA_3DSetSpriteAlpha(26+(2*x)+1,31);
						Click3DButton(26+(2*x));
						if (selected.SubMenu==x) 
						selected.ClickTime=DEFAULT_DOUBLECLICK_DURATION;
						selected.SubMenu=x;
						break;	
					}   
					break;
		case 2:	switch(system.Language)
					{
							case 0: WriteTopScreenText(0,"Language\n\nChange MENUdo's language into your own native or favorite language\n\nEnglish\n\nNote: Other Languages is in progress");
									  break;
							case 1: WriteTopScreenText(0,"语言\n\n更改MENUdo的语言。\n-简体中文-");
									  break;
					}	  
		   		if (PA_3DSpriteTouched(44) || PA_3DSpriteTouched(45) || Pad.Newpress.A)
					{
						if (Stylus.Newpress || Pad.Newpress.A)
						{
						   if (selected.ClickTime!=0 || Pad.Newpress.A)
							{   
	  						 	system.Language=0;
								selected.ClickTime=0;
//							   if (system.Language > 1) system.Language=0; 
							   loadmSettingsGui(system.Language);
								PA_3DSetSpriteAlpha(9,31);
								PA_3DSetSpriteAlpha(10,31);
	
							}			
							else
							selected.ClickTime=DEFAULT_DOUBLECLICK_DURATION;
	
	
	
							for(i=44;i<=45;i++)
								PA_3DSetSpriteAlpha(i,31);
							
							Click3DButton(44);
	
	
						}	
						break;	
					}   
	
					break;
		case 3:	switch(system.Language)
					{
						case 0: switch(selected.SubMenu)
									{
											case 0: WriteTopScreenText(0,"Backlight Strength\n\nChange DS lite's default brightness\n\n0 - Dark");
													  break;
											case 1: WriteTopScreenText(0,"Backlight Strength\n\nChange DS lite's default brightness\n\n1 - Weak");
													  break;
											case 2: WriteTopScreenText(0,"Backlight Strength\n\nChange DS lite's default brightness\n\n2 - Bright");
													  break;
											case 3: WriteTopScreenText(0,"Backlight Strength\n\nChange DS lite's default brightness\n\n3 - Clear");
													  break;
									}	  
									break;
						case 1: switch(selected.SubMenu)
									{
											case 0: WriteTopScreenText(1,"背光强度\n\n修改DSL的默认背光\n\n0 - 暗");
													  break;
											case 1: WriteTopScreenText(1,"背光强度\n\n修改DSL的默认背光\n\n1 - 弱");
													  break;
											case 2: WriteTopScreenText(1,"背光强度\n\n修改DSL的默认背光\n\n2 - 亮");
													  break;
											case 3: WriteTopScreenText(1,"背光强度\n\n修改DSL的默认背光\n\n3 - 明亮");
													  break;
									}	  
									break;
					}			
		   		for (x=0;x<=3;x++) 
					if ((Stylus.Newpress&&( PA_3DSpriteTouched(46+(2*x)) || PA_3DSpriteTouched(47+(2*x)))) || (Pad.Newpress.Left || Pad.Newpress.Right))
					{
					   if (Pad.Newpress.Left) x=(system.BacklightStrength>0)?system.BacklightStrength-1:3;
					   if (Pad.Newpress.Right) x=(system.BacklightStrength<3)?system.BacklightStrength+1:0;
						for(i=46;i<=53;i++)
							PA_3DSetSpriteAlpha(i,15);
					   PA_3DSetSpriteAlpha(46+(2*x)+0,31);
					   PA_3DSetSpriteAlpha(46+(2*x)+1,31);
						Click3DButton(46+(2*x));
						system.BacklightStrength=x;
						//if (isDSLITE()) 
						PA_SetDSLBrightness(x);
						break;	
					}   
					selected.SubMenu = system.BacklightStrength;
					break;
		case 4:	switch(system.Language)
					{
						case 0:	switch(selected.SubMenu)
									{
											case 0: WriteTopScreenText(0,"Energy Saving\n\nActivating this would automatically \nlower your screens brightness whenever your DS is low in battery.\n\nDisabled");
													  break;
											case 1: WriteTopScreenText(0,"Energy Saving\n\nActivating this would automatically \nlower your screens brightness whenever your DS is low in battery.\n\nEnabled");
													  break;
									}	  
									break;
						case 1:	switch(selected.SubMenu)
									{
											case 0: WriteTopScreenText(1,"省电模式\n\n低电的时候自动调低DSL的亮度。\n\n关闭");
													  break;
											case 1: WriteTopScreenText(1,"省电模式\n\n低电的时候自动调低DSL的亮度。\n\n开启");
													  break;
									}	  
									break;
					}			
		   		for (x=0;x<=1;x++) 
					if (PA_3DSpriteTouched(54+(2*x)) || PA_3DSpriteTouched(55+(2*x)) || (Pad.Newpress.Left || Pad.Newpress.Right))
					{
					   if (Pad.Newpress.Left) x=(selected.SubMenu>0)?selected.SubMenu-1:1;
					   if (Pad.Newpress.Right) x=(selected.SubMenu<1)?selected.SubMenu+1:0;
						for(i=54;i<=57;i++)
							PA_3DSetSpriteAlpha(i,15);
					   PA_3DSetSpriteAlpha(54+(2*x)+0,31);
					   PA_3DSetSpriteAlpha(54+(2*x)+1,31);
						Click3DButton(54+(2*x));
						system.EnergySaving = x;
						break;	
					}   
						selected.SubMenu = system.EnergySaving;
					break;
		case 5:	switch(system.Language)
					{
						case 0:	switch(selected.SubMenu)
									{
											case 0: WriteTopScreenText(0,"Prompt New Files\n\nEnabling this feature would make\nMENUdo detect new installed NDS \nfiles in your cart in boot ups, and ask you\nwhether to load them.\n\nDisabled");
													  break;
											case 1: WriteTopScreenText(0,"Prompt New Files\n\nEnabling this feature would make\nMENUdo detect new installed NDS \nfiles in your cart in boot ups, and ask you\nwhether to load them.\n\nEnabled");
													  break;
									}	  
									break;
						case 1:	switch(selected.SubMenu)
									{
											case 0: WriteTopScreenText(1,"新文件提示\n\n启用这个功能会在启动的时候自动检测新安装的NDS文件并且询问如何操作。\n\n关闭");
													  break;
											case 1: WriteTopScreenText(1,"新文件提示\n\n启用这个功能会在启动的时候自动检测新安装的NDS文件并且询问如何操作。\n\n开启");
													  break;
									}	  
									break;
					}			
		   		for (x=0;x<=1;x++) 
					if (PA_3DSpriteTouched(58+(2*x)) || PA_3DSpriteTouched(59+(2*x)) || ( Pad.Newpress.Left || Pad.Newpress.Right))
					{
					   if (Pad.Newpress.Left) x=(selected.SubMenu>0)?selected.SubMenu-1:1;
					   if (Pad.Newpress.Right) x=(selected.SubMenu<1)?selected.SubMenu+1:0;
						for(i=58;i<=61;i++)
							PA_3DSetSpriteAlpha(i,15);
					   PA_3DSetSpriteAlpha(58+(2*x)+0,31);
					   PA_3DSetSpriteAlpha(58+(2*x)+1,31);
						Click3DButton(58+(2*x));
//						system.PromptCommands = x;
	
						break;	
					}   
//					selected.SubMenu = system.PromptCommands;
					break;
		case 6:	switch(system.Language)
					{
						case 0:	switch(selected.SubMenu)
									{
											case 0: WriteTopScreenText(0,"blank");
													  break;
											case 1: WriteTopScreenText(0,"blank");
													  break;
									}	  
									break;
					}			
		   		for (x=0;x<=1;x++) 
					if (PA_3DSpriteTouched(62+(2*x)) || PA_3DSpriteTouched(63+(2*x)) || ( Pad.Newpress.Left || Pad.Newpress.Right))
					{
					   if (Pad.Newpress.Left) x=(selected.SubMenu>0)?selected.SubMenu-1:1;
					   if (Pad.Newpress.Right) x=(selected.SubMenu<1)?selected.SubMenu+1:0;
						for(i=62;i<=65;i++)
							PA_3DSetSpriteAlpha(i,15);
					   PA_3DSetSpriteAlpha(62+(2*x)+0,31);
					   PA_3DSetSpriteAlpha(62+(2*x)+1,31);
						Click3DButton(62+(2*x));
						system.InvertScroll = x;
	
						break;	
					}   
					selected.SubMenu = system.InvertScroll;
					break;
	}		
}			
void changeMenuTo(int value)
{
   int i;
	for(i=3;i<=17;i++)
		PA_3DSetSpriteAlpha(i,5);
		
	PA_3DSetSpriteAlpha(3+(2*value),31);
	PA_3DSetSpriteAlpha(4+(2*value),31);
	if (selected.Menu!=value)
	{
	   selected.Menu=value;

	}   
	selected.SubMenu=0;
	for (i=18;i<=65;i++)
	{

		if (i%2==0)
			Click3DButton(i);
		PA_3DSetSpriteAlpha(i,15);
		PA_3DSetSpriteVisible(i,0);		   
	}		
	updateSettings();
}		



void Update16cText()
{
   int i=0;
   switch (system.Language)
	{
				   //English
	   case 0:  PA_16cText(0,35+OPTION_X,PA_3DGetSpriteY(3)-6,200,PA_3DGetSpriteY(3)-6,"Assign Autorun"		,selected.Menu==0?1:8,1,100);
				   PA_16cText(0,35+OPTION_X,PA_3DGetSpriteY(5)-6,200,PA_3DGetSpriteY(5)-6,"Assign Menu"			,selected.Menu==1?1:8,1,100);
				   PA_16cText(0,35+OPTION_X,PA_3DGetSpriteY(7)-6,200,PA_3DGetSpriteY(7)-6,"Language"				,selected.Menu==2?1:8,1,100);
				   PA_16cText(0,35+OPTION_X,PA_3DGetSpriteY(9)-6,200,PA_3DGetSpriteY(9)-6,"Backlight Strength"	,selected.Menu==3?1:8,1,100);
				   PA_16cText(0,35+OPTION_X,PA_3DGetSpriteY(11)-6,200,PA_3DGetSpriteY(11)-6,"Energy Saving"			,selected.Menu==4?1:8,1,100);
				   PA_16cText(0,35+OPTION_X,PA_3DGetSpriteY(13)-6,200,PA_3DGetSpriteY(13)-6,"Prompt New Files"		,selected.Menu==5?1:8,1,100);
				   PA_16cText(0,35+OPTION_X,PA_3DGetSpriteY(15)-6,200,PA_3DGetSpriteY(15)-6,"Invert Y-Scroll"		,selected.Menu==6?1:8,1,100);
				   break;
	}   


		if (selected.Confirm) 
		{
			switch(selected.Menu)
			{
				case 0:	switch(system.Language)
							{
			   				case 0:Create3DButtonText(0,18,selected.SubMenu==0? "Up" :
																	    selected.SubMenu==1? "Down":
																	    selected.SubMenu==2? "Left":
																								    "Right",10);
										 break;
			   				case 1:Create3DButtonText(1,18,selected.SubMenu==0? " 上" :
																	    selected.SubMenu==1? " 下":
																	    selected.SubMenu==2? " 左":
																								    " 右",10);
										 break;
							}		 
		   				PA_3DSetSpriteAlpha(200+(2*selected.SecondSubMenu),31);
							PA_3DSetSpriteAlpha(201+(2*selected.SecondSubMenu),31);	
		   				PA_3DSetSpriteAlpha(18,31);
							PA_3DSetSpriteAlpha(19,31);	
							for (i=20;i<=25;i++)
								PA_3DSetSpriteVisible(i,0);					   
							for(i=200;i<=219;i++)
							{
								if (i%2==0) PA_3DSetSpriteXY(i,PA_3DGetSpriteX(19)+50,PA_3DGetSpriteY(19)+(((i-200)/2)*14));
								if (i%2==1) PA_3DSetSpriteXY(i,PA_3DGetSpriteX(19)+50+44,PA_3DGetSpriteY(19)+(((i-200)/2)*14));
							}			
						   break;
				case 1:	switch(system.Language)
							{
			   				case 0:Create3DButtonText(0,26,selected.SubMenu==0? "0" :
																		 selected.SubMenu==1? "1" :
																		 selected.SubMenu==2? "2" :
																		 selected.SubMenu==3? "3" :
																		 selected.SubMenu==4? "4" :
																		 selected.SubMenu==5? "5" :
																		 selected.SubMenu==6? "6" :
																		 selected.SubMenu==7? "7" :
																		 							 "8" ,10);
											break;
			   				case 1:Create3DButtonText(0,26,selected.SubMenu==0? "0" :
																		 selected.SubMenu==1? "1" :
																		 selected.SubMenu==2? "2" :
																		 selected.SubMenu==3? "3" :
																		 selected.SubMenu==4? "4" :
																		 selected.SubMenu==5? "5" :
																		 selected.SubMenu==6? "6" :
																		 selected.SubMenu==7? "7" :
																		 							 "8" ,10);
											break;
							}			
		   				PA_3DSetSpriteAlpha(200+(2*selected.SecondSubMenu),31);
							PA_3DSetSpriteAlpha(201+(2*selected.SecondSubMenu),31);	
		   				PA_3DSetSpriteAlpha(26,31);
							PA_3DSetSpriteAlpha(27,31);	
							for(i=200;i<=219;i++)
							{
								if (i%2==0) PA_3DSetSpriteXY(i,PA_3DGetSpriteX(27)+50,PA_3DGetSpriteY(27)+(((i-200)/2)*14));
								if (i%2==1) PA_3DSetSpriteXY(i,PA_3DGetSpriteX(27)+50+44,PA_3DGetSpriteY(27)+(((i-200)/2)*14));
							}			
							for (i=28;i<=43;i++)
								PA_3DSetSpriteVisible(i,0);					   
						   break;
			}	
			updateSettingSubMenu();		
		}			
		else
			switch(selected.Menu)
			{
				case 0:	switch(system.Language)
							{
			   				case 0:	Create3DButtonText(0,18,"Up"		,selected.SubMenu==0?10:9);
										   Create3DButtonText(0,20,"Down"	,selected.SubMenu==1?10:9);
										   Create3DButtonText(0,22,"Left"	,selected.SubMenu==2?10:9);
										   Create3DButtonText(0,24,"Right"	,selected.SubMenu==3?10:9);
										   break;
			   				case 1:	Create3DButtonText(1,18," 上"		,selected.SubMenu==0?10:9);
										   Create3DButtonText(1,20," 下"	,selected.SubMenu==1?10:9);
										   Create3DButtonText(1,22," 左"	,selected.SubMenu==2?10:9);
										   Create3DButtonText(1,24," 右"	,selected.SubMenu==3?10:9);
										   break;
							}   
						   
		   				PA_3DSetSpriteAlpha(18+(2*selected.SubMenu),31);
							PA_3DSetSpriteAlpha(19+(2*selected.SubMenu),31);	
							for (i=18;i<=25;i++)
								PA_3DSetSpriteVisible(i,1);					   
						   break;
				case 1:	switch(system.Language)
							{
								case 0:Create3DButtonText(0,26,"0"				,selected.SubMenu==0?10:9);
										Create3DButtonText(0,28,"1"				,selected.SubMenu==1?10:9);
										Create3DButtonText(0,30,"2"				,selected.SubMenu==2?10:9);
										Create3DButtonText(0,32,"3"				,selected.SubMenu==3?10:9);
										Create3DButtonText(0,34,"4"				,selected.SubMenu==4?10:9);
										Create3DButtonText(0,36,"5"				,selected.SubMenu==5?10:9);
										Create3DButtonText(0,38,"6"				,selected.SubMenu==6?10:9);
										Create3DButtonText(0,40,"7"				,selected.SubMenu==7?10:9);
										Create3DButtonText(0,42,"8"				,selected.SubMenu==8?10:9);
										break;
								case 1:Create3DButtonText(0,26,"0"				,selected.SubMenu==0?10:9);
										Create3DButtonText(0,28,"1"				,selected.SubMenu==1?10:9);
										Create3DButtonText(0,30,"2"				,selected.SubMenu==2?10:9);
										Create3DButtonText(0,32,"3"				,selected.SubMenu==3?10:9);
										Create3DButtonText(0,34,"4"				,selected.SubMenu==4?10:9);
										Create3DButtonText(0,36,"5"				,selected.SubMenu==5?10:9);
										Create3DButtonText(0,38,"6"				,selected.SubMenu==6?10:9);
										Create3DButtonText(0,40,"7"				,selected.SubMenu==7?10:9);
										Create3DButtonText(0,42,"8"				,selected.SubMenu==8?10:9);
										break;
							}													
		   				PA_3DSetSpriteAlpha(26+(2*selected.SubMenu),31);
							PA_3DSetSpriteAlpha(27+(2*selected.SubMenu),31);	
							for (i=26;i<=43;i++)
								PA_3DSetSpriteVisible(i,1);					   
						   break;
				case 2:	switch(system.Language)
							{
								case 0:Create3DButtonText(0, 44,"English",10);
										break;
								case 1:Create3DButtonText(1, 44,"      简化字",10);
										break;
							}			
								
//		                Sim16cText(0,35,16 +4,200,30  +4,"??????"			,1,UTF8,0);
//							Create3DButtonText(0,44," ???"	,10);

//???

							

							for (i=44;i<=45;i++)
							{
								PA_3DSetSpriteVisible(i,1);					   
								PA_3DSetSpriteAlpha(i,31);					   
							}			
						   break;
				case 3:	switch(system.Language)
							{
								case 0:Create3DButtonText(0,46,"0"				,system.BacklightStrength==0?10:9);
										Create3DButtonText(0,48,"1"				,system.BacklightStrength==1?10:9);
										Create3DButtonText(0,50,"2"				,system.BacklightStrength==2?10:9);
										Create3DButtonText(0,52,"3"				,system.BacklightStrength==3?10:9);
										break;
								case 1:Create3DButtonText(0,46,"0"				,system.BacklightStrength==0?10:9);
										Create3DButtonText(0,48,"1"				,system.BacklightStrength==1?10:9);
										Create3DButtonText(0,50,"2"				,system.BacklightStrength==2?10:9);
										Create3DButtonText(0,52,"3"				,system.BacklightStrength==3?10:9);
										break;
							}			
		   				PA_3DSetSpriteAlpha(46+(2*system.BacklightStrength),31);
							PA_3DSetSpriteAlpha(47+(2*system.BacklightStrength),31);	
							for (i=46;i<=53;i++)
								PA_3DSetSpriteVisible(i,1);					   
						   break;
				case 4:	switch(system.Language)
							{
								case 0:Create3DButtonText(0,54,"Enable"		,system.EnergySaving==0?10:9);
										 Create3DButtonText(0,56,"Disable"		,system.EnergySaving==1?10:9);
										 break;
								case 1:Create3DButtonText(1,54," 开启"		,system.EnergySaving==0?10:9);
										 Create3DButtonText(1,56," 关闭"		,system.EnergySaving==1?10:9);
										 break;
							}			
		   				PA_3DSetSpriteAlpha(54+(2*system.EnergySaving),31);
							PA_3DSetSpriteAlpha(55+(2*system.EnergySaving),31);	
							for (i=54;i<=57;i++)
								PA_3DSetSpriteVisible(i,1);					   
						   break;
				case 5:	/*switch(system.Language)
							{
								case 0:Create3DButtonText(0,58,"Enable"		,system.PromptCommands==0?10:9);
										Create3DButtonText(0,60,"Disable"		,system.PromptCommands==1?10:9);
										break;
								case 1:Create3DButtonText(1,58," 开启"		,system.PromptCommands==0?10:9);
										Create3DButtonText(1,60," 关闭"		,system.PromptCommands==1?10:9);
										break;
							}
		   				PA_3DSetSpriteAlpha(58+(2*system.PromptCommands),31);
							PA_3DSetSpriteAlpha(59+(2*system.PromptCommands),31);	
							for (i=58;i<=61;i++)
								PA_3DSetSpriteVisible(i,1);					   */
						   break;
				case 6:	switch(system.Language)
							{
								case 0:Create3DButtonText(0,62,"Enable"		,system.InvertScroll==0?10:9);
										Create3DButtonText(0,64,"Disable"		,system.InvertScroll==1?10:9);
										break;
								case 1:Create3DButtonText(1,62," 开启"		,system.InvertScroll==0?10:9);
										Create3DButtonText(1,64," 关闭"		,system.InvertScroll==1?10:9);
										break;
							}
		   				PA_3DSetSpriteAlpha(62+(2*system.InvertScroll),31);
							PA_3DSetSpriteAlpha(63+(2*system.InvertScroll),31);	
							for (i=62;i<=65;i++)
								PA_3DSetSpriteVisible(i,1);					   
						   break;
			}   
}		

void loadmSettingsGui(u8 language){

  	edgeButtonTex = CreateTexFromThemeResource("settings/optionButton_Edge.bmp",6,1); //PA_3DCreateTex((void*)edgeButton_Texture, 8, 16, TEX_16COL);	

	edgeRectangleTex = CreateTexFromThemeResource("settings/categoryButton_Edge.bmp",5,1); //PA_3DCreateTex((void*)edgeRectangle_Texture, 8, 16, TEX_4COL);	


	PA_3DCreateSpriteFromTex(3,edgeRectangleTex,64,16, 5,32+32+OPTION_X,29+OPTION_Y);
	PA_3DCreateSpriteFromTex(4,edgeRectangleTex,8,16, 5,100+OPTION_X,29+OPTION_Y);
	PA_3DSetSpriteHflip(4,1);

	PA_3DCreateSpriteFromTex(5,edgeRectangleTex,50,16, 5,32+25+OPTION_X,62+OPTION_Y);
	PA_3DCreateSpriteFromTex(6,edgeRectangleTex,8,16, 5,86+OPTION_X,62+OPTION_Y);
	PA_3DSetSpriteHflip(6,1);

	PA_3DCreateSpriteFromTex(7,edgeRectangleTex,40,16, 5,32+20+OPTION_X,91+OPTION_Y);
	PA_3DCreateSpriteFromTex(8,edgeRectangleTex,8,16, 5,76+OPTION_X,91+OPTION_Y);
	PA_3DSetSpriteHflip(8,1);
	
	PA_3DCreateSpriteFromTex(9,edgeRectangleTex,78,16, 5,64+7+OPTION_X,114+OPTION_Y);
	PA_3DCreateSpriteFromTex(10,edgeRectangleTex,8,16,  5,114+OPTION_X,114+OPTION_Y);
	PA_3DSetSpriteHflip(10,1);
	
	PA_3DCreateSpriteFromTex(11,edgeRectangleTex,56,16, 5,32+28+OPTION_X,137+OPTION_Y);
	PA_3DCreateSpriteFromTex(12,edgeRectangleTex,8,16,  5,92+OPTION_X,137+OPTION_Y);
	PA_3DSetSpriteHflip(12,1);

	PA_3DCreateSpriteFromTex(13,edgeRectangleTex,70,16, 5,32+35+OPTION_X,160+OPTION_Y);
	PA_3DCreateSpriteFromTex(14,edgeRectangleTex,8,16,  5,106+OPTION_X,160+OPTION_Y);
	PA_3DSetSpriteHflip(14,1);

	PA_3DCreateSpriteFromTex(15,edgeRectangleTex,60,16, 5,32+30+OPTION_X,183+OPTION_Y);
	PA_3DCreateSpriteFromTex(16,edgeRectangleTex,8,16,  5,96+OPTION_X,183+OPTION_Y);
	PA_3DSetSpriteHflip(16,1);	
		


	//init [submenu] for assign autorun 
	int i=0;

	for (i=0;i<4;i++)
		Create3DButton(18+(i*2),PA_3DGetSpriteX(4)+20+(40*(i/2)),PA_3DGetSpriteY(4)+1+((i%2)*16),28);

	//init [submenu] for assign menu 
	for (i=0;i<9;i++)
		Create3DButton(26+(i*2),PA_3DGetSpriteX(6)+20+(30*(i/2)),PA_3DGetSpriteY(6)+1+((i%2)*16),20);

	//init [submenu] for Rom Loader
	Create3DButton(44,PA_3DGetSpriteX(8)+20,91+1	+OPTION_Y,100);

	//init [submenu] for Backlight Strength 
	for (i=0;i<4;i++)
		Create3DButton(46+(i*2),PA_3DGetSpriteX(10)+20+(30*i),PA_3DGetSpriteY(10)+1,22);

	//init [submenu] for Energy Saving
	for (i=0;i<2;i++)
		Create3DButton(54+(i*2),PA_3DGetSpriteX(12)+20+(50*i),PA_3DGetSpriteY(12)+1,40);
	
	//init [submenu] for Force Settings
	for (i=0;i<2;i++)
		Create3DButton(58+(i*2),PA_3DGetSpriteX(14)+20+(50*i),PA_3DGetSpriteY(14)+1,40);

	for (i=0;i<2;i++)
		Create3DButton(62+(i*2),PA_3DGetSpriteX(16)+20+(50*i),PA_3DGetSpriteY(16)+1,40);
		
	for(i=3;i<=16;i++)
		PA_3DSetSpriteAlpha(i,5);

	for (i=18;i<=65;i++)
	{
	   PA_3DSetSpriteAlpha(i,15);
		PA_3DSetSpriteVisible(i,0);		  
	}		
	for (i=0;i<10;i++)
		Create3DButton(200+(i*2),PA_3DGetSpriteX(18),PA_3DGetSpriteY(18)+(i*16),80);
	for (i=200;i<=219;i++)
	{
	   PA_3DSetSpriteAlpha(i,15);
		PA_3DSetSpriteVisible(i,0);		  
	}	
	PA_3DSetSpriteAlpha(3,31);
	PA_3DSetSpriteAlpha(4,31);
	PA_3DSetSpriteAlpha(18,31);
	PA_3DSetSpriteAlpha(19,31);
   
}   
void loadThemeResource()
{
   char* path = returnThemeResourcePath("settings/TopScreen.jpg", 1);
   FILE* jpegFile = fopen(path,"rb");
	loadFatBgJpeg(1, jpegFile);
	fclose(jpegFile);
	free(path);
	path = returnThemeResourcePath("settings/settings.ini", 1);
	readINI = fopen (path, "rb"); 
	textBoxTopScreen_Black = (bool)readIniFileInt("TopScreen_TextColor_Black");
	initAntiAliasedText(1,1,textBoxTopScreen_Black);
	textBoxTopScreen_X1 = readIniFileInt("TopScreen_TextBox_X1");
	textBoxTopScreen_Y1 = readIniFileInt("TopScreen_TextBox_Y1");
	textBoxTopScreen_X2 = readIniFileInt("TopScreen_TextBox_X2");
	textBoxTopScreen_Y2 = readIniFileInt("TopScreen_TextBox_Y2");
	fclose(readINI);
	free(path);

	initClock("settings",0, 1);
	create3dBackgroundLayer(2,0,0,0);
//	PA_3DCreateSpriteFromTex(2,CreateTexFromFatBmp(returnString("fat:/_menudo/themes/%s/settings/backgroundColor.bmp",CurrentTheme),3,1),256,256,3,256/2,192/2);
	PA_3DSetSpritePrio(2,0);
	initAmbienceFromTheme("Settings",500);
	if (textScreenColorIsBlack(1)==0) setAntiAliasDepth(1, 8);	
}

bool menuSettings(char* text)
{
	PA_Init3D();	
	PA_Reset3DSprites();
   int i;
   if (!system.iniLoaded)
   {
		LoadCurrentConfig();
	}	
	if (selected.Confirm) 
	{
		selected.Confirm=0;
		selected.ClickTime=0;
		for(i=200;i<=219;i++)
			PA_3DSetSpriteVisible(i,0);		

		switch (selected.Menu)								
		{
			case 0:	for(i=18;i<=25;i++)
						{
							PA_3DSetSpriteAlpha(i,15);
							PA_3DSetSpriteVisible(i,1);		
							if (i%2==0) Click3DButton(i);
						}
						sprintf(system.startup[selected.SubMenu],"%s",text);
						break;			
			case 1:	for(i=26;i<=43;i++)
						{
							PA_3DSetSpriteAlpha(i,15);
							PA_3DSetSpriteVisible(i,1);		
							if (i%2==0) Click3DButton(i);
						}			
						sprintf(system.menuRuns[selected.SubMenu],"%s",text);
						break;
		}			

	}		
	 // Uses Bg0, Init 3D...
	PA_Reset3DSprites(); // Init or Reset 3D Sprites


//	FontInit(&fontMing9C,Ming9c_bin);
	PA_Init16cBg(0,1);
	PA_SetBgPrio(0,0,1);
	PA_SetBgPrio(0,1,0);						
	PA_Init16bitBg(1,0);
	PA_Init16cBg(1,1);
	PA_SetBgPrio(1,0,1);
	PA_SetBgPrio(1,1,0);						
	loadThemeResource();
	

	selected.Menu=0;
	selected.SubMenu=0;


//	u16 tempTex = ; // PA_3DCreateTex((void*)settingsBackground_Texture, 8, 8, TEX_4COL);	


	loadmSettingsGui(system.Language);
   logMessage("\nsettings5");

   switch (system.Language)
	{
	   case 0:  WriteTopScreenText(0,"System Settings\n\nPersonalize your menu. You can assign what nds file or feature a selected menu would run. You can also disable or activate a number of features available here. Note: This section is in progress.");
	   			break;
	   case 1:  WriteTopScreenText(1,"系统设置\n自定义你的菜单。\n你也可以自定义按键事件。\n你可以打开或者关闭一个特性。\n\n\n注意：这个特性还在制作过程中");
	   			break;
   }
 
	int x;
	initThemeTransition("settings",1);

	while(1) 
	{
      PA_16cErase(0);
		Update3DButtonsAnimation();		
		Update16cText();
		updateScreenTransition();
		if (Pad.Newpress.L)
		{
			shrinkMenu("settings","TopScreen.jpg",0,0);
		   PA_TextLineSpacing(-2);
			updateSettings();
			initAntiAliasedText(1,1,textBoxTopScreen_Black);
			if (textScreenColorIsBlack(1)==0) setAntiAliasDepth(1, 8);	
			PA_Init16cBg(0,1);
			PA_SetBgPrio(0,0,1);
			PA_SetBgPrio(0,1,0);						
			PA_EnableSpecialFx(0, SFX_NONE, SFX_BG1 , SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
		}   

		updateClock(0, 1,1);
		if (!Stylus.Held && selected.JustConfirmed)selected.JustConfirmed=0;
		if (Stylus.Held || Pad.Newpress.A || Pad.Newpress.Left || Pad.Newpress.Right)
		{
		   updateSettings();
		   if (selected.Confirm)
		   {
				while(selected.Confirm)
				{
				   PA_16cErase(0);
					Update3DButtonsAnimation();		
					Update16cText();
					transiteScreenBrightness(1,0);
					transiteScreenBrightness(0,0);
					updateClock(0, 6,1);
					if (!Stylus.Held && selected.JustConfirmed)selected.JustConfirmed=0;
					if (Stylus.Held || (Pad.Newpress.B || Pad.Newpress.A || Pad.Newpress.Up || Pad.Newpress.Down))updateSettingSubmenu();
				   updateAmbience();
				   if (selected.ClickTime > 0)selected.ClickTime--;
					Soul_waitForVBL();
					transiteScreenAnd3DProcess();
				}		
				continue;
			}			

		}
		if (!selected.Confirm)
		{
			//Change selected menu thru stylus but only when action [second sub] menu is not active
			if (Stylus.Held)
			{
				for (x=0;x<=6;x++) 
					if ((PA_3DSpriteTouched(3+(2*x)) || PA_3DSpriteTouched(4+(2*x)))&& pa_3dsprites[4+(2*x)].alpha == 5)
					{
					   changeMenuTo(x);
					   break;
					}   
			}			
			//Change selected menu thru D-Pad but only when action [second sub] menu is not active

			if (Pad.Newpress.Up && selected.Menu>0) changeMenuTo(selected.Menu-1);
			if (Pad.Newpress.Down && selected.Menu<6) changeMenuTo(selected.Menu+1);
		}			
		
		
		
	   if (Pad.Newpress.B && !selected.Confirm)
		{
		   SaveCurrentConfig();
			initThemeTransition("settings", 0);
		   while (isScreenTransiting())
			{
				updateScreenTransition();
				updateAmbience();
				Soul_waitForVBL();
	     	}		
		   break;
		}



	   updateAmbience();
	   if (selected.ClickTime > 0)selected.ClickTime--;
		Soul_waitForVBL();
		transiteScreenAnd3DProcess();
		
	}

return 0;
	
} // End of main()


