#include <PA9.h>       // Include for PA_Lib
#include <fat.h>
#include <sys/dir.h>


const unsigned short black_arialAA12_Pal[16] __attribute__ ((aligned (4)));

extern char assignList[30][30];
extern int assignSelected;
extern char assignSelectedSkip;
extern bool assignNavigate;
extern int assignAmount;



	
void resetList();
void addList(char* text, ...) ;
void setList ( int amount, ...);



void noThemeMenu_menudoCmds()
{
	setList(8,"Navigate Dir"
				,"Run Gba Slot"
				,"mShortcut"
				,"mExplorer"
				,"mPulutan"
				,"mPlayer"
				,"mNote"
				,"User Settings"
				,"Power Off");
}			
void noThemeMenu_Update16c()
{
   PA_16cErase(0);
	int i;
	for(i=0;i<=10;i++)
	{
		if (i==(assignAmount-assignSelectedSkip)) 
		{
		   break;
		}   
		if (i==(assignSelected-assignSelectedSkip))
			PA_16cText(0,7,10+(15*i),240,10+(15*i),assignList[i+assignSelectedSkip],8,1,100);
			else
			PA_16cText(0,7,10+(15*i),240,10+(15*i),assignList[i+assignSelectedSkip],4,1,100);
	}		
	if (i<=10) 
	{
		if (i==(assignSelected-assignSelectedSkip))
		PA_16cText(0,7,10+(15*i),240,10+(15*i),"Cancel",8,1,100);
		else
		PA_16cText(0,7,10+(15*i),240,10+(15*i),"Cancel",4,1,100);
	}			
}   
void noThemeMenu_ListDirNDS()
{
	struct stat st;
	static char filename[256]; 
	resetList();
	DIR_ITER* dirroot = diropen("fat:/");

	while (dirnext(dirroot, filename, &st) == 0) 
	{
		if (st.st_mode & S_IFDIR && !PA_CompareText(filename,".") && filename[0] != '_') 
		{
         addList(filename);
		}   
	}
	dirclose(dirroot);
}   
void display_noThemeMenu(char* toLOAD3)
{
	PA_SetBgPrio(0,0,1);
	PA_SetBgPrio(0,1,0);

	noThemeMenu_menudoCmds();
	PA_LoadPal16c(PAL_BG0, black_arialAA12_Pal);


//	PA_SetSFXAlpha(0, 31, 15);


	
	noThemeMenu_Update16c();
	bool navigateDirMenu=0;

	while (1)
	{
		if (Pad.Newpress.Down)
		{
		   if (assignSelected==assignAmount)
		   {
				assignSelected=0;
			   if (assignAmount>10) 
				{
				   assignSelectedSkip=0;
					noThemeMenu_Update16c();
				}			
			}   
		   else
		   assignSelected++;
			noThemeMenu_Update16c();
		}   
		if (Pad.Newpress.Up)
		{
		   if (assignSelected==0)
		   {
				assignSelected=assignAmount;
			   if (assignAmount>10) 
				{
				   assignSelectedSkip=assignAmount-10;
					noThemeMenu_Update16c();
				}			
			}   
		   else
			   assignSelected--;
	   	noThemeMenu_Update16c();
		}   
		if (navigateDirMenu)
		{
			if (Pad.Newpress.A && assignSelected<assignAmount)
			{
			   sprintf(toLOAD3,"%s",assignList[assignSelected]);
			   return;
			}   
			if (Pad.Newpress.B || (Pad.Newpress.A && assignSelected==assignAmount))
			{
			   navigateDirMenu=0;
				noThemeMenu_menudoCmds();
				noThemeMenu_Update16c();
			}   
		}
		else   
		{
			if (Pad.Newpress.A)
			{
				switch (assignSelected)
				{
				  	case 0: 	navigateDirMenu=1;
							   noThemeMenu_ListDirNDS();
								noThemeMenu_Update16c();
								break;
					case 1:	sprintf(toLOAD3,"gba");
								break;
					case 2:	sprintf(toLOAD3,"mShortcut");
								break;
					case 3:	sprintf(toLOAD3,"mExplore");
								break;
					case 4:	sprintf(toLOAD3,"mPlayer");
								break;
					case 5:	sprintf(toLOAD3,"mNote");
								break;
					case 6:	sprintf(toLOAD3,"mSettings");
								break;
					case 7:	sprintf(toLOAD3,"power");
								break;
				}			
												
			   if (!(assignSelected == 0 || assignSelected == 9))return;
			}			
			
		}			


		ZoomXY_3DProcess(128,0,0);  

		Soul_waitForVBL();

	}
   
}   
