#ifdef __cplusplus
extern "C" {
#endif

#include <PA9.h>
#include "bmp3DSprite.h"
#include "bmpTex.h"
#include "bmpFatTex.h"
#include "..\..\misc\debug.h"

/*
FIX Needed: find another way other than us
*/
unsigned short bmp_256Pal[256] __attribute__ ((aligned (4))); // temp pal from file
//unsigned short bmp_4Pal[4] __attribute__ ((aligned (4)));
						//512*256 

//unsigned char *bmp_tex = NULL;
unsigned char bmp_tex[1024*512] __attribute__ ((aligned (4)));	//512x512 texture for the Gif.
		unsigned char alpha_line[1024] __attribute__ ((aligned (4)));

unsigned char bmp_256Alpha[256] __attribute__ ((aligned (4)));
int bmp_height;
int bmp_width;	
//u16 colors;
int temp=0; 
int temp1=0; 

u16 zero = 0;



int getRecentBmpWidth() { return bmp_width; }
int getRecentBmpHeight(){ return bmp_height; }   
void Soul_Load3DSpritePal(u16 palette_number, void* palette,int colors);
u16 CreateTexFromBmpWithAlpha(void *bmp, u8 pal , void *bmpAlpha)
{
   int i;
	u8 *tempbmp = (u8*)bmp;
	BMPHeader0 *Bmpinfo0 = (BMPHeader0 *) (tempbmp);
	BMP_Headers *Bmpinfo = (BMP_Headers*)(tempbmp+14);
	

	

  
	u8 *gfx = tempbmp+(Bmpinfo0->ImageStart1 + ((Bmpinfo0->ImageStart2)<<16));

	bmp_width = Bmpinfo->Width; 
	bmp_height = Bmpinfo->Height;
	debugTxt("allocating memory");

	if (Bmpinfo->BitsperPixel > 8) return 0;
	
	u8 *colormap = tempbmp+14+Bmpinfo->SizeofHeader;

	//malloc bmp_tex to memory. if bmp_tex is empty free it, to avoid memory leak
	


		
debugTxt("clearing memory");		
		DMA_Force(zero, bmp_tex, (bmp_width*bmp_height)>>1, DMA_16NOW); // Blank out
		DMA_Force(zero, bmp_256Pal, (256)>>1, DMA_16NOW); // Blank out

		int magenta=0; 
    	u16 colors = Bmpinfo->ImportantColors;
    	bool colorIsA3I5;

		i = 0;
debugTxt("retrieving pal");
		for(temp=0; temp<colors; temp++)
		{
			bmp_256Pal[temp]= PA_RGB(((colormap[(temp<<2)+2])>>3)&31, ((colormap[(temp<<2)+1])>>3)&31, ((colormap[(temp<<2)+0])>>3)&31);
			if(bmp_256Pal[temp]==PA_RGB(31,0,31))
			{
			   magenta=temp;
			   bmp_256Pal[temp]=bmp_256Pal[0];
			}   
		}   

//		flushToMemory();	
debugTxt("computing pal");
		if (magenta==0)
		{
			for(temp=0; temp<colors; temp++)
				bmp_256Pal[temp+1]=  PA_RGB(((colormap[(temp<<2)+2])>>3)&31, ((colormap[(temp<<2)+1])>>3)&31, ((colormap[(temp<<2)+0])>>3)&31);
			bmpToTexAlpha(gfx,bmp_tex,colors,0);
		}			
		else
		{
		   colors--;   
			bmpToTexAlpha(gfx,bmp_tex,colors,magenta);

		}   
    	if (colors<8)
	    	colorIsA3I5=0;
    	else
	    	colorIsA3I5=1;

		tempbmp = (u8*)bmpAlpha;
		Bmpinfo0 = (BMPHeader0 *) (tempbmp);
		Bmpinfo = (BMP_Headers*)(tempbmp+14);
		
	  
		gfx = tempbmp+(Bmpinfo0->ImageStart1 + ((Bmpinfo0->ImageStart2)<<16));


		colormap = tempbmp+14+Bmpinfo->SizeofHeader;

		u32 bmp_width2  = Bmpinfo->Width;
		u32 bmp_height2 = Bmpinfo->Height;
		DMA_Force(zero, bmp_256Alpha, (256)>>1, DMA_16NOW); // Blank out

	 	u8 alphacolors = Bmpinfo->ImportantColors;
	
		int greycolor=0;			
		i=0;
//		flushToMemory();	
		if (Bmpinfo->BitsperPixel > 8) return 0;
		if (bmp_width  != bmp_width2) return 0; 	//BMP alpha and texture are not the same
		if (bmp_height != bmp_height2) return 0; 
		for(temp=0; temp<alphacolors; temp++)
		{
		   greycolor =(((colormap[(temp<<2)+2]>>3)&31) + ((colormap[(temp<<2)+1]>>3)&31) + ((colormap[(temp<<2)+0]>>3)&31))/3;
			bmp_256Alpha[temp+1]=  PA_RGB(greycolor, greycolor, greycolor);
		}			
debugTxt("allocating texture");
		if (colorIsA3I5)	
		{
			for(temp=bmp_height-1; temp>=0; temp--)
			{
				for(temp1=0; temp1<bmp_width; temp1++)
				{
					if (bmp_tex[i]!=0) 
					bmp_tex[i] += (bmp_256Alpha[gfx[(temp*bmp_width)+temp1]+1]>>2)<<5; //7 - no alpha 0- not visible anymore
				  	i++;
				}		
			}
		}			
		else
		{
			for(temp=bmp_height-1; temp>=0; temp--)
			{
				for(temp1=0; temp1<bmp_width; temp1++)
				{
					if (bmp_tex[i]!=0) 
					bmp_tex[i] += (bmp_256Alpha[gfx[(temp*bmp_width)+temp1]+1])<<3; //31 max
				  	i++;
				}		
			}
		}			
//		flushToMemory();// flushToMemory(); //ZoomXY_3DProcess(128,0,0);  		
		Soul_Load3DSpritePal(pal, (void*)bmp_256Pal,colors); 
		u16 result;
		if (colorIsA3I5)
			result = PA_3DCreateTex((void*)bmp_tex,	nearestTexDimension(bmp_width),nearestTexDimension(bmp_height), TEX_A3I5);
		else
			result = PA_3DCreateTex((void*)bmp_tex,	nearestTexDimension(bmp_width),nearestTexDimension(bmp_height), TEX_A5I3);

		
return result;
}
u16 MaskTexWithBmpAlpha(unsigned char *texture,void *bmpAlpha, int texwidth, int texheight, int texType)
{
   int i;
	if (!(texType== TEX_A3I5 || texType== TEX_A5I3)) {return 0;}
	u8 *tempbmp = (u8*)bmpAlpha;
	BMPHeader0 *Bmpinfo0 = (BMPHeader0 *) (tempbmp);
	BMP_Headers *Bmpinfo = (BMP_Headers*)(tempbmp+14);
	
  
	u8 *gfx = tempbmp+(Bmpinfo0->ImageStart1 + ((Bmpinfo0->ImageStart2)<<16));


	u8 *colormap = tempbmp+14+Bmpinfo->SizeofHeader;

	u32 bmp_width2  = Bmpinfo->Width;
	u32 bmp_height2 = Bmpinfo->Height;
	DMA_Force(zero, bmp_256Alpha, (256)>>1, DMA_16NOW); // Blank out

 	u8 alphacolors = Bmpinfo->ImportantColors;

	int greycolor=0;			
	i=0;
	flushToMemory();	
	if (Bmpinfo->BitsperPixel > 8) return 0;
	if (texwidth  != bmp_width2) return 0;
	if (texheight != bmp_height2)return 0;
	for(temp=0; temp<alphacolors; temp++)
	{
	   greycolor =(((colormap[(temp<<2)+2]>>3)&31) + ((colormap[(temp<<2)+1]>>3)&31) + ((colormap[(temp<<2)+0]>>3)&31))/3;
		bmp_256Alpha[temp+1]=  PA_RGB(greycolor, greycolor, greycolor);
	}			
	if (texType== TEX_A3I5)	
	{
		for(temp=texheight-1; temp>=0; temp--)
		{
			for(temp1=0; temp1<texwidth; temp1++)
			{
				if (texture[i]!=0) 
				texture[i] += (bmp_256Alpha[gfx[(temp*texwidth)+temp1]+1]>>2)<<5; //7 - no alpha 0- not visible anymore
			  	i++;
			}		
		}
	}			
	else
	{
		for(temp=texheight-1; temp>=0; temp--)
		{
			for(temp1=0; temp1<texwidth; temp1++)
			{
				if (texture[i]!=0) 
				texture[i] += (bmp_256Alpha[gfx[(temp*texwidth)+temp1]+1])<<3; //31 max
			  	i++;
			}		
		}
	}			
	return 1;
}
s16 MaskTexWithFatBmpAlphaFILE(FILE* handle, unsigned char *texture, int texwidth, int texheight, int texType)
{
	   int i;
	   
		if (!(texType== TEX_A3I5 || texType== TEX_A5I3)) 
		{
		   ShowDialogBox(1,0,1,"Selected Texture is not compatible \n%d",texType);
		   return 0;
		}   

	   if (!handle) return 0;

		fseek(handle, 18, SEEK_SET);
		u32 bmp_width2; u32 bmp_height2;
		fread(&bmp_width2, 4, 1, handle);	
		fseek(handle, 22, SEEK_SET);
		fread(&bmp_height2, 4, 1, handle);	
		if (texwidth  != bmp_width2)  
		{
		   ShowDialogBox(1,0,1,"Mask Texture \nSize is not %d x %d", texwidth,texheight);
		   return 0;
		}   
		if (texheight != bmp_height2) 
		{
		   ShowDialogBox(1,0,1,"Mask Texture \nSize is not %d x %d", texwidth,texheight);
		   return 0;
		}   
		
		u16 bit;
		fseek(handle, 28, SEEK_SET);
		fread(&bit, 2, 1, handle);	
		//bit=8;
	 	u8 alphacolors;
		fseek(handle, 50, SEEK_SET);
		fread(&alphacolors, 4, 1, handle);	
//		flushToMemory();flushToMemory();flushToMemory();
		if (bit >8)
		{
		   ShowDialogBox(1,0,1,"Mask Texture , is using %d bit \n instead of 256 color / 8bit bmp", bit); 			//return 0 if bitmap is not 256color
		   return 0;
		}   
		DMA_Force(zero, bmp_256Alpha, (256)>>1, DMA_16NOW); // Blank out		
		DMA_Force(zero, alpha_line, (1024)>>1, DMA_16NOW); // Blank out		

		int greycolor=0;			
		fseek(handle, 54, SEEK_SET);
		unsigned char col[4];
		for(temp=0; temp<alphacolors; temp++)
		{
			fread(col, sizeof(char), 4, handle);	   
		   greycolor =(((col[2]>>3)&31) + ((col[1]>>3)&31) + ((col[0]>>3)&31))*.3;
			bmp_256Alpha[temp+1]=  greycolor;
		}   

	   i=0;
	   fseek(handle, 10, SEEK_SET); //Seek offset bitmap
	   fread(&i,1,4,handle);
	   //i++;
	   fseek(handle, i, SEEK_SET); //start of bmp / end of pal 
	   i=0;
   
		


		if (texType== TEX_A3I5)	
		{
			for(temp=texheight-1; temp>=0; temp--)
			{
			   i=(temp*texwidth)	;
				fread(&alpha_line, 1, texwidth, handle); 
				for(temp1=0; temp1<texwidth; temp1++)		
				{
					if (texture[i]!=0) 
					texture[i] += (bmp_256Alpha[alpha_line[temp1]+1]>>2)<<5; //7 - no alpha 0- not visible anymore
				  	i++;

				}		
			}
		}			
		else
		{

			for(temp=texheight-1; temp>=0; temp--)
			{
			   i=(temp*texwidth);
				fread(&alpha_line, 1, texwidth, handle); 
				for(temp1=0; temp1<texwidth; temp1++)		
				{
					if (texture[i] !=0) texture[i] += (bmp_256Alpha[alpha_line[temp1]+1])<<3; //31 max
				  	i++;
				}		
			}
			
		}			
	//ShowDialogBox(1,0,1,"BUMP"); 
	return 1;
}
s16 MaskTexWithFatBmpAlpha(unsigned char *texture,char *bmpAlpha, int texwidth, int texheight, int texType)
{
   FILE* handle = fopen(bmpAlpha, "rb");
   int i= MaskTexWithFatBmpAlphaFILE(handle, texture, texwidth, texheight, texType);
   fclose(handle);
   return i;
}

//Need fix?
u16 CreateTexFromBmp(void *bmp , u8 pal)
{
	int i;	

	u8 *tempbmp = (u8*)bmp;

	BMPHeader0 *Bmpinfo0 = (BMPHeader0 *) (tempbmp);
	BMP_Headers *Bmpinfo = (BMP_Headers*)(tempbmp+14);
	debugTxt("reading headers");
	u8 *gfx = tempbmp+(Bmpinfo0->ImageStart1 + ((Bmpinfo0->ImageStart2)<<16));

	//malloc bmp_tex to memory. if bmp_tex is empty free it, to avoid memory leak
	
	debugTxt("allocating");
	bmp_width = Bmpinfo->Width; 
	bmp_height = Bmpinfo->Height;

//	if (Bmpinfo->BitsperPixel > 8) return 0;
	debugTxt("dmaforce");
	u8 *colormap = tempbmp+14+Bmpinfo->SizeofHeader;

	DMA_Force(zero, bmp_tex, (nearestTexDimension(bmp_width)*nearestTexDimension(bmp_height))>>1, DMA_16NOW); // Blank out
	DMA_Force(zero, bmp_256Pal, (256)>>1, DMA_16NOW); // Blank out
	debugTxt("dmaforce");
	int magenta=0; 
 	u16 colors = Bmpinfo->ImportantColors;
	i = 0;

	for(temp=0; temp<colors; temp++)
	{
		bmp_256Pal[temp]= PA_RGB(((colormap[(temp<<2)+2])>>3)&31, ((colormap[(temp<<2)+1])>>3)&31, ((colormap[(temp<<2)+0])>>3)&31);
		if(bmp_256Pal[temp]==PA_RGB(31,0,31))
		{
		   magenta=temp;
		   bmp_256Pal[temp]=bmp_256Pal[0];
		}   
	}   
	debugTxt("loading pal");
	if (magenta==0)
	{
		for(temp=0; temp<colors; temp++)
			bmp_256Pal[temp+1]=  PA_RGB(((colormap[(temp<<2)+2])>>3)&31, ((colormap[(temp<<2)+1])>>3)&31, ((colormap[(temp<<2)+0])>>3)&31);
		bmpToTex(gfx,bmp_tex,colors,0);
	}			
	else
	{
	   colors--;   
		bmpToTex(gfx,bmp_tex,colors,magenta);
	}   
	debugTxt("loading tex");
		
	debugTxt("vbl");
	Soul_Load3DSpritePal(pal, (void*)bmp_256Pal,colors); 
	debugTxt("pal");
	u16 result = PA_3DCreateTex((void*)bmp_tex,	nearestTexDimension(bmp_width),nearestTexDimension(bmp_height), getColorTexType(colors));
	debugTxt("creating texture");
	
	return result;
}
#include "../../commands/game_select/game_select_struct.h"
u16 CreateTexFromFatBmpWithAlpha2(char * filename , u8 pal, char * alphafilename, bool gameselectDefaultIcon)
{
	initDebugTxt();
   debugTxt("CreateTexFromFatBmpWithAlpha");
   debugTxt(filename);
   debugTxt(alphafilename);
   int i;
   FILE *handle = fopen(filename, "rb");
   if (handle)
	{

		fseek(handle, 18, SEEK_SET);
		fread(&bmp_width, 4, 1, handle);	
		fseek(handle, 22, SEEK_SET);
		fread(&bmp_height, 4, 1, handle);	
		
		u16 bit;	
		fseek(handle, 28, SEEK_SET);
		fread(&bit, 2, 1, handle);	
		
		u16 colors;
		fseek(handle, 50, SEEK_SET);
		fread(&colors, 4, 1, handle);	
	   debugTxt("Reading Header");

		if (bit >8) return 0; 			//return 0 if bitmap is not 256color
		//malloc bmp_tex to memory. if bmp_tex is empty free it, to avoid memory leak

	DMA_Force(zero, bmp_tex, (nearestTexDimension(bmp_width)*nearestTexDimension(bmp_height))>>1, DMA_16NOW); // Blank out
	DMA_Force(zero, bmp_256Pal, (256)>>1, DMA_16NOW); // Blank out
		
		fseek(handle, 54, SEEK_SET); // 54 is start of palette
		unsigned char col[4];
		int magenta=0;
    	bool colorIsA3I5;
		for(temp=0; temp<256; temp++)
		{
			fread(col, sizeof(char), 4, handle);	   
			bmp_256Pal[temp]= PA_RGB(col[2]>>3,col[1]>>3,col[0]>>3);
			if(bmp_256Pal[temp]==PA_RGB(31,0,31))
			{
			   magenta=temp;
			   bmp_256Pal[temp]=bmp_256Pal[0];
			}   
		}   
		if (magenta==0)
		{
		   fseek(handle, 54, SEEK_SET);
			for(temp=0; temp<colors; temp++)
			{
				fread(col, sizeof(char), 4, handle);	   
				bmp_256Pal[temp+1]= PA_RGB(col[2]>>3,col[1]>>3,col[0]>>3);
			}   

			bmpFatToTexAlpha(handle,bmp_tex,colors,0);
		}			
		else
		{
		   colors--;   
			bmpFatToTexAlpha(handle,bmp_tex,colors,magenta);
		}   
		fclose(handle);
    	if (colors<8)
	    	colorIsA3I5=0;
    	else
	    	colorIsA3I5=1;
//		bmpFatTo_A5I3Tex

	   handle = fopen(alphafilename, "rb");
	   if (!handle) return 0; //no file found

		fseek(handle, 18, SEEK_SET);
		u32 bmp_width2; u32 bmp_height2;
		fread(&bmp_width2, 4, 1, handle);	
		fseek(handle, 22, SEEK_SET);
		fread(&bmp_height2, 4, 1, handle);	
		if (bmp_width  != bmp_width2) return 0; 	//BMP alpha and texture are not the same
		if (bmp_height != bmp_height2) return 0; 
		
		fseek(handle, 28, SEEK_SET);
		fread(&bit, 2, 1, handle);	
	 	u8 alphacolors;
		fseek(handle, 50, SEEK_SET);
		fread(&alphacolors, 4, 1, handle);	
		
		if (bit >8) return 0; 			//return 0 if bitmap is not 256color
		DMA_Force(zero, bmp_256Alpha, (256)>>1, DMA_16NOW); // Blank out		
		DMA_Force(zero, alpha_line, (1024)>>1, DMA_16NOW); // Blank out		
		int greycolor=0;			
		fseek(handle, 54, SEEK_SET);
		for(temp=0; temp<alphacolors; temp++)
		{
			fread(col, sizeof(char), 4, handle);	   
		   greycolor =(((col[2]>>3)&31) + ((col[1]>>3)&31) + ((col[0]>>3)&31))/3;
			bmp_256Alpha[temp+1]=  greycolor;
		}   

	   i=0;
	   fseek(handle, 10, SEEK_SET); //Seek offset bitmap
	   fread(&i,1,4,handle);
	   fseek(handle, i, SEEK_SET); //start of bmp / end of pal 
	   i=0;
   


		if (colorIsA3I5)	
		{
			for(temp=bmp_height-1; temp>=0; temp--)
			{
			   i=(temp*bmp_width);
				fread(&alpha_line, 1, bmp_width, handle); 
				for(temp1=0; temp1<bmp_width; temp1++)
				{
					if (bmp_tex[i]!=0) 
					bmp_tex[i] += (bmp_256Alpha[alpha_line[temp1]+1]>>2)<<5; //7 - no alpha 0- not visible anymore
				  	i++;

				}		
			}
		}			
		else
		{
		
			for(temp=bmp_height-1; temp>=0; temp--)
			{
			   i=(temp*bmp_width);
				fread(&alpha_line, 1, bmp_width, handle); 
				for(temp1=0; temp1<bmp_width; temp1++)
				{
					//bmp_tex[i] += 31<<3;
					if (bmp_tex[i] !=0) bmp_tex[i] += (bmp_256Alpha[alpha_line[temp1]+1])<<3; //31 max

//											  bmp_tex[i] += (bmp_256Alpha[(int)(gfx[(temp*bmp_width)+temp1]+1)])<<3; //31 max
				  	i++;
				}		
			}
			
		}			
		
//		flushToMemory(); //flushToMemory(); //ZoomXY_3DProcess(128,0,0);  		
		
		Soul_Load3DSpritePal(pal, (void*)bmp_256Pal,colors); 
		u16 result;
		if (colorIsA3I5)
			result = PA_3DCreateTex((void*)bmp_tex,	nearestTexDimension(bmp_width),nearestTexDimension(bmp_height), TEX_A3I5);
		else
			result = PA_3DCreateTex((void*)bmp_tex,	nearestTexDimension(bmp_width),nearestTexDimension(bmp_height), TEX_A5I3);
		if (gameselectDefaultIcon)
		{
		   for(i=0;i<7;i++) 	
			{
				Soul_Load3DSpritePal((i%7)+10, (void*)bmp_256Pal,colors); 
				if (colorIsA3I5)
					navigation.IconTex[i] = PA_3DCreateTex((void*)bmp_tex,	nearestTexDimension(bmp_width),nearestTexDimension(bmp_height), TEX_A3I5);
				else
					navigation.IconTex[i] = PA_3DCreateTex((void*)bmp_tex,	nearestTexDimension(bmp_width),nearestTexDimension(bmp_height), TEX_A5I3);
			}   
		}					
	 		
		 return result;
	 }// if handle   
	 else
	 {
//	   char chrtemp[200];
//	   sprintf(chrtemp,"%s \nNot Found",filename);
//	   chrtemp[30]='\n';
	 }   
return 0;
}   
u16 CreateTexFromFatBmpWithAlpha(char * filename , u8 pal, char * alphafilename)
{
   return CreateTexFromFatBmpWithAlpha2(filename , pal, alphafilename,false);
}   

u32 garbage[100];

u16 CreateTexFromFatBmpWithAlphaFILE(FILE *handle , u8 pal, FILE* alphaHandle)
{
 //  return 0;

//	flushToMemory();
//
	int i;
debugTxt("Creating Bmp Alpha");
   if (handle)
	{
		fseek(alphaHandle, 18, SEEK_SET);
		u32 bmp_width2; u32 bmp_height2;
		fread(&bmp_width2, 4, 1, alphaHandle);	
		fseek(alphaHandle, 22, SEEK_SET);
		fread(&bmp_height2, 4, 1, alphaHandle);	
		debugTxt("Reading Alpha Header");

		fseek(handle, 18, SEEK_SET);
		fread(&bmp_width, 4, 1, handle);	
		fread(&bmp_height, 4, 1, handle);	
	
		u16 bit;
		fseek(handle, 28, SEEK_SET);
		fread(&bit, 2, 1, handle);	
		
		u16 colors;
		fseek(handle, 50, SEEK_SET);
		fread(&colors, 4, 1, handle);	

		debugTxt("allocating");
		

		if (bmp_width  != bmp_width2) return 0; 	//BMP alpha and texture are not the same
		if (bmp_height != bmp_height2) return 0; 
		
		fseek(alphaHandle, 28, SEEK_SET);
		fread(&bit, 2, 1, alphaHandle);	
	 	u8 alphacolors;
		fseek(alphaHandle, 50, SEEK_SET);
		fread(&alphacolors, 4, 1, alphaHandle);	

		debugTxt("finished");

		if (bit >8) return 0; 			//return 0 if bitmap is not 256color

		debugTxt("Allocating");
	DMA_Force(zero, bmp_tex, (nearestTexDimension(bmp_width)*nearestTexDimension(bmp_height))>>1, DMA_16NOW); // Blank out
	DMA_Force(zero, bmp_256Pal, (256)>>1, DMA_16NOW); // Blank out
		
		fread(&garbage, 4, 1, handle);	
		unsigned char col[4];
		int magenta=0;
    	bool colorIsA3I5;
    	debugTxt("Reading Pallete");
		for(temp=0; temp<256; temp++)
		{
			fread(col, sizeof(char), 4, handle);	   
			bmp_256Pal[temp]= PA_RGB(col[2]>>3,col[1]>>3,col[0]>>3);
			if(bmp_256Pal[temp]==PA_RGB(31,0,31))
			{
			   magenta=temp;
			   bmp_256Pal[temp]=bmp_256Pal[0];
			}   
		}   
		debugTxt("Reading Bitmap");
		if (magenta==0)
		{
		   fseek(handle, 54, SEEK_SET);
			for(temp=0; temp<colors; temp++)
			{
				fread(col, sizeof(char), 4, handle);	   
				bmp_256Pal[temp+1]= PA_RGB(col[2]>>3,col[1]>>3,col[0]>>3);
			}   

			bmpFatToTexAlpha(handle,bmp_tex,colors,0);
		}			
		else
		{
		   colors--;   
			bmpFatToTexAlpha(handle,bmp_tex,colors,magenta);
		}   
//		fclose(handle);
    	if (colors<8)
	    	colorIsA3I5=0;
    	else
	    	colorIsA3I5=1;
//		bmpFatTo_A5I3Tex

	   if (!alphaHandle) return 0; //no file found
		
		if (bit >8) return 0; 			//return 0 if bitmap is not 256color
		DMA_Force(zero, bmp_256Alpha, (256)>>1, DMA_16NOW); // Blank out		
		DMA_Force(zero, alpha_line, (1024)>>1, DMA_16NOW); // Blank out		
		debugTxt("Reading/Constructing Alpha Pallete");
		int greycolor=0;			
		fseek(alphaHandle, 54, SEEK_SET);

		for(temp=0; temp<alphacolors; temp++)
		{
			fread(col, sizeof(char), 4, alphaHandle);	   
		   greycolor =(((col[2]>>3)&31) + ((col[1]>>3)&31) + ((col[0]>>3)&31))/3;
			bmp_256Alpha[temp+1]=  greycolor;
		}   

	   i=0;
	   fseek(alphaHandle, 10, SEEK_SET); //Seek offset bitmap
	   fread(&i,1,4,alphaHandle);
	   fseek(alphaHandle, i, SEEK_SET); //start of bmp / end of pal 
	   i=0;
   


		if (colorIsA3I5)	
		{
			for(temp=bmp_height-1; temp>=0; temp--)
			{
			   i=(temp*bmp_width);
				fread(&alpha_line, 1, bmp_width, alphaHandle); 
				for(temp1=0; temp1<bmp_width; temp1++)
				{
					if (bmp_tex[i]!=0) 
					bmp_tex[i] += (bmp_256Alpha[alpha_line[temp1]+1]>>2)<<5; //7 - no alpha 0- not visible anymore
				  	i++;

				}		
			}
		}			
		else
		{
		
			for(temp=bmp_height-1; temp>=0; temp--)
			{
			   i=(temp*bmp_width);
				fread(&alpha_line, 1, bmp_width, alphaHandle); 
				for(temp1=0; temp1<bmp_width; temp1++)
				{
					//bmp_tex[i] += 31<<3;
					if (bmp_tex[i] !=0) bmp_tex[i] += (bmp_256Alpha[alpha_line[temp1]+1])<<3; //31 max

//											  bmp_tex[i] += (bmp_256Alpha[(int)(gfx[(temp*bmp_width)+temp1]+1)])<<3; //31 max
				  	i++;
				}		
			}
			
		}			
		debugTxt("flushing");
//		flushToMemory(); //flushToMemory(); //ZoomXY_3DProcess(128,0,0);  		
		debugTxt("loading pal to vram");
		Soul_Load3DSpritePal(pal, (void*)bmp_256Pal,colors); 
		u16 result;
		swiIntrWait(0,    1 );
		debugTxt("creating texture");
		if (colorIsA3I5)
			result = PA_3DCreateTex((void*)bmp_tex,	nearestTexDimension(bmp_width),nearestTexDimension(bmp_height), TEX_A3I5);
		else
			result = PA_3DCreateTex((void*)bmp_tex,	nearestTexDimension(bmp_width),nearestTexDimension(bmp_height), TEX_A5I3);
		debugTxt("releasing memory");

	
		debugTxt("sending result");
	 	return result;
	 }// if alphaHandle   
	 else
	 {
//	   char chrtemp[200];
//	   sprintf(chrtemp,"%s \nNot Found",filename);
//	   chrtemp[30]='\n';
	 }   
return 0;

}
FILE *alphahandle2;
u16 CreateTexFromFatBmpFILE(FILE* handle, char * filename,u8 pal, bool searchForAlpha)
{
   
   debugTxt("Searching for Alpha");
	//searchForAlpha=0;
  if (searchForAlpha)
	{
		int temp = strlen(filename)+6;
		char alphafile[temp];
		sprintf(alphafile,"%s",filename);
		alphafile[temp]='\0';
		alphafile[temp-1]='p';
		alphafile[temp-2]='m';
		alphafile[temp-3]='b';
		alphafile[temp-4]='.';
		alphafile[temp-5]='a';
		alphafile[temp-6]='h';
		alphafile[temp-7]='p';
		alphafile[temp-8]='l';
		alphafile[temp-9]='a';
		alphafile[temp-10]='.';
   debugTxt("making alpha handle");

	   alphahandle2 = fopen(alphafile, "rb");			
//	   return 0;	
		//debugMiliSec(false);
	   if (alphahandle2) 
		{
//		   fclose (alphahandle);
//   		logMessage("Alpha found"); 
   		   debugTxt("Alpha Found finished loading");
//   		   return 0;
			return CreateTexFromFatBmpWithAlphaFILE(handle,pal,alphahandle2);
		}			
	   fclose (alphahandle2);
	}		

//	 return 0;

   if (handle)
	{

	   debugTxt("No Alpha");
		fseek(handle, 18, SEEK_SET);
		fread(&bmp_width, 4, 1, handle);	
		fseek(handle, 22, SEEK_SET);
		fread(&bmp_height, 4, 1, handle);	
	
		u16 bit;
		fseek(handle, 28, SEEK_SET);
		fread(&bit, 2, 1, handle);	
		
		u16 colors;
		fseek(handle, 50, SEEK_SET);
		fread(&colors, 4, 1, handle);	
   	debugTxt("Reading BMP Header");

		

		if (bit >8) return 0; 			//return 0 if bitmap is not 256color
	//malloc bmp_tex to memory. if bmp_tex is empty free it, to avoid memory leak

	   debugTxt("Allocating Memory");
		
	DMA_Force(zero, bmp_tex, (nearestTexDimension(bmp_width)*nearestTexDimension(bmp_height))>>1, DMA_16NOW); // Blank out
	DMA_Force(zero, bmp_256Pal, (256)>>1, DMA_16NOW); // Blank out
			fseek(handle, 54, SEEK_SET); // 54 is start of palette
		unsigned char col[4];
		int magenta=0;
	   debugTxt("Reading Pallette");
		for(temp=0; temp<colors; temp++)
		{
			fread(col, sizeof(char), 4, handle);	   
			bmp_256Pal[temp]= PA_RGB(col[2]>>3,col[1]>>3,col[0]>>3);
			if(bmp_256Pal[temp]==PA_RGB(31,0,31))
			{
			   magenta=temp;
			   bmp_256Pal[temp]=bmp_256Pal[0];
			}   
		}   
		if (magenta==0)
		{
		   debugTxt("Reading BMP zero magenta");

		   fseek(handle, 54, SEEK_SET);
			for(temp=0; temp<colors; temp++)
			{
				fread(col, sizeof(char), 4, handle);	   
				bmp_256Pal[temp+1]= PA_RGB(col[2]>>3,col[1]>>3,col[0]>>3);
			}   

			bmpFatToTex(handle,bmp_tex,colors,0);
		}			
		else
		{
		   debugTxt("Reading BMP");

		   colors--;   
			bmpFatToTex(handle,bmp_tex,colors,magenta);
//			Alert("1");
//			Alert(filename);
		}   

		Soul_Load3DSpritePal(pal, (void*)bmp_256Pal,colors); 
	   debugTxt("Loading to Pal");  		
//	   
	   

		
		u16 i = PA_3DCreateTex((void*)bmp_tex,	nearestTexDimension(bmp_width),nearestTexDimension(bmp_height), getColorTexType(colors));
	   debugTxt("Loading to Texture");  	
			
		return i;
	 }
return 0;
}   

u16 CreateTexFromFatBmp(char * filename,u8 pal, bool searchForAlpha)
{
	 initDebugTxt();
	 debugTxt(filename);
    FILE *handle = fopen(filename, "rb");
	 u16 i =CreateTexFromFatBmpFILE(handle, filename,pal,  searchForAlpha);
	  
	 fclose(handle);
	 return i;
}	 


bool UpdateTexFromFatBmpWithAlphaFILE(u16 texture, FILE * handle, u8 pal, FILE* alphaHandle)
{
  if (handle && alphaHandle)
	{
		int i;
		fseek(handle, 18, SEEK_SET);
		fread(&bmp_width, 4, 1, handle);	
		fseek(handle, 22, SEEK_SET);
		fread(&bmp_height, 4, 1, handle);	
			

		u16 bit;
		fseek(handle, 28, SEEK_SET);
		fread(&bit, 2, 1, handle);	
		
		u16 colors;
		fseek(handle, 50, SEEK_SET);
		fread(&colors, 4, 1, handle);	
		flushToMemory();		//flushToMemory();		flushToMemory();

		if (bit >8) return 0; 			//return 0 if bitmap is not 256color
		//malloc bmp_tex to memory. if bmp_tex is empty free it, to avoid memory leak
	DMA_Force(zero, bmp_tex, (nearestTexDimension(bmp_width)*nearestTexDimension(bmp_height))>>1, DMA_16NOW); // Blank out
	DMA_Force(zero, bmp_256Pal, (256)>>1, DMA_16NOW); // Blank out
		
		fseek(handle, 54, SEEK_SET); // 54 is start of palette
		unsigned char col[4];
		int magenta=0;
    	bool colorIsA3I5;
		for(temp=0; temp<256; temp++)
		{
			fread(col, sizeof(char), 4, handle);	   
			bmp_256Pal[temp]= PA_RGB(col[2]>>3,col[1]>>3,col[0]>>3);
			if(bmp_256Pal[temp]==PA_RGB(31,0,31))
			{
			   magenta=temp;
			   bmp_256Pal[temp]=bmp_256Pal[0];
			}   
		}   
		if (magenta==0)
		{
		   fseek(handle, 54, SEEK_SET);
			for(temp=0; temp<colors; temp++)
			{
				fread(col, sizeof(char), 4, handle);	   
				bmp_256Pal[temp+1]= PA_RGB(col[2]>>3,col[1]>>3,col[0]>>3);
			}   

			bmpFatToTexAlpha(handle,bmp_tex,colors,0);
		}			
		else
		{
		   colors--;   
			bmpFatToTexAlpha(handle,bmp_tex,colors,magenta);
		}   
		
    	if (colors<8)
	    	colorIsA3I5=0;
    	else
	    	colorIsA3I5=1;
//		bmpFatTo_A5I3Tex


		fseek(alphaHandle, 18, SEEK_SET);
		u32 bmp_width2; u32 bmp_height2;
		fread(&bmp_width2, 4, 1, alphaHandle);	
		fseek(alphaHandle, 22, SEEK_SET);
		fread(&bmp_height2, 4, 1, alphaHandle);	
		if (bmp_width  != bmp_width2) return 0; 	//BMP alpha and texture are not the same
		if (bmp_height != bmp_height2) return 0; 
		
		fseek(alphaHandle, 28, SEEK_SET);
		fread(&bit, 2, 1, alphaHandle);	
	 	u8 alphacolors;
		fseek(alphaHandle, 50, SEEK_SET);
		fread(&alphacolors, 4, 1, alphaHandle);	
		
		if (bit >8) return 0; 			//return 0 if bitmap is not 256color
		DMA_Force(zero, bmp_256Alpha, (256)>>1, DMA_16NOW); // Blank out		
		DMA_Force(zero, alpha_line, (1024)>>1, DMA_16NOW); // Blank out		
		

		int greycolor=0;			
		fseek(alphaHandle, 54, SEEK_SET);
		for(temp=0; temp<alphacolors; temp++)
		{
			fread(col, sizeof(char), 4, alphaHandle);	   
		   greycolor =(((col[2]>>3)&31) + ((col[1]>>3)&31) + ((col[0]>>3)&31))/3;
			bmp_256Alpha[temp+1]=  greycolor;
		}   

	   i=0;
	   fseek(alphaHandle, 10, SEEK_SET); //Seek offset bitmap
	   fread(&i,1,4,alphaHandle);
	   fseek(alphaHandle, i, SEEK_SET); //start of bmp / end of pal 
	   i=0;
   



		if (colorIsA3I5)	
		{
			for(temp=bmp_height-1; temp>=0; temp--)
			{
			   i=(temp*bmp_width);
				fread(&alpha_line, 1, bmp_width, alphaHandle); 
				for(temp1=0; temp1<bmp_width; temp1++)
				{
					if (bmp_tex[i]!=0) 
					bmp_tex[i] += (bmp_256Alpha[alpha_line[temp1]+1]>>2)<<5; //7 - no alpha 0- not visible anymore
				  	i++;

				}		
			}
		}			
		else
		{
		
			for(temp=bmp_height-1; temp>=0; temp--)
			{
			   i=(temp*bmp_width);
				fread(&alpha_line, 1, bmp_width, alphaHandle); 
				for(temp1=0; temp1<bmp_width; temp1++)
				{
					//bmp_tex[i] += 31<<3;
					if (bmp_tex[i] !=0) bmp_tex[i] += (bmp_256Alpha[alpha_line[temp1]+1])<<3; //31 max

//											  bmp_tex[i] += (bmp_256Alpha[(int)(gfx[(temp*bmp_width)+temp1]+1)])<<3; //31 max
				  	i++;
				}		
			}
			
		}			
		
		
		Soul_Load3DSpritePal(pal, (void*)bmp_256Pal,colors); 
		PA_3DUpdateGfx(texture, (void*)bmp_tex);
		
		return 1;
	 }// if alphaHandle   
return 0;

}
bool UpdateTexFromFatBmpWithAlpha(u16 texture, char * filename , u8 pal, char * alphafilename)
{
   
   FILE *handle = fopen(filename, "rb");
   FILE *alphaHandle = fopen(alphafilename, "rb");
	bool result = 0;
   if (handle && alphaHandle)
	{
	 result = UpdateTexFromFatBmpWithAlphaFILE(texture, handle, pal, alphaHandle);
	}
	fclose(handle);
	fclose(alphaHandle);   
	return result;
}   

bool UpdateTexFromFatBmpFILE(u16 texture, FILE * handle , u8 pal)
{
   if (handle)
	{

		fseek(handle, 18, SEEK_SET);
		fread(&bmp_width, 4, 1, handle);	
		fseek(handle, 22, SEEK_SET);
		fread(&bmp_height, 4, 1, handle);	
		
		
		
		u16 bit;
		fseek(handle, 28, SEEK_SET);
		fread(&bit, 2, 1, handle);	
		if (bit >8) return 0; 			//return 0 if bitmap is not 256color
	
		u16 colors;
		fseek(handle, 50, SEEK_SET);
		fread(&colors, 4, 1, handle);	


	//malloc bmp_tex to memory. if bmp_tex is empty free it, to avoid memory leak
		
	DMA_Force(zero, bmp_tex, (nearestTexDimension(bmp_width)*nearestTexDimension(bmp_height))>>1, DMA_16NOW); // Blank out
	DMA_Force(zero, bmp_256Pal, (256)>>1, DMA_16NOW); // Blank out
		
		fseek(handle, 54, SEEK_SET); // 54 is start of palette
		unsigned char col[4];
		int magenta=0;

		for(temp=0; temp<colors; temp++)
		{
			fread(col, sizeof(char), 4, handle);	   
			bmp_256Pal[temp]= PA_RGB(col[2]>>3,col[1]>>3,col[0]>>3);
			if(bmp_256Pal[temp]==PA_RGB(31,0,31))
			{
			   magenta=temp;
			   bmp_256Pal[temp]=bmp_256Pal[0];
			}   
		}   
		//seek for the error here

		if (magenta==0)
		{
		   fseek(handle, 54, SEEK_SET);
			for(temp=0; temp<colors; temp++)
			{
				fread(col, sizeof(char), 4, handle);	   
				bmp_256Pal[temp+1]= PA_RGB(col[2]>>3,col[1]>>3,col[0]>>3);
			}   

			bmpFatToTex(handle,bmp_tex,colors,0);
//				Alert("0");
//			Alert(filename);
		}			
		else
		{
		   colors--;   
			bmpFatToTex(handle,bmp_tex,colors,magenta);
//			Alert("1");
//			Alert(filename);
		}   
		flushToMemory(); //flushToMemory(); //ZoomXY_3DProcess(128,0,0);  		
		Soul_Load3DSpritePal(pal, (void*)bmp_256Pal,colors); 
		PA_3DUpdateGfx(texture, (void*)bmp_tex);
		
		return 1;
	 }
return 0;
}   

bool UpdateTexFromFatBmp(u16 texture, char * filename , u8 pal, bool searchForAlpha)
{
	FILE *handle = fopen(filename, "rb");
  if (searchForAlpha)
	{
		int temp = strlen(filename)+6;
		char alphafile[temp];
		sprintf(alphafile,"%s",filename);
		alphafile[temp]='\0';
		alphafile[temp-1]='p';
		alphafile[temp-2]='m';
		alphafile[temp-3]='b';
		alphafile[temp-4]='.';
		alphafile[temp-5]='a';
		alphafile[temp-6]='h';
		alphafile[temp-7]='p';
		alphafile[temp-8]='l';
		alphafile[temp-9]='a';
		alphafile[temp-10]='.';
	   FILE *alphahandle = fopen(alphafile, "rb");			
	   if (alphahandle) 
		{
		   bool result =  UpdateTexFromFatBmpWithAlphaFILE(texture, handle,pal,alphahandle);
			fclose (alphahandle);
			fclose (handle);
			return result;
		}			
	   fclose (alphahandle);
	}		

   
   if (handle)
	{
	   bool result = UpdateTexFromFatBmpFILE(texture, handle,pal);
	   fclose (handle);
		return result;
	 }
return 0;
}   

bool CreateSpriteFromFatBmp(u16 sprite,char * filename , u8 pal,u16 x,u16 y, bool searchForAlpha)
{
   FILE *handle = fopen(filename, "rb+");
   if (handle)
	{
		logMessage("%s - Sprite BMP Found",filename); 
	 	PA_3DCreateSpriteFromTex(sprite, CreateTexFromFatBmpFILE(handle , filename,pal,searchForAlpha), bmp_width,bmp_height, pal, x,y);
	 	fclose(handle);
		return 1;
	}// if handle   
	fclose(handle);
	logMessage("%s - Sprite BMP NOT Found",filename); 
//	ShowDialogBox(1,0,1,"%s\nNot Found",filename); 
	return 0;
}   
/*
bool CreateSpriteFromFatBmpFILE(u16 sprite, FILE*handle, u8 pal,u16 x,u16 y, bool searchForAlpha)
{
   if (handle)
	{
		//logMessage("%s - Sprite BMP Found",filename); 
	 	PA_3DCreateSpriteFromTex(sprite, CreateTexFromFatBmpFILE(handle , pal,searchForAlpha), bmp_width,bmp_height, pal, x,y);
		return 1;
	}// if handle   
	logMessage("%s - Sprite BMP NOT Found",filename); 
//	ShowDialogBox(1,0,1,"%s\nNot Found",filename); 
	return 0;
}   
*/

bool CreateSpriteFromFatBmpWithAlpha(u16 sprite,char * filename , u8 pal,char * alphafilename , u16 x,u16 y)
{

   FILE *handle = fopen(filename, "rb");
   
   if (handle)
	{
	   logMessage("%s - Sprite BMP Found",filename); 
		PA_3DCreateSpriteFromTex(sprite, CreateTexFromFatBmpWithAlpha(filename , pal,alphafilename), bmp_width,bmp_height, pal, x,y);
		return 1;
	 }// if handle   
	 logMessage("%s - Sprite BMP NOT Found",filename); 
	//ShowDialogBox(1,0,1,"%s\nNot Found",filename); 
	return 0;
}   
bool CreateSpriteFromBmp(u16 sprite,void * bmp , u8 pal,u16 x,u16 y)
{
	PA_3DCreateSpriteFromTex(sprite, CreateTexFromBmp((void*)bmp , pal), 
												nearestTexDimension(bmp_width),
												nearestTexDimension(bmp_height), 
												pal, x,y);
	return 1;
}   
bool CreateSpriteFromBmpWithAlpha(u16 sprite,void * bmp , u8 pal, void *bmpAlpha,u16 x,u16 y)
{
	PA_3DCreateSpriteFromTex(sprite, CreateTexFromBmpWithAlpha((void*)bmp , pal,(void*)bmpAlpha), 
												nearestTexDimension(bmp_width),
												nearestTexDimension(bmp_height), 
												pal, x,y);
	return 1;
}   
extern char CurrentTheme[256];

char* returnThemeResourcePath(char * filename, bool useDefaultIfMissing)
{

   char * path = malloc(256); 
   sprintf(path,"fat:/_menudo/themes/%s/%s",CurrentTheme,filename);
   if (!useDefaultIfMissing) return path;

   if (filename[strlen(filename)-1]=='/')
   {
//      while(true){ flushToMemory();}
		if (verifyDir(path)) 
			return path;
		else
		{
		   sprintf(path,"fat:/_menudo/default/%s",filename);
			if (verifyDir(path)) return path;
		}			
	}		
	else
	{
	   FILE * filechecker =fopen(path,"rb");
		if (filechecker)
		{
		   fclose(filechecker);
		  	return path;
		  	
		}
		else
		{
		   fclose(filechecker);	   
		   sprintf(path,"fat:/_menudo/default/%s",filename);
		   filechecker =fopen(path,"rb");
			if (filechecker)
			{
			   fclose(filechecker);	   
			   return path;
			}   
		}		  	   
	}		
	return NULL;
}   
FILE* returnThemeResourcePathFILE(char * filename, char* type, bool useDefaultIfMissing)
{

   char path[256]; 
   sprintf(path,"fat:/_menudo/themes/%s/%s",CurrentTheme,filename);
	
   FILE * filechecker =fopen(path,type);
	if (filechecker || !useDefaultIfMissing)
	{
	  	return filechecker;
	  	
	}
	else
	{
	   fclose(filechecker);	   
	   sprintf(path,"fat:/_menudo/default/%s",filename);
	   filechecker =fopen(path,type);
		   return filechecker;
	}		  	   

}   
char* returnDefaultResourcePath(char * filename)
{

   char * path = malloc(256); 
   sprintf(path,"fat:/_menudo/default/%s",filename);
   if (filename[strlen(filename)-1]=='/')
   {
//      while(true){ flushToMemory();}
		if (verifyDir(path)) return path;
	}		
	else
	{
	   FILE * filechecker =fopen(path,"rb");
		if (filechecker)
		{
		   fclose(filechecker);
		  	return path;
		  	
		}

	}		
	return NULL;
}   
u16 CreateTexFromThemeResource(char * filename , u8 pal, bool useDefaultIfMissing)
{
//   initDebugTxt();
//   debugTxt("CreateTexFromThemeResource");
//   debugTxt(filename);
   
   char * path = returnThemeResourcePath(filename, useDefaultIfMissing);
	u16 tex = CreateTexFromFatBmp(path,pal,1);
	if (path != NULL) free (path);
  	return  tex; //PA_3DCreateTex((void*)edgeButton_Texture, 8, 16, TEX_16COL);	
}   

void free3dVram()
{
//	if (bmp_tex!=NULL) 
	{
//	   free(bmp_tex);
	}   
}	
#ifdef __cplusplus
}
#endif




