
#ifdef __cplusplus
extern "C" {
#endif
								  /*TEX_A5I3 : 8 colors  + 5 bit alpha*/
								  /*TEX_A3I5 : 32 colors + 3 bit alpha*/ 
#define nearestTexDimension(x)   x <= 8 	? 8  : \
   										x <= 16  ? 16 : \
											x <= 32  ? 32 : \
											x <= 64  ? 64 : \
											x <= 128 ? 128: \
											x <= 256 ? 256: \
											x <= 512 ? 512: \
														  1024

#define convertToNearestBit(x)   x <= 1 	? 0 : \
											x <= 2 	? 1 : \
											x <= 4 	? 2 : \
											x <= 8 	? 3 : \
   										x <= 16  ? 4 : \
											x <= 32  ? 5 : \
											x <= 64  ? 6 : \
											x <= 128 ? 7 : \
											x <= 256 ? 8 : \
											x <= 512 ? 9 : \
														  10
#define getAlphaColorTexType(x) 	x < 8 ?		TEX_A5I3  : TEX_A3I5
											
#define getColorTexType(x) 		x < 4? 		TEX_4COL  : \
											x < 16? 		TEX_16COL : \
								   						TEX_256COL 
											   				
#define isPowerBy8(x)				x == 8 || x == 16 || x == 32 || x == 64 || x == 128 || x == 256 || x == 512 || x == 1024

#define 	colorToTransparent(point,magenta)	if(point==magenta) 	\
																point=0; 			\
															else 						\
																if(point==0) 		\
																	point=magenta; 
//#define BMPPIXELMAX 131072																	
	
int getRecentBmpWidth();
int getRecentBmpHeight();

s16 MaskTexWithFatBmpAlpha(unsigned char *texture,char *bmpAlpha, int texwidth, int texheight, int texType);
u16 MaskTexWithBmpAlpha(unsigned char *texture,void *bmpAlpha, int texwidth, int texheight, int texType);

u16 CreateTexFromBmpWithAlpha(void *bmp, u8 pal , void *bmpAlpha);
u16 CreateTexFromBmp(void *bmp , u8 pal);
u16 CreateTexFromFatBmpWithAlpha(char * filename , u8 pal, char * alphafilename);
u16 CreateTexFromFatBmp(char * filename , u8 pal, bool searchForAlpha);

bool CreateSpriteFromFatBmpWithAlpha(u16 sprite,char * filename , u8 pal,char * alphafilename , u16 x,u16 y);
bool CreateSpriteFromFatBmp(u16 sprite,char * filename , u8 pal,u16 x,u16 y, bool searchForAlpha);
bool CreateSpriteFromBmp(u16 sprite,void * bmp , u8 pal,u16 x,u16 y);
bool CreateSpriteFromBmpWithAlpha(u16 sprite,void * bmp , u8 pal, void *bmpAlpha,u16 x,u16 y);

u16 CreateTexFromThemeResource(char * filename , u8 pal, bool useDefaultIfMissing);
#ifdef __cplusplus
}
#endif



