#include <PA9.h>
#include "../../gfx/all_gfx.h"

const unsigned short blackarialAA12_Pal[8] __attribute__ ((aligned (4))) = //0, 60250, 46509, 54965, 51794, 40167, 35939, 32768};
//{64543, 65535, 62364, 57079, 50737, 45452, 39110, 35939};
{PA_RGB(5,5,5), 
PA_RGB(4,4,4), 
PA_RGB(6,6,6), 
PA_RGB(8,8,8),
PA_RGB(10,10,10), 
PA_RGB(13,13,13), 
PA_RGB(18,18,18), 
PA_RGB(25,25,25)};
//const unsigned short arialAA12_Pal[8] __attribute__ ((aligned (4))) = {0, 38053, 51794, 43338, 46509, 58136, 62364, 65535};
const unsigned short arialAA12_Pal[8] __attribute__ ((aligned (4))) = {
64543, 
65535, 
62364, 
57079, 
50737, 
45452, 
39110, 
35939};

bool screenTextBlack[2];

void initAntiAliasedText(bool screen, int layer, bool black)
{
   screenTextBlack[screen] = black;
 	PA_LoadPal16c((screen? PAL_BG1            : PAL_BG0      ) , 
	 				  ( black? blackarialAA12_Pal : arialAA12_Pal));
	PA_EnableSpecialFx(screen, SFX_ALPHA, 	layer == 0? SFX_BG0 :
	   												layer == 1? SFX_BG1 :
														layer == 2? SFX_BG2 :
																	   SFX_BG3
													, SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
	PA_SetSFXAlpha(screen, black? 6 : 31, black? 0 : 15);
										// 13-8 not sure with black
										
}   
// 0  - 10 text opacity
// 11 - 31 AA Depth
void setAntiAliasDepth(bool screen, int x)
{
//   if (x>16) x=16;
  	PA_SetSFXAlpha(screen, screenTextBlack[screen]?x:31, screenTextBlack[screen]? 1 : 15 );  
}   

bool textScreenColorIsBlack(bool screen)
{
   return screenTextBlack[screen];
}   
void spaceLetteringForAAText()
{
	PA_16cTextLetterSpacing(-1);
}	
void spaceLetteringForDefault()
{
	PA_16cTextLetterSpacing(0);
   PA_TextLineSpacing(1);
}	
