//Gfx converted using Mollusk's PAGfx Converter

//This file contains all the .h, for easier inclusion in a project

#ifndef ALL_GFX_H
#define ALL_GFX_H

#ifndef PAGfx_struct
    typedef struct{
    void *Map;
    int MapSize;
    void *Tiles;
    int TileSize;
    void *Palette;
    int *Info;
} PAGfx_struct;
#endif


// Sprite files : 
extern const unsigned char selectBorder_Sprite[128] __attribute__ ((aligned (4))) ;  // Pal : selectBorder_Pal
extern const unsigned char ndsIcon2d_Sprite[512] __attribute__ ((aligned (4))) ;  // Pal : ndsIcon2d_Pal
extern const unsigned char slider_Sprite[512] __attribute__ ((aligned (4))) ;  // Pal : slider_Pal
extern const unsigned char next0_Sprite[1024] __attribute__ ((aligned (4))) ;  // Pal : button1_Pal
extern const unsigned char next1_Sprite[1024] __attribute__ ((aligned (4))) ;  // Pal : button2_Pal
extern const unsigned char play0_Sprite[1024] __attribute__ ((aligned (4))) ;  // Pal : button3_Pal
extern const unsigned char play1_Sprite[1024] __attribute__ ((aligned (4))) ;  // Pal : button4_Pal
extern const unsigned char prev0_Sprite[1024] __attribute__ ((aligned (4))) ;  // Pal : button5_Pal
extern const unsigned char prev1_Sprite[1024] __attribute__ ((aligned (4))) ;  // Pal : button6_Pal
extern const unsigned char menu0_Sprite[1024] __attribute__ ((aligned (4))) ;  // Pal : button7_Pal
extern const unsigned char menu1_Sprite[1024] __attribute__ ((aligned (4))) ;  // Pal : button8_Pal
extern const unsigned char musicIcon_Sprite[128] __attribute__ ((aligned (4))) ;  // Pal : musicIcon_Pal
extern const unsigned char miniButton_Sprite[1024] __attribute__ ((aligned (4))) ;  // Pal : bgEdge_Pal
extern const unsigned char bgEdge_Sprite[256] __attribute__ ((aligned (4))) ;  // Pal : bgEdge_Pal

// Background files : 
extern const int BG3_Info[3]; // BgMode, Width, Height
extern const unsigned short BG3_Map[768] __attribute__ ((aligned (4))) ;  // Pal : BG3_Pal
extern const unsigned char BG3_Tiles[1152] __attribute__ ((aligned (4))) ;  // Pal : BG3_Pal
extern PAGfx_struct BG3; // background pointer

extern const int BG2_Info[3]; // BgMode, Width, Height
extern const unsigned short BG2_Map[768] __attribute__ ((aligned (4))) ;  // Pal : BG2_Pal
extern const unsigned char BG2_Tiles[192] __attribute__ ((aligned (4))) ;  // Pal : BG2_Pal
extern PAGfx_struct BG2; // background pointer

extern const int BG1_Info[3]; // BgMode, Width, Height
extern const unsigned short BG1_Map[768] __attribute__ ((aligned (4))) ;  // Pal : BG1_Pal
extern const unsigned char BG1_Tiles[192] __attribute__ ((aligned (4))) ;  // Pal : BG1_Pal
extern PAGfx_struct BG1; // background pointer

extern const char arialAA12_Height;
extern const char arialAA12_Sizes[256];
extern const int arialAA12_Info[3]; // BgMode, Width, Height
extern const unsigned short arialAA12_Map[1024] __attribute__ ((aligned (4))) ;  // Pal : arialAA12_Pal
extern const unsigned char arialAA12_Tiles[13280] __attribute__ ((aligned (4))) ;  // Pal : arialAA12_Pal
extern PAGfx_struct arialAA12; // background pointer

extern const char arialAA12_jap_Height;
extern const char arialAA12_jap_Sizes[256];
extern const int arialAA12_jap_Info[3]; // BgMode, Width, Height
extern const unsigned short arialAA12_jap_Map[1024] __attribute__ ((aligned (4))) ;  // Pal : arialAA12_jap_Pal
extern const unsigned char arialAA12_jap_Tiles[23872] __attribute__ ((aligned (4))) ;  // Pal : arialAA12_jap_Pal
extern PAGfx_struct arialAA12_jap; // background pointer

extern const char arial_size4_Height;
extern const char arial_size4_Sizes[256];
extern const int arial_size4_Info[3]; // BgMode, Width, Height
extern const unsigned short arial_size4_Map[1024] __attribute__ ((aligned (4))) ;  // Pal : arial_size4_Pal
extern const unsigned char arial_size4_Tiles[10400] __attribute__ ((aligned (4))) ;  // Pal : arial_size4_Pal
extern PAGfx_struct arial_size4; // background pointer

extern const char arial_size3_Height;
extern const char arial_size3_Sizes[256];
extern const int arial_size3_Info[3]; // BgMode, Width, Height
extern const unsigned short arial_size3_Map[1024] __attribute__ ((aligned (4))) ;  // Pal : arial_size3_Pal
extern const unsigned char arial_size3_Tiles[8032] __attribute__ ((aligned (4))) ;  // Pal : arial_size3_Pal
extern PAGfx_struct arial_size3; // background pointer

extern const char arial_size2_Height;
extern const char arial_size2_Sizes[256];
extern const int arial_size2_Info[3]; // BgMode, Width, Height
extern const unsigned short arial_size2_Map[1024] __attribute__ ((aligned (4))) ;  // Pal : arial_size2_Pal
extern const unsigned char arial_size2_Tiles[7392] __attribute__ ((aligned (4))) ;  // Pal : arial_size2_Pal
extern PAGfx_struct arial_size2; // background pointer

extern const char arial_size1_Height;
extern const char arial_size1_Sizes[256];
extern const int arial_size1_Info[3]; // BgMode, Width, Height
extern const unsigned short arial_size1_Map[256] __attribute__ ((aligned (4))) ;  // Pal : arial_size1_Pal
extern const unsigned char arial_size1_Tiles[6624] __attribute__ ((aligned (4))) ;  // Pal : arial_size1_Pal
extern PAGfx_struct arial_size1; // background pointer

extern const char jap_font_Height;
extern const char jap_font_Sizes[256];
extern const int jap_font_Info[3]; // BgMode, Width, Height
extern const unsigned short jap_font_Map[1024] __attribute__ ((aligned (4))) ;  // Pal : jap_font_Pal
extern const unsigned char jap_font_Tiles[21824] __attribute__ ((aligned (4))) ;  // Pal : jap_font_Pal
extern PAGfx_struct jap_font; // background pointer


// Sprite files : 
extern const unsigned char rotateButton_Texture[64] __attribute__ ((aligned (4))) ;  // Pal : rotateButton_Pal
extern const unsigned char scaleButton_Texture[64] __attribute__ ((aligned (4))) ;  // Pal : scaleButton_Pal
extern const unsigned char black_background_Texture[16] __attribute__ ((aligned (4))) ;  // Pal : black_background_Pal

// Palette files : 
extern const unsigned short selectBorder_Pal[2] __attribute__ ((aligned (4))) ;
extern const unsigned short ndsIcon2d_Pal[14] __attribute__ ((aligned (4))) ;
extern const unsigned short slider_Pal[14] __attribute__ ((aligned (4))) ;
extern const unsigned short button1_Pal[16] __attribute__ ((aligned (4))) ;
extern const unsigned short button2_Pal[15] __attribute__ ((aligned (4))) ;
extern const unsigned short button3_Pal[16] __attribute__ ((aligned (4))) ;
extern const unsigned short button4_Pal[16] __attribute__ ((aligned (4))) ;
extern const unsigned short button5_Pal[16] __attribute__ ((aligned (4))) ;
extern const unsigned short button6_Pal[15] __attribute__ ((aligned (4))) ;
extern const unsigned short button7_Pal[16] __attribute__ ((aligned (4))) ;
extern const unsigned short button8_Pal[15] __attribute__ ((aligned (4))) ;
extern const unsigned short musicIcon_Pal[8] __attribute__ ((aligned (4))) ;
extern const unsigned short bgEdge_Pal[9] __attribute__ ((aligned (4))) ;
extern const unsigned short BG3_Pal[9] __attribute__ ((aligned (4))) ;
extern const unsigned short BG2_Pal[7] __attribute__ ((aligned (4))) ;
extern const unsigned short BG1_Pal[7] __attribute__ ((aligned (4))) ;
extern const unsigned short arialAA12_Pal[8] __attribute__ ((aligned (4))) ;
extern const unsigned short arialAA12_jap_Pal[8] __attribute__ ((aligned (4))) ;
extern const unsigned short arial_size4_Pal[2] __attribute__ ((aligned (4))) ;
extern const unsigned short arial_size3_Pal[2] __attribute__ ((aligned (4))) ;
extern const unsigned short arial_size2_Pal[2] __attribute__ ((aligned (4))) ;
extern const unsigned short arial_size1_Pal[2] __attribute__ ((aligned (4))) ;
extern const unsigned short jap_font_Pal[2] __attribute__ ((aligned (4))) ;
extern const unsigned short rotateButton_Pal[3] __attribute__ ((aligned (4))) ;
extern const unsigned short scaleButton_Pal[4] __attribute__ ((aligned (4))) ;
extern const unsigned short black_background_Pal[2] __attribute__ ((aligned (4))) ;


#endif

