#include <PA9.h>
int makeint(int b1, int b2, int b3, int b4, int reversed)
{
 if(reversed)
 {
	return (b1<<24)+(b2<<16)+(b3<<8)+b4;   
 }	else {
  	return (b4<<24)+(b3<<16)+(b2<<8)+b1;   
 }	   

}   

u8 makechar(int b1, int b2, int b3, int b4, int reversed)
{
int i=makeint(b1, b2, b3, b4, reversed);
 if (i>=128) i=127;
 if (i<0) i=0;
 return i;

}   

int abs(int num)
{
   if (num<0)
   return num*-1;
   else
   return num;
}   
int atoi ( const char * str );

char* convertBytesToNearest(long size)
{
	char *charTemp = (char*)malloc(256); 
	memset(charTemp, 0, 256);
//	unsigned int byte, i = 1, size;
   long newSize=0;
   if(1024 > size) {
   /*bytes*/
     newSize=size;
     sprintf(charTemp,"%ld bytes",newSize);
     }
     else if(1024*1024 > size) {
     /*kilobytes*/
     newSize = size/1024;
     sprintf(charTemp,"%ld KB",newSize);
     }
     else if(1024*1024*1024  > size) {
     /*megabytes*/
     newSize = size/1024/1024;
     sprintf(charTemp,"%ld MB",newSize);
     }
     if(1024 <= size) 
     sprintf(charTemp,"%s (%ld bytes)",charTemp,size);
     return charTemp;

}	   

u32 timetoMilisecs(char* time)
{
	u32 milisecs = 0;
	char temp[2];
	temp[0] = time[0];
	temp[1] = time[1];
	milisecs = atoi(temp) * 6000;
	temp[0] = time[3];
	temp[1] = time[4];	
	milisecs += atoi(temp) * 100;
	temp[0] = time[6];
	temp[1] = time[7];	
	milisecs += atoi(temp);
	return milisecs;
}   
char* milisecsToTime(u32 milisecs)
{
   char *temp = malloc(20);
   sprintf(temp,"%02d:%02d.%02d",(int)milisecs/6000,(int)(milisecs/100)%60,(int)milisecs%100);
   return temp;
}   
s16 getNearestAngle(u16 start_angle,u16 target_angle)
{
	s16 a = 0;
	s16 b = 0;
	s16 c = 0;
	s16 a1 = start_angle; 
	s16 a2 = target_angle;
	if (a1> 256) 
	{
	   a= 512 - a1; //448
	}
		else
	{   
	    a= a1 *-1;
	}   
	
	b= a2 + a; //0
	c= 512 - (abs(b));
	if (b<c)
	{
	   return b;		   
	}
	else   
	{
		return c*-1;		   
	}			
}   

