#include <PA9.h>  // PAlib include
#include "../engine/engine.h"
int maxValueTo(int value, int max)
{
   if (value>max) 
		return max;
	else
		return value;
}   
int maxLimitValueTo(int value, int limit, int max)
{
   if (value>max) 
		return max;
	else
   if (value<limit) 
		return limit;
	else
		return value;
}   
int limitValueTo(int value, int limit)
{
   if (value<limit) 
		return limit;
	else
		return value;
}   

int limitValueToScreenX(int value)
{
   if (value<0)   return 0;
	if (value>256) return 256;
	return value;
}   
int limitValueToScreenY(int value)
{
   if (value<0)   return 0;
	if (value>192) return 192;
	return value;
}   

bool isFileNameNDS(char* file)
{
   if (file[strlen(file)-1] == 's' || file[strlen(file)-1] == 'S')
   if (file[strlen(file)-2] == 'd' || file[strlen(file)-2] == 'D')
   if (file[strlen(file)-3] == 'n' || file[strlen(file)-3] == 'N')
   if (file[strlen(file)-4] == '.' || file[strlen(file)-4] == '.')
   return true;
   
   return false;
}   

void Draw16cPixelRoundedRectangle(bool screen, int x1,int y1,int x2,int y2,u8 color)
{
   	int x,y;
		clear16cZone(screen,x1,y1,x2,y2);
		for (x=x1;x<=x2;x++)
		for (y=y1;y<=y2;y++)
		if (!(x==x1 && y == y1) && !(x==x1 && y == y2)&& !(x==x2 && y == y1)&& !(x==x2 && y == y2)) 
		PA_16cPutPixel(screen,x,y,color);
}	
char* formatText (char* text,int amount, ...)
{
	va_list vl;
	va_start(vl,amount);
	u8 *stringPointer; 

	char string[amount][256];
	int i,y;
	for (y=0;y<amount;y++)
	{
		stringPointer = (u8*)va_arg(vl, const u8 *);
		for (i = 0; stringPointer[i]; i++) 
		{
		   string[y][i] = stringPointer[i];
		}
	   string[y][i] = 0;
	}	  
	va_end(vl);
	char *output = malloc(sizeof(char)*500);
	int x=0;
	int stringArray=0;
	for (y=0;text[y];y++)
	{
	   if (text[y] == '$')
		{
		   stringArray=text[y+1]-'0';
		   if (stringArray<0) stringArray=0;
		   if (stringArray>amount) stringArray=amount;
			for (i = 0; string[stringArray][i]; i++) 
			{
			   output[x] = string[stringArray][i];
			   x++;
			}		   
		   y++;
		}   
		else
	   {
		   if (text[y] == '\\' && text[y+1] == 'n')
		   {
				output[x] = '\n';
				y++;
			}			
		   else
				output[x] = text[y];
			x++;
		}			
	}	  
	output[x] = 0;
	return output;
}
char* returnString(char* text, ...) 
{

   char *charTemp= (char*)malloc(256); 
   memset(charTemp, 0, 256);
	s16 j, i;
	u16 textcount = 0; // compte le nombre de lettres...
	u8 PAtext[32]; // tableau o l'on copie les nombres et tout...
	u8 PAtextcount = 0; // Quand on a un nombre, il faut savoir sa longueur
	u8 *PAextext; // Extra text
	s32 PAtextnumber;
	double tempdouble = 0;
	     
	
	va_list varg;           /* Variable identifiant le prochain paramtre. */

   va_start(varg, text);
   
   PAtextcount = 0;
   


	   
	   
	   
	   for (j = 0; text[j]; j++) {
	      if (text[j] == '%') {
				if (text[j+1] == 's') {  // S'il y a %s, c'est une chaine de caractres...
	            PAextext = (u8*)va_arg(varg, const u8 *);  // Pointeur vers la chaine de charactres...
	            for (i = 0; PAextext[i]; i++) {
	               charTemp[textcount] = PAextext[i];
	               ++textcount;
	            }
	            j += 1;
	         }
	         else if ((text[j+1] == 'x')) {
				u32 test = va_arg(varg, u32);
				u8 temp;
				u8 started = 0;
				for(i = 0; i < 32; i+=4){
				   temp = (test>>(28-i))&15;
				   if(started || temp){
					   if(temp >= 10) charTemp[textcount] = 'A'+(temp-10); 
					   else charTemp[textcount] = '0'+(temp); 
						textcount++;
					   started = 1;
					}					   
				}   
				j++;
			}	
	         else if ((text[j+1] == 'd') || (text[j+1] == 'f')) {
				double test = 0;
	            if (text[j+1] == 'd') {
					PAtextnumber = va_arg(varg, s32);
					test = PAtextnumber;
				}
	            else {  // On ne prend que la partie entire pour l'instant, on garde le reste pour plus tard :p
	               tempdouble = va_arg(varg, double);
				   test = tempdouble;
				   PAtextnumber = (s32)tempdouble ;
	               tempdouble -= PAtextnumber;
	            }
	
	            s8 neg = 0; // Si negatif, passe  1...
	            if (test < 0) {
	               PAtextnumber = -PAtextnumber;
				   //tempdouble = -tempdouble;
	               neg = 1;
	            }
	
	            for (i = 0; PAtextnumber || (!PAtextnumber && !i); i++) {  // tant que le nombre ne vaut pas 0 mais que i est positif, on continu  la convertir...
	               PAtext[i] = '0' + (PAtextnumber%10);
	               PAtextnumber = PAtextnumber / 10; // Nombre de dpart...
	            }
	            if (neg) {
	               PAtext[i] = '-';
	               ++i;
	            }
	            for (i--; i > -1; i--) {
	               	charTemp[textcount] = PAtext[i];
	               ++ textcount;
	            }
	            j += 1;
	            
	            if (text[j] == 'f') { // Il reste donc la virgule  traiter...
	               charTemp[textcount] = '.';
	
	               ++ textcount;
	               i = text[j+1] - 48;  // Nombre de chiffres aprs la virgule...
	               PAtext[1] = 0; // Permet de stopper si c'est vba...
				   if (tempdouble < 0) tempdouble = -tempdouble;
	               while((i-- > 0)) { // Pas plus de 6 chiffres aprs la virgule...
	                  tempdouble *= 10;
					  //if (
	                  PAtextnumber = (s32)tempdouble;
	                  tempdouble -= PAtextnumber;
	                  PAtext[0] = '0' + PAtextnumber;
							charTemp[textcount] = PAtext[0];
	                  ++ textcount;
	               }
	            j += 1;
	            }
	
	          }
			  else if ((text[j+3] == 'd') && (text[j+1] != ' ')&& (text[j+2] != ' ')){ // C'est plus loin, donc on a genre %02d...
	            PAtextnumber = va_arg(varg, s32);
	            s8 neg = 0; // Si negatif, passe  1...
				u8 amettre = text[j+1]; // Nombre  mettre pour remplir
				s8 nfois = text[j+2] - '0'; // Nombre de caractres  mettre
		
	            if (PAtextnumber < 0) {
	               PAtextnumber = -PAtextnumber;
	               neg = 1;
	            }
	
	            for (i = 0; PAtextnumber || (!PAtextnumber && !i); i++) {  // tant que le nombre ne vaut pas 0 mais que i est positif, on continu  la convertir...
	               PAtext[i] = 48 + (PAtextnumber%10);
	               PAtextnumber = PAtextnumber / 10; // Nombre de dpart...
				   nfois--; // Un nombre de moins  mettre...
	            }
				
				while(nfois > 0) { // On complte de 0 est tout...
					charTemp[textcount] = amettre;//'X';
					++textcount;
					--nfois;
				}
				
	            if (neg) {
	               PAtext[i] = '-';
	               ++i;
	            }
	            for (i--; i > -1; i--) {
	     				charTemp[textcount] = PAtext[i];
	               ++ textcount;
	            }
	            j += 3;
			  
			  }
	          else { // Sinon c'est juste
					charTemp[textcount] = text[j];
	            ++textcount;
	          }
	      }
		  else if (text[j] == '\n'){
		     textcount = 0;
	
		  }
	      else if ((text[j] == '/') && (text[j+1] == 'n')) {
	         textcount = 0;
	
			 j++;
	      }
	      else{
				charTemp[textcount] = text[j];
	         ++textcount;
	      }
	   }
	
				charTemp[textcount] = '\0';
	    va_end(varg);           /* Terminaison. */
	return charTemp;
}




void flushToMemory()
{
//   Soul_waitForVBL();
/*int i=0;
float stresser=100;
	for(i=100;i>0;i--)
	{
	   stresser/=(float)(i)/0.3214;
	}   */
//	PA_SetBrightness(1,1);
	swiIntrWait(0, 1);
	swiIntrWait(0, 1);
//	PA_SetBrightness(1,0);
}   
void cleanMemory(){
  restart3d();
	restart16cBg(0);
	restart16cBg(1); 
	restart16bitBg(0); 
	restart16bitBg(1); 

	PA_Reset3DSprites();
	PA_ResetBgSys();
	PA_ResetSpriteSys();	
	PA_DisableSpecialFx(0);
	PA_DisableSpecialFx(1);
 	PA_TextAlign(0);
	PA_16cTextLetterSpacing(0);
}	



 

int getDotPos(char* address)
{
   u16 i;
   i=strlen(address);
   while (1)
   {
		i--;
      if (address[i] == '.') 
		{
		   return i;   
		}   
		if (i==0)
		{
		   return 0;   
		}   
   }   
} 

char* getFiletype(char* address)
{
  char *charTemp= (char*)malloc(256); 
  memset(charTemp, 0, 256);
   u16 i,x;
   x=0;
	strncpy (charTemp,"",256);
   u16 len = strlen(address);
   i=len;

   while (1)
   {
		i--;
      if (address[i] == '.') 
		{
		   break;
		}
		if (i==0)
		{
		   return "";
		}   
   }   
   while (i<len)
   {
		i++;
		charTemp[x]=address[i];
		x++;
   }   
	charTemp[x]='\0';
	return charTemp;
} 

#define ATTR_DISABLED   (2<<8);

void hidesprite (u8 screen, u8 obj)
{
 PA_obj[screen][obj].atr0 |= (2<<8);

} 
void showsprite (u8 screen, u8 obj)
{
PA_obj[screen][obj].atr0 &= ~(2<<8);
}

void PA_Shutdown() //spinal
{
	IPC->aux |= BIT(6 ); // libnds arm7 code: #define PM_POWER_DOWN BIT(6)
}


char* getFileNameTrimmed(char* address)
{
   u16 i=0,y=0;
	char *output= (char*)malloc(256); 
   for (i=strlen(address); i>0; i--)
   {
      
      if (address[i] == '/') break;
   }
   i++;
   while (i<=strlen(address))
   {
      output[y]=address[i];
      y++;
      i++;
        	if (address[i]     == '.')  
        	if (address[i+1]   == 'n' || address[i+1]   == 'N')  
        	if (address[i+2]   == 'd' || address[i+2]   == 'D')  
        	if (address[i+3]   == 's' || address[i+3]   == 'S')  
        	break;
   }   
   output[y]='\0';
   return output;
}   
