#include <PA9.h>       // Include for PA_Lib
#include "functions.h"
#include "commonVariables.h"
#include "..\commands\main_menu\types.h"
#include "interfaceScreen.h"
extern int k;
extern int i;
extern int l;
extern FILE* readINI; 
extern FILE* recipeFile; 
extern FILE* imgFile;
extern FILE* projectInfo;
extern int i;
extern int canvasZoom;
extern char CurrentTheme[256];

void saveProject ()
{
   PA_SetBrightness(1,31);
   PA_SetBrightness(0,31);
	char charTemp[256];	
	sprintf(charTemp,"fat:/_menudo/themes/%s/mainscreen/theme.recipe",CurrentTheme);
	recipeFile = fopen (charTemp, "wb"); 
	for (i=0;i<30;i++)
	for (k=0;k<30;k++)
	{
	   sprintf(charTemp,"%d",sprite[i].data[k].key_frame);
	   fwrite (charTemp, 1 , 6 , recipeFile );
	   sprintf(charTemp,"%d",sprite[i].data[k].angle);
	   fwrite (charTemp, 1 , 6 , recipeFile );
	   sprintf(charTemp,"%ld",sprite[i].data[k].x);
	   fwrite (charTemp, 1 , 6 , recipeFile );
	   sprintf(charTemp,"%ld",sprite[i].data[k].y);
  	   fwrite (charTemp, 1 , 6 , recipeFile );
	   sprintf(charTemp,"%d",sprite[i].data[k].pivot_x);
	   fwrite (charTemp, 1 , 6 , recipeFile );
	   sprintf(charTemp,"%d",sprite[i].data[k].pivot_y);
	   fwrite (charTemp, 1 , 6 , recipeFile );
	   sprintf(charTemp,"%d",sprite[i].data[k].width);
	   fwrite (charTemp, 1 , 6 , recipeFile );
	   sprintf(charTemp,"%d",sprite[i].data[k].height);
	   fwrite (charTemp, 1 , 6 , recipeFile );
	   sprintf(charTemp,"%d",sprite[i].data[k].alpha);
	   fwrite (charTemp, 1 , 6 , recipeFile );
	   sprintf(charTemp,"%d",sprite[i].data[k].prio);
	   fwrite (charTemp, 1 , 6 , recipeFile );
	}	
	fclose(recipeFile);
	sprintf(charTemp,"fat:/_menudo/themes/%s/mainscreen/project.info",CurrentTheme);
	projectInfo = fopen (charTemp, "wb"); 
	for (k = 0; k <= numberofsprites-1; k++)
	{
	   sprintf(charTemp,"%d",spriteIsLocked[k]);
		fwrite (charTemp, 1 , 1 , projectInfo);
	}			
	fclose(projectInfo);
   PA_SetBrightness(1,0);
   PA_SetBrightness(0,0);
}   
void loadProject ()
{
//	PA_Print(0,"Load");
}
void hideItem (int item)
{
	spriteIsHidden[item] = !spriteIsHidden[item];
}
void lockItem (int item)
{
	spriteIsLocked[item] = !spriteIsLocked[item];
}
void zoomOut()
{
canvasZoom+=10;
}
void zoomIn()
{
canvasZoom-=10;
}

void clearClipboard()
{
	clipboardAmount=0;
}
void undoAction()
{
//	PA_Print(0,"Undo");
}
void redoAction()
{
//	PA_Print(0,"Redo");
}
void copyAll()
{
  	clipboardAmount=7;
	assignClipboard(0, sprite[selectedMenu].data[getKeyframe(selectedMenu)].x, CLIPBOARD_TYPE_X);
	assignClipboard(1, sprite[selectedMenu].data[getKeyframe(selectedMenu)].y, CLIPBOARD_TYPE_Y);
	assignClipboard(2, sprite[selectedMenu].data[getKeyframe(selectedMenu)].width, CLIPBOARD_TYPE_W);
	assignClipboard(3, sprite[selectedMenu].data[getKeyframe(selectedMenu)].height, CLIPBOARD_TYPE_H);
	assignClipboard(4, sprite[selectedMenu].data[getKeyframe(selectedMenu)].angle, CLIPBOARD_TYPE_R);
	assignClipboard(5, sprite[selectedMenu].data[getKeyframe(selectedMenu)].alpha, CLIPBOARD_TYPE_A);
	assignClipboard(6, sprite[selectedMenu].data[getKeyframe(selectedMenu)].prio, CLIPBOARD_TYPE_P);
  	clipboardBeingDragged=0;
}  	
void pasteAll()
{
   for (i=0;i<clipboardAmount;i++)
   {
	   switch (clipboard[i].Type)
	   {
			 case CLIPBOARD_TYPE_X: sprite[selectedMenu].data[getKeyframe(selectedMenu)].x = clipboard[i].Value;
			 								clipKeyFrame_IfAtCornerMenu(x);
			    							break;
			 case CLIPBOARD_TYPE_Y: sprite[selectedMenu].data[getKeyframe(selectedMenu)].y = clipboard[i].Value;
			 								clipKeyFrame_IfAtCornerMenu(y);			
			    							break;
			 case CLIPBOARD_TYPE_W: sprite[selectedMenu].data[getKeyframe(selectedMenu)].width = clipboard[i].Value;
			 								clipKeyFrame_IfAtCornerMenu(width);
			    							break;
			 case CLIPBOARD_TYPE_H: sprite[selectedMenu].data[getKeyframe(selectedMenu)].height = clipboard[i].Value;
			 								clipKeyFrame_IfAtCornerMenu(height);
			    							break;
			 case CLIPBOARD_TYPE_R: sprite[selectedMenu].data[getKeyframe(selectedMenu)].angle = clipboard[i].Value;
			 								clipKeyFrame_IfAtCornerMenu(angle);			
			    							break;
			 case CLIPBOARD_TYPE_A: sprite[selectedMenu].data[getKeyframe(selectedMenu)].alpha = clipboard[i].Value;
			 								clipKeyFrame_IfAtCornerMenu(alpha);
			    							break;
			 case CLIPBOARD_TYPE_P: sprite[selectedMenu].data[getKeyframe(selectedMenu)].prio = clipboard[i].Value;
			 								
			    							break;
		}   
   }  
}   
char* spriteToFilename(u8 sprite)
{
   switch(sprite)
   {
		case 0	: return "1";
		case 1	: return "2";
		case 2	: return "3";
		case 3	: return "4";
		case 4	: return "5";
		case 5	: return "a";
		case 6	: return "b";
		case 7	: return "c";
		case 8	: return "d";
		case 9	: return "e";
		case 10  : return "1a"; 
		case 11  : return "1b"; 
		case 12  : return "1c"; 
		case 13  : return "1d"; 
		case 14  : return "1e"; 
		case 15  : return "1f"; 
		case 16  : return "2a";
		case 17  : return "2b";
		case 18  : return "3a";
		case 19  : return "3b";
		case 20  : return "4a";
		case 21  : return "4b";
		case 22  : return "5a";
		case 23  : return "5b";
		case 24  : return "5c";
		case 25  : return "5d";
		case 26  : return "5e";
		case 27  : return "5f";
	}	
	return "out of range";
}   

void deleteClipboard(int clipboardID)
{
   clipboard[clipboardAmount].Type=0;
   clipboardAmount--;
   for (i=clipboardID-1;i<clipboardAmount;i++)
   {
      clipboard[i].Type =clipboard[i+1].Type;
      clipboard[i].Value =clipboard[i+1].Value;
   }
   clipboard[clipboardAmount].Type=0;
}   
