#include <PA9.h>       // Include for PA_Lib
#include "../../gfx/all_gfx.h"
#include "../../engine/engine.h"
#include "../services/mWifi.h"
/*#include "tempBG.h"
#include "borderbottom.h"
#include "borderbottom_alpha.h"
#include "bordertop.h"
#include "bordertop_alpha.h"

#include "arrow.h"
#include "arrow_alpha.h"
#include "avatar.h"

#include "roundedtop.h"
#include "roundedtop_alpha.h"
#include "roundedbottom.h"
#include "roundedbottom_alpha.h"

#include "topscreen_achievements.h"
#include "topscreen_trash.h"
#include "topscreen_buddy.h"
#include "topscreen_sent.h"
#include "topscreen_outbox.h"
#include "topscreen_inbox.h"
#include "topscreen_messages.h"
#include "topscreen_messagewindow.h"
#include "topscreen.h"
#include "guildScreen.h"
#include "message_alpha.h"
#include "message.h"*/
u16 borderTopTex;
u16 borderBottomTex;
u16 roundedTopTex;
u16 roundedBottomTex;
u16 borderImgTex;
u16 arrowTex;
u16 messageWindow;
extern bool messageNew[100];
extern int selectedMessage;
extern int achievementAmount;
extern int inboxNew;
extern int inboxAmount;
extern int outboxAmount;
extern int sentAmount;
extern int trashAmount;
extern u8 buddyAmount;
extern u8 buddyOnline;
int menuScroll=0;
extern int subMenu;
bool mWifi_menuChanged=0;
bool mWifi_returnToShrink=0; 

#define INBOX_SPRITE_AMOUNT 500
void checkButtonHit()
{   
   if (!Stylus.Held) return;
	u8 i=0;
	for (i=0;i<5;i++)
		if (PA_StylusInZone(6,4+(21*i),6+20,4+(21*(i+1))))
		{
		   break;
		}		
	if (i==5	) return;
	if (i==subMenu) return;
	subMenu=i;
	mWifi_changeMenu(subMenu);
}		

void mWifi_init3dBox()
{
/*	borderTopTex = CreateTexFromBmpWithAlpha((void*)bordertop,0,(void*)bordertop_alpha);
	borderBottomTex = CreateTexFromBmpWithAlpha((void*)borderbottom,1,(void*)borderbottom_alpha);
	roundedTopTex = CreateTexFromBmpWithAlpha((void*)roundedtop,2,(void*)roundedtop_alpha);
	roundedBottomTex = CreateTexFromBmpWithAlpha((void*)roundedbottom,3,(void*)roundedbottom_alpha);
	messageWindow = CreateTexFromBmpWithAlpha((void*)message,7,(void*)message_alpha);
	borderImgTex = CreateTexFromBmp((void*)avatar,5);
	arrowTex = CreateTexFromBmpWithAlpha((void*)arrow,6,(void*)arrow_alpha);*/
	borderTopTex = CreateTexFromThemeResource("mwifi/bordertop.bmp",0,1);
	borderBottomTex = CreateTexFromThemeResource("mwifi/borderbottom.bmp",1,1);
	roundedTopTex = CreateTexFromThemeResource("mwifi/roundedtop.bmp",2,1);
	roundedBottomTex = CreateTexFromThemeResource("mwifi/roundedbottom.bmp",3,1);
	messageWindow = CreateTexFromThemeResource("mwifi/message.bmp",7,1);
	borderImgTex = CreateTexFromThemeResource("mwifi/avatar.bmp",5,1);
	arrowTex = CreateTexFromThemeResource("mwifi/arrow.bmp",6,1);
}	   
void mWifi_create3dBox(int sprite, int x, int y, int width, int height, bool rounded, u8 windowType)
{
   if (rounded)
	{   
	   PA_3DCreateSpriteFromTex(sprite,roundedTopTex,width,height,2,x,y);
	   PA_3DCreateSpriteFromTex(sprite+1,roundedBottomTex,width,16,3,x,y+(height/2)+8);
	   PA_3DCreateSpriteFromTex(sprite+2,roundedTopTex,16,height,2,(width/2)+x+8,y);
	   PA_3DCreateSpriteFromTex(sprite+3,roundedBottomTex,16,16,3,(width/2)+x+8,y+(height/2)+8);
	}
	else
	{   
	   PA_3DCreateSpriteFromTex(sprite,borderTopTex,width,height,0,x,y);
	   PA_3DCreateSpriteFromTex(sprite+1,borderBottomTex,width,16,1,x,y+(height/2)+8);
	   PA_3DCreateSpriteFromTex(sprite+2,borderTopTex,16,height,0,(width/2)+x+8,y);
	   PA_3DCreateSpriteFromTex(sprite+3,borderBottomTex,16,16,1,(width/2)+x+8,y+(height/2)+8);
	}   
   PA_3DSetSpriteHflip(sprite+2,1);
   PA_3DSetSpriteHflip(sprite+3,1);
   if (windowType==1)
   {
   	PA_3DCreateSpriteFromTex(sprite+4,borderImgTex,64,64,5,x+40-(width/2),y+8-height);
	}  	
   if (windowType==2)
   {
   	PA_3DCreateSpriteFromTex(sprite+4,arrowTex,16,16,6,x+23-(width/2),y+8);
   	PA_3DSetSpriteTopLeft(sprite+4,0,-38);
   	PA_3DSetSpriteTopRight(sprite+4,0,-38);
   	PA_3DSetSpriteBottomLeft(sprite+4,0,-38);
   	PA_3DSetSpriteBottomRight(sprite+4,0,-38);
	}  	
//   PA_3DSetSpriteAlpha(sprite,0);
//   PA_3DSetSpriteAlpha(sprite+1,0);
//   PA_3DSetSpriteAlpha(sprite+2,0);
//   PA_3DSetSpriteAlpha(sprite+3,0);
}   
void mWifi_set3dBoxXY(int sprite,int x,int y)
{
   PA_3DSetSpriteXY(sprite,x,y);
   PA_3DSetSpriteXY(sprite+1,x,y+(pa_3dsprites[sprite].Height/2)+8);
   PA_3DSetSpriteXY(sprite+2,(pa_3dsprites[sprite].Width/2)+x+8,y);
   PA_3DSetSpriteXY(sprite+3,(pa_3dsprites[sprite].Width/2)+x+8,y+(pa_3dsprites[sprite].Height/2)+8);
   PA_3DSetSpriteXY(sprite+4,x+40-(pa_3dsprites[sprite].Width/2),y+34-(pa_3dsprites[sprite].Height/2));
}   
bool mWifi_3dBoxTouched(int sprite)
{
   if (PA_3DSpriteTouched(sprite)) return 1;
   if (PA_3DSpriteTouched(sprite+1)) return 1;
   if (PA_3DSpriteTouched(sprite+2)) return 1;
   if (PA_3DSpriteTouched(sprite+3)) return 1;
   if (PA_3DSpriteTouched(sprite+4)) return 1;
   return 0;
}
void mWifi_set3dBoxPriority(int sprite,int priority)   
{
   PA_3DSetSpritePrio(sprite+0,priority);
   PA_3DSetSpritePrio(sprite+1,priority);
   PA_3DSetSpritePrio(sprite+2,priority);
   PA_3DSetSpritePrio(sprite+3,priority);
   PA_3DSetSpritePrio(sprite+4,priority);
}   
void mWifi_3dSpriteEaseToXY(int sprite,int x, int y)
{
   int easeX = ((PA_3DGetSpriteX(sprite)-x)*.8);
   int easeY = ((PA_3DGetSpriteY(sprite)-y)*.8);
   
   PA_3DSetSpriteXY(sprite,x+easeX,y+easeY);
}   
void mWifi_3dBoxEaseToXY(int sprite,int x, int y)
{
	if(!(PA_3DGetSpriteX(sprite)==x && PA_3DGetSpriteY(sprite)==y))
	{
	   int easeX = ((PA_3DGetSpriteX(sprite)-x)*.8);
	   int easeY = ((PA_3DGetSpriteY(sprite)-y)*.8);
	   
      mWifi_set3dBoxXY(sprite,x+easeX,y+easeY);
      mWifi_set3dBoxPriority(sprite,1024+1);
	}   
	else
      mWifi_set3dBoxPriority(sprite,1024);
}
void mWifiAllowEasing()
{
   if (!Stylus.Newpress) return;
	int x,y;
	int sprite=0;
	while(true)
	{
	   if (mWifi_3dBoxTouched(sprite)) break;
	   if (!pa_3dsprites[sprite].Alive)return;
	   sprite+=5;
	}   
	if (mWifi_3dBoxTouched(sprite))
	{
	   x = Stylus.X -PA_3DGetSpriteX(sprite);
	   y = Stylus.Y -PA_3DGetSpriteY(sprite);
	   while(Stylus.Held)
	   {
			mWifi_UpdateEasing();
	      mWifi_set3dBoxXY(sprite,Stylus.X-x,Stylus.Y-y);
			mWifi_UpdateText();
			updateAmbience();
   		ZoomXY_3DProcess(128,0,0);
			Soul_waitForVBL();
		}			
	}		   
}
#define StylusInLeftTextToolbar() PA_StylusInZone(5,178,100,192)
#define StylusInRightTextToolbar() PA_StylusInZone(5,150,250,192)
void mWifi_composeMessage()
{
   PA_16cErase(0);
   char* chrtemp = NULL;
   char* wifiString= malloc(100+100+100+100);
   memset(wifiString,0,(100+100+100+100));
   setKeyboardShrinkZoom(0);
   chrtemp  = inputKeyboard(0, "toUsername",PA_3DGetSpriteX(0)+43-(pa_3dsprites[0].Width/2),PA_3DGetSpriteY(0)+26-(pa_3dsprites[0].Height/2),PA_3DGetSpriteX(0)+(pa_3dsprites[0].Width/2)-5,PA_3DGetSpriteY(0)+(pa_3dsprites[0].Height/2), 0, PLAIN_TEXTCOLOR, 0, 1,5, 0, 1,0);
   if (!inputKeyboard_EndedWithEnter())
   {
	   if (chrtemp!=NULL) free(chrtemp);
	   if (wifiString!=NULL) free(wifiString);
      return;
   }
	flushToMemory();   
	sprintf(wifiString, "action=12&sid=%s&toUsername=%s",wifi.SID,chrtemp);
	flushToMemory();
   if (chrtemp!=NULL) free(chrtemp);
   chrtemp  = inputKeyboard(0, "subject",PA_3DGetSpriteX(0)+43-(pa_3dsprites[0].Width/2),PA_3DGetSpriteY(0)+26-(pa_3dsprites[0].Height/2),PA_3DGetSpriteX(0)+(pa_3dsprites[0].Width/2)-5,PA_3DGetSpriteY(0)+(pa_3dsprites[0].Height/2), 0, PLAIN_TEXTCOLOR, 0, 1,5, 0, 1,0);
   if (!inputKeyboard_EndedWithEnter())
   {
	   if (chrtemp!=NULL) free(chrtemp);
	   if (wifiString!=NULL) free(wifiString);
      return;
   }   
	flushToMemory();
	sprintf(wifiString, "%s&subject=%s",wifiString,chrtemp);
	flushToMemory();
   if (chrtemp!=NULL) free(chrtemp);
   chrtemp  = inputKeyboard(0, "body",PA_3DGetSpriteX(0)+43-(pa_3dsprites[0].Width/2),PA_3DGetSpriteY(0)+26-(pa_3dsprites[0].Height/2),PA_3DGetSpriteX(0)+(pa_3dsprites[0].Width/2)-5,PA_3DGetSpriteY(0)+(pa_3dsprites[0].Height/2), 0, PLAIN_TEXTCOLOR, 0, 1,5, 0, 1,0);
   if (!inputKeyboard_EndedWithEnter())
   {
	   if (chrtemp!=NULL) free(chrtemp);
	   if (wifiString!=NULL) free(wifiString);
      return;
   }   
	flushToMemory();
	sprintf(wifiString, "%s&body=%s&",wifiString,chrtemp);
	flushToMemory();
   setKeyboardShrinkZoom(1);

   if (chrtemp!=NULL) free(chrtemp);

	char * BB_msgOutline= malloc(10);
   memset(BB_msgOutline,0,sizeof(BB_msgOutline));

   		
	myPostHTTP(BB_msgOutline,MWIFI_LINK,wifiString);
	flushToMemory();	flushToMemory();
	Soul_waitForVBL();
//   if (wifiString!=NULL) free(wifiString); //magerror un http post kung na free ito na hindi pa tapus un post
//   if (BB_msgOutline!=NULL) free(BB_msgOutline);
   
	initAntiAliasedText(0,1,1);
	setAntiAliasDepth(0,31);
	initAntiAliasedText(1,0,1);
	setAntiAliasDepth(1,31);
}  
#define DOUBLECLICK_TIMER 20
bool mWifi_dragList(int amount)
{
	int originY;
	int accelY;
	int doubleClickCounter=0;
	int doubleClickMenu=-1;
	int i;
	do
	{
		originY=Stylus.Y;
		accelY=0;
		if (Stylus.Newpress && Stylus.X >6+20 && subMenu>=10) 
		{
		   doubleClickCounter=DOUBLECLICK_TIMER;
		   doubleClickMenu=(Stylus.Y/40)+(menuScroll/-40);
		}   
		while (Stylus.Held)
		{
			if (Stylus.Newpress  && Stylus.X <=6+20) break;
		   accelY = Stylus.Y-originY;
		   menuScroll+=accelY;
		   originY=Stylus.Y;
			mWifi_UpdateEasing();
			if (doubleClickCounter>0) doubleClickCounter--;
			if (doubleClickCounter>DOUBLECLICK_TIMER-5)
			{
	   		for (i=5;i>=0;i--)
			      if (mWifi_3dBoxTouched(i*5))
			      {
			         break;
			      }
		      if (i!=-1) mWifi_set3dBoxXY(i*5,pa_3dsprites[i*5].X,pa_3dsprites[i*5].Y+1);
			} 
	  		mWifi_UpdateText();
	  		updateAmbience();
			ZoomXY_3DProcess(128,0,0);
			Soul_waitForVBL();
		}
		accelY=accelY<<2;
		while (accelY!=0 || (subMenu>=10 && doubleClickCounter>0))
		{
		   if (Stylus.Newpress) accelY=0;
   		if ((menuScroll>=(amount-4)*-40 && menuScroll <=0)) 
			   accelY*=.9;
			else
				accelY*=.4;
		   menuScroll+=accelY>>2;

			mWifi_UpdateEasing();

			if (doubleClickCounter>0) doubleClickCounter--;
			if (doubleClickCounter>DOUBLECLICK_TIMER-5)
			{
	   		for (i=5;i>=0;i--)
			      if (mWifi_3dBoxTouched(i*5))
			      {
			         break;
			      }
		      if (i!=-1) mWifi_set3dBoxXY(i*5,pa_3dsprites[i*5].X,pa_3dsprites[i*5].Y+1);
			}   
	  		mWifi_UpdateText();
	  		updateAmbience();
			ZoomXY_3DProcess(128,0,0);
			if (subMenu>=10)
			{
			   if (Stylus.Newpress)
				{
					if (Stylus.Newpress && Stylus.X >6+20) 
					{
					   if (doubleClickMenu==(Stylus.Y/40)+(menuScroll/-40))
					   {
					      selectedMessage=(Stylus.Y/40)+(menuScroll/-40);
					      return 1;
					   }
						else
						{   
						   doubleClickCounter=DOUBLECLICK_TIMER;
						   doubleClickMenu=(Stylus.Y/40)+(menuScroll/-40);
						}   
					}   
				   break;
				}   
			}			
			Soul_waitForVBL();
		}			
	}while (Stylus.Newpress);
	return 0;
}	 
void mWifi_logout()
{
   
}   
void mWifi_CheckMenuActions()
{
   int i=0;
   int amount=0;
   switch (subMenu)
   {
		case 20: 
		case 21: 
		case 22: 
		case 23: 
					if (Stylus.Newpress)
					{
						if (StylusInLeftTextToolbar())
						{
						   subMenu-=10;
						   mWifi_changeMenu();
						}   
						if (StylusInRightTextToolbar()) mWifi_composeMessage();
					}			
		   		mWifiAllowEasing();
					break;
      case 3:
      case 0: 
					if (Stylus.Newpress)
					{
						if (StylusInLeftTextToolbar()) mWifi_returnToShrink=1; 
						if (StylusInRightTextToolbar())
						{
						   BB_logoffUser();
						   mWifi_returnToShrink=1; 
						}   
					}			
		   		mWifiAllowEasing();
					break;
      case 1:	if (Stylus.Newpress)
      			{
      			   
			   		for (i=3;i>=0;i--)
					      if (mWifi_3dBoxTouched(i*5))
					      {
					         break;
					      }
					   if(i!=-1)
					   {
					      int timer=0;
					      Stylus.Newpress=0;
					      mWifi_set3dBoxXY(i*5,pa_3dsprites[i*5].X,pa_3dsprites[i*5].Y+1);
							mWifi_UpdateText();
							updateAmbience();
							ZoomXY_3DProcess(128,0,0);
							Soul_waitForVBL();
							for(timer=DOUBLECLICK_TIMER;timer>0;timer--)
	         			{
	         			   if (timer==DOUBLECLICK_TIMER-2) mWifi_set3dBoxXY(i*5,pa_3dsprites[i*5].X,pa_3dsprites[i*5].Y-1);
								if (!mWifi_3dBoxTouched(i*5))
								{
									break;
								}			
								else
	         			   if (Stylus.Newpress)
         			   	{
         			   	   subMenu=10+i;
         			   	   mWifi_changeMenu(subMenu);
         			   	   return;
         			   	}   
								mWifi_UpdateText();
								updateAmbience();
								ZoomXY_3DProcess(128,0,0);
								Soul_waitForVBL();
	         			}   
	         			break;
							Stylus.Newpress=1;		
					   }   
				   }   
				   break;
      case 2:	
      case 4:	
      case 10:	
      case 11:	
      case 12:	
      case 13:	
		   	   switch (subMenu)
				   {
						case 2: 	amount=buddyAmount;
						   		break;
						case 4: 	amount=achievementAmount;
						   		break;
						case 10: amount=inboxAmount;
						   		break;
						case 11: amount=outboxAmount;
						   		break;
					   case 12: amount=sentAmount;
						   		break;
						case 13: amount=trashAmount;
						   		break;


					 }  	
					if (Stylus.Newpress && subMenu >=10)
					{
						if (StylusInLeftTextToolbar())
						{
						   subMenu=1;
						   mWifi_changeMenu();
						}   
						if (StylusInRightTextToolbar()) mWifi_composeMessage();
					}	
					if (Stylus.Newpress && Stylus.X >6+20)
					{
						bool changeMenu = mWifi_dragList(amount);
						if (changeMenu && selectedMessage<amount)
						{
						   if (messageNew[selectedMessage]) mWifi_sendMessengeAsRead(selectedMessage);
						   subMenu+=10;
							mWifi_changeMenu();
						}			
					}		
					else
					{
			   		if (menuScroll>=(amount-4)*-40 && menuScroll <=0)
						{
	//					   if (menuScroll <0) if (Pad.Held.Down) menuScroll++;
	//						if (menuScroll>(amount-4)*-40) if (Pad.Held.Up) menuScroll--;
	
						}			
						else
						{
			   			if (0<menuScroll || amount<4)
			   			{
			   			   menuScroll*=.92;
			   			}
			   			else
			   			if ((menuScroll/-40)>=(amount-4))
			   			{
			   			   i=(menuScroll-((amount-4)*-40));
			   			   i*=.92;
			   			   menuScroll=((amount-4)*-40)+i;
			   			}
					   }			
					}   
      			break;
	}			   
	return;
}	
//int abs(int i) {return i*(i<0?-1:1);}
void mWifi_UpdateEasing()
{
   int i=0;
	int temp=0;
	int amount=0;

   switch (subMenu)
   {
      case 0:	mWifi_3dBoxEaseToXY(0,134,30);
					mWifi_3dBoxEaseToXY(5,134,120);
					break;
		case 1: 	for (i=0;i<4;i++)
		   		{
			   		mWifi_3dBoxEaseToXY(i*5,134,10+(30*i));
				  	} 	
				  	break;
			case 2: 	
			case 4: 	
			case 10: 
			case 11: 
		   case 12: 
			case 13: 
			   	   switch (subMenu)
					   {
							case 2: 	amount=buddyAmount;
							   		break;
							case 4: 	amount=achievementAmount;
							   		break;
							case 10: amount=inboxAmount;
							   		break;
							case 11: amount=outboxAmount;
							   		break;
						   case 12: amount=sentAmount;
							   		break;
							case 13: amount=trashAmount;
							   		break;
						 }  
						 if (mWifi_menuChanged)
						 {
							 while(!(Stylus.Newpress || (!mWifi_menuChanged && Stylus.Held)))
							 {
								for (i=0;i<6;i++)
					   		{
					   		   temp = 15+(40*i)+(menuScroll%240)+40;
					   		   if (temp<0)
						   		   temp = 240-(abs(temp)%240);
						   		//if (i+((i)+menuScroll)/40)>=inboxAmount)
						   		if ((temp-menuScroll)/40>=amount+1)
						   		{
						   			mWifi_set3dBoxXY(i*5,134,-100);
						   			continue;
								   }			
						   		temp-=40;
						   		mWifi_3dBoxEaseToXY(i*5,134,temp);
							  	} 	
								mWifi_UpdateText();
								updateAmbience();
								ZoomXY_3DProcess(128,0,0);
							  	Soul_waitForVBL();
							  	if (mWifi_menuChanged && !Stylus.Held) mWifi_menuChanged=0;
							  	if (Stylus.Held)
							  	{
									for (i=0;i<5;i++)
										if (PA_StylusInZone(6,4+(21*i),6+20,4+(21*(i+1))))
										{
										   break;
										}		
									if (i!= 5&& i!= subMenu) break;
								}			
							 }   
							 Stylus.Newpress=1;
							mWifi_CheckMenuActions();
							
						}		 
						for (i=0;i<6;i++)
			   		{
			   		   temp = 15+(40*i)+(menuScroll%240)+40;
			   		   if (temp<0)
				   		   temp = 240-(abs(temp)%240);
				   		//if (i+((i)+menuScroll)/40)>=inboxAmount)
				   		if ((temp-menuScroll)/40>=amount+1)
				   		{
				   			mWifi_set3dBoxXY(i*5,134,-100);
				   			continue;
						   }			
				   		temp-=40;

				   		mWifi_set3dBoxXY(i*5,134,temp);

					  	} 	
					  	break;
		/*case 2: 	for (i=0;i<8;i++)
		   		{
			   		mWifi_3dBoxEaseToXY((i)*5,134-(51*(i%2?-1:1)),(40*((i+2)/2))-27);
				  	} 	*/
		case 20: 
		case 21: 
		case 22: 
		case 23: 
		   		mWifi_3dSpriteEaseToXY(0,128,128);
					break;
      case 3:	mWifi_3dBoxEaseToXY(0,134,80);
					break;
	}		
	mWifi_menuChanged=0;
}		
#define MWIFI_16C_BGY_SCROLL 8

void mWifi_changeMenu()
{
   mWifi_menuChanged=1;
   int i=0;
   mWifi_clearInterface();
   PA_16cErase(1);

	mWifi_displayTopScreenUsername();
	PA_BGScrollY(0,1,8);
   switch (subMenu)
   {
      case 0: 	loadBMPWithResource(1,0,0,"mwifi/topscreen/main.bmp");
					mWifi_create3dBox(0,134,30,188,56,0,1);
					mWifi_create3dBox(5,134,120,188,69,1,2);
					break;
		case 1: 	loadBMPWithResource(1,0,0,"mwifi/topscreen/messages.bmp");
					for (i=0;i<4;i++)
		   		{
			   		mWifi_create3dBox(i*5,134,10+(40*i),188,16,0,0);
				  	} 		
				  	mWifi_displayMessagesTextAmount();
					break;
			case 2: 	
			case 10: 
			case 11: 
		   case 12: 
			case 13: 
			case 4:
			   		mWifi_refreshDataFromAccount();
			   		switch (subMenu)
						{
							case 2: 	loadBMPWithResource(1,0,0,"mwifi/topscreen/buddy.bmp");
										break;
							case 10: loadBMPWithResource(1,0,0,"mwifi/topscreen/inbox.bmp");
										break;
							case 11: loadBMPWithResource(1,0,0,"mwifi/topscreen/outbox.bmp");
										break;
						   case 12: loadBMPWithResource(1,0,0,"mwifi/topscreen/sent.bmp");
										break;
							case 13: loadBMPWithResource(1,0,0,"mwifi/topscreen/trash.bmp");
										break;
							case 4:	loadBMPWithResource(1,0,0,"mwifi/topscreen/achievements.bmp");
										break;
						}			
			   		if (subMenu==2) mWifi_displayBuddyTextAmount();
			   		if (subMenu!=4 && subMenu!=2) mWifi_displayMessagesTextAmount();
						menuScroll=0;
			   		PA_BGScrollY(0,1,8+MWIFI_16C_BGY_SCROLL);
						for (i=0;i<6;i++)
			   		{
				   		mWifi_create3dBox(i*5,134,15+(40*i),188,24,0,0);
					  	} 		
						break;
		case 20: 
		case 21: 
		case 22: 
		case 23: 
		   		loadBMPWithResource(1,0,0,"mwifi/topscreen/messages.bmp");
		   		PA_3DCreateSpriteFromTex(0,messageWindow,256,256,7,256/2,256/2);
		   		PA_BGScrollY(0,1,8+MWIFI_16C_BGY_SCROLL);
		   		mWifi_displayMessageInfo();
		   		return;
					break;
//					mWifi_create3dBox(0,134,8,188,12,0,0);
/*		   		for (i=0;i<7;i++)
		   		{
			   		mWifi_create3dBox(i*5,134,15+(40*i),188,24,0,0);
//			   		mWifi_create3dBox(i*5,134-(51*(i%2?-1:1)),(40*((i+2)/2))-5,85,24,0,0);
				  	} 		
					break; */
      case 3: 	PA_16cErase(1);
      			PA_16cErase(0);
					loadBMPWithResource(1,0,0,"mwifi/topscreen/guildScreen.bmp");
					mWifi_create3dBox(0,134,80,188,160,0,1);
					break;
	}
	int x,y;			
	for (i=0;i<=7;i++)
	{
	   x = PA_3DGetSpriteX(i*5)+((PA_3DGetSpriteX(i*5)-128)/2);
	   y = PA_3DGetSpriteY(i*5)+((PA_3DGetSpriteY(i*5)-96)/2);
	   x+= PA_RandMax(64)-32;
	   y+= PA_RandMax(64)-32;
	   mWifi_set3dBoxXY(i*5,x,y);
	}   
}   
void mWifi_clear16cWindow(int sprite)
{
   clear16cZone(0,4+PA_3DGetSpriteX(sprite)-(pa_3dsprites[sprite].Width/2),3+PA_3DGetSpriteY(sprite)-(pa_3dsprites[sprite].Height/2),12+PA_3DGetSpriteX(sprite)+(pa_3dsprites[sprite].Width/2),10+PA_3DGetSpriteY(sprite)+(pa_3dsprites[sprite].Height/2));
}   

void mWifi_removeBottomBar16c()
{
	int x,y;	
	for(x=0;x<256;x++)
		for(y=186;y<200;y++)
			PA_16cDeletePixel(0,x,y);
}	
void mWifi_create16cSeperator(int x,int y)
{
   int i;
		for(i=-8;i<=4;i++)
			PA_16cPutPixel(0,x,y+i,4);   
}   

void mWifi_clearInterface()
{
   int i;
   for (i=0;i<INBOX_SPRITE_AMOUNT;i++) PA_3DSetSpriteVisible(i,0);
}   

