#include <PA9.h>

struct playerInfo{
	struct songInfo{
	   char title[256];
	   char author[256];
	   int duration;
	   int currentTime;
	} Song;
   u8 state;
} Player;

#define PLAYMODE_STOP 0
#define PLAYMODE_PAUSE 1
#define PLAYMODE_PLAY 2



bool isMusicPlaying()
{
   return Player.state==PLAYMODE_PLAY;
}   
void playMusic()
{
   Player.state = PLAYMODE_PLAY;
}   
void pauseMusic()
{
   Player.state = PLAYMODE_PAUSE;
}   
void stopMusic()
{
   Player.state = PLAYMODE_STOP;
}   

char* getSongTitle()
{
   return Player.Song.title;
}   

char* getSongAuthor()
{
   return Player.Song.author;
}   

char* getDurationString()
{
   char* duration = malloc(sizeof(char)*100);
   sprintf(duration,"%d:%d",Player.Song.duration/60
									,Player.Song.duration%60);
	return duration;
}   

char* getCurrentTimeString()
{
   char* duration = malloc(sizeof(char)*100);
   sprintf(duration,"%d:%d",Player.Song.currentTime/60
									,Player.Song.currentTime%60);
	return duration;
}
void loadMusic()
{
   sprintf(Player.Song.title,"Happiness");
   sprintf(Player.Song.author,"Monkey Magic");
   Player.Song.duration = 387;
   Player.Song.currentTime = 100;
}   

void togglePlayPauseMusic()
{
   if (Player.state == PLAYMODE_PLAY)
	   pauseMusic();
	else
		playMusic();
   
}   
