#include <PA9.h>
#include "../engine/engine.h"
#include "../scripter/ideScripter.h"
#include "shrink.h"
#include "../misc/clock.h"
#include "../misc/misc.h"
#include "../misc/transition.h"
#include "../userConfigFunctions.h"
extern int shrinkX;
extern int shrinkY;
void removeShrinkBackground()
{
/*   Soul_waitForVBL();
   Soul_waitForVBL();
   int transparentColor = PA_16cGetPixel(0,35,35);
	int x, y;
   for (y=24;y<192;y++)
	   for (x=31;x<256;x++)
	   	if (PA_16cGetPixel(0,x,y) == transparentColor) 
			PA_16cDeletePixel(0,x,y);*/
}   
void shrinkFlashLightApp()
{
   PA_16cErase(0);

   PA_EnableSpecialFx(0, SFX_NONE, SFX_BG1 , SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
   
   load16cBMPWithResource(0,0,0,"shrink/FlashLight.16c.bmp");
	removeShrinkBackground();
	 int i=0;  
	while(true)
	{
	   if (Stylus.Newpress)
	   {
			if (PA_StylusInZone(77,45,77+100,45+100))
		   {
		      PA_SetDSLBrightness(3);
		      Soul_waitForVBL();
	         PA_SetBrightness(0,31);
	         PA_SetBrightness(1,31);
	         Stylus.Newpress=0;
		      while(!(Stylus.Newpress || Pad.Newpress.Anykey || Pad.Held.Y))
		      {
		         Soul_waitForVBL();
		      }   
   
	         PA_SetBrightness(0,0);
	         PA_SetBrightness(1,0);
	         PA_SetDSLBrightness(system.BacklightStrength);
		   }   
		   else
				if (PA_StylusInZone(102,148,102+50,148+15) ) break;
			else
				if (!PA_StylusInZone(68,37,68+120,37+126) ) break;
		}   
		if (Pad.Newpress.L) break;
		updateAmbience();  //Update Ambience / Animated Background
		ZoomXY_3DProcess(112,(shrinkX+3)*-1,(shrinkY)*-1);
	   Soul_waitForVBL();
	}   
	changeShrinkPage(1);
}   

u8 shrinkThemeEdit(char * menu)
{
   PA_16cErase(0);

   PA_EnableSpecialFx(0, SFX_NONE, SFX_BG1 , SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
   
   load16cBMPWithResource(0,0,0,"shrink/ThemeTools.16c.bmp");
	removeShrinkBackground();
	 int i=0;  
	while(true)
	{
  
	   if (Stylus.Newpress)
	   {
			if (PA_StylusInZone(62,45,62+161,45+32))
	      {
			   cleanMemory();
          if (stricmp(menu,"gamenavigate")==0)
		      ambienceScripter(menu, SCRIPTFOR_GAMESELECT);
            else
		      rcpimaker();
			   return 1;
		   }
		   else
			if (PA_StylusInZone(62,80,62+161,80+32))
	      {
			   cleanMemory();
//		      rcpimaker();
		      ambienceScripter(menu, SCRIPTFOR_AMBIENCE);
			   return 1;
		   }
		   else
			if (PA_StylusInZone(62,134,62+161,134+32))
			{
			   changeShrinkPage(1);
			   return 0;
			}  	
			else
			if (PA_StylusInZone(50,40,50+177,40+133))
			{
			   changeShrinkPage(1);
			   return 0;
			}  	
		}   
		if (Pad.Newpress.L)
		{
		   changeShrinkPage(1);
		   return 0;
		}
		updateAmbience();  //Update Ambience / Animated Background
		ZoomXY_3DProcess(112,(shrinkX+3)*-1,(shrinkY)*-1);
	   Soul_waitForVBL();
	}   
}   
