#include <PA9.h>
#include "../../misc/misc.h"
#include "../../misc/math.h"
#include "../../engine/engine.h"
#include "../../engine/ambience/shunt.h"
#include "../../userConfigFunctions.h"
#include "game_select_accessors.h"
#include "game_select_animate.h"
#include "game_select_input.h"
#include "game_select_nds.h"
#include "game_select_struct.h"
extern int gameSelect_counter;
extern int SelectMenu;

extern u16 fileAmount;
 
#define SCROLLVALUE_DESTINATION 128
#define GAMESELECT_NORMAL_ANIMATION_SPEED 8

//void TopScreenText(u8 lineNumber);
s16 Custom16cText(u8 screen, s16 basex, s16 basey, s16 maxx, s16 maxy, char* text, u8 color, u8 size, s32 limit);


extern s32 AccelerationY;
extern u16 ndsIconTex;
void updateDpadScroll()
{
	if (AccelerationY==0 && !Stylus.Held && !getInputLeft()  && !getInputRight()) 
	{
		if (gameSelect_counter >0)
		{
		   if (gameSelect_counter < SCROLLVALUE_DESTINATION-20)
			   gameSelect_counter+= getGameSelectSpeed();
		   else
			   gameSelect_counter+= getGameSelectSpeed()/2;	   
		}   
		if (gameSelect_counter <0)
		{	
		   if (gameSelect_counter > -SCROLLVALUE_DESTINATION+20)
			   gameSelect_counter-= getGameSelectSpeed();
		   else
			   gameSelect_counter-= getGameSelectSpeed()/2;	   
		}	
	}			
}	
void updateStylusScroll()
{
	if (SelectMenu >0 && gameSelect_counter < -SCROLLVALUE_DESTINATION)
	{

		gameSelect_counter=0;
		SelectMenu--;
		char iconToUpdate=SelectMenu-3;
	   PA_3DSetSpriteTex(getIconSprite(iconToUpdate),ndsIconTex);
		PA_3DSetSpritePal(getIconSprite(iconToUpdate),2);
		getSelectIcon(iconToUpdate);		

	}		
	if (SelectMenu <=fileAmount-1&&gameSelect_counter > SCROLLVALUE_DESTINATION)
	{
	   gameSelect_counter=0;
		SelectMenu++;
		char iconToUpdate=SelectMenu+3;
		PA_3DSetSpriteTex(getIconSprite(iconToUpdate+7),ndsIconTex);
		PA_3DSetSpritePal(getIconSprite(iconToUpdate+7),2);
		getSelectIcon(iconToUpdate);		
	}	
}
void updateScroll()
{
	updateDpadScroll();
	updateStylusScroll();
}	

