#include <PA9.h>
#include "../../misc/misc.h"
#include "../../engine/ambience/ambience.h"
#include "../../engine/ambience/shunt.h"
#include "../../engine/text/text_engine.h"
#include "game_select_scriptengine.h"
#include "game_select_accessors.h"
#include "game_select_struct.h"
//#include "visualizer.h"
#include "../../engine/engine.h"
#include "../../userConfigFunctions.h"
extern char equation[20][MAX_AMBIENCEPROPERTIES][MAX_EQUATIONLENGTH];

void updateProperty(int i, int ambience,int property);
extern bool horizontalNavigationControls;
bool overlay_Found=0;
bool overlayDuplicate_Found=0;
bool iconDuplicate_Found=0;
u32 idleCounter=0;

extern int SelectMenu;
extern int gameSelect_counter;

extern u16 fileAmount;

#define PRIORITY_GAMESELECTICON_SPRITE 500
	


void updateIdleCounter()
{
	if ((gameSelect_counter%128)==0) idleCounter++;
}	
void loadGameSelectScript()
{
   char* filename = returnThemeResourcePath("/gamenavigate/Navigate.Script", 1);
	FILE* testRead = fopen (filename, "rb");  
	if (filename!=NULL) free(filename);
	if(testRead)
	{
	   char chrTemp[100];
	   fgets(chrTemp, 100, testRead);
	   if (PA_CompareText(chrTemp,"Navigate Script v.01"))
	   {
	      int x,i;
			for (x=0;x<MAX_GAMESELECT;x++)
			{
			 	if (x <= 3)
			 	{
					for (i=0;i<MAX_GAMESELECT_SPRITE_PROPERTIES;i++)
					{
				   	fgets(equation[GAMESELECT_EQUATION_START+x][i], MAX_EQUATIONLENGTH, testRead);
					   if (equation[GAMESELECT_EQUATION_START+x][i][strlen(equation[GAMESELECT_EQUATION_START+x][i])-1]=='\n')
						equation[GAMESELECT_EQUATION_START+x][i][strlen(equation[GAMESELECT_EQUATION_START+x][i])-1]='\0';
					}	 	  
				}		
				else
				{
					for (i=0;i<6;i++)
					{
				   	fgets(equation[GAMESELECT_EQUATION_START+x][i], MAX_EQUATIONLENGTH, testRead);
					   if (equation[GAMESELECT_EQUATION_START+x][i][strlen(equation[GAMESELECT_EQUATION_START+x][i])-1]=='\n')
						equation[GAMESELECT_EQUATION_START+x][i][strlen(equation[GAMESELECT_EQUATION_START+x][i])-1]='\0';
					}	
				} 
			}  
		}
	}			
	else
	{
//	   char testalert[100];
//	   sprintf(testalert,"%s",filename);
//		Alert(testalert);
	}		
	fclose(testRead);   
		
}   
extern int tempAnimVar;
extern bool heldIcon;
void updateOverlayProperty(int i, int iconSprite, int overlaySprite,int property)
{
 
	switch (property)
	{
	   case 0: if (!isSyntaxError()) 
	   
						pa_3dsprites[overlaySprite].X= i; 
					else
	   		  	 pa_3dsprites[overlaySprite].X = 0;
				  return;
		case 1: if (!isSyntaxError()) 
						pa_3dsprites[overlaySprite].Y= i; 
					else
				  	 pa_3dsprites[overlaySprite].Y = 0;
				  return;
		case 2: if (!isSyntaxError()) 
						pa_3dsprites[overlaySprite].Width= i; 
					else
				  	 pa_3dsprites[overlaySprite].Width = pa_3dsprites[overlaySprite].ImgWidth;
				  return;
		case 3: if (!isSyntaxError()) 
						pa_3dsprites[overlaySprite].Height= i; 
					else
				  	 pa_3dsprites[overlaySprite].Height = pa_3dsprites[overlaySprite].ImgHeight;
				  return;
		case 4: if (!isSyntaxError()) 
					{
						if (i>31) i=31;
						if (i<=0) 
						{
						   i=0;
						   PA_3DSetSpriteVisible(overlaySprite,0);
						}   
						
						pa_3dsprites[overlaySprite].alpha= i; 
					}			
					else
				  	 pa_3dsprites[overlaySprite].alpha = pa_3dsprites[iconSprite].alpha;
				  return;
		case 5: if (!isSyntaxError()) 
						pa_3dsprites[overlaySprite].RotZ= i; 
					else
				  	 pa_3dsprites[overlaySprite].RotZ = pa_3dsprites[iconSprite].RotZ ;
				  return;

		case 6: if (!isSyntaxError()) 
						pa_3dsprites[overlaySprite].RotX= i;
					else
				  	 pa_3dsprites[overlaySprite].RotX = pa_3dsprites[iconSprite].RotX;
				  return;
		case 7: if (!isSyntaxError()) 
						pa_3dsprites[overlaySprite].RotY= i; 
					else
				  	 pa_3dsprites[overlaySprite].RotY = pa_3dsprites[iconSprite].RotY;
				  return;
		case 8: if (!isSyntaxError()) 
						pa_3dsprites[overlaySprite].corner[0].x= i; 
					else
				  	 pa_3dsprites[overlaySprite].corner[0].x = pa_3dsprites[iconSprite].corner[0].x;
				  return;
		case 9: if (!isSyntaxError()) 
						pa_3dsprites[overlaySprite].corner[0].y= i; 
					else
				  	 pa_3dsprites[overlaySprite].corner[0].y = pa_3dsprites[iconSprite].corner[0].y;
				  return;
		case 10: if (!isSyntaxError()) 
						pa_3dsprites[overlaySprite].corner[1].x= i; 
					else
				  	 pa_3dsprites[overlaySprite].corner[1].x = pa_3dsprites[iconSprite].corner[1].x;
				  return;
		case 11: if (!isSyntaxError()) 
						pa_3dsprites[overlaySprite].corner[1].y= i; 
					else
				   	 pa_3dsprites[overlaySprite].corner[1].y = pa_3dsprites[iconSprite].corner[1].y;
					return;
		case 12: if (!isSyntaxError()) 
						pa_3dsprites[overlaySprite].corner[2].x= i;
					else
				   	 pa_3dsprites[overlaySprite].corner[2].x = pa_3dsprites[iconSprite].corner[2].x;
					return;
		case 13: if (!isSyntaxError()) 
						pa_3dsprites[overlaySprite].corner[2].y= i; 
					else
				   	 pa_3dsprites[overlaySprite].corner[2].y = pa_3dsprites[iconSprite].corner[2].y;
					return;
		case 14: if (!isSyntaxError()) 
						pa_3dsprites[overlaySprite].corner[3].x= i; 
					else
				   	 pa_3dsprites[overlaySprite].corner[3].x = pa_3dsprites[iconSprite].corner[3].x;
					return;
		case 15: if (!isSyntaxError()) 
						pa_3dsprites[overlaySprite].corner[3].y= i; 
					else
						pa_3dsprites[overlaySprite].corner[3].y = pa_3dsprites[iconSprite].corner[3].y;
					return;
		case 16: if (!isSyntaxError()) 
					{
						if (i>=MAX_AMBIENCE) 
						{
						   i=PRIORITY_ONTOP;
						   return;
						} 		
						if (i<=0) 
						{
						   i=0;
						}   
						pa_3dsprites[overlaySprite].Priority= PRIORITY_AMBIENCESPRITE+i; 
					}			
					else
						pa_3dsprites[overlaySprite].Priority= pa_3dsprites[iconSprite].Priority+1;
				  	return;
	}
}   
extern int abs(int num);
void updateIconProperty(int i, int sprite,int property)
{
	switch (property)
	{
	   case 0: if (!isSyntaxError()) 
						pa_3dsprites[sprite].X= i; 
					else
	   		  	 pa_3dsprites[sprite].X = 0;
   		  	    if (!horizontalNavigationControls)pa_3dsprites[sprite].X+=(tempAnimVar*2);
				  return;
		case 1: if (!isSyntaxError()) 
						pa_3dsprites[sprite].Y= i; 
					else
				  	 pa_3dsprites[sprite].Y = 0;
   		  	    if (horizontalNavigationControls)pa_3dsprites[sprite].Y+=(tempAnimVar*2);
				  return;
		case 2: if (!isSyntaxError()) 
						pa_3dsprites[sprite].Width= i; 
					else
				  	 pa_3dsprites[sprite].Width = pa_3dsprites[sprite].ImgWidth;
				  	 if (PA_3DSpriteTouched(sprite)) pa_3dsprites[sprite].Width-=heldIcon;
				  return;
		case 3: if (!isSyntaxError()) 
						pa_3dsprites[sprite].Height= i; 
					else
				  	 pa_3dsprites[sprite].Height = pa_3dsprites[sprite].ImgHeight;
				  	 if (PA_3DSpriteTouched(sprite)) pa_3dsprites[sprite].Height-=heldIcon;
				  return;
		case 4: if (!isSyntaxError()) 
					{
						if (i>31) i=31;
						if (i<=0) 
						{
						   i=0;
						   PA_3DSetSpriteVisible(sprite,0);
						}   
						
						pa_3dsprites[sprite].alpha= i; 
					}			
					else
				  	 pa_3dsprites[sprite].alpha = 31;
				  	 if (pa_3dsprites[sprite].alpha-abs(tempAnimVar*1.6)<0)
				  	 	pa_3dsprites[sprite].alpha=0;
				  	 else
						pa_3dsprites[sprite].alpha-=(abs(tempAnimVar*1.6));
						if (pa_3dsprites[sprite].alpha<=0) 
						{
						   PA_3DSetSpriteVisible(sprite,0);
						}   
				  return;
		case 5: if (!isSyntaxError()) 
						pa_3dsprites[sprite].RotZ= i; 
					else
				  	 pa_3dsprites[sprite].RotZ = 0;
				  return;

		case 6: if (!isSyntaxError()) 
						pa_3dsprites[sprite].RotX= i;
					else
				  	 pa_3dsprites[sprite].RotX = 0;
				  return;
		case 7: if (!isSyntaxError()) 
						pa_3dsprites[sprite].RotY= i; 
					else
				  	 pa_3dsprites[sprite].RotY = 0;
				  return;
		case 8: if (!isSyntaxError()) 
						pa_3dsprites[sprite].corner[0].x= i; 
					else
				  	 pa_3dsprites[sprite].corner[0].x = 0;
				  return;
		case 9: if (!isSyntaxError()) 
						pa_3dsprites[sprite].corner[0].y= i; 
					else
				  	 pa_3dsprites[sprite].corner[0].y = 0;
				  return;
		case 10: if (!isSyntaxError()) 
						pa_3dsprites[sprite].corner[1].x= i; 
					else
				  	 pa_3dsprites[sprite].corner[1].x = 0;
				  return;
		case 11: if (!isSyntaxError()) 
						pa_3dsprites[sprite].corner[1].y= i; 
					else
				   	 pa_3dsprites[sprite].corner[1].y = 0;
					return;
		case 12: if (!isSyntaxError()) 
						pa_3dsprites[sprite].corner[2].x= i;
					else
				   	 pa_3dsprites[sprite].corner[2].x = 0;
					return;
		case 13: if (!isSyntaxError()) 
						pa_3dsprites[sprite].corner[2].y= i; 
					else
				   	 pa_3dsprites[sprite].corner[2].y = 0;
					return;
		case 14: if (!isSyntaxError()) 
						pa_3dsprites[sprite].corner[3].x= i; 
					else
				   	 pa_3dsprites[sprite].corner[3].x = 0;
					return;
		case 15: if (!isSyntaxError()) 
						pa_3dsprites[sprite].corner[3].y= i; 
					else
						pa_3dsprites[sprite].corner[3].y = 0;
					return;
		case 16: if (!isSyntaxError()) 
					{
						if (i<=0) 
						{
						   i=0;
						}   
						pa_3dsprites[sprite].Priority= PRIORITY_GAMESELECTICON_SPRITE+i; 
					}			
					else
						pa_3dsprites[sprite].Priority= PRIORITY_GAMESELECTICON_SPRITE;
				  	return;
	}
}   
void updateGameSelectIcons()
{
   int y,i;
	int currentIcon;
	for (y=0;y<100;y++)
	{
	   if (y<0) y=0;
	   if (y >= fileAmount) break;   
	      
		currentIcon=getIconSprite(y);   
	   if (pa_3dsprites[currentIcon].Alive)
	   {
	      PA_3DSetSpriteVisible(currentIcon,0);
			for (i=0;i<MAX_GAMESELECT_SPRITE_PROPERTIES;i++)
			{
		   	updateIconProperty(readExpression(equation[GAMESELECT_EQUATION_START][i],128*y,1),currentIcon,i);
			   if (!isSyntaxError() && pa_3dsprites[currentIcon].alpha!=0)
					 PA_3DSetSpriteVisible(currentIcon,1);
			}  	
		}			
	}		
}	
void updateGameSelectText()
{
//   return;
	if (tempAnimVar!=0) return;
   int y,i;
	int positionX;
	int positionY;
	int textEmphasize;
	int XLimit;
	int XOffset;
	int x;
	int textAlign;
	u16 displayString[256];
	bool subTitle2_isSyntaxError=0;
	int stringlength=0;

	readExpression(equation[GAMESELECT_EQUATION_START+7][0],0,1);
	if (isSyntaxError()) subTitle2_isSyntaxError=1;

	readExpression(equation[GAMESELECT_EQUATION_START+7][1],0,1);
	if (isSyntaxError()) subTitle2_isSyntaxError=1;
	for (i=0;i<4;i++)
		for (y=0;y<100;y++)
		{
		   if (y<0) y=0;
	   if (y > fileAmount) break;   
	    
		   if (!pa_3dsprites[getIconSprite(y)].Alive) continue;
			textEmphasize = readExpression(equation[GAMESELECT_EQUATION_START+4+i][5],128*y,1);
			if (isSyntaxError()) textEmphasize = 2;
			if (textEmphasize==0) continue;
			
			positionX = readExpression(equation[GAMESELECT_EQUATION_START+4+i][0],128*y,1);
			if (isSyntaxError()) continue;
			
			XLimit = readExpression(equation[GAMESELECT_EQUATION_START+4+i][3],128*y,1);
			if (isSyntaxError()) XLimit = 500;
			if  (positionX+XLimit<0) continue;
			if  (positionX>256) continue;
			positionY = readExpression(equation[GAMESELECT_EQUATION_START+4+i][1],128*y,1);
			if (isSyntaxError()) continue;
			if  (positionY>220) continue;
			if  (positionY<-30) continue;
			
			
			XOffset = readExpression(equation[GAMESELECT_EQUATION_START+4+i][2],128*y,1);
			if (isSyntaxError()) XOffset = 0;
			textAlign = readExpression(equation[GAMESELECT_EQUATION_START+4+i][4],128*y,1);
			if (isSyntaxError()) textAlign = 0;
			if (textAlign<0) textAlign=0;
			if (textAlign>2) textAlign=2;
			if (textEmphasize>=2) 
			{
			   spaceLetteringForAAText();
			}   
			else
			{
			   positionY+=4;
			}   
			PA_TextAlign(textAlign);
//			char chrTemp[256];
			if (subTitle2_isSyntaxError) 
			{
			   x=0;
			   while (navigation.Description[y][1][x])
			   {
			      displayString[x] = navigation.Description[y][1][x];
			      x++;
			   }
				displayString[x] = ' ';   
			   x++;
			   int x2=0;
			   while (navigation.Description[y][2][x2])
			   {
			      displayString[x] = navigation.Description[y][2][x2];
			      x2++;
			      x++;
			   }   
			      displayString[x] =0;
			}   
			if (i==0)
			{
			   x=0;
			   while (navigation.FileName[y][x])
			   {
			      displayString[x] = navigation.FileName[y][x];
			      x++;
			   }
			      displayString[x] =0;
			   stringlength=x;
			   for(x=0;x<30;x++)
				{

				   if (displayString[x]=='_') displayString[x]=' ';
				   else
				   if (displayString[x]=='(')
			   	{
			   	   displayString[x]=0;
			   	   break;
			   	}
				}	
				if (x==30)
				{
				   displayString[x+1]=0;
				   displayString[x+0]='.';
				   displayString[x-1]='.';
				   displayString[x-2]='.';
				}   
			   
			}   
			display16cTextWithOffsetUInt16(0,positionX,positionY,positionX+XLimit,positionY,	i==0? displayString:
																											  	i==1? navigation.Description[y][0]:
			   																								i==2 && subTitle2_isSyntaxError? displayString:
																												i==2? navigation.Description[y][1] :
																														navigation.Description[y][2]
																											 ,textEmphasize==1?SEMITRANSLUCENT_TEXTCOLOR:ANTIALIASED_COLOR
																											 ,textEmphasize==1?3:ANTIALIASED_FONT,XOffset);
			PA_TextAlign(ALIGN_LEFT);
			spaceLetteringForDefault();

		}
}		
void parentSprite(int child,int parent)
{
	   pa_3dsprites[child].X += pa_3dsprites[parent].X;
		pa_3dsprites[child].Y += pa_3dsprites[parent].Y;
		float proportion = ((float)pa_3dsprites[parent].Width)/((float)pa_3dsprites[parent].ImgWidth);
	   pa_3dsprites[child].Width = proportion*pa_3dsprites[child].Width;
		proportion = ((float)pa_3dsprites[parent].Height)/((float)pa_3dsprites[parent].ImgHeight);
	   pa_3dsprites[child].Height = proportion*pa_3dsprites[child].Height;
} 
void updateGameSelectSubSprites()
{
	int currentIcon;
	int currentOverlay;
	int currentDuplicate;
	int currentOverlayDuplicate;
	int y,i;

	for (y=0;y<100;y++)	// why does int i for loop work?	
	{
	   currentIcon=getIconSprite(y);
	   currentOverlay=getOverlaySprite(y);
	   currentDuplicate=getIconDuplicateSprite(y);
	   currentOverlayDuplicate=getOverlayDuplicateSprite(y);
		if (y>=fileAmount)
		{
		   PA_3DSetSpriteVisible(currentIcon,0);
			if (overlay_Found) PA_3DSetSpriteVisible(currentOverlay,0);
			if (iconDuplicate_Found)PA_3DSetSpriteVisible(currentDuplicate,0);
			if (overlayDuplicate_Found) PA_3DSetSpriteVisible(currentOverlayDuplicate,0);
		   continue;
		}   
		if (pa_3dsprites[currentIcon].Alive == 0) 
		{
			pa_3dsprites[currentOverlay].Alive = 0;
			pa_3dsprites[currentDuplicate].Alive = 0;
			pa_3dsprites[currentOverlayDuplicate].Alive = 0;
			continue;
		}			
		else
		{
			pa_3dsprites[currentOverlay].Alive = 1;
			pa_3dsprites[currentDuplicate].Alive = 1;
			pa_3dsprites[currentOverlayDuplicate].Alive = 1;
		}			
		
		for (i=0;i<MAX_GAMESELECT_SPRITE_PROPERTIES;i++)
		{
	   	if (overlay_Found) updateOverlayProperty(readExpression(equation[GAMESELECT_EQUATION_START+1][i],128*y,1),currentIcon,currentOverlay,i);
	   	if (iconDuplicate_Found)updateOverlayProperty(readExpression(equation[GAMESELECT_EQUATION_START+2][i],128*y,1),currentIcon,currentDuplicate,i);
	   	if (overlayDuplicate_Found) updateOverlayProperty(readExpression(equation[GAMESELECT_EQUATION_START+3][i],128*y,1),currentIcon,currentOverlayDuplicate,i);
		}  	
	   

		if (overlay_Found) parentSprite(currentOverlay,currentIcon);
		if (iconDuplicate_Found)parentSprite(currentDuplicate,currentIcon);
		if (overlayDuplicate_Found) parentSprite(currentOverlayDuplicate,currentIcon);
	}
}   
void limitVisibleIconsTo(int limit)
{
	int i;

	int remainderCounter=0; 

	//Show maximum of only 7 icons onscreen
	//counts the numbers and distributes it until 7

	for (i=0;i<100;i++) 
	{
	   PA_3DSetSpriteVisible(getIconSprite(i),0);
	}	
	remainderCounter=0;
	bool remainderCounterFoward=1;
	i=0;
	bool overLimit=0;
	if (SelectMenu-3 <=0 || SelectMenu+3 > fileAmount)overLimit=1;
	while(true)
	{
		if (!overLimit)
		{
			if (gameSelect_counter <0) PA_3DSetSpriteVisible(getIconSprite(SelectMenu+remainderCounter)-1,1);
			if (gameSelect_counter >0) PA_3DSetSpriteVisible(getIconSprite(SelectMenu+remainderCounter)+1,1);
		}			
		if (gameSelect_counter ==0 || overLimit)PA_3DSetSpriteVisible(getIconSprite(SelectMenu+remainderCounter),1);

		if (remainderCounterFoward) 
		{
			remainderCounter=(remainderCounter+1)*-1;
			remainderCounterFoward = 0;
		}
		else
		{
			remainderCounter=(remainderCounter)*-1;
			remainderCounterFoward = 1;
		}
		if (fileAmount<SelectMenu+remainderCounter) //distribute to negative if counter went higher than the max limit
		{
			remainderCounter=(remainderCounter)*-1;
			remainderCounter--;
			remainderCounterFoward = 0;
		}
		if (SelectMenu+remainderCounter<0)			//vice versa if counter is lower than 0
		{
			remainderCounter=(remainderCounter)*-1;
			remainderCounterFoward = 1;
		}
		i++;
		if (i==limit)break;

	}


   
}
void updateGameSelect()
{
   limitVisibleIconsTo(7);
//   updateTimerCounter();
   updateIdleCounter();
	updateGameSelectText();
	updateGameSelectIcons();
	updateGameSelectSubSprites();
}  
  

int overlayTex=-1;

void initGameSelectSprites(bool folder)
{
//   folder=!folder;
	u16 overlayTex_Width=0;
	u16 overlayTex_Height=0;
	u16 overlayTex_Pal=1;
//	u16 iconDuplicateTex=0;
	u16 overlayDuplicateTex=0;
	char* path;
	if (folder)
	{
		path = returnString("fat:/_menudo/themes/%s/gamenavigate/folderoverlay.bmp",CurrentTheme);
		FILE* testRead = fopen (path, "rb");  
    if (!testRead){
      if (path!=NULL)	free(path);
      path = returnString("fat:/_menudo/themes/%s/gamenavigate/overlay.bmp",CurrentTheme);
		}
		fclose(testRead);
	}
	else
		path = returnString("fat:/_menudo/themes/%s/gamenavigate/overlay.bmp",CurrentTheme);
	bool filefound=1;
	if (overlayTex==-1)
	{
		overlayTex = CreateTexFromFatBmp(path,1,1); 
		if (overlayTex==0) filefound=0;
	}
		else
	{
	//   return;
		filefound = UpdateTexFromFatBmp(overlayTex,path,1,1); 
	}
	
	if (path!=NULL)	free(path);
	if (!filefound) 
	{
	   overlayTex=1;
		overlay_Found=false;
	}		
	else
	{
		overlay_Found=true;
		overlayTex_Width=getRecentBmpWidth();
		overlayTex_Height=getRecentBmpHeight();
	}


	
	
// 	iconDuplicateTex=CreateTexFromBmpWithAlpha((void*)logo,iconTex_Pal,(void*)logoduplicate_alpha);	
 	
	iconDuplicate_Found=false;
	
// 	overlayDuplicateTex=CreateTexFromBmpWithAlpha((void*)overlay,overlayTex_Pal,(void*)overlayduplicate_alpha);	
 	
	overlayDuplicate_Found=false;
	

   int y;
	for (y=0;y<100;y++)
	{
	   if (overlay_Found)
		{
			pa_3dsprites[getOverlaySprite(y)].textureID= overlayTex; 
			pa_3dsprites[getOverlaySprite(y)].ImgWidth=overlayTex_Width;
			pa_3dsprites[getOverlaySprite(y)].ImgHeight=overlayTex_Height;
			if(((textures[pa_3dsprites[getOverlaySprite(y)].textureID]>>26)&7) == TEX_4COL){
			   pa_3dsprites[getOverlaySprite(y)].palette = (overlayTex_Pal)<<1;
			}
			else{
			   pa_3dsprites[getOverlaySprite(y)].palette = (overlayTex_Pal); 
			}	
		   if (overlayDuplicate_Found) 
			{
				pa_3dsprites[getOverlayDuplicateSprite(y)].textureID= overlayDuplicateTex; 
				pa_3dsprites[getOverlayDuplicateSprite(y)].ImgWidth=overlayTex_Width;
				pa_3dsprites[getOverlayDuplicateSprite(y)].ImgHeight=overlayTex_Height;
				if(((textures[pa_3dsprites[getOverlayDuplicateSprite(y)].textureID]>>26)&7) == TEX_4COL){
				   pa_3dsprites[getOverlayDuplicateSprite(y)].palette = (overlayTex_Pal)<<1;
				}
				else{
				   pa_3dsprites[getOverlayDuplicateSprite(y)].palette = (overlayTex_Pal); 
				}		   
			}	
		}   
	   if (iconDuplicate_Found) 
		{
/*			pa_3dsprites[getIconDuplicateSprite(y)].textureID= iconDuplicateTex; 
			pa_3dsprites[getIconDuplicateSprite(y)].ImgWidth=32; //icon dimension
			pa_3dsprites[getIconDuplicateSprite(y)].ImgHeight=32;
			if(((textures[pa_3dsprites[getIconDuplicateSprite(y)].textureID]>>26)&7) == TEX_4COL){
			   pa_3dsprites[getIconDuplicateSprite(y)].palette = iconTex_Pal<<1;
			}
			else{
			   pa_3dsprites[getIconDuplicateSprite(y)].palette = iconTex_Pal; 
			}*/		   
		}   
		
	}
}			


