#include <PA9.h>
#include "wirelessTop.h"
#include "select_misc.h"
#include "selectBg.h"
#include "wirelessMenu.h"
#include "../../engine/engine.h"
bool selectWireless(bool initBg)
{
	int AppsOpened=-1;
   while(true)
   {
      PA_DisableSpecialFx(0);
      AppsOpened++;
      if (initBg)
      {
	      clearSystem();
			PA_Init16bitBg(1, 3);
			PA_Init16cBg(1, 2); 
			PA_Init16cBg(0, 1);
			PA_SetBgPrio(0,0,1);
			PA_SetBgPrio(0,1,0);
		}	

		PA_Screen=0;
		PA_SwitchScreens();
 		PA_SetBrightness(0,31);
 		PA_SetBrightness(1,0);
 		PA_16cErase(0);
 		PA_16cErase(1);
		PA_SetBgPrio(1,0,1);
		PA_SetBgPrio(1,3,0);
		int transitionAnimation=31*15;
		PA_SetBgRot(1,3,transitionAnimation*-1,0,0,0,0,256);
		select_Load16cBMPtoBG(0,(void*)wirelessTop);
		Load16cBMPtoBG(1,(void*)selectBg,0,0);
		PA_Clear16bitBg(1);
		PA_LoadBmpEx(1,49,25,(void*)wirelessMenu);

	   Soul_waitForVBL();

	   while(true)
	   {
			transitionAnimation = transiteSelectMenu(transitionAnimation);
			if((Stylus.Newpress && PA_StylusInZone(0,0,47,21)) || Pad.Newpress.B || Pad.Newpress.L)	
			{
				PA_SwitchScreens();
				return (AppsOpened>0);   
			} 
	      Soul_waitForVBL();
	   }   
		PA_SwitchScreens();
	   initBg=1;
	}

	return (AppsOpened>0);   
}   
