#include <PA9.h>
#include "select_misc.h"
extern int transitionAnimation;
void updatePDA(u8 subMenu)
{
   PA_Clear16bitBg(1);
   transiteSelectMenu(0,subMenu);
   switch(subMenu)
   {
      case 0: loadBMPWithResource(1,49,25,"appselect/pdaMenu1.bmp");
      			break;
      case 1: loadBMPWithResource(1,49,25,"appselect/pdaMenu2.bmp");
      			break;
      case 2: loadBMPWithResource(1,49,25,"appselect/pdaMenu3.bmp");
      			break;
      case 3: loadBMPWithResource(1,49,25,"appselect/pdaMenu4.bmp");
      			break;
      case 5: loadBMPWithResource(1,49,25,"custommenus/pda/menu.bmp");
      			break;
   }   

   return;
}   

bool selectPDA(bool initBg)
{
	int AppsOpened=-1;
	int subMenu=0;
	int i=0;
   while(true)
   {
      hideAll2dSprites();
      PA_DisableSpecialFx(0);
      PA_DisableSpecialFx(1);
      AppsOpened++;
      if (initBg)
      {
	      clearSystem();
			PA_Init16bitBg(1, 3);
			PA_Init16cBg(1, 2); 
			PA_Init16cBg(0, 1);
			PA_SetBgPrio(0,0,1);
			PA_SetBgPrio(0,1,0);
		}	

		PA_Screen=0;
		PA_SwitchScreens();
 		PA_SetBrightness(0,31);
 		PA_SetBrightness(1,0);
 		PA_16cErase(0);
 		PA_16cErase(1);
		transitionAnimation=31*5;
		PA_SetBgRot(1,3,transitionAnimation*-1,0,0,0,0,256);
		Settings16cBMP(0,"custommenus/pda/top.16c.bmp");
		load16cBMPWithResource(1,0,0,"appselect/pdaBg.16c.bmp");
		PA_Clear16bitBg(1);
		//PA_LoadBmpEx(1,49,25,(void*)pdaMenu1);
		updatePDA(subMenu);
		initSelectMenu();
		PA_SetBgPalCol(1, 0, PA_RGB(171>>3,184>>3,229>>3));
		PA_16cClearZone(1,31,24,255,192);
		

	   while(true)
	   {
	      if(Stylus.Newpress) 
			{
			   if (subMenu==0)
				{
					SUBMENU_ACTION_BUTTON(0,doodleApp());
					SUBMENU_ACTION_BUTTON(1,notepadApp());
				}			
			   if (subMenu==1)
			   {
					if(PA_StylusInZone(49,25+(0*40),217,65+(0*40)))		
					{	
					   alarmApp();	
					   initBg=1;
					   break;	
					}
				}
				if (subMenu==2)
				{
					if(PA_StylusInZone(49,25+(0*40),217,65+(0*40)))		
					{	
					   inputDiagnose();	
						AppsOpened--;	
					   break;	
					}
					if(PA_StylusInZone(49,25+(1*40),217,65+(1*40)))		
					{	
					   pixelDoctor();	
						AppsOpened--;	
					   break;	
					}
				}			
			   if (subMenu==3)
			   {
					if(PA_StylusInZone(49,25+(0*40),217,65+(0*40)))		
					{	
					   morseDS();	
						AppsOpened--;	
					   break;	
					}
				}
			   if (subMenu==5)
			   {
					customMenuStylusDetect("pda");
				}
  			}		
			if (Stylus.Held)
			{
			   SUBMENU_ICON_BUTTON(5,22,25,42,0,updatePDA);
			   SUBMENU_ICON_BUTTON(5,43,25,63,1,updatePDA);
			   SUBMENU_ICON_BUTTON(5,64,25,84,2,updatePDA);
			   SUBMENU_ICON_BUTTON(5,85,25,105,3,updatePDA);
			   SUBMENU_ICON_BUTTON(5,170,25,190,5,updatePDA);		
			}		
			transitionAnimation = transiteSelectMenu(transitionAnimation);
			if((Stylus.Newpress && PA_StylusInZone(0,0,47,21)) || Pad.Newpress.B || Pad.Newpress.L)	
			{
				deinitSelectMenu();
				PA_SwitchScreens();
				return (AppsOpened>0);  
			} 
	
			updateTopScreenRipple();
	      Soul_waitForVBL();
	   }   
		PA_SwitchScreens();
	}   
	deinitSelectMenu();
	return (AppsOpened>0);  
}   
