#include <PA9.h>
//#include "wirelessTop.h"
#include "select_misc.h"
extern int transitionAnimation;
void updateWIFI(u8 subMenu)
{
   PA_Clear16bitBg(1);
   switch(subMenu)
   {
      case 0: loadBMPWithResource(1,49,25,"appselect/wirelessMenu.bmp");
      			break;
      case 5: loadBMPWithResource(1,49,25,"custommenus/wifi/menu.bmp");
      			break;
   }   
   transiteSelectMenu(0,subMenu);
   return;
}   

bool selectWireless(bool initBg)
{
	int AppsOpened=-1;
	int subMenu=5;
	int i=0;
   while(true)
   {
      hideAll2dSprites();
      PA_DisableSpecialFx(0);
      PA_DisableSpecialFx(1);
      AppsOpened++;
      if (initBg)
      {
	      clearSystem();
			PA_Init16bitBg(1, 3);
			PA_Init16cBg(1, 2); 
			PA_Init16cBg(0, 1);
			PA_SetBgPrio(0,0,1);
			PA_SetBgPrio(0,1,0);
		}	

		PA_Screen=0;
		PA_SwitchScreens();
 		PA_SetBrightness(0,31);
 		PA_SetBrightness(1,0);
 		PA_16cErase(0);
 		PA_16cErase(1);
		transitionAnimation=31*5;
		PA_SetBgRot(1,3,transitionAnimation*-1,0,0,0,0,256);
		Settings16cBMP(0,"custommenus/wifi/top.16c.bmp");
		load16cBMPWithResource(1,0,0,"appselect/selectBg.16c.bmp");
		PA_Clear16bitBg(1);
		loadBMPWithResource(1,49,25,"custommenus/wifi/menu.bmp");
		initSelectMenu();
		PA_SetBgPalCol(1, 0, PA_RGB(171>>3,184>>3,229>>3));
		PA_16cClearZone(1,31,24,255,192);
		char* temp;
	   while(true)
	   {
	      if (Pad.Newpress.A) 
			{
		PA_Clear16bitBg(1);
		loadBMPWithResource(1,49,25,"appselect/wirelessMenu.bmp");
			}   
	      if(Stylus.Newpress) 
			{
			   if (subMenu==0)
				{
//					SUBMENU_ACTION_BUTTON(0,doodleWhiteboard());
				}			
			   if (subMenu==5)
			   {
					customMenuStylusDetect("wifi");
				}
  			}		
			if (Stylus.Held)
			{
// 			   SUBMENU_ICON_BUTTON(5,22,25,42,0,updateWIFI);
			   SUBMENU_ICON_BUTTON(5,170,25,190,5,updateWIFI);					
			}		
			transitionAnimation = transiteSelectMenu(transitionAnimation,subMenu);
			if((Stylus.Newpress && PA_StylusInZone(0,0,47,21)) || Pad.Newpress.B || Pad.Newpress.L)	
			{
				deinitSelectMenu();
				PA_SwitchScreens();
				return (AppsOpened>0);   
			} 
			updateTopScreenRipple();
	      Soul_waitForVBL();
	   }   
		PA_SwitchScreens();
	}
	deinitSelectMenu();
	return (AppsOpened>0);   
}   

