#include <PA9.h>

int getBlue(int color) {return (color >> 10) & 31;}
int getGreen(int color) {return (color >> 5) & 31;}
int getRed(int color) {return color & 31;}
void fillBitmap(bool screen, int color)
{
   int x, y;
	for (x=0;x<256;x++)
		for (y=0;y<192;y++)
			PA_Put16bitPixel(screen,x,y,color);
}
s8 bg_16bit[2];
restart16bitBg(bool screen)
{
   bg_16bit[screen] = -1;
}
bool is16bitActive(bool screen)
{
   return bg_16bit[screen] != -1;
}   
void init16bitBg(bool screen, u8 priority)
{
//   if (is16bitActive(screen)) return;
   bg_16bit[screen] = priority;
	PA_Init16bitBg(screen,priority);
}	
