#include <PA9.h>       // Include for PA_Lib
#include "shunt.h"

#include "visualizer.h"

#include "black.h"
#include "ambience.h"

//Include Player Functions
#include "../../commands\multimedia\music\player_sound.h"


#include "ambience00_color.h"
#include "ambience00_alpha.h"

#include "ambience0_color.h"
#include "ambience0_alpha.h"

#include "ambience1_color.h"
#include "ambience1_alpha.h"

#include "ambience2_color.h"
#include "ambience2_alpha.h"





extern char equation[20][MAX_AMBIENCEPROPERTIES][MAX_EQUATIONLENGTH];


extern int ambienceTex[MAX_AMBIENCETEX];
extern u16 ambienceTexWidth[MAX_AMBIENCETEX];
extern u16 ambienceTexHeight[MAX_AMBIENCETEX];
extern u8  ambienceTex_Amount;

void clearVisualizer()
{
   memset(equation,0,20*MAX_AMBIENCEPROPERTIES*MAX_EQUATIONLENGTH);
   ambienceTex_Amount=0;
   PA_Reset3DSprites();
}   
void loadVisualizer()
{	
	sprintf(equation[0][0],"((x0-100)%%500)-64");
	sprintf(equation[1][0],"(((x0>1)-200)%%500)-64");
	sprintf(equation[2][0],"((x0>1)%%500)-64");
	sprintf(equation[3][0],"((x0+20)%%500)-64");
	sprintf(equation[4][0],"((x0/3)%%500)-64");
	sprintf(equation[5][0],"((x0*2)%%500)-64");
	sprintf(equation[6][0],"((x0-20)%%500)-64");
	
	sprintf(equation[0][1],"128-(((x0-100)%%500)>3)");
	sprintf(equation[1][1],"128-((((x0>1)-200)%%500)>3)");
	sprintf(equation[2][1],"100-(((x0>1)%%500)>2)");
	sprintf(equation[3][1],"100-(((x0+20)%%500)>1)");
	sprintf(equation[4][1],"200-(((x0/3)%%500))");
	sprintf(equation[5][1],"200-(((x0*2)%%500)>2)");
	sprintf(equation[6][1],"180-(((x0-20)%%500)>2)");
	
	sprintf(equation[0][2],"16+(k0>2)");
	sprintf(equation[1][2],"20+(k1>3)");
	sprintf(equation[2][2],"18+(k2>1)");
	sprintf(equation[3][2],"14+(k3)");
	sprintf(equation[4][2],"16+(k4>2)");
	sprintf(equation[5][2],"22+(k5>2)");

	sprintf(equation[0][3],"16+(k0>2)");
	sprintf(equation[1][3],"20+(k1>3)");
	sprintf(equation[2][3],"18+(k2>1)");
	sprintf(equation[3][3],"14+(k3)");
	sprintf(equation[4][3],"16+(k4>2)");
	sprintf(equation[5][3],"22+(k5>2)");

/* version 1
	sprintf(equation[6][0],"128");
	sprintf(equation[6][1],"70");
	sprintf(equation[6][2],"64");
	sprintf(equation[6][3],"64");
	sprintf(equation[6][17],"1");
	
	sprintf(equation[7][0],"128");
	sprintf(equation[7][1],"112");
	sprintf(equation[7][2],"64");
	sprintf(equation[7][3],"64");
	sprintf(equation[7][17],"1");
	
	sprintf(equation[8][0],"128");
	sprintf(equation[8][1],"134");
	sprintf(equation[8][2],"64");
	sprintf(equation[8][3],"64");
	sprintf(equation[8][17],"2");*/
// version 2
	sprintf(equation[6][0],"128+(s(x0<1)>4)");
	sprintf(equation[6][1],"70-(c(x0<1)>4)");
	sprintf(equation[6][2],"64+(c(x0<1)>4)");
	sprintf(equation[6][3],"64+(c(x0<1)>4)");
	sprintf(equation[6][17],"1");


	sprintf(equation[7][0],"128+(s(x0<1)>4)");
	sprintf(equation[7][1],"110-(c(x0<1)>6)");
	sprintf(equation[7][2],"64+(c(x0<1)>4)");
	sprintf(equation[7][3],"64+(c(x0<1)>4)");
	sprintf(equation[7][17],"1");

	sprintf(equation[8][0],"128+(s(x0<1)>4)");
	sprintf(equation[8][1],"145+(c(x0<1)>6)");
	sprintf(equation[8][2],"64+(c(x0<1)>4)");
	sprintf(equation[8][3],"64+(c(x0<1)>4)");
	sprintf(equation[8][17],"2");

	ambienceTex_Amount=0;
	ambienceTex[ambienceTex_Amount]=CreateTexFromBmpWithAlpha((void*)ambience0_color,(MAX_PALLETE-ambienceTex_Amount),(void*)ambience0_alpha);
	ambienceTexWidth[ambienceTex_Amount]=getRecentBmpWidth();
	ambienceTexHeight[ambienceTex_Amount]=getRecentBmpHeight();
	ambienceTex_Amount++;
	ambienceTex[ambienceTex_Amount]=CreateTexFromBmpWithAlpha((void*)ambience1_color,(MAX_PALLETE-ambienceTex_Amount),(void*)ambience1_alpha);
	ambienceTexWidth[ambienceTex_Amount]=getRecentBmpWidth();
	ambienceTexHeight[ambienceTex_Amount]=getRecentBmpHeight();
	ambienceTex_Amount++;
	ambienceTex[ambienceTex_Amount]=CreateTexFromBmpWithAlpha((void*)ambience2_color,(MAX_PALLETE-ambienceTex_Amount),(void*)ambience2_alpha);
	ambienceTexWidth[ambienceTex_Amount]=getRecentBmpWidth();
	ambienceTexHeight[ambienceTex_Amount]=getRecentBmpHeight();
	ambienceTex_Amount++;

	PA_3DCreateSpriteFromTex(100,CreateTexFromBmp((void*)black,10),256,192,10,256/2,192/2);
	PA_3DSetSpritePrio(100,1);



}		
