#include <PA9.h>

#define soundChannel 1


void Soul_SoundDefaultPlay(u8 *data, u32 size, u8 volume, u8 pan, u8 loop, u8 prio)
{
//return;
    SoundInfo snd = { 
        data, 
        size, 
        as_default_format, 
        as_default_rate, 
        volume, 
        pan, 
        loop, 
        prio, 
        as_default_delay 
    };

    AS_SoundDirectPlay(soundChannel, snd);
}

void Soul_playSound(u8* snd, u32 sndsize)
{
//return;
   Soul_SoundDefaultPlay(snd, sndsize, 127,0,0,0);
}   



u8 sndbuffer[100*1024];
u32 buffer_size;


bool loadFatSndRaw(FILE* filename)
{	
return 1;
	if(filename)
	{
	   AS_SoundStop(soundChannel);
		rewind (filename);	   
		fseek (filename, 0 , SEEK_END);
		buffer_size = ftell (filename);
		rewind (filename);

		fread (sndbuffer, 1, buffer_size, filename);	


		Soul_playSound((u8*)sndbuffer, (u32)buffer_size);

		return 1;
	}
	else
   {
		return 0;
	}		
}   


bool loadFatSndWav(FILE* filename)
{	
	if(filename)
	{
	   AS_SoundStop(soundChannel);
		int fileSize = 0;
		fseek(filename, 0, SEEK_END);
		fileSize = ftell(filename);
		if (fileSize>=sizeof(sndbuffer)) return 0;
		rewind(filename);
		
		// Get some wav stats.
		short channels = 0;
		int sampleRate = 0;
		short bitsPerSample = 0;
		fseek(filename, 22, SEEK_SET);
		fread(&channels, sizeof(short), 1, filename);
		fread(&sampleRate, sizeof(int), 1, filename);
		fseek(filename, 34, SEEK_SET);
		fread(&bitsPerSample, sizeof(short), 1, filename);
		
		// Advance past the header since we just want the RAW data.
		fseek(filename, 44, SEEK_SET);

		int bytesRead = fread(sndbuffer, 1, fileSize, filename);
		
	    SoundInfo snd = { 
			sndbuffer,
			bytesRead-100,
			bitsPerSample == 16 ? AS_PCM_16BIT : AS_PCM_8BIT,
			sampleRate,
			127, // volume cant exceed 127 ....
			0,
			false, // Loop
			0,
			AS_NO_DELAY
		};
    
		AS_SoundDirectPlay(soundChannel, snd);
		return 1;
		
	}
	else
   {
		return 0;
	}		
}   

