#include <PA9.h> 

unsigned short palette[32] __attribute__ ((aligned (4)));
unsigned char  temp_tex[512]; 
unsigned char  image[(32*32)]; 


void convertIconToTex(unsigned char outputTex[],unsigned char originaltex[], unsigned short pal[])
{
	int yy=0, x1=0;
	for(yy=0; yy<512; ++yy)
	{
		x1 = (((yy>>5)%4)<<3)+(((yy%32)<<1)%8)+(((((yy>>5)>>2)<<3)+((yy%32)>>2))<<5);
		outputTex[x1  ] = (originaltex[yy]&15)+1;
		outputTex[x1+1] = ((originaltex[yy] >> 4)&15)+1;
	}

	for(yy=16; yy>1; yy--)
	{
	   pal[yy]=pal[yy-1];
	}   
	pal[1]= PA_RGB(31,31,31);
}		

int getIconTexture(char* file, u8 paletteNum)
{
    FILE *handle = fopen(file, "rb");
    
	
    if (handle) {

	   int datalocation=0x68;
	   u32 newlocation=0;

		fseek(handle, datalocation, SEEK_SET); // move datalocation bytes from start of file
		fread(&newlocation, sizeof(u32), 1, handle);
      if (newlocation==0)
      {
         fclose(handle);
         return -1;
      }   
		datalocation=newlocation+544; // +544 is palette
		fseek(handle, datalocation, SEEK_SET);
		fread(&palette, 1, 32, handle); // read the part of the header we need
		
		datalocation=newlocation+32; // +32 is icon
		fseek(handle, datalocation, SEEK_SET);
		
		fread(&temp_tex, 1, 512, handle); // read the part of the header we need

		convertIconToTex(image,temp_tex,palette);
		memset(temp_tex,0,512);
		
		int i;
						//32*32
		for (i=0;i<(1024);i+=2)
			temp_tex[i>>1] = (u16)(image[i] + 
											 	  (image[i+1] << 4));
//		flushToMemory();
		fclose(handle);
		Soul_waitForVBL();		Soul_waitForVBL();
		PA_Load3DSpritePal(paletteNum, (void*)palette);
		return PA_3DCreateTex((void*)temp_tex, 32, 32, TEX_16COL);	
	
    }
	fclose(handle);
	return -1;
//   sprintf (system.newNDS[shortcutNumber].location,"%s",charTemp);
	

    
}  
