#define WINDOW_TYPE_TEXTONLY 0
#define WINDOW_TYPE_TEXTANDIMAGE 1
#define WINDOW_TYPE_MULTIMEDIA 2

void initWindowSystem();
void createWindow(int windowStyle, bool semiTransparent, int type,char* text1, char* text2, char* text3) ;

char* getWindowText(int line);
void closeWindow();

void resizeWindow(int width, int height);
void moveWindow(int x, int y);
void updateWindow();
int getWindowX();
int getWindowY();
int getWindowHeight();
int getWindowWidth();
int getWindowType();
int getWindowTimeNotTouched();
bool isWindowDoubleClicked();
bool isWindowHit();

bool isWindowAlive();
int setWindowTimeNotTouched(int value);
void displayNewNdsWindow();
void displayLastGameWindow();
bool isStylusInWindowZone();
void killWindow();
