#include <PA9.h>       // Include for PA_Lib

// Function: main()
void createKeyLit(int x1, int y1)
{
   int x;
   int y;
   for (x=x1-6;x<=x1+6;x++)
   for (y=y1-6;y<=y1+6;y++)
   {
      if (x<0 || x>=256) continue;
      if (y<0 || y>=192) continue;
      if (y==y1-6 && x==x1-6) continue;
      if (y==y1-6 && x==x1+6) continue;
      if (y==y1+6 && x==x1-6) continue;
      if (y==y1+6 && x==x1+6	) continue;
   	PA_16cPutPixel(1,x,y,1);
	}  	   
}   
#define allowDiagnoseLit(input,x,y)\
	   if (Pad.Newpress.input) createKeyLit(x,y);\
	   if (Pad.Held.input) createKeyLit(x+32,y);\
	   if (Pad.Released.input) createKeyLit(x+70,y);

#define allowDiagnoseLitStylus(x,y)\
	   if (Stylus.Newpress) createKeyLit(x,y);\
	   if (Stylus.Held) createKeyLit(x+32,y);\
	   if (Stylus.Released) createKeyLit(x+70,y);

void inputDiagnose()
{
   PA_SwitchScreens();	
	PA_Clear16bitBg(1);
	PA_16cErase(0);
	PA_16cErase(1);
	char* path = returnThemeResourcePath("apps/inputDiagnose/diagnoseInterface_top.jpg", 1);
	if (path!=NULL)
	{
		loadJPEGWithPath(1,path);
		free(path);
	}		
	
	PA_SetBgPrio(1,3,1);
	PA_SetBgPrio(1,2,0);
	PA_SetBgPalCol(1,1,PA_RGB(0,0,0));
	load16cBMPWithResource(0,0,0,"apps/inputDiagnose/diagnoseInterface_bot.16c.bmp");
	while (1)
	{
	   allowDiagnoseLit(L,40,34+(23*0));
	   allowDiagnoseLit(Up,40,34+(23*1));
	   allowDiagnoseLit(Left,40,34+(23*2));
	   allowDiagnoseLit(Right,40,34+(23*3));
	   allowDiagnoseLit(Down,40,34+(23*4));
	   allowDiagnoseLit(Start,40,34+(23*5));
	   allowDiagnoseLitStylus(40,34+(23*6));

	   allowDiagnoseLit(R,165,34+(23*0));
	   allowDiagnoseLit(Y,165,34+(23*1));
	   allowDiagnoseLit(X,165,34+(23*2));
	   allowDiagnoseLit(A,165,34+(23*3));
	   allowDiagnoseLit(B,165,34+(23*4));
	   allowDiagnoseLit(Select,165,34+(23*5));	   
		Soul_waitForVBL();		
		PA_16cErase(1);
		if (Stylus.Newpress && PA_StylusInZone(218,176,256,192)) break;
	}
	PA_SetBgPrio(1,3,0);
	PA_SetBgPrio(1,0,1);
   PA_SwitchScreens();
} // End of main()
