#include <PA9.h>
#include "../engine/engine.h"
	
void notepadApp()
{
   irqDisable(IRQ_HBLANK);
   PA_SwitchScreens();
   clearSystem();
	PA_Init16bitBg(0,2);
	PA_Init16cBg(0,1);
	PA_Init16bitBg(1,2);
	PA_Init16cBg(1,1);

	char* path = returnThemeResourcePath("apps/notepad/notepadBackground.jpg", 1);
	if (path!=NULL)
	{
		loadJPEGWithPath(1,path);
		free(path);
	}		
	fillBitmap(0, PA_RGB(31,31,31));
//	PA_LoadBmp(0,(void*)notepadBackground);
	PA_SetBgPrio(0,0,1);
	PA_SetBgPrio(0,1,0);
	int month=PA_RTC.Month-1;
//	initCalendarSprites(month);
	initAntiAliasedText (0,1,1);
	initAntiAliasedText (1,1,1);
	PA_SetSFXAlpha(0, 31, 0);
	PA_SetSFXAlpha(1, 31, 0);

   setKeyboardWhiteBoardMode(0);
   char* output =inputKeyboard(1, "",25,10,246,192, 0, 6, 2,1,5, 0, 0,0);
   if (output!=NULL) free(output);
//   setKeyboardWhiteBoardMode(0);
   PA_SwitchScreens();
}   
