// Includes
#include <PA9.h>       // Include for PA_Lib

void pixelDoctor()
{
//   PA_SwitchScreens();
	PA_Clear16bitBg(1);
	PA_SetBgPalCol(0,1,PA_RGB(0,0,0));
	fillScreen16c(0,1);	
	PA_16cErase(1);
	PA_TextAlign(1);
	PA_SetBgPalCol(1,0,PA_RGB(0,0,0));
	PA_SetBgPalCol(0,2,PA_RGB(31,31,31));
	PA_SetBgPalCol(0,0,PA_RGB(0,0,0));
	PA_16cText(0,0,140,250,192,"Pixel Doctor\nMovethe flickering box to the pixel that needs to be cured\nStylus and cursor to Move\nL to switch Screen\nB to leave",2,1,256);
	PA_TextAlign(0);
	// Infinite loop to keep the program running
	int x=0;
	int y=0;
	bool switchedScreen=0;
	PA_WaitFor(Stylus.Released);
	Stylus.X=256/2;
	Stylus.Y=192/2;
	while (1)
	{
	   if (Pad.Held.Down && Stylus.Y<192) Stylus.Y++;
	   if (Pad.Held.Up && Stylus.Y>0) Stylus.Y--;
	   if (Pad.Held.Right && Stylus.X<256) Stylus.X++;
	   if (Pad.Held.Left && Stylus.X>0) Stylus.X--;
	   if (Pad.Newpress.L)
		{
		   switchedScreen=!switchedScreen;
		   PA_SwitchScreens();
		}
	   for (x=Stylus.X-8;x<=Stylus.X+8;x++)
	   for (y=Stylus.Y-8;y<=Stylus.Y+8;y++)
	   {
	      if (x<0 || x>=256) continue;
	      if (y<0 || y>=192) continue;
	   	PA_16cPutPixel(1,x,y,1);
	   	switch(PA_RTC.Frames%5)
	   	{
				case 0: PA_SetBgPalCol(1,1,PA_RGB(0,0,0));
						  break;
				case 1: PA_SetBgPalCol(1,1,PA_RGB(31,0,0));
						  break;
				case 2: PA_SetBgPalCol(1,1,PA_RGB(0,31,0));
						  break;
				case 3: PA_SetBgPalCol(1,1,PA_RGB(0,0,31));
						  break;
				case 4: PA_SetBgPalCol(1,1,PA_RGB(31,31,31));
						  break;
			}	  
		}  	
	   
		Soul_waitForVBL();		
		PA_16cErase(1);
	   if (Pad.Newpress.B) break;
	}
	if (switchedScreen)
   PA_SwitchScreens();
}
