#include <PA9.h>       // Include for PA_Lib
#include "engine/engine.h"
#include "commonVariables.h"
#include "gfx/all_gfx.c"
#include <fat.h>

#include <sys/dir.h>
#include <unistd.h>
#include "userConfigFunctions.h"
 
#include "misc/fat.h"
#include "misc/transition.h"
#include "misc/misc.h"
#include "misc/debug.h"
#include "commands/commands.h"

#include "system/services/mwifi.h"

#include "load_bot.h"
#include "load_top.h"
/*
Special Thanks to
Noobey - for helping me on my wifi problems

*/

char filePath[256];	
char* CurrentMenuCommand;
bool systemBooting=1;
FILE* readINI; 
FILE* imgFile;
FILE* movieJPG;
FILE* historyFile;
FILE* fileChecker;
extern bool enableDebugLog;
#define PM_DSLITE_REG   (4)
#define PM_IS_LITE      BIT(6)
u8 getBattery()
{
	return IPC->battery & 3;
}
char* getCurrentCommand()
{
	if (CurrentMenuCommand != NULL) free(CurrentMenuCommand);
   CurrentMenuCommand = malloc(256);
   sprintf(CurrentMenuCommand,"%s",	system.menuRuns[getMenuSequence()]);
   if (!verifyCommand(CurrentMenuCommand))
	{
	   switch (getMenuSequence())
	   {
	      case 0:	sprintf(CurrentMenuCommand,"power");
	         		break;
	      case 1:	sprintf(CurrentMenuCommand,"mSettings");
	         		break;
	      case 2:	sprintf(CurrentMenuCommand,"mExplore");
	         		break;
	      case 3:	sprintf(CurrentMenuCommand,"mWireless");
	         		break;
	      case 4:	sprintf(CurrentMenuCommand,"mPda");
	         		break;
	      case 5:	sprintf(CurrentMenuCommand,"mMultimedia");
	         		break;
	      case 6:	sprintf(CurrentMenuCommand,"applications");
	         		break;
	      case 7:	sprintf(CurrentMenuCommand,"GAMES");
	         		break;
	      case 8:	sprintf(CurrentMenuCommand,"gba");
	         		break;
        } 		
     }   
	return CurrentMenuCommand ;
}	
void clearSystem()
{
   PA_Init2D();
   PA_VBLCountersReset();
   PA_VBLFunctionReset();
	PA_ResetRecoSys();
	PA_InitVBL();
}   
//extern FILE* historyFile;
struct lastFileInfo
{
	char ndsFile[80];
	char rootFolder[80];
	char subFolder[80];
	bool found;
} lastFile;

void openLastDirectoryCmd()
{
	 getLastFileInfo();
	 getLastMenu(0);	
//	if(lastFile.ndsFile[0]==0) return;
	executeCommand(lastFile.rootFolder);
//	cleanMemory();	
}	
extern bool enableLoading;
bool bootupfinished=0;
bool allowbootupfinish=0;
void VBL_Load16cBMPtoBG();
void VBL_LoadingScreen();
extern int testcounter;
bool bootupFadeIn=0;
void bootupLoadScreen()
{
   bootupfinished=0;
   if (enableLoading) return;
	Load16cBMPtoBG(1,(void*)load_top,0,0);
	Load16cBMPtoBG2(0,(void*)load_bot,0,0);
	bootupFadeIn=0;
	   PA_VBLCountersReset();
		PA_VBLCounterStart(1);	
		testcounter=PA_VBLCounter[1];
		PA_VBLFunctionInit(VBL_LoadingScreen);	
}
bool isBootupFinished()
{
   return bootupfinished;	
}   
void waitTillBootupToBeFinishedIsAllowed()
{
	while (!allowbootupfinish) Soul_waitForVBL();
}	
extern int temptext;
void clearbootupLoadScreen()
{
//bootupfinished=0;
	if (bootupfinished) return;
   if (!enableLoading) 
	{
         temptext=0;	   
	   PA_VBLCountersReset();
		PA_VBLCounterStart(1);	
		testcounter=PA_VBLCounter[1];
		bootupFadeIn=1;
		PA_VBLFunctionInit(VBL_LoadingScreen);	

	}   
	else
	{
      allowbootupfinish=1;
   }   
}   

void update_clearbootupLoadScreen()
{
//   allowbootupfinish=0;
	if (bootupfinished) return;
   waitTillBootupToBeFinishedIsAllowed();
   bootupfinished=1;

	setBrightness(0,31);
	setBrightness(1,31);   		   
   PA_16cErase(0);
   PA_16cErase(1);

	   return;

}   
u8 transitionCounter=31;
void bootupFadeFromWhite()
{
   if (transitionCounter>0)
	{
	   transitionCounter--;
	   setBrightness(0,transitionCounter);
	   setBrightness(1,transitionCounter);

	}   
}	
int main(int argc, char ** argv)
{
	
	PA_Init();
	PA_InitVBL();

	setBrightness(0,0);
	setBrightness(1,0);
   restart3d();
	init3d();
	
	//PA_WaitFor(Stylus.Held);
//   InitWifi();
  // PA_ConnectWifiWFC();
	restart16cBg(0);
	restart16cBg(1); 
	restart16bitBg(0); 
	restart16bitBg(1); 
	init16bitBg(1,2);
   init16cBg(0, 1);
   init16cBg(1, 1);

   Soul_waitForVBL();
//enableLoading=1;
	if (Pad.Held.L || Pad.Held.R) enableLoading=(!enableLoading);
	initFonts();
//	test();
	bootupLoadScreen();
	
	initDebugTxt();		
	debugTxt("menudo start");	
	debugTxt("menudoAFDSA ET");	
	debugTxt("meASDFSDnudo staSFArt");	
	debugTxt("AS DAS menudo start");	
	
	initDebugTxt();		
	PA_InitRand();

	if (!fatInit(8, true))
	{
		debugTxt("Fat Init Failed");
		while (true){ }	   
	}			



//	PA_InitASLibForMP3(AS_MODE_MP3 | AS_MODE_SURROUND | AS_MODE_16CH);	// The parameter is passed to AS_Init(). Call this function only once!!!  Default settings are: AS_SetDefaultSettings(AS_PCM_8BIT, 11025, AS_SURROUND);



	debugTxt("Fat init");

/*
	debugTxt("Fat Success");

	if (isFirstMENUdoBootup())
	{
	   initAntiAliasedText(0,1,0);	
	   spaceLetteringForAAText();
	   display16cText(0,0,0,250,192,"First time loading MENUdo",1,5);
	   spaceLetteringForDefault();
	}   
	else
	if (!didPreviousBootupSucceed())
	{
	   initAntiAliasedText(0,1,0);
	   spaceLetteringForAAText();
	   display16cText(0,0,0,256,192,"MENUdo has detected a bootup attempt has failed,\nPlease refer to\nhttp://www.gamenow.asia/wiki/Bootup_trouble\nfor help\nIf problems still occur.\nPress Anykey to continue",1,5);
	   PA_WaitFor(Pad.Newpress.Anykey ||Pad.Newpress.Y || Stylus.Newpress);
	   spaceLetteringForDefault();
	}   
	
	debugTxt("Checking if first bootup and/or not succeeded");
	confirmBootupSucceeded(0);*/
	
	debugTxt("Init Finished");
   system.ShuffleThemes=1;
	LoadCurrentConfig();
	debugTxt("Loading Settings");
	memset(lastFile.ndsFile,0,sizeof(lastFile.ndsFile));

	debugTxt("askPassword();");
	askPassword();

	wifi.APnotFound=0;	
	if (Pad.Held.B) wifi.autoLoginCancelled=1;
	int i=1;

	debugTxt("begin_DetectNewFile();");
//	if (system.DetectNewFiles)  begin_DetectNewFile();

	debugTxt("loadHistoryLastTheme();");
	loadHistoryLastTheme();
//	loadMainMenuCommands();
	debugTxt("Checking Shortcuts");
//	system.directToMain=1;
   	getLastMenu(1);	
	if (Pad.Held.Up||Pad.Held.Down||Pad.Held.Left||Pad.Held.Right||Pad.Held.Y||Pad.Held.X||Pad.Held.A)		
	{
		if (Pad.Held.Up)		sprintf(filePath,"%s",system.startup[0]); else
		if (Pad.Held.Down)	sprintf(filePath,"%s",system.startup[1]); else
		if (Pad.Held.Left)		sprintf(filePath,"%s",system.startup[2]); else
		if (Pad.Held.Right) 	sprintf(filePath,"%s",system.startup[3]); else
		if (Pad.Held.Y)		sprintf(filePath,"%s",system.startup[4]); else
		if (Pad.Held.X)		sprintf(filePath,"%s",system.startup[5]); else
		if (Pad.Held.A)		sprintf(filePath,"%s",system.startup[6]);

	   executeCommand(filePath);
	}	
	else
	if (Pad.Held.B)		
	{
		sprintf(filePath,"%s",system.startup[7]);
	   if (!system.directToMain) 
   	{
//		   loadIntroSMF();   	   
   	}   

	}			
	else
	{
		
	   if (system.directToMain) 
		   loadIntroSMF();   	   
   	else
   	{
	   	openLastDirectoryCmd();
		}  	

	}   

//	if (Pad.Held.Y) loadLastFile();
//	if (!Pad.Held.B) 
//	executeCommand("games");
	debugTxt("Boot 1complete");
//	initDebugTxt();
//stopLoadScreen();


//	   executeCommand("games");
 checkBoot();
deinitDebugTxt();	

cleanMemory();
	while (1)
	{

		do{
		   if (i==0)
			   i = runMenu(0);
			else
			   i = runMenu(1);
//			i=1;	   
/*		   while (i==0)
		   	i = runMenu(0);*/
		   if (i!=0) cleanMemory();
		   checkBoot();
//		   if (IncompleteFiles) break;
		} while (i!=-1);
/*	   if (IncompleteFiles) 
		{
		   display_noThemeMenu(filePath);
		   cleanMemory();
		}   */
		PA_3DDeleteSprite(50);
		PA_3DDeleteSprite(49);

		executeCommand(CurrentMenuCommand);
	
		//cleanMemory();
	checkBoot();
			

		Soul_waitForVBL();
		
	}
	
	return 0;
} // End of main()


