#include <PA9.h>       // Include for PA_Lib

#include "../engine/engine.h"

#include "black.h"
#include <sys/dir.h>
#include "ideScripter.h"
#include "../misc/misc.h"
#include "../misc/fat.h"
//Include Player Functions
#include "../commands\multimedia\music\player_sound.h"
#include "../commands\multimedia\music\player_visualizer.h"
#include "../commands\game_select\game_select_scriptengine.h"
#include "ambience0_color.h"
#include "ambience0_alpha.h"

#define StylusYAtTextBox() (14<Stylus.Y&& 32>Stylus.Y)


char blinktimer_counter=0;
int textLineX=0;
int textCursorColumn=0;
extern bool overlay_Found;
extern bool overlayDuplicate_Found;
extern bool iconDuplicate_Found;
extern u16 x; 

extern int gameSelect_counter;
extern int idleCounter;


extern char equation[20][MAX_AMBIENCEPROPERTIES][MAX_EQUATIONLENGTH];
//extern char gameSelectEquation[MAX_GAMESELECT][MAX_AMBIENCEPROPERTIES-1][MAX_EQUATIONLENGTH];

//u16 fileAmount = NUMBER_OF_CLONES;
bool calculator_variableMode=0;

char clipboard[MAX_EQUATIONLENGTH];


int selectHold_counter=0;
s8 selectedAmbience=4;
int selectedProperties=0;
u8 ideScriptFor=0;
s8 getSelectedAmbience(int i)
{
 	if (ideScriptFor==SCRIPTFOR_GAMESELECT)
	   return GAMESELECT_EQUATION_START+i;
   else
	   return i;
}   
void inputValChar(char letter, char letter2)
{
   int i;
   for (i=strlen(equation[getSelectedAmbience(selectedAmbience)][selectedProperties]);i>textCursorColumn;i--)
   {
      equation[getSelectedAmbience(selectedAmbience)][selectedProperties][i] = equation[getSelectedAmbience(selectedAmbience)][selectedProperties][i-1];
   }  
	equation[getSelectedAmbience(selectedAmbience)][selectedProperties][textCursorColumn] = letter;
	textCursorColumn++;

   for (i=strlen(equation[getSelectedAmbience(selectedAmbience)][selectedProperties]);i>textCursorColumn;i--)
   {
      equation[getSelectedAmbience(selectedAmbience)][selectedProperties][i] = equation[getSelectedAmbience(selectedAmbience)][selectedProperties][i-1];
   }  
	equation[getSelectedAmbience(selectedAmbience)][selectedProperties][textCursorColumn] = letter2;
	textCursorColumn++;

}   
void inputChar(char letter)
{
   int i;
   for (i=strlen(equation[getSelectedAmbience(selectedAmbience)][selectedProperties]);i>textCursorColumn;i--)
   {
      equation[getSelectedAmbience(selectedAmbience)][selectedProperties][i] = equation[getSelectedAmbience(selectedAmbience)][selectedProperties][i-1];
   }  
	equation[getSelectedAmbience(selectedAmbience)][selectedProperties][textCursorColumn] = letter;
	textCursorColumn++;

	
}   
void deleteChar()//int column)
{
   int i;
//   for (i=strlen(equation[getSelectedAmbience(selectedAmbience)][selectedProperties]);i>textCursorColumn;i--)
	if (equation[getSelectedAmbience(selectedAmbience)][selectedProperties][textCursorColumn-2]=='x' || equation[getSelectedAmbience(selectedAmbience)][selectedProperties][textCursorColumn-2]=='z' || equation[getSelectedAmbience(selectedAmbience)][selectedProperties][textCursorColumn-2]=='k') 
	{
	   for (i=textCursorColumn-1;i<strlen(equation[getSelectedAmbience(selectedAmbience)][selectedProperties]);i++)
	   {
	      equation[getSelectedAmbience(selectedAmbience)][selectedProperties][i] = equation[getSelectedAmbience(selectedAmbience)][selectedProperties][i+1];
	   }  
		textCursorColumn--;
	   for (i=textCursorColumn-1;i<strlen(equation[getSelectedAmbience(selectedAmbience)][selectedProperties]);i++)
	   {
	      equation[getSelectedAmbience(selectedAmbience)][selectedProperties][i] = equation[getSelectedAmbience(selectedAmbience)][selectedProperties][i+1];
	   }  
		textCursorColumn--;
	}   
	else
	{
	   for (i=textCursorColumn-1;i<strlen(equation[getSelectedAmbience(selectedAmbience)][selectedProperties]);i++)
	   {
	      equation[getSelectedAmbience(selectedAmbience)][selectedProperties][i] = equation[getSelectedAmbience(selectedAmbience)][selectedProperties][i+1];
	   }  
		textCursorColumn--;
	}		
	if (textLineX>0)textLineX-=3;
}   
#define LetterPos(ch,col)	Forumla_AddLetterPos(ch, x, y, size, col);\
									x += pa_bittextdefaultsize[size][ch]+textinfo.letterspacing;

int StringPos(char*string, s16 x, s16 y, u8 size, u16 color){
   int i;
   int new_x=x;
   for (i=0;string[i];i++)
   {
	   if (new_x>=0)
	   {
		   PA_LetterPos.Letter[PA_LetterPos.NLetters].Letter = string[i];
			PA_LetterPos.Letter[PA_LetterPos.NLetters].X = new_x;
			PA_LetterPos.Letter[PA_LetterPos.NLetters].Y = y;
			PA_LetterPos.Letter[PA_LetterPos.NLetters].Size = size;
			PA_LetterPos.Letter[PA_LetterPos.NLetters].Color = color;
			PA_LetterPos.NLetters++;	
		}	
		new_x += pa_bittextdefaultsize[size][(int)string[i]]+textinfo.letterspacing;
	}		
	return new_x;
}


extern inline void Forumla_AddLetterPos(s16 Letter, s16 x, s16 y, u8 size, u16 color){
   if (x<0) return;
   PA_LetterPos.Letter[PA_LetterPos.NLetters].Letter = Letter;
	PA_LetterPos.Letter[PA_LetterPos.NLetters].X = x;
	PA_LetterPos.Letter[PA_LetterPos.NLetters].Y = y;
	PA_LetterPos.Letter[PA_LetterPos.NLetters].Size = size;
	PA_LetterPos.Letter[PA_LetterPos.NLetters].Color = color;
	PA_LetterPos.NLetters++;	
}

void Formula_DoLetterPos(s16 basex, s16 basey, char* text, u16 color, u8 size, s32 limit){
	s16 x = basex; s16 y = basey;
	s16 oldx=0;
	s16 letterstart;
	u8 lx, letter = ' ';
	s16 i;
	
	PA_LetterPos.NLetters = 0;
	letterstart = 0;
	
	if((textinfo.align == ALIGN_JUSTIFY)||(textinfo.align == ALIGN_LEFT)) limit += 100; // Pour bien caler la ligne
	u8 groupCounter=0;
	for(i = 0; (i < limit+100)&&(equation[getSelectedAmbience(selectedAmbience)][selectedProperties][i]); i++)
	{
	   letter = equation[getSelectedAmbience(selectedAmbience)][selectedProperties][i]; 
	   lx = pa_bittextdefaultsize[size][letter]+textinfo.letterspacing;
	   if (textCursorColumn==i) 
		{
			if (x-5>0)
				x -= 5;	 

			
		   if (x>250-textLineX && textLineX< (x-256)+textLineX)
			{			
				break;
			}							
		   if (x<0)
			{			
				textLineX= textLineX+x;
			}		

	   	LetterPos('|',10);
			x += 5;	 

		}   
		if (x+lx>250) 
		{
		   x+=lx;
		   continue;
		}  	

		oldx=x;
	   if (!(letter >= '0' && letter <= '9') && (equation[getSelectedAmbience(selectedAmbience)][selectedProperties][i-1] >= '0' && equation[getSelectedAmbience(selectedAmbience)][selectedProperties][i-1] <= '9')) x += 5;	 
	   switch (letter)
	   {
	      case 'r': 	x = StringPos("rand",x,y,size,2);
						   break;
	      case 'a': 	x = StringPos("abs",x,y,size,2);
						   break;
	      case '<': 	x = StringPos("<<",x,y,size,2);
						   break;
	      case '>': 	x = StringPos(">>",x,y,size,2);
						   break;
	      case 't': 	x = StringPos("tan",x,y,size,2);
						   break;
	      case 'c': 	x = StringPos("cos",x,y,size,2);
						   break;
	      case 's': 	x = StringPos("sin",x,y,size,2);
						   break;
	      case 'm': 	x = StringPos("max",x,y,size,2);
						   break;
	      case 'n': 	x = StringPos("min",x,y,size,2);
						   break;
	      case '*': 	x = StringPos("x",x,y,size,2);
	      				break;
	      case 'x': 	switch (equation[getSelectedAmbience(selectedAmbience)][selectedProperties][i+1])
							{
							   case '0': x = StringPos("timer",x,y,size,2);
							   			 break;
							   case '1': x = StringPos("hTimer",x,y,size,2);
							   			 break;
							   case '2': x = StringPos("gSelect",x,y,size,2);
							   			 break;
					   	}		 
					      i++;
						   break;
	      case 'k': 	x = StringPos("khz",x,y,size,2);
	         			if (equation[getSelectedAmbience(selectedAmbience)][selectedProperties][i+1] >= '0' && equation[getSelectedAmbience(selectedAmbience)][selectedProperties][i+1] <= '5')
	         			{
								LetterPos((int)equation[getSelectedAmbience(selectedAmbience)][selectedProperties][i+1],2);
							}  	
						   else
						   {
								LetterPos('A',2);
							}  	
					      i++;
						   break;
	      case 'z': 	x = StringPos("_khz",x,y,size,2);
	         			if (equation[getSelectedAmbience(selectedAmbience)][selectedProperties][i+1] >= '0' && equation[getSelectedAmbience(selectedAmbience)][selectedProperties][i+1] <= '5')
	         			{
								LetterPos((int)equation[getSelectedAmbience(selectedAmbience)][selectedProperties][i+1],2);
							}  	
						   else
						   {
								LetterPos('A',2);
							}  	
					      i++;
						   break;
			default:		Forumla_AddLetterPos(letter, x, y, size, letter >= '0' && letter <= '9'? 4:10);
				   		x += lx;   
		}   
		if (!(letter >= '0' && letter <= '9')) x += 5;	 
		if (letter == '(') groupCounter++;
		if (letter == ')') groupCounter--;
		if (Stylus.Held)  if (StylusYAtTextBox()) if (oldx<Stylus.X&& x>Stylus.X) 
		{
		   if (letter == 'x' || letter == 'k' || letter == 'z') 
				textCursorColumn=i-1;
			else
			   textCursorColumn=i;
		}   
	}   
	if (Stylus.Held) if (StylusYAtTextBox()) if (x<Stylus.X&&256>Stylus.X) textCursorColumn=i;
	
	if (textCursorColumn==i) 
	{
	   LetterPos('|',10);
		x += 15;	 
	   if (x>256-textLineX && textLineX< (x-256)+textLineX)
		{			
			textLineX= (x-256)+textLineX;
		}			
		if (x<=256)
		{		
			for (i=0; i<groupCounter;i++)
			{
			   if (x>256) break;
				LetterPos(')',9);
				x += 5;	 
			}		
		}		
	}
	
	
	if(equation[getSelectedAmbience(selectedAmbience)][selectedProperties][i-1] == ' ') x-= pa_bittextdefaultsize[size][(u8)(' ')]; // Retirer la largeur de l'espace	 
	PA_DoAlign(letterstart, x, 256, (letter != '\n') && (equation[getSelectedAmbience(selectedAmbience)][selectedProperties][i] != '\0'));

	// End Position
	PA_LetterPos.Letter[PA_LetterPos.NLetters].X = x;
	PA_LetterPos.Letter[PA_LetterPos.NLetters].Y = y;

}

void pa_16cTextDecompress(u8 size);
s16 Formula_16cText(u8 screen, s16 basex, s16 basey, char* text, u8 color, u8 size, s32 limit){
	s32 i;
	
	pa_16cTextDecompress(size);
		
	Formula_DoLetterPos(basex, basey, text, color, size, limit);
	
	if(limit > PA_LetterPos.NLetters) limit = PA_LetterPos.NLetters; // Plus short que prvu
	
	for(i = 0; i < limit; i++) 
	{
	   if (PA_LetterPos.Letter[i].Letter == '|')
	   {
			if (blinktimer_counter%120< 60) 
			{
			   PA_16cPutPixel(screen, PA_LetterPos.Letter[i].X+5,PA_LetterPos.Letter[i].Y-1,10);
			   PA_16cPutPixel(screen, PA_LetterPos.Letter[i].X+5,PA_LetterPos.Letter[i].Y,10);
			   PA_16cPutPixel(screen, PA_LetterPos.Letter[i].X+5,PA_LetterPos.Letter[i].Y+1,10);
			   PA_16cPutPixel(screen, PA_LetterPos.Letter[i].X+5,PA_LetterPos.Letter[i].Y+2,10);
			   PA_16cPutPixel(screen, PA_LetterPos.Letter[i].X+5,PA_LetterPos.Letter[i].Y+3,10);
			   PA_16cPutPixel(screen, PA_LetterPos.Letter[i].X+5,PA_LetterPos.Letter[i].Y+4,10);
			   PA_16cPutPixel(screen, PA_LetterPos.Letter[i].X+5,PA_LetterPos.Letter[i].Y+5,10);
			   PA_16cPutPixel(screen, PA_LetterPos.Letter[i].X+5,PA_LetterPos.Letter[i].Y+6,10);
			   PA_16cPutPixel(screen, PA_LetterPos.Letter[i].X+5,PA_LetterPos.Letter[i].Y+7,10);
			   PA_16cPutPixel(screen, PA_LetterPos.Letter[i].X+5,PA_LetterPos.Letter[i].Y+8,10);
			}   
	   }
		else
		{   
	   PA_16cLetter(screen, PA_LetterPos.Letter[i].X, PA_LetterPos.Letter[i].Y, 
										PA_LetterPos.Letter[i].Letter, PA_LetterPos.Letter[i].Size, PA_LetterPos.Letter[i].Color);
		}			
	}			




	blinktimer_counter++;
	return limit;
}
char* returnProperty(int property)
{
	switch (property)
	{
	   case 0: return "X";
		case 1: return "Y";
		case 2: return "Width";
		case 3: return "Height";
		case 4: return "Alpha";
		case 5: return "RotZ";
		case 6: return "RotX"; 
		case 7: return "RotY";
		case 8: return "corner[0].x";
		case 9: return "corner[0].y";
		case 10: return "corner[1].x";
		case 11: return "corner[1].y";
		case 12: return "corner[2].x"; 
		case 13: return "corner[2].y";
		case 14: return "corner[3].x";
		case 15: return "corner[3].y";
		case 16: return "Priority";
		case 17: return "Texture";
		
	}
   return "error";
}   

bool DrawStylusInZone_16cBox(int x1,int y1,int x2,int y2)
{
   if (PA_StylusInZone(x1,y1,x2,y2))
   {
	   int i;
	   for (i=x1;i<=x2;i++)
	   {
	      PA_16cPutPixel(1,i,y1,3);
	   }   
	   for (i=y1;i<=y2;i++)
	   {
	      PA_16cPutPixel(1,x1,i,3);
	      PA_16cPutPixel(1,x2,i,3);
	   }   
	   for (i=x1;i<=x2;i++)
	   {
	      PA_16cPutPixel(1,i,y2,3);
	   }
		return 1;   
	}			
	return 0;
}   
char checkStylusInput(int scriptFor)
{
   if (Stylus.Newpress) 
   {

		if (!calculator_variableMode)
		{
	      if (PA_StylusInZone(5,  60, 32, 80))  inputChar('r');
			if (PA_StylusInZone(35, 60, 62, 80))  inputChar('/');
			if (PA_StylusInZone(67, 60, 93, 80))  inputChar('-');
			if (PA_StylusInZone(99, 60, 122,80))  inputChar('*');
			if (PA_StylusInZone(130,60, 154,80))  inputChar('s');
			if (PA_StylusInZone(5,  85, 31, 104)) inputChar('7');
			if (PA_StylusInZone(35, 85, 62, 104)) inputChar('8');
			if (PA_StylusInZone(67, 85, 92, 104)) inputChar('9');
			if (PA_StylusInZone(99, 85, 123,130)) inputChar('+');
			if (PA_StylusInZone(130,85, 155,104)) inputChar('c');

			if (PA_StylusInZone(5,  110,31, 130)) inputChar('4');
			if (PA_StylusInZone(35, 110,63, 130)) inputChar('5');
			if (PA_StylusInZone(67, 110,93, 130)) inputChar('6');
			if (PA_StylusInZone(5,  135,31, 157)) inputChar('1');
			if (PA_StylusInZone(35, 135,62, 157)) inputChar('2');
			if (PA_StylusInZone(67, 135,92, 157)) inputChar('3');
			if (PA_StylusInZone(99, 135,123,157)) inputChar('%');
			if (PA_StylusInZone(130,135,155,157)) inputChar('^');
			if (PA_StylusInZone(5,  160,62, 181)) inputChar('0');
			if (PA_StylusInZone(69, 160,93, 181)) inputChar('<');
			if (PA_StylusInZone(99, 160,124,181)) inputChar('>');
			if (PA_StylusInZone(130,160,156,181)) inputChar('a');

			if (PA_StylusInZone(191,138, 218,158))  inputChar('m');			
			if (PA_StylusInZone(225,138, 250,158)) inputChar('n');	
	
		}			
		else
		{
	      if (PA_StylusInZone(5,  60, 32, 80))  inputValChar('x','0');
			if (PA_StylusInZone(35, 60, 62, 80))  inputValChar('x','1');
			if (scriptFor == SCRIPTFOR_GAMESELECT) if (PA_StylusInZone(67, 60, 93, 80))  inputValChar('x','2');
				
			if (PA_StylusInZone(5,  85, 31, 104)) inputValChar('k','0');
			if (PA_StylusInZone(35, 85, 62, 104)) inputValChar('k','1');
			if (PA_StylusInZone(67, 85, 92, 104)) inputValChar('k','2');
			if (PA_StylusInZone(99, 85, 123,130)) inputValChar('k','6');
		
			if (PA_StylusInZone(5,  110,31, 130)) inputValChar('k','3');
			if (PA_StylusInZone(35, 110,63, 130)) inputValChar('k','4');
			if (PA_StylusInZone(67, 110,93, 130)) inputValChar('k','5');
				
			if (PA_StylusInZone(5,  135,31, 157)) inputValChar('z','0');
			if (PA_StylusInZone(35, 135,62, 157)) inputValChar('z','1');
			if (PA_StylusInZone(67, 135,92, 157)) inputValChar('z','2');
			if (PA_StylusInZone(99, 135,123,157)) inputValChar('z','6');
			if (PA_StylusInZone(130,135,155,157)) inputValChar('z','3');
			if (PA_StylusInZone(5,  160,62, 181)) inputValChar('z','4');
			if (PA_StylusInZone(69, 160,93, 181)) inputValChar('z','5');
		}   
		if (PA_StylusInZone(191,59, 250,80))  if (textCursorColumn>0) deleteChar();
		if (PA_StylusInZone(191,110,218,130)) inputChar('(');
		if (PA_StylusInZone(225,110,250,130)) inputChar(')');
//		if (PA_StylusInZone(191,138,250,158)) 
		if (PA_StylusInZone(191,161,250,188)) 
		{
			if (calculator_variableMode)
				loadBMPWithResource(1,0,0,"apps/themetools/Scripter_FunctionInterface.bmp");
			else
				loadBMPWithResource(1,0,0,"apps/themetools/Scripter_VariableInterface.bmp");
			calculator_variableMode=!calculator_variableMode;
		}   
		if (PA_StylusInZone(164,34,188,55)) memset(clipboard,0,sizeof(clipboard));
		if (PA_StylusInZone(195,34,219,55)) 
		{
		   memset(clipboard,0,sizeof(clipboard));
		   sprintf(clipboard,"%s",equation[getSelectedAmbience(selectedAmbience)][selectedProperties]);
		}   
		if (PA_StylusInZone(224,34,248,55)) 
		{
		   memset(equation[getSelectedAmbience(selectedAmbience)][selectedProperties],0,sizeof(equation[getSelectedAmbience(selectedAmbience)][selectedProperties]));
		   sprintf(equation[getSelectedAmbience(selectedAmbience)][selectedProperties],"%s",clipboard);
		}   
		if (equation[getSelectedAmbience(selectedAmbience)][selectedProperties][0]==0)memset(equation[getSelectedAmbience(selectedAmbience)][selectedProperties],0,sizeof(equation[getSelectedAmbience(selectedAmbience)][selectedProperties]));
      if (PA_StylusInZone(5,  34, 32, 55)) return 1;
		if (PA_StylusInZone(35, 34, 62, 55)) return 2;
//		   inputChar('x');
//		   inputChar('0');
   }
   return 0;
}   
extern char CurrentTheme[256];

void saveScript(char * menu,int scriptFor)
{
		char ambiencePath[256];   
	char CurrentMenu[256];
   PA_SetBrightness(0,31);   
   PA_SetBrightness(1,31);
	if (stricmp(menu,"topscreen")==0)
	{
		sprintf(CurrentMenu,"Mainmenu");
	}		
	else
	{
		if (stricmp(menu,"gamenavigate")==0)
		{
			sprintf(CurrentMenu,"GameNavigate");
		}		
		else
			sprintf(CurrentMenu,"%s",menu);
	}		
	
	char chrTemp[200];
	if (scriptFor!=SCRIPTFOR_GAMESELECT)  
	{
	char charTemp[256];
		sprintf(charTemp,"fat:/_menudo/themes/%s/ambience/ambience.ini", CurrentTheme);
		readINI = fopen (charTemp, "rb"); 
		char varname[100];
		sprintf(varname,"%s_Folder",CurrentMenu);
		char* folderpath = (char *)readIniFileString(varname);
	//	logMessage(folderpath);
		bool usedefault=0;
		if (strcmp(CurrentMenu,"mWifi")==0 && folderpath == NULL)
		{
		   usedefault=1;
			free(folderpath);   	   
			sprintf(charTemp,"fat:/_menudo/default/ambience/ambience.ini");
			readINI = fopen (charTemp, "rb"); 
			sprintf(varname,"%s_Folder",CurrentMenu);
			folderpath = (char *)readIniFileString(varname);
		}
		if (usedefault)
		{
	
			sprintf(charTemp,"fat:/_menudo/default/ambience/%s",folderpath);
		}		
		else
		{
			sprintf(charTemp,"fat:/_menudo/themes/%s/ambience/%s",CurrentTheme,folderpath);
	
		}		
	//	logMessage(charTemp);
		if (folderpath!=NULL) free(folderpath);   	
	
		sprintf(ambiencePath,"%s",charTemp);
		
		sprintf(varname,"%s_Script",CurrentMenu);
		char * ambienceScript=readIniFileString(varname);
		sprintf(ambiencePath,"%s/%s",ambiencePath,ambienceScript);
		if (ambienceScript!=NULL) free (ambienceScript);
	
		fclose (readINI);
	}		
	else
	{

		sprintf(ambiencePath,"fat:/_menudo/themes/%s/gamenavigate/Navigate.Script",CurrentTheme);
	}   
//   sprintf(ambiencePath,"fat:/
  FILE* testWrite = fopen (ambiencePath, "wb");  
logMessage(ambiencePath);
 //  FILE* testWrite = fopen ("fat:/test.test", "wb");  
   int i;
	if (scriptFor==SCRIPTFOR_GAMESELECT)  
	{ 

	   fwrite("Navigate Script v.01\n",strlen("Navigate Script v.01\n"),1,testWrite);
		for (x=0;x<MAX_GAMESELECT;x++)
		{
		 	if (x <= 3)
		 	{
				for (i=0;i<MAX_GAMESELECT_SPRITE_PROPERTIES;i++)
				{
		         sprintf(chrTemp,"%s\n",equation[getSelectedAmbience(x)][i]);
		         fwrite(chrTemp, strlen(chrTemp), 1, testWrite);
				}	 	  
			}		
			else
			{
				for (i=0;i<6;i++)
				{
		         sprintf(chrTemp,"%s\n",equation[getSelectedAmbience(x)][i]);
		         fwrite(chrTemp, strlen(chrTemp), 1, testWrite);
				}	
			} 
		}  
    
	}	
	else
	{
	   fwrite("Ambience Script v.01\n",strlen("Ambience Script v.01\n"),1,testWrite);
		for (x=0;x<MAX_AMBIENCE;x++)
		for (i=0;i<MAX_AMBIENCEPROPERTIES;i++)
		{
		   sprintf(chrTemp,"%s\n",equation[getSelectedAmbience(x)][i]);
		   fwrite(chrTemp, strlen(chrTemp), 1, testWrite);
		}  
	}		
	fclose(testWrite);		
   PA_SetBrightness(1,0);
   PA_SetBrightness(0,0);
}   


extern int ambienceTex[MAX_AMBIENCETEX];
extern u16 ambienceTexWidth[MAX_AMBIENCETEX];
extern u16 ambienceTexHeight[MAX_AMBIENCETEX];
extern u8  ambienceTex_Amount;

void updateTopScreenVarText(int mode, int scriptFor)
{
   char chrTemp[200];
   int i,y;
   y=0;
   if (scriptFor == SCRIPTFOR_GAMESELECT)
   {
      switch(selectedAmbience)
      {
         case 0: 	sprintf(chrTemp,"Logo");
         			break;
         case 1: 	sprintf(chrTemp,"Overlay");
         			break;
         case 2: 	sprintf(chrTemp,"Logo Duplicate");
         			break;
         case 3: 	sprintf(chrTemp,"Overlay Duplicate");
         			break;
         case 4: 	sprintf(chrTemp,"Filename");
         			break;         
         case 5: 	sprintf(chrTemp,"Title 1");
         			break;
         case 6: 	sprintf(chrTemp,"Subtitle 1");
         			break;
         case 7: 	sprintf(chrTemp,"Subtitle 2");
         			break;
		}		
   }  	
   else
   {
	  	sprintf(chrTemp,"Sprite %d.%s",selectedAmbience,returnProperty(selectedProperties));
   } 		

   PA_16cText(0,2,3,200,3,chrTemp,PLAIN_TEXTCOLOR,2,100);  	


 	y=2;
 	int x=0;
 	if (scriptFor != SCRIPTFOR_GAMESELECT || (scriptFor == SCRIPTFOR_GAMESELECT && selectedAmbience <= 3))
 	{
		for (i=0;i<(scriptFor==SCRIPTFOR_GAMESELECT? MAX_GAMESELECT_SPRITE_PROPERTIES : MAX_AMBIENCEPROPERTIES);i++)
		{
		   if ((equation[getSelectedAmbience(selectedAmbience)][i][0] != 0 || mode == 1) && mode != 0)
		   {
			   sprintf(chrTemp,"%d", readExpression(equation[getSelectedAmbience(selectedAmbience)][i],0,scriptFor==SCRIPTFOR_GAMESELECT));
			   PA_16cText(0,20+(x*40),10*(y),200,10*(y),chrTemp,selectedProperties==i?PLAIN_TEXTCOLOR:SEMITRANSLUCENT_TEXTCOLOR,2,100);
			   x++;
			   if (i==1 || i==3 || i==4 || i==7 || i==9 || i==11 || i==13 || i==15 || i==16 || i==17)
			   {
			      y++;
			      x=0;
			   }   
			}   
		}	 	  
	}		
	else
	{
	   // whenever text objects are being scripted
		for (i=0;i<6;i++)
		{
		   if ((equation[getSelectedAmbience(selectedAmbience)][i][0] != 0 || mode == 1) && mode != 0)
		   {
			   sprintf(chrTemp,"%d", readExpression(equation[getSelectedAmbience(selectedAmbience)][i],0,scriptFor==SCRIPTFOR_GAMESELECT));
			   PA_16cText(0,20+(x*40),10*(y),200,10*(y),chrTemp,selectedProperties==i?PLAIN_TEXTCOLOR:SEMITRANSLUCENT_TEXTCOLOR,2,100);
			   x++;
			   if (i==1  || i==3 || i==4)
			   {
			      y++;
			      x=0;
			   }   
			}   
		}	
	}   

}   
void moveCursor (bool right)
{
	if (right || (right && selectHold_counter==SELECT_HOLDDURATION)) 
	{
	   textCursorColumn++;
	   if (equation[getSelectedAmbience(selectedAmbience)][selectedProperties][textCursorColumn-1]=='x' || equation[getSelectedAmbience(selectedAmbience)][selectedProperties][textCursorColumn-1]=='k' || equation[getSelectedAmbience(selectedAmbience)][selectedProperties][textCursorColumn-1]=='z') textCursorColumn++;
	   blinktimer_counter=0;
	   if (selectHold_counter!=SELECT_HOLDDURATION || textCursorColumn>(strlen(equation[getSelectedAmbience(selectedAmbience)][selectedProperties]))-1)
		{
		   selectHold_counter=0;
		}   
	   if (textCursorColumn>strlen(equation[getSelectedAmbience(selectedAmbience)][selectedProperties]))
	   {
	      textCursorColumn = 0;
	   }   
	}   
	if (!right || (!right && selectHold_counter==SELECT_HOLDDURATION)) 
	{
	   textCursorColumn--;
	   if (equation[getSelectedAmbience(selectedAmbience)][selectedProperties][textCursorColumn-1]=='x' || equation[getSelectedAmbience(selectedAmbience)][selectedProperties][textCursorColumn-1]=='k' || equation[getSelectedAmbience(selectedAmbience)][selectedProperties][textCursorColumn-1]=='z') textCursorColumn--;
	   blinktimer_counter=0;
	   if (selectHold_counter!=SELECT_HOLDDURATION || textCursorColumn<1)
		{
		   selectHold_counter=0;
		}   
	   if (textCursorColumn<0) 
	   {
	      textCursorColumn = strlen(equation[getSelectedAmbience(selectedAmbience)][selectedProperties]);
	   }   
	}   
	if (right || !right) selectHold_counter=0;
	if ((right || !right) && selectHold_counter<SELECT_HOLDDURATION) selectHold_counter++;
}   
void flipPage(int scriptFor)
{
   switch (scriptFor)
   {
      case SCRIPTFOR_AMBIENCE:
							selectedAmbience= (selectedAmbience+1)%MAX_AMBIENCE;
							break;
      case SCRIPTFOR_GAMESELECT:
			         	selectedAmbience= (selectedAmbience+1)%MAX_GAMESELECT;
					   	break;
		case SCRIPTFOR_VISUALIZER:
					   	selectedAmbience= (selectedAmbience+1)%MAX_VISUALIZER;
					   	break;
	}   
   textCursorColumn=0;
}
//void ambienceScripter(char * path, char * filename, int scriptFor)

void ambienceScripter(char * menu, int scriptFor)
{	
//    scriptFor=SCRIPTFOR_GAMESELECT;
   ideScriptFor=scriptFor;
	PA_Init3D();
	PA_Reset3DSprites();
	PA_Init16cBg(0,1);
	PA_SetBgPrio(0,0,1);
	PA_SetBgPrio(0,1,0);
	PA_Init16bitBg(1,1);
	PA_Init16cBg(1,0);
	PA_SwitchScreens();
	initAntiAliasedText(0,1,0);
	PA_DisableSpecialFx(0);
//	initAmbience(path,filename, scriptFor==SCRIPTFOR_GAMESELECT?true:false);
//	initAmbienceFromTheme("Mainmenu",50);

	loadBMPWithResource(1,0,0,"apps/themetools/Scripter_FunctionInterface.bmp");
/*	if (stricmp(menu,"topscreen")==0)
	{
		initAmbienceFromTheme("Mainmenu",50);
	}		
	else
	{
		if (stricmp(menu,"gamenavigate")==0)
		{
			initAmbienceFromTheme("GameNavigate",50);
		}		
		else
			initAmbienceFromTheme(menu,50);
	}	*/
	loadGameSelectScript();

/*	if (scriptFor==SCRIPTFOR_GAMESELECT)
	{
	   FILE *navipath;
	   int i=0;
	   char chrtemp[256];
	   while(1)
	   {
		   sprintf(chrtemp,"%s/navi.%02d",path,i);
		   navipath=fopen (chrtemp, "rb");  
		   if (!navipath)
		   {
				fclose(navipath);			      
		   sprintf(chrtemp,"%s/navi.%02d",path,i-1);
				break;
		   }
			fclose(navipath);
		   i++;
		}
	   loadGameSelectScript(chrtemp);
//	   loadGameSelectScript("navi.00");
	}   */
	
	int scriptRange_Min=0;
	int scriptRange_Max;
	if (scriptFor==SCRIPTFOR_GAMESELECT)
		scriptRange_Max=0+((MAX_GAMESELECT_SPRITE_PROPERTIES)-1);
	else
		scriptRange_Max=((MAX_AMBIENCEPROPERTIES)-1);
		
	

/*	ambienceTex_Amount=4;*/
	/*
	sprintf(equation[0][0],"200+(x2>1)");
	sprintf(equation[0][1],"150-(c((-128)n(128mx2))>4)");
	sprintf(equation[0][2],"16+(c((-128)n(128mx2))>4)");
	sprintf(equation[0][3],"16+(c((-128)n(128mx2))>4)");

	sprintf(equation[2][1],"48");
	sprintf(equation[2][3],"0-32");	

	sprintf(equation[3][1],"48");
	
	sprintf(equation[4][0],"200+(x2>1)");
	sprintf(equation[4][1],"150");

	sprintf(equation[4][2],"0-(x1>1)");

	
	
	sprintf(equation[GAMESELECT_EQUATION_START+0][0],"32");
	sprintf(equation[GAMESELECT_EQUATION_START+0][1],"96+(x2>2)");
	sprintf(equation[GAMESELECT_EQUATION_START+0][2],"16n(cx2>3)");
	sprintf(equation[GAMESELECT_EQUATION_START+0][3],"16n(cx2>3)");

	sprintf(equation[GAMESELECT_EQUATION_START+4][0],"50");
	sprintf(equation[GAMESELECT_EQUATION_START+4][1],"86+(x2>2)");
	sprintf(equation[GAMESELECT_EQUATION_START+4][5],"((ax2)>6)m1");	
	
	sprintf(equation[GAMESELECT_EQUATION_START+5][0],"60");	
	sprintf(equation[GAMESELECT_EQUATION_START+5][1],"78+(x2>2)");	
	sprintf(equation[GAMESELECT_EQUATION_START+5][5],"(1-(((ax2)>6)m1))*2");

	sprintf(equation[GAMESELECT_EQUATION_START+6][0],"60");	
	sprintf(equation[GAMESELECT_EQUATION_START+6][1],"94+(x2>2)");	
	sprintf(equation[GAMESELECT_EQUATION_START+6][5],"(1-(((ax2)>6)m1))*2");*/
	
		
//	sprintf(equation[3][1],"48");

//	sprintf(equation[1][1],"0"); 
/*	sprintf(equation[0][0],"(((x0)-100)%%500)-64");
	sprintf(equation[1][0],"(((x0>1)-200)%%500)-64");
	sprintf(equation[2][0],"((x0>1)%%500)-64");
	sprintf(equation[3][0],"((x0+20)%%500)-64");
	sprintf(equation[4][0],"((x0/3)%%500)-64");
	sprintf(equation[5][0],"((x0*2)%%500)-64");
	sprintf(equation[6][0],"((x0-20)%%500)-64");
	sprintf(equation[0][1],"128-(((x0)%%500)>3)");
	sprintf(equation[1][1],"128-(((x0<1)%%500)>3)");
	sprintf(equation[2][1],"100-(((x0>1)%%500)>2)");
	sprintf(equation[3][1],"100-(((x0+20)%%500)>1)");
	sprintf(equation[4][1],"200-(((x0/3)%%500))");
	sprintf(equation[5][1],"200-(((x0)%%500)>2)");
	sprintf(equation[6][1],"180-(((x0-20)%%500)>2)");
	
	sprintf(equation[0][2],"16+(k0>2)");
	sprintf(equation[1][2],"20+(k1>3)");
	sprintf(equation[2][2],"18+(k2>1)");
	sprintf(equation[3][2],"14+(k3)");
	sprintf(equation[4][2],"16+(k4>2)");
	sprintf(equation[5][2],"22+(k5>2)");

	sprintf(equation[0][3],"16+(k0>2)");
	sprintf(equation[1][3],"20+(k1>3)");
	sprintf(equation[2][3],"18+(k2>1)");
	sprintf(equation[3][3],"14+(k3)");
	sprintf(equation[4][3],"16+(k4>2)");
	sprintf(equation[5][3],"22+(k5>2)");

	
	
	ambienceTex[0]=CreateTexFromBmpWithAlpha((void*)ambience0_color,(ambienceTex_Amount+AMBIENCE_PALSTART),(void*)ambience0_alpha);
	ambienceTexWidth[0]=getRecentBmpWidth();
	ambienceTexHeight[0]=getRecentBmpHeight();
	ambienceTex_Amount++;*/
	if (scriptFor==SCRIPTFOR_GAMESELECT) initGameSelectSprites(0);

	
//	PA_3DCreateSpriteFromTex(100,CreateTexFromBmp((void*)black,10),256,192,10,256/2,192/2);
//	PA_3DSetSpritePrio(100,1);
	create3dBackgroundLayer(100,0,0,0); //place bg ini here
	PA_3DSetSpritePrio(100,1);
	
	textCursorColumn = 0;
	int debugMode=1;
	int i=0;
//	initMikMod(HtheB, (u32)HtheB_size, 64, 0);
	while(1)
	{
//	   sprintf(chrTemp,"ambience[%d]",selectedAmbience,returnProperty(selectedProperties));
//   	PA_16cText(1,5,3,200,3,chrTemp,10,2,100);
   	Formula_16cText(1,(textLineX*-1)+4,20,equation[getSelectedAmbience(selectedAmbience)][selectedProperties],10,2,MAX_EQUATIONLENGTH);
		updateTopScreenVarText(scriptFor==SCRIPTFOR_GAMESELECT?1:debugMode, scriptFor);

								
	   switch (scriptFor)
	   {
	      case SCRIPTFOR_AMBIENCE:
								updateAmbience(scriptFor==SCRIPTFOR_GAMESELECT?true:false);
						   	break;
	      case SCRIPTFOR_GAMESELECT:
				         	updateGameSelect();
				         	updateTimerCounter();
						   	break;
			case SCRIPTFOR_VISUALIZER:
						   	updateVisualizer();
						   	break;
		}   
		
		i=checkStylusInput(scriptFor);
		switch(i)
		{
		   case 1:	return;
		      		break;
		   case 2: 	saveScript(menu,scriptFor);
		      		break;
		}



		if (Pad.Newpress.Select) debugMode = (debugMode+1)%3;
   	
   	if (Pad.Newpress.Down)  
		{
		   if (selectedProperties< scriptRange_Max)
		   {
		   	selectedProperties++;
			}  	
			else
			{
			   selectedProperties=scriptRange_Min;
			}   
		   textCursorColumn=strlen(equation[getSelectedAmbience(selectedAmbience)][selectedProperties]);
		}   
		if (Pad.Newpress.L) flipPage(scriptFor);

		if (Pad.Newpress.Start) 
		{
			memset(equation[getSelectedAmbience(selectedAmbience)][selectedProperties],0,MAX_EQUATIONLENGTH);
			textCursorColumn=0;
		}
   	if (Pad.Newpress.Up)  
		{
		   if (selectedProperties>scriptRange_Min)
		   {
		   	selectedProperties--;
			}  	
			else
		   {
		      selectedProperties=scriptRange_Max;
		   }   
		   textCursorColumn=strlen(equation[getSelectedAmbience(selectedAmbience)][selectedProperties]);
		}   

		if (Pad.Newpress.Right) moveCursor(true);
		if (Pad.Newpress.Left) moveCursor(false);
//		if (Pad.Newpress.A) saveScript(menu,scriptFor);
		if (Pad.Newpress.R) 
		{
		   PA_SwitchScreens();
			if (shrinkMenu("Mainmenu","",0,10)) return;
		   PA_SwitchScreens();
		}			
		if (Pad.Held.B)idleCounter=0;
		if (Pad.Held.A)gameSelect_counter=0;
		if (Pad.Held.X)gameSelect_counter+=4;
		if (Pad.Held.Y)gameSelect_counter-=4;
//		updateGameSelectCounter();
		ZoomXY_3DProcess(128,0,0);  
		Soul_waitForVBL();
		PA_16cErase(0);
		PA_16cErase(1);
	}	
}		
