#include <PA9.h>       // Include for PA_Lib

#include "commonVariables.h"
#include "..\commands\main_menu\types.h"
#include "functions.h"
#include "../gfx/all_gfx.h"
//#include "RecipeMakerGui.h" // gif to include
#include "interfaceScreen.h"
 
int i, k;

s16 lastTopStylusX=0;
s16 lastTopStylusY=0;
u8 dragEnable=0;
extern u8 functionMode;



int temp;




s16 scrollLayerY =0;

inline void assignClipboard(int clipboardId, int value, int type)
{
	clipboard[clipboardId].Value = value;
	clipboard[clipboardId].Type=type;
}   
inline int clipboardToValue(int value,int type)
{
	return type<=1?value>>8:value;
}	
inline void dragValueToClipboard(char* text) 
{
   PA_16cText(1,Stylus.X+10, Stylus.Y,Stylus.X+100, Stylus.Y,text	,10,2,100);
}   


void initInterface()
{
	PA_Init16bitBg(1, 0);
	loadBMPWithResource(1,0,0,"apps/themetools/rcpiMaker_Interface.bmp");
	PA_Init16cBg(1,1);

	PA_SetBgPrio(1,0,2);
	PA_SetBgPrio(1,1,1);
	PA_SetBgPrio(1,3,3);
	PA_LoadSprite16cPal(1,0,(void*)selectBorder_Pal);
	PA_CreateSprite(1, 0,(void*)selectBorder_Sprite, OBJ_SIZE_32X8,0, 0, 50, 50);
	PA_CreateSprite(1, 1,(void*)selectBorder_Sprite, OBJ_SIZE_32X8,0, 0, 50, 50);
	PA_SetSpriteDblsize(1, 0, 1);
	PA_SetSpriteDblsize(1, 1, 1);
	PA_SetSpriteRotEnable(1, 0, 0);
	PA_SetSpriteRotEnable(1, 1, 0);
	PA_SetRotsetNoAngle(1, 0, 80, 200);
	PA_SetSpritePrio(1,0,2);
	PA_SetSpritePrio(1,1,2);
   PA_SetSpriteXY(1,0,3,22+scrollLayerY);
   PA_SetSpriteXY(1,1,0,22+scrollLayerY);
}   

void dragLayerListBox()
{
	for(i=(scrollLayerY+15)/-10;i<19-((scrollLayerY+10)/10);++i)
	{
	   if (i<0) i=0;
	   if (i>27) break;
		if (Stylus.Y >= 10+scrollLayerY+((i+1)*12) && Stylus.Y <= 23+scrollLayerY+((i+1)*12))
		{
		   selectedMenu=i;
		   functionMode = 0;
		   PA_SetSpriteXY(1,0,3,22+scrollLayerY+(i*12));
		   PA_SetSpriteXY(1,1,0,22+scrollLayerY+(i*12));
		   break;
		}   
	}	
   if (Stylus.Y<=30)
   {
		if (scrollLayerY<0)
		{
		   selectedMenu=((scrollLayerY+5)/-12)+1;
		   functionMode = 0;
		   PA_SetSpriteXY(1,0,3,22+scrollLayerY+((selectedMenu)*12));
		   PA_SetSpriteXY(1,1,0,22+scrollLayerY+((selectedMenu)*12));
		   scrollLayerY+=2;
		}
		else
		{
		   selectedMenu=0;
		   functionMode = 0;
		   PA_SetSpriteXY(1,0,3,22+scrollLayerY);
		   PA_SetSpriteXY(1,1,0,22+scrollLayerY);
			scrollLayerY=0;
		}			
   }   
   else
   if (Stylus.Y>=182)
   {
		if (scrollLayerY>-169)
		{

		   selectedMenu=i-1;
		   functionMode = 0;
		   PA_SetSpriteXY(1,0,3,24+scrollLayerY+((i-1)*12));
		   PA_SetSpriteXY(1,1,0,24+scrollLayerY+((i-1)*12));
		   scrollLayerY-=2;
		}
		else
		{
			scrollLayerY=-169;   
		}			
   }   
   if (PA_GetSpriteY(1,0) <22)
   {
      PA_SetSpriteY(1,0,22);
      PA_SetSpriteY(1,1,22);			
   }   
}			   
bool interactInterface()
{
		if (clipboardAmount!=0)
		{
			if (clipboardAmount <12 || clipboard[clipboardAmount].Type==0) 
				for (i=0;i<clipboardAmount;i++)
					if (i != clipboardBeingDragged-1 || !Stylus.Held )
					{
					   sprintf(charTemp,"%s:%d",clipBoardTypeToString(clipboard[i].Type),clipboardToValue(clipboard[i].Value,clipboard[i].Type));
						switch(i)
						{
								case 0: 	if (PA_StylusInZone(75,109,100,117) && Stylus.Newpress) {clipboard[clipboardAmount].Type=clipboard[i].Type+2;clipboard[clipboardAmount].Value=clipboard[i].Value; clipboardBeingDragged=i+1;}
											break;
								case 1: 	if (PA_StylusInZone(75,129,100,137) && Stylus.Newpress) {clipboard[clipboardAmount].Type=clipboard[i].Type+2;clipboard[clipboardAmount].Value=clipboard[i].Value; clipboardBeingDragged=i+1;}
											break;
								case 2: 	if (PA_StylusInZone(75,149,100,157) && Stylus.Newpress) {clipboard[clipboardAmount].Type=clipboard[i].Type+2;clipboard[clipboardAmount].Value=clipboard[i].Value; clipboardBeingDragged=i+1;}
											break;
								case 3: 	if (PA_StylusInZone(120,109,145,117) && Stylus.Newpress) {clipboard[clipboardAmount].Type=clipboard[i].Type+2;clipboard[clipboardAmount].Value=clipboard[i].Value; clipboardBeingDragged=i+1;}
											break;
								case 4: 	if (PA_StylusInZone(120,129,145,137) && Stylus.Newpress) {clipboard[clipboardAmount].Type=clipboard[i].Type+2;clipboard[clipboardAmount].Value=clipboard[i].Value; clipboardBeingDragged=i+1;}
											break;
								case 5: 	if (PA_StylusInZone(120,149,145,157) && Stylus.Newpress) {clipboard[clipboardAmount].Type=clipboard[i].Type+2;clipboard[clipboardAmount].Value=clipboard[i].Value; clipboardBeingDragged=i+1;}
											break;
								case 6: 	if (PA_StylusInZone(165,109,190,117) && Stylus.Newpress) {clipboard[clipboardAmount].Type=clipboard[i].Type+2;clipboard[clipboardAmount].Value=clipboard[i].Value; clipboardBeingDragged=i+1;}
											break;
								case 7: 	if (PA_StylusInZone(165,129,190,137) && Stylus.Newpress) {clipboard[clipboardAmount].Type=clipboard[i].Type+2;clipboard[clipboardAmount].Value=clipboard[i].Value; clipboardBeingDragged=i+1;}
											break;
								case 8: 	if (PA_StylusInZone(165,149,190,157) && Stylus.Newpress) {clipboard[clipboardAmount].Type=clipboard[i].Type+2;clipboard[clipboardAmount].Value=clipboard[i].Value; clipboardBeingDragged=i+1;}
											break;
								case 9: 	if (PA_StylusInZone(215,109,190,117) && Stylus.Newpress) {clipboard[clipboardAmount].Type=clipboard[i].Type+2;clipboard[clipboardAmount].Value=clipboard[i].Value; clipboardBeingDragged=i+1;}
											break;
								case 10: if (PA_StylusInZone(215,129,190,137) && Stylus.Newpress) {clipboard[clipboardAmount].Type=clipboard[i].Type+2;clipboard[clipboardAmount].Value=clipboard[i].Value; clipboardBeingDragged=i+1;}
											break;
								case 11: if (PA_StylusInZone(215,149,190,157) && Stylus.Newpress) {clipboard[clipboardAmount].Type=clipboard[i].Type+2;clipboard[clipboardAmount].Value=clipboard[i].Value; clipboardBeingDragged=i+1;}
											break;
						}			
					}			
		}			


		if (Stylus.Newpress)
		{
			lastTopStylusX=Stylus.X;
			lastTopStylusY=Stylus.Y;
		   if (PA_StylusInZone(95,45,95+38,45+15)) 			dragEnable=DRAG_X;
		   else if (PA_StylusInZone(95,63,95+38,63+15))  	dragEnable=DRAG_Y;
		   else if (PA_StylusInZone(151,45,151+38,45+15)) 	dragEnable=DRAG_W;
		   else if (PA_StylusInZone(151,63,151+38,63+15)) 	dragEnable=DRAG_H;
		   else if (PA_StylusInZone(208,45,208+38,45+15)) 	dragEnable=DRAG_R;
		   else if (PA_StylusInZone(208,63,208+16,63+15)) 	dragEnable=DRAG_A;
		   else if (PA_StylusInZone(236,63,236+16,63+15)) 	dragEnable=DRAG_P;
		   else if (PA_StylusInZone(77,45,92,60))  	  		assignClipboard(clipboardAmount, sprite[selectedMenu].data[getKeyframe(selectedMenu)].x, DRAG_VALUE_X);
		   else if (PA_StylusInZone(77,63,92,78))  	  		assignClipboard(clipboardAmount, sprite[selectedMenu].data[getKeyframe(selectedMenu)].y, DRAG_VALUE_Y);
		   else if (PA_StylusInZone(133,45,148,60))  	  	assignClipboard(clipboardAmount, sprite[selectedMenu].data[getKeyframe(selectedMenu)].width, DRAG_VALUE_W);
		   else if (PA_StylusInZone(133,63,148,78))  	  	assignClipboard(clipboardAmount, sprite[selectedMenu].data[getKeyframe(selectedMenu)].height, DRAG_VALUE_H);
		   else if (PA_StylusInZone(193,45,205,45+15)) 		assignClipboard(clipboardAmount, sprite[selectedMenu].data[getKeyframe(selectedMenu)].angle, DRAG_VALUE_R);
		   else if (PA_StylusInZone(193,63,205,63+15)) 		assignClipboard(clipboardAmount, sprite[selectedMenu].data[getKeyframe(selectedMenu)].alpha, DRAG_VALUE_A);
		   else if (PA_StylusInZone(223,63,233,63+15)) 		assignClipboard(clipboardAmount, sprite[selectedMenu].data[getKeyframe(selectedMenu)].prio, DRAG_VALUE_P);
			else if (PA_StylusInZone(18,3,18+15,3+15)) 		return 1;
			else if (PA_StylusInZone(48,3,48+15,3+15)) 		saveProject();
			else if (PA_StylusInZone(208,87,208+10,87+10)) 	hideItem(selectedMenu);
			else if (PA_StylusInZone(242,87,242+10,87+10)) 	lockItem(selectedMenu);
			else if (PA_StylusInZone(186,3,186+25,3+15)) 	zoomOut();
			else if (PA_StylusInZone(210,3,210+25,3+15)) 	zoomIn();
			else if (PA_StylusInZone(235,3,255,3+15)) 		toggleAmbience();
			else if (PA_StylusInZone(182,171,182+15,171+15))clearClipboard();
			else if (PA_StylusInZone(122,171,122+17,171+17))undoAction();
			else if (PA_StylusInZone(152,171,152+17,171+17))redoAction();
			else if (PA_StylusInZone(232,169,232+20,169+20)) copyAll();
			else if (PA_StylusInZone(208,169,208+17,169+20)) pasteAll();
			else if (PA_StylusInZone(0,21,70,192))
					{
					   dragEnable=DRAG_LAYERS;
					}   
		}


		if (Stylus.Held)
		{
			switch (dragEnable)
			{
			   case DRAG_LAYERS: dragLayerListBox(scrollLayerY);
			   						break;

				case DRAG_P: dragValue(sprite[selectedMenu].data[getKeyframe(selectedMenu)].prio,(Stylus.Y-lastTopStylusY)>>2,(Stylus.Y-lastTopStylusY)>>2);
						   	 clipKeyFrame_IfAtCornerMenu(prio);
								 break;

				case DRAG_A: dragValue(sprite[selectedMenu].data[getKeyframe(selectedMenu)].alpha,(Stylus.Y-lastTopStylusY)>>2,(Stylus.Y-lastTopStylusY)>>1);
								 if (sprite[selectedMenu].data[getKeyframe(selectedMenu)].alpha > 31) sprite[selectedMenu].data[getKeyframe(selectedMenu)].alpha =31;
						   	 clipKeyFrame_IfAtCornerMenu(alpha);
								 break;
								 
				case DRAG_R: dragValue(sprite[selectedMenu].data[getKeyframe(selectedMenu)].angle,(Stylus.Y-lastTopStylusY)>>2,(Stylus.Y-lastTopStylusY));
								 sprite[selectedMenu].data[getKeyframe(selectedMenu)].angle %=512;
						   	 clipKeyFrame_IfAtCornerMenu(angle);
								 break;
								 
				case DRAG_H: dragValue(sprite[selectedMenu].data[getKeyframe(selectedMenu)].height,(Stylus.Y-lastTopStylusY)>>1,(Stylus.Y-lastTopStylusY)>>1);
/*								 if (Pad.Held.L)
								 {
								    proportionValue(width,height,imgwidth,imgheight);
							   	 clipKeyFrame_IfAtCornerMenu(width);
								 }   */
						   	 clipKeyFrame_IfAtCornerMenu(height);
								 break;
								 
				case DRAG_W: dragValue(sprite[selectedMenu].data[getKeyframe(selectedMenu)].width,(Stylus.Y-lastTopStylusY)>>1,(Stylus.Y-lastTopStylusY)>>1);
/*								 if (Pad.Held.L)
								 {
								    proportionValue(height,width,imgwidth,imgheight);
							   	 clipKeyFrame_IfAtCornerMenu(height);
								 }   */
						   	 clipKeyFrame_IfAtCornerMenu(width);
								 break;
								 
				case DRAG_Y: dragValue(sprite[selectedMenu].data[getKeyframe(selectedMenu)].y,(Stylus.Y-lastTopStylusY)<<5,(Stylus.Y-lastTopStylusY)<<9);
						   	 clipKeyFrame_IfAtCornerMenu(y);
								 break;
								 
				case DRAG_X: dragValue(sprite[selectedMenu].data[getKeyframe(selectedMenu)].x,(Stylus.Y-lastTopStylusY)<<5,(Stylus.Y-lastTopStylusY)<<9);
						   	 clipKeyFrame_IfAtCornerMenu(x);
								 break;
			}		
			if (clipboard[clipboardAmount].Type>0)
			{
			   if (PA_StylusInZone(0,21,70,192))
			   {
					dragEnable=DRAG_LAYERS;			      
				}			
				else
				{
					if (clipboardAmount==0)
					{

						   PA_TextAlign(2);
							PA_16cText(1,71,130,256,130,"drop here",PA_StylusInZone(71,104,256,162)?10:9,2,100);
						   PA_TextAlign(0);
					}			
					else
					if (clipboardAmount==12)
					{
					   PA_TextAlign(2);
						PA_16cText(1,71,130,256,130,"clipboard full",9,2,100);
					   PA_TextAlign(0);
					}   
					dragEnable=0;
				}			

		   sprintf(charTemp,"%s:%ld",clipBoardTypeToString(clipboard[clipboardAmount].Type-2),clipboard[clipboardAmount].Type-2<=1?clipboard[clipboardAmount].Value>>8:clipboard[clipboardAmount].Value);
			dragValueToClipboard(charTemp);
			}		
		}			
			
		
		if (Stylus.Released) 
		{
		   dragEnable=0;

		   PA_SetSpriteXY(1,0,3,22+scrollLayerY+(selectedMenu*12));
		   PA_SetSpriteXY(1,1,0,22+scrollLayerY+(selectedMenu*12));
		   if (clipboard[clipboardAmount].Type>0)
			{
			   if (PA_StylusInZone(95,45,95+38,45+15)) 		  
				{
				   sprite[selectedMenu].data[getKeyframe(selectedMenu)].x= clipboardToValue(clipboard[clipboardAmount].Value<<8,clipboard[clipboardAmount].Type-2);
		   		clipKeyFrame_IfAtCornerMenu(x);
				}   
			   else if (PA_StylusInZone(95,63,95+38,63+15))   
				{
				   sprite[selectedMenu].data[getKeyframe(selectedMenu)].y= clipboardToValue(clipboard[clipboardAmount].Value<<8,clipboard[clipboardAmount].Type-2);
		   		clipKeyFrame_IfAtCornerMenu(y);
				}   
			   else if (PA_StylusInZone(151,45,151+38,45+15)) 
			   {
					sprite[selectedMenu].data[getKeyframe(selectedMenu)].width= clipboardToValue(clipboard[clipboardAmount].Value,clipboard[clipboardAmount].Type-2);
		   		clipKeyFrame_IfAtCornerMenu(width);
				}   
			   else if (PA_StylusInZone(151,63,151+38,63+15)) 
			   {
					sprite[selectedMenu].data[getKeyframe(selectedMenu)].height= clipboardToValue(clipboard[clipboardAmount].Value,clipboard[clipboardAmount].Type-2);
		   		clipKeyFrame_IfAtCornerMenu(height);
				}   
			   else if (PA_StylusInZone(208,45,208+38,45+15)) 
			   {
					sprite[selectedMenu].data[getKeyframe(selectedMenu)].angle= clipboardToValue(clipboard[clipboardAmount].Value,clipboard[clipboardAmount].Type-2);
		   		clipKeyFrame_IfAtCornerMenu(angle);
				}   
			   else if (PA_StylusInZone(208,63,208+16,63+15)) 
			   {
					sprite[selectedMenu].data[getKeyframe(selectedMenu)].alpha= clipboardToValue(clipboard[clipboardAmount].Value,clipboard[clipboardAmount].Type-2);
		   		clipKeyFrame_IfAtCornerMenu(alpha);
				}   
			   else if (PA_StylusInZone(236,63,236+16,63+15)) 
			   {
					sprite[selectedMenu].data[getKeyframe(selectedMenu)].prio = clipboardToValue(clipboard[clipboardAmount].Value,clipboard[clipboardAmount].Type-2);
					clipKeyFrame_IfAtCornerMenu(prio);
				}   
			   else if (PA_StylusInZone(71,99,256,162))
			   {
					if (clipboardAmount<12 && clipboardBeingDragged==0)
					{
						clipboard[clipboardAmount].Type = clipboard[clipboardAmount].Type-2;
						clipboardAmount++;
					}			
				}			
				else
				if (clipboardBeingDragged!=0) deleteClipboard(clipboardBeingDragged);
			}	
			 clipboardBeingDragged=0;		
		   clipboard[clipboardAmount].Type=0;
		}   

	return 0;
}	

void updateInterface(bool screenswitched)
{
	if (clipboardAmount!=0)
	{
		if (clipboardAmount <12 || clipboard[clipboardAmount].Type==0) 
			for (i=0;i<clipboardAmount;i++)
				if (i != clipboardBeingDragged-1 || !Stylus.Held )
				{
				   sprintf(charTemp,"%s:%d",clipBoardTypeToString(clipboard[i].Type),clipboardToValue(clipboard[i].Value,clipboard[i].Type));
					switch(i)
					{
					   
							case 0: 	PA_16cText(1,75,109,256,109,charTemp,screenswitched && (clipboard[clipboardAmount].Type==0 || PA_StylusInZone(71,104,256,162))?10:9,2,100);
										break;
							case 1: 	PA_16cText(1,75,129,256,129,charTemp,screenswitched && (clipboard[clipboardAmount].Type==0 || PA_StylusInZone(71,104,256,162))?10:9,2,100);
										break;
							case 2: 	PA_16cText(1,75,149,256,149,charTemp,screenswitched && (clipboard[clipboardAmount].Type==0 || PA_StylusInZone(71,104,256,162))?10:9,2,100);
										break;
							case 3: 	PA_16cText(1,120,109,256,109,charTemp,screenswitched && (clipboard[clipboardAmount].Type==0 || PA_StylusInZone(71,104,256,162))?10:9,2,100);
										break;
							case 4: 	PA_16cText(1,120,129,256,129,charTemp,screenswitched && (clipboard[clipboardAmount].Type==0 || PA_StylusInZone(71,104,256,162))?10:9,2,100);
										break;
							case 5: 	PA_16cText(1,120,149,256,149,charTemp,screenswitched && (clipboard[clipboardAmount].Type==0 || PA_StylusInZone(71,104,256,162))?10:9,2,100);
										break;
							case 6: 	PA_16cText(1,165,109,256,109,charTemp,screenswitched && (clipboard[clipboardAmount].Type==0 || PA_StylusInZone(71,104,256,162))?10:9,2,100);
										break;
							case 7: 	PA_16cText(1,165,129,256,129,charTemp,screenswitched && (clipboard[clipboardAmount].Type==0 || PA_StylusInZone(71,104,256,162))?10:9,2,100);
										break;
							case 8: 	PA_16cText(1,165,149,256,149,charTemp,screenswitched && (clipboard[clipboardAmount].Type==0 || PA_StylusInZone(71,104,256,162))?10:9,2,100);
										break;
							case 9: 	PA_16cText(1,215,109,256,109,charTemp,screenswitched && (clipboard[clipboardAmount].Type==0 || PA_StylusInZone(71,104,256,162))?10:9,2,100);
										break;
							case 10: PA_16cText(1,215,129,256,129,charTemp,screenswitched && (clipboard[clipboardAmount].Type==0 || PA_StylusInZone(71,104,256,162))?10:9,2,100);
										break;
							case 11: PA_16cText(1,215,149,256,149,charTemp,screenswitched && (clipboard[clipboardAmount].Type==0 || PA_StylusInZone(71,104,256,162))?10:9,2,100);
										break;
					}			
				}			
	}			
	else
	if (clipboard[clipboardAmount].Type==0) PA_16cText(1,75,109,250,161,"Double Tap L: Change Screen\n(Hold L+Cursor)/Drag Stylus: Move Sprites\nCursor: Navigate Menu\nY Button: Copy All Attributes\nA Button: Paste Attributes",10,1,100);		
		
	PA_16cTextAlign(0);
	sprintf(charTemp,"%ld",sprite[selectedMenu].data[getKeyframe(selectedMenu)].x>>8);
   PA_16cText(1,99, 49,95+76, 49,charTemp	,10,2,100);
	sprintf(charTemp,"%ld",sprite[selectedMenu].data[getKeyframe(selectedMenu)].y>>8);
   PA_16cText(1,99, 67,95+76, 67,charTemp	,10,2,100);
	sprintf(charTemp,"%d",sprite[selectedMenu].data[getKeyframe(selectedMenu)].width);
   PA_16cText(1,155,49,151+76,49,charTemp	,10,2,100);
	sprintf(charTemp,"%d",sprite[selectedMenu].data[getKeyframe(selectedMenu)].height);
   PA_16cText(1,155,67,151+76,67,charTemp	,10,2,100);
	sprintf(charTemp,"%d",sprite[selectedMenu].data[getKeyframe(selectedMenu)].angle);
   PA_16cText(1,212,49,208+76,49,charTemp	,10,2,100);
	sprintf(charTemp,"%d",sprite[selectedMenu].data[getKeyframe(selectedMenu)].alpha);
   PA_16cText(1,212,67,208+32,67,charTemp	,10,2,100);		   
	sprintf(charTemp,"%d",sprite[selectedMenu].data[getKeyframe(selectedMenu)].prio);
   PA_16cText(1,240,67,236+32,67,charTemp	,10,2,100);		   

	if (spriteIsHidden[selectedMenu]) PA_16cText(1,211,89,208+10,87+10,"X",10,1,100);
	if (spriteIsLocked[selectedMenu]) PA_16cText(1,244,89,242+10,87+10,"X",10,1,100);
	PA_16cText(1,79,34,250,34,spriteToFilename(selectedMenu),10,1,100);


	for(i=(scrollLayerY+5)/-12;i<16-((scrollLayerY+10)/12);++i)
	{
	   if (i<0) i=0;
	   if (i>27) break;
	   temp= 26+scrollLayerY+(i*12);

		PA_16cText(1,3,temp,67,temp,spriteToFilename(i),10,1,100);
		for (k=0;k<67;k++)
		PA_16cPutPixel(1,k,36+scrollLayerY+(i*12),10);
		if (spriteIsHidden[i])
		{
			PA_16cPutPixel(1,63,temp+1,10);
			PA_16cPutPixel(1,64,temp+1,10);
			PA_16cPutPixel(1,65,temp+1,10);
			PA_16cPutPixel(1,64,temp  ,10);
			PA_16cPutPixel(1,64,temp+2,10);
		}			
		if (spriteIsLocked[i])
		{
			PA_16cPutPixel(1,63,temp+7,10);
//				PA_16cPutPixel(1,64,temp+7,10);
			PA_16cPutPixel(1,65,temp+7,10);
			PA_16cPutPixel(1,64,temp+6,10);
			PA_16cPutPixel(1,64,temp+8,10);
		}			
	}	
	PA_16cClearZone(1,0,0,88,24);


}
