#include <PA9.h>       // Include for PA_Lib
#include "../../engine/engine.h"
//#include "amb_00.h"
//#include "amb_01.h"

int subMenu=0;
int selectedMessage=0;
int achievementAmount=10;
int inboxNew=3;
int inboxAmount=12;
int outboxAmount=6;
int sentAmount=20;
int trashAmount=4;
u8 buddyAmount=4;
u8 buddyOnline=1;
extern bool mWifi_returnToShrink;



void mWifi_interface()
{
   mWifi_returnToShrink=0; 
	PA_Init3D(); // Uses Bg0, Init 3D...
	PA_Reset3DSprites(); // Init or Reset 3D Sprites
	
	PA_Init16cBg(0,1);
	
	PA_Init16bitBg(1,1);
	PA_Init16cBg(1,0);
	PA_SetBgPrio(0,0,1);
	PA_SetBgPrio(0,1,0);

	subMenu=0;
	create3dBackgroundLayer(100,31,31,31);
	
	initAntiAliasedText(0,1,1);
	setAntiAliasDepth(0,31);
	initAntiAliasedText(1,0,1);
	setAntiAliasDepth(1,31);
	spaceLetteringForAAText();
	
	mWifi_init3dBox();
	mWifi_refreshDataFromAccount();
	mWifi_changeMenu();
	
	initAmbienceFromTheme("mWifi",900);
	
	
/*	CreateSpriteFromBmp(900,(void*)amb_00,20,256/2,256/2);
	PA_3DSetSpritePrio(900,10);
	CreateSpriteFromBmp(901,(void*)amb_01,21,256/2,176);
	PA_3DSetSpriteWidth(901,256);
	PA_3DSetSpritePrio(901,1900);
*/
//	mWifi_set3dBoxXY(0,138,36);



	while(1) 
	{
	
	   checkButtonHit();
  	   mWifi_CheckMenuActions();
		mWifi_UpdateEasing();
		mWifi_UpdateText();
		updateAmbience();
		ZoomXY_3DProcess(128,0,0);
		Soul_waitForVBL();
		if (mWifi_returnToShrink) return; 
		if (Pad.Newpress.L)
		{
		   if (shrinkMenu("mWifi","",0,10)) return;
		  	initAntiAliasedText(0,1,1);
			setAntiAliasDepth(0,31);
			initAntiAliasedText(1,0,1);
			setAntiAliasDepth(1,31);
		}   
	}

//	return 0;
}	
