#include <PA9.h>       // Include for PA_Lib
#include "../services/mWifi.h"
extern int selectedMessage;

extern int menuScroll;
extern int subMenu;
extern bool mWifi_menuChanged;
#define MWIFI_16C_BGY_SCROLL 8
struct navigationInfo
{
	char FileName[100][100];
	char Description[100][3][60];
	u16 IconTex[7]; //[7];
} navigation;

#define messageTitle navigation.FileName
#define messageSubtitle navigation.Description
bool messageNew[100];
u16 messageID[100];
extern int inboxNew;
extern int inboxAmount;
extern int outboxAmount;
extern int sentAmount;
extern int trashAmount;
extern u8 buddyAmount;
extern u8 buddyOnline;
extern int achievementAmount;

//bool mWifi_needRefresh=1;
void mWifi_sendMessengeAsRead(int msg)
{
   messageNew[msg]=0;
   if (inboxNew>0 && subMenu==10) //inbox
	{
	   inboxNew--;
	}   
	
}   
#define BUFFERSIZE 1024
u32 mWifi_divideMsgDataParameter(u32 charCounter, char *chrTemp, char* BB_msgOutline)
{
   int i=0;
   memset(chrTemp,0,sizeof(chrTemp));
   while(true)
   {
      if (BB_msgOutline[charCounter]=='\n' || BB_msgOutline[charCounter]=='\0' || charCounter>=BUFFERSIZE) 
		{
		   chrTemp[i] = '\0';
		   break;
		}   
      chrTemp[i] = BB_msgOutline[charCounter];
      charCounter++;
      i++;
   }   
   charCounter++;
   return charCounter;
}   
void mWifi_getAmountDataFromAccount()
{
   char wifiString[100];
   memset(wifiString,0,100);
	sprintf(wifiString, "action=10&sid=%s&msgtype=0&",wifi.SID);
	char * BB_msgOutline= malloc(BUFFERSIZE);
   memset(BB_msgOutline,0,sizeof(BB_msgOutline));
	
	myPostHTTP(BB_msgOutline,MWIFI_LINK,wifiString);
	
	u32 charCounter=0;
   char chrTemp[256];

   inboxNew=2;
   inboxAmount=4;

	charCounter=mWifi_divideMsgDataParameter(charCounter, chrTemp, BB_msgOutline);
   inboxAmount=atoi(chrTemp);

  	charCounter=mWifi_divideMsgDataParameter(charCounter, chrTemp, BB_msgOutline);
   inboxNew=atoi(chrTemp);

  	charCounter=mWifi_divideMsgDataParameter(charCounter, chrTemp, BB_msgOutline);
   outboxAmount=atoi(chrTemp);

  	charCounter=mWifi_divideMsgDataParameter(charCounter, chrTemp, BB_msgOutline);
   sentAmount=atoi(chrTemp);
   
  	charCounter=mWifi_divideMsgDataParameter(charCounter, chrTemp, BB_msgOutline);
   trashAmount=atoi(chrTemp);

  	charCounter=mWifi_divideMsgDataParameter(charCounter, chrTemp, BB_msgOutline);
   buddyAmount=atoi(chrTemp);
   
  	charCounter=mWifi_divideMsgDataParameter(charCounter, chrTemp, BB_msgOutline);
   buddyOnline=atoi(chrTemp);

  	charCounter=mWifi_divideMsgDataParameter(charCounter, chrTemp, BB_msgOutline);
   achievementAmount=atoi(chrTemp);
   if (BB_msgOutline!=NULL) free(BB_msgOutline);
}   
void mWifi_getMsgDataFromAccount()
{
   mWifi_getAmountDataFromAccount();
   /*
   char BB_msgOutline[BUFFERSIZE];
//   sprintf(BB_msgOutline,"2\n1\nWelcome to gamenow.asia\nSoulanger");
//   sprintf(BB_msgOutline,"3\n0\nTitle\nSubtitle\n");
	u32 charCounter=0;
	u8 msgAmount=0;
   char chrTemp[256];
   memset(BB_msgOutline,0,sizeof(BB_msgOutline));
   sprintf(BB_msgOutline,"3\n1\nTitle\nSubtitle\n2\n1\nWelcome to gamenow.asia\nSoulanger\n12\n0\nI play pokemon how about you?\npokefan999\n2\n0\nHey when will you pay your dep\nsomeoneyouknow");
   */
   char wifiString[100];
   memset(wifiString,0,100);
	sprintf(wifiString, "action=11&sid=%s&msgtype=0&",wifi.SID);
	char * BB_msgOutline= malloc(BUFFERSIZE);
   memset(BB_msgOutline,0,sizeof(BB_msgOutline));
	
	myPostHTTP(BB_msgOutline,MWIFI_LINK,wifiString);
	
	u32 charCounter=0;
   char chrTemp[256];
u32 msgAmount;
   
   
   for(msgAmount=0;msgAmount<inboxAmount;msgAmount++)
   {
		charCounter=mWifi_divideMsgDataParameter(charCounter, chrTemp, BB_msgOutline);
		messageID[msgAmount]=atoi(chrTemp);
		charCounter=mWifi_divideMsgDataParameter(charCounter, chrTemp, BB_msgOutline);
		if (chrTemp[0]=='1') messageNew[msgAmount]=1;
		charCounter=mWifi_divideMsgDataParameter(charCounter, chrTemp, BB_msgOutline);
		sprintf(messageTitle[msgAmount],"%s",chrTemp);
		charCounter=mWifi_divideMsgDataParameter(charCounter, chrTemp, BB_msgOutline);
	   sprintf(messageSubtitle[msgAmount][0],"%s",chrTemp);
	}		
   if (BB_msgOutline!=NULL) free(BB_msgOutline);
}   

#define MWIFI_COMMUNICATION_ERROR FALSE
void alertCommunicationError()
{
   
}   
void mWifi_refreshDataFromAccount()
{
   inboxNew=0;
	inboxAmount=0;
	outboxAmount=0;
	sentAmount=0;
	trashAmount=0;
	buddyAmount=0;
	buddyOnline=0;
	achievementAmount=0;
	memset(messageNew,0,sizeof(messageNew));
	memset(messageID,0,sizeof(messageID));
	memset(navigation.FileName,0,sizeof(navigation.FileName));
	memset(navigation.Description,0,sizeof(navigation.Description));
	
	mWifi_getMsgDataFromAccount();
	if (MWIFI_COMMUNICATION_ERROR)
	{
	   alertCommunicationError();
	}   
}   
void mWifi_displayTopScreenUsername()
{
   PA_16cTextAlign(0);
   char chrTemp[256];
   sprintf (chrTemp,"Hi, %s",wifi.username);
   display16cText(1,7,1,256,0,chrTemp,1,5);
}   
void mWifi_displayBuddyTextAmount()
{
   PA_16cTextAlign(0);
   char chrTemp[256];
  sprintf(chrTemp,"%d/%d",buddyOnline,buddyAmount);
   display16cText(1,138,166,256,0,chrTemp,1,5);
}   
char* mWifi_getMessenger(int listNumber)
{
   char* messenger = malloc(256);
   sprintf(messenger,"%s",messageSubtitle[listNumber][0]);
   return messenger;
}   

char* mWifi_getDateReceived()
{
   char* date = malloc(256);
   sprintf(date,"September 15, 1991");
   return date;
}   
void mWifi_displayMessageInfo()
{
   PA_16cTextAlign(0);
   char chrTemp[256];
   char* chrReturn = NULL;
/*   switch (subMenu)
   {
		case 20:	sprintf(chrTemp,"Inbox Message %d",selectedMessage);
					break;
		case 21:	sprintf(chrTemp,"Outbox Message %d", selectedMessage);
					break;
		case 22:	sprintf(chrTemp,"Sent Message %d",selectedMessage);
					break;
		case 23:	sprintf(chrTemp,"Trash Message %d", selectedMessage);
					break;
	}			*/
   display16cText(1,45+1,116+2+16,256,0,messageTitle[selectedMessage],1,5);   
   

   chrReturn = mWifi_getMessenger(selectedMessage);
   if (subMenu == 20 || subMenu == 23)
	   sprintf(chrTemp,"From: %s", chrReturn);
	else
	   sprintf(chrTemp,"To: %s", chrReturn);
   if (chrReturn!= NULL) free(chrReturn);
   display16cText(1,45,116+2+32+2,256,0,chrTemp,2,2);   
   
   chrReturn = mWifi_getDateReceived();
   sprintf(chrTemp,"Date: %s", chrReturn);
   if (chrReturn!= NULL) free(chrReturn);
   display16cText(1,45,116+2+16+32,256,0,chrTemp,2,2);   
}   
void mWifi_displayMessagesTextAmount()
{
   PA_16cTextAlign(0);
   char chrTemp[256];
   sprintf(chrTemp,"%d/%d",inboxNew,inboxAmount);
   display16cText(1,77,166,256,0,chrTemp,1,5);

   sprintf(chrTemp,"%d",outboxAmount);
   display16cText(1,130,166,256,0,chrTemp,1,5);
   
   sprintf(chrTemp,"%d",sentAmount);
   display16cText(1,170,166,256,0,chrTemp,1,5);

   sprintf(chrTemp,"%d",trashAmount);
   display16cText(1,207,166,256,0,chrTemp,1,5);

}   
char* mWifi_GetListSubTitle(int listNumber)
{
   int listType=subMenu;   
   char* chrTemp= malloc(256);
   char* chrResult=NULL;
	switch (listType)
	{
		case 10:	
		case 11:	
		case 12:	
		case 13:	chrResult=mWifi_getMessenger(listNumber);
					break;
		case 2:	chrResult=malloc(256);
		   		if (listNumber<buddyOnline)
						sprintf(chrResult,"Online");
					else
			   		sprintf(chrResult,"Offline");
					break;
		case 4:	chrResult=malloc(256);
		   		sprintf(chrResult,"100 Games Played");
					break;
		default:	chrResult=malloc(256);
					sprintf(chrResult,"subtitle");
					break;
	}			

	switch (listType)
	{
		case 10:	
		case 13:	sprintf(chrTemp,"From: %s",chrResult);
					break;
		case 11:	
		case 12:	sprintf(chrTemp,"To: %s",chrResult);
					break;
		default:	sprintf(chrTemp,"%s",chrResult);
					break;
	}			
	if (chrResult!= NULL) free(chrResult);
	return chrTemp;
}   
char* mWifi_GetListTitle(int listNumber)
{
   int listType=subMenu;   
   char* chrTemp= malloc(256);
/*	switch (listType)
	{
		case 2:	sprintf(chrTemp,"Buddy %d", listNumber);
					break;
		case 4:	sprintf(chrTemp,"Achievement %d",listNumber);
					break;
		case 10:	sprintf(chrTemp,"Inbox Message %d",listNumber);
					break;
		case 11:	sprintf(chrTemp,"Outbox Message %d", listNumber);
					break;
		case 12:	sprintf(chrTemp,"Sent Message %d",listNumber);
					break;
		case 13:	sprintf(chrTemp,"Trash Message %d", listNumber);
	}			*/
	sprintf(chrTemp,"%s",messageTitle[listNumber]);
	return chrTemp;
}   
char* mWifi_GetMessage(int listNumber)
{
   int listType=subMenu;   
   char* chrTemp= malloc(BUFFERSIZE);
   memset(chrTemp,0,sizeof(BUFFERSIZE));
   char wifiString[100];
   memset(wifiString,0,100);
	switch (listType)
	{
		case 20:
					sprintf(wifiString, "action=13&msgid=%d&",messageID[selectedMessage]);
					
					myPostHTTP(chrTemp,MWIFI_LINK,wifiString);
					break;
		case 21:	sprintf(chrTemp,"Hi Soul!\nIts fudge, how are ya? I like megaman, you look like chinese.\nBla bla bla. Lorem ipsum donor rofl lol omg bla bla ZOMG haxxor, fuxxored bla. Outbox Message %d", listNumber);
					break;
		case 22:	sprintf(chrTemp,"Hi Soul!\nIts fudge, how are ya? I like megaman, you look like chinese.\nBla bla bla. Lorem ipsum donor rofl lol omg bla bla ZOMG haxxor, fuxxored bla. Sent Message %d",listNumber);
					break;
		case 23:	sprintf(chrTemp,"Hi Soul!\nIts fudge, how are ya? I like megaman, you look like chinese.\nBla bla bla. Lorem ipsum donor rofl lol omg bla bla ZOMG haxxor, fuxxored bla. Trash Message %d", listNumber);
	}			
	return chrTemp;
}  
void mWifi_UpdateTextList(u8 totalAmount)
{
   int listType=subMenu;
   PA_16cTextAlign(0);
  	char chrTemp[256];
   int i=0;
   int temp=0;

   if ((menuScroll/-40)<totalAmount)
		for (i=0;i<6;i++)
		{
		   if (i+(menuScroll/-40)<0) continue;
		   if (i+(menuScroll/-40)==totalAmount) break;
		   
		   char* chrReturn = NULL;
		   chrReturn = mWifi_GetListTitle(i+(menuScroll/-40));
			if (i+(menuScroll/-40)<inboxNew && listType == 10)
			   sprintf(chrTemp,"(New) %s",chrReturn);
			else
			   sprintf(chrTemp,"%s",chrReturn);
			if (chrReturn!= NULL) free(chrReturn);
			
		   if(mWifi_menuChanged)
		   {
			   temp = PA_3DGetSpriteY(i*5)-21;
			}			
			else
			{
				temp = (i*40)-6;
			}   

			if (menuScroll<0)
				temp -= abs(menuScroll)%40;
				else
				temp += menuScroll%40;
			temp += 16+MWIFI_16C_BGY_SCROLL;

			if (temp>192) continue;
			display16cText(0,PA_3DGetSpriteX(i*5)+10-(pa_3dsprites[i*5].Width/2),temp,256,0,chrTemp,1,5);
			temp +=16;
			
		   chrReturn = mWifi_GetListSubTitle(i+(menuScroll/-40));

			display16cText(0,PA_3DGetSpriteX(i*5)+10-(pa_3dsprites[i*5].Width/2),temp,256,0,chrReturn,2,2);
			if (chrReturn!= NULL) free(chrReturn);
		}	


}   
char* mWifi_getUserTitle()
{
   char* result = malloc(256);
   sprintf(result,"Asian Monkey");
   return result;
}   
char* mWifi_getUserGuild()
{
   char* result = malloc(256);
   sprintf(result,"Chicken Society X");
   return result;
}   
char* mWifi_getUserGuildPosition()
{
   char* result = malloc(256);
   sprintf(result,"Member");
   return result;
}   

void mWifi_UpdateText()
{
   int i=0;
   int y=0;
	PA_16cErase(0);
  	char chrTemp[256];
  	char messageText[256];
	int temp=0;
	PA_16cTextAlign(0);
	int amount=0;
   char* chrResult=NULL;
   switch (subMenu)
   {
      case 0:	
					if (inboxNew>0)
					{
						sprintf(messageText,"%d Unread Message",inboxNew);
						if (inboxNew==1)
							sprintf(messageText,"%s\n",messageText);
						else
							sprintf(messageText,"%ss\n",messageText);
					}			
					else
					{
						sprintf(messageText,"%d Private Message",inboxAmount);
						if (inboxAmount==1)
							sprintf(messageText,"%s\n",messageText);
						else
							sprintf(messageText,"%ss\n",messageText);
					}		
					
					if (buddyOnline>0)
					{
						sprintf(messageText,"%s%d Friend",messageText,buddyOnline);
						if (buddyOnline==1)
							sprintf(messageText,"%s Online\n",messageText);
						else
							sprintf(messageText,"%ss Online\n",messageText);
					}	
					else
					{
						sprintf(messageText,"%s%d Friend",messageText,buddyAmount);
						if (buddyAmount==1)
							sprintf(messageText,"%s Offline\n",messageText);
						else
							sprintf(messageText,"%ss Offline\n",messageText);
					}	
							
					sprintf(messageText,"%s%d Achievement",messageText,achievementAmount);
					if (achievementAmount>1) sprintf(messageText,"%ss\n",messageText);
		   		if (pa_3dsprites[0].Priority == 1025) 
					{
					   display16cText(0,PA_3DGetSpriteX(5)+20-(pa_3dsprites[5].Width/2),
												PA_3DGetSpriteY(5)-(pa_3dsprites[5].Height/2)+10,
												PA_3DGetSpriteX(5)+(pa_3dsprites[5].Width/2),
												0,
												"You have",1,5);
					   display16cText(0,PA_3DGetSpriteX(5)+30-(pa_3dsprites[5].Width/2),
												PA_3DGetSpriteY(5)-(pa_3dsprites[5].Height/2)+25,
												PA_3DGetSpriteX(5)+(pa_3dsprites[5].Width/2),
												PA_3DGetSpriteY(5)+(pa_3dsprites[5].Height/2)+12,
												messageText,1,5);
						mWifi_clear16cWindow(0);
					}			
					display16cText(0,PA_3DGetSpriteX(0)+72-(pa_3dsprites[0].Width/2),PA_3DGetSpriteY(0)-(pa_3dsprites[0].Height/2)+12,PA_3DGetSpriteX(0)+(pa_3dsprites[0].Width/2),0,wifi.username,1,5);
					for (i=PA_3DGetSpriteX(0)+72-(pa_3dsprites[0].Width/2);i<PA_3DGetSpriteX(0)+(pa_3dsprites[0].Width/2);i++)
					{
					   PA_16cPutPixel(0,i,PA_3DGetSpriteY(0)-(pa_3dsprites[0].Height/2)+27,3);
					}   
					chrResult=mWifi_getUserTitle();
					sprintf(chrTemp,"\"%s\"",chrResult);
					display16cText(0,PA_3DGetSpriteX(0)+72-(pa_3dsprites[0].Width/2),PA_3DGetSpriteY(0)-(pa_3dsprites[0].Height/2)+28,PA_3DGetSpriteX(0)+(pa_3dsprites[0].Width/2),0,chrTemp,1,5);
					if (chrResult!= NULL) free(chrResult);
					chrResult=mWifi_getUserGuild();
					display16cText(0,PA_3DGetSpriteX(0)+72-(pa_3dsprites[0].Width/2),PA_3DGetSpriteY(0)-(pa_3dsprites[0].Height/2)+42,PA_3DGetSpriteX(0)+(pa_3dsprites[0].Width/2),0,chrResult,1,5);
					

					if (pa_3dsprites[5].Priority == 1025)  
					{
					   mWifi_clear16cWindow(5);
					   display16cText(0,PA_3DGetSpriteX(5)+20-(pa_3dsprites[5].Width/2),
												PA_3DGetSpriteY(5)-(pa_3dsprites[5].Height/2)+10,
												PA_3DGetSpriteX(5)+(pa_3dsprites[5].Width/2),
												0,
												"You have",1,5);
					   display16cText(0,PA_3DGetSpriteX(5)+30-(pa_3dsprites[5].Width/2),
												PA_3DGetSpriteY(5)-(pa_3dsprites[5].Height/2)+25,
												PA_3DGetSpriteX(5)+(pa_3dsprites[5].Width/2),
												PA_3DGetSpriteY(5)+(pa_3dsprites[5].Height/2)+12,
												messageText,1,5);
					}   
					if (pa_3dsprites[0].Priority != 1025 && pa_3dsprites[5].Priority != 1025) 
					{
					   display16cText(0,PA_3DGetSpriteX(5)+20-(pa_3dsprites[5].Width/2),
												PA_3DGetSpriteY(5)-(pa_3dsprites[5].Height/2)+10,
												PA_3DGetSpriteX(5)+(pa_3dsprites[5].Width/2),
												0,
												"You have",1,5);
					   display16cText(0,PA_3DGetSpriteX(5)+30-(pa_3dsprites[5].Width/2),
												PA_3DGetSpriteY(5)-(pa_3dsprites[5].Height/2)+25,
												PA_3DGetSpriteX(5)+(pa_3dsprites[5].Width/2),
												PA_3DGetSpriteY(5)+(pa_3dsprites[5].Height/2)+12,
												messageText,1,5);
					}			

					break;
		case 1:	sprintf(chrTemp, "Inbox (%d/%d)", inboxNew,inboxAmount);
		   		display16cText(0,PA_3DGetSpriteX(i)+10-(pa_3dsprites[i].Width/2),PA_3DGetSpriteY(i),PA_3DGetSpriteX(i)+(pa_3dsprites[i].Width/2),0,chrTemp,1,5);
					i+=5;
					sprintf(chrTemp, "Outbox (%d)", outboxAmount);
					display16cText(0,PA_3DGetSpriteX(i)+10-(pa_3dsprites[i].Width/2),PA_3DGetSpriteY(i),PA_3DGetSpriteX(i)+(pa_3dsprites[i].Width/2),0,chrTemp,1,5);
					i+=5;
					sprintf(chrTemp, "Sent (%d)", sentAmount);
					display16cText(0,PA_3DGetSpriteX(i)+10-(pa_3dsprites[i].Width/2),PA_3DGetSpriteY(i),PA_3DGetSpriteX(i)+(pa_3dsprites[i].Width/2),0,chrTemp,1,5);
					i+=5;
					sprintf(chrTemp, "Trash (%d)", trashAmount);
					display16cText(0,PA_3DGetSpriteX(i)+10-(pa_3dsprites[i].Width/2),PA_3DGetSpriteY(i),PA_3DGetSpriteX(i)+(pa_3dsprites[i].Width/2),0,chrTemp,1,5);
					i+=5;
					break;

		case 20: 	
		   	   switch (subMenu)
				   {
						case 2: 	amount=buddyAmount;
						   		break;
						case 4: 	amount=achievementAmount;
						   		break;
						case 10: amount=inboxAmount;
						   		break;
						case 11: amount=outboxAmount;
						   		break;
					   case 12: amount=sentAmount;
						   		break;
						case 13: amount=trashAmount;
						   		break;
					 }  
					chrResult=mWifi_GetMessage(amount);
		   		display16cText(0,PA_3DGetSpriteX(0)+43-(pa_3dsprites[0].Width/2),PA_3DGetSpriteY(0)+26-(pa_3dsprites[0].Height/2),PA_3DGetSpriteX(0)+(pa_3dsprites[0].Width/2)-5,PA_3DGetSpriteY(0)+(pa_3dsprites[0].Height/2),
						chrResult,1,5);					
					if (chrResult!= NULL) free(chrResult);
					break;
		case 3: 	y=PA_3DGetSpriteY(0)+15-(pa_3dsprites[0].Height/2);
		   		display16cText(0,PA_3DGetSpriteX(0)+70-(pa_3dsprites[0].Width/2),y,PA_3DGetSpriteX(0)+256,0,
						"Soulanger",1,5);
					y+=16;

					for (i=PA_3DGetSpriteX(0)+72-(pa_3dsprites[0].Width/2);i<PA_3DGetSpriteX(0)+(pa_3dsprites[0].Width/2);i++)
					{
					   PA_16cPutPixel(0,i,y,3);
					}   
					y+=4;
					chrResult=mWifi_getUserTitle();
					sprintf(chrTemp,"\"%s\"",chrResult);
		   		display16cText(0,PA_3DGetSpriteX(0)+70-(pa_3dsprites[0].Width/2),y,PA_3DGetSpriteX(0)+256,0,
						chrTemp,1,5);
					if (chrResult!= NULL) free(chrResult);
					PA_16cTextAlign(1);
					y=PA_3DGetSpriteY(0)+70-(pa_3dsprites[0].Height/2);
					PA_16cTextAlign(0);
					chrResult=mWifi_getUserGuildPosition();
					sprintf(chrTemp,"A clan \"%s\" of",chrResult);
		   		display16cText(0,PA_3DGetSpriteX(0)+16-(pa_3dsprites[0].Width/2),y,PA_3DGetSpriteX(0)+256,0,
						chrTemp,1,5);
					if (chrResult!= NULL) free(chrResult);
					y+=16;
					PA_16cTextAlign(1);
					chrResult=mWifi_getUserGuild();
		   		display16cText(0,PA_3DGetSpriteX(0)+32-(pa_3dsprites[0].Width/2),y,PA_3DGetSpriteX(0)+(pa_3dsprites[0].Width/2),0,
						chrResult,1,5);
					PA_16cTextAlign(2);
					y+=30;
		   		display16cText(0,PA_3DGetSpriteX(0)-(pa_3dsprites[0].Width/2),y,PA_3DGetSpriteX(0)+(pa_3dsprites[0].Width/2),0,
						"--No Ideas Yet--",1,5);

		   		break;
		case 2:	mWifi_UpdateTextList(buddyAmount);
					break;
		case 4:	mWifi_UpdateTextList(achievementAmount);
					break;
		case 10:	mWifi_UpdateTextList(inboxAmount);
					break;
		case 11:	mWifi_UpdateTextList(outboxAmount);
					break;
		case 12:	mWifi_UpdateTextList(sentAmount);
					break;
		case 13:	mWifi_UpdateTextList(trashAmount);
					break;
	}			
	if (chrResult!= NULL) free(chrResult);
	mWifi_removeBottomBar16c();
	switch (subMenu)
	{
	   case 20:
	   case 21:
	   case 22:
	   case 23:	
	   case 10:
	   case 11:
	   case 12:
	   case 13:	PA_16cTextAlign(0);
			   	switch (subMenu)
					{
					   case 20: display16cText(0,5,178+MWIFI_16C_BGY_SCROLL,250,0,"Inbox",1,5);
					      		break;
					   case 21: display16cText(0,5,178+MWIFI_16C_BGY_SCROLL,250,0,"Outbox",1,5);
					      		break;
					   case 22: display16cText(0,5,178+MWIFI_16C_BGY_SCROLL,250,0,"Sent",1,5);
					      		break;
					   case 23: display16cText(0,5,178+MWIFI_16C_BGY_SCROLL,250,0,"Trash",1,5);
					      		break;
					   default: display16cText(0,5,178+MWIFI_16C_BGY_SCROLL,250,0,"Messages",1,5);
					      		break;
					}   	
					mWifi_create16cSeperator(PA_LetterPos.Letter[PA_LetterPos.NLetters].X+5,PA_LetterPos.Letter[PA_LetterPos.NLetters].Y+10);
	   			PA_16cTextAlign(1);
					display16cText(0,5,178+MWIFI_16C_BGY_SCROLL,250,0,"Compose",1,5);
					mWifi_create16cSeperator(PA_LetterPos.Letter[0].X-5,PA_LetterPos.Letter[0].Y+10);
					break;
	   case 1:	PA_16cTextAlign(1);
					display16cText(0,5,178,250,0,"Compose",1,5);
					mWifi_create16cSeperator(PA_LetterPos.Letter[0].X-5,PA_LetterPos.Letter[0].Y+10);
					break;
		case 2:
		case 4:
					PA_16cTextAlign(0);
					display16cText(0,5,178+MWIFI_16C_BGY_SCROLL,250,0,"Return",1,5);
					mWifi_create16cSeperator(PA_LetterPos.Letter[PA_LetterPos.NLetters].X+5,PA_LetterPos.Letter[PA_LetterPos.NLetters].Y+10);
					PA_16cTextAlign(1);
					display16cText(0,5,178+MWIFI_16C_BGY_SCROLL,250,0,"Log Off",1,5);
					mWifi_create16cSeperator(PA_LetterPos.Letter[0].X-5,PA_LetterPos.Letter[0].Y+10);
					break;
		default:
					PA_16cTextAlign(0);
					display16cText(0,5,178,250,0,"Return",1,5);
					mWifi_create16cSeperator(PA_LetterPos.Letter[PA_LetterPos.NLetters].X+5,PA_LetterPos.Letter[PA_LetterPos.NLetters].Y+10);
					PA_16cTextAlign(1);
					display16cText(0,5,178,250,0,"Log Off",1,5);
					mWifi_create16cSeperator(PA_LetterPos.Letter[0].X-5,PA_LetterPos.Letter[0].Y+10);
					break;
	}			
	PA_16cTextAlign(0);
}		

