#include <PA9.h> 
#include <sys/dir.h>
#include "fileDetector.h"

#define MAX_NEWNDS 8
struct  fileDetectorInfo
{
	struct  newNDSinfo
	{   
	   char path[200];
	} newNDS[MAX_NEWNDS];   

	u8 amountNewNDS;
	u8 newNdsCounter;
} fileDetector;

bool generateNewNdsList(FILE* newlog, FILE* oldlog, char *start, int depth)
{
   struct stat st;
   
   DIR_ITER *dir = diropen(start);
   static char child[256];
   char temp[256];
   bool fileIsOld=0;
   if (dir)
   {
      while (dirnext(dir, child, &st) == 0)
      {
         if (child[0] == '_')
            continue;
            
         if (strlen(child) == 1 && child[0] == '.')
            continue;
                  
         if (strlen(child) == 2 && child[0] == '.' && child[1] == '.')
            continue;
         
         if (!(st.st_mode & S_IFDIR))
        	if (child[strlen(child)-1]   == 's' || child[strlen(child)-1]   == 'S')  
        	if (child[strlen(child)-2]   == 'd' || child[strlen(child)-2]   == 'D')  
        	if (child[strlen(child)-3]   == 'n' || child[strlen(child)-3]   == 'N')  
        	if (child[strlen(child)-4]   == '.')  
         {
            char charTemp2[256];
            char charTemp[256];
				sprintf(charTemp2,"%s%s",start,child);
				fseek(oldlog,0,SEEK_SET);
				fseek(newlog,0,SEEK_SET);
				fileIsOld=0;
			   while(fgets(charTemp, 256, oldlog)!=NULL)
				   if (PA_CompareText(charTemp,charTemp2))
					{
					   fileIsOld=1;
					   break;
					}   
			   if (fileIsOld)
				{
//					PA_Print(1,"\nFile is old");
				   continue;
				}   
			   while(fgets(charTemp, 256, newlog)!=NULL)
				   if (PA_CompareText(charTemp,charTemp2))
					{
					   fileIsOld=1;
					   break;
					}   
			   if (fileIsOld)
				{
//					PA_Print(1,"\nFile is old");
				   continue;
				}   

				if (fileDetector.newNdsCounter >= 8)
				{
				   fseek (oldlog, 0, SEEK_END);
					fwrite(charTemp2, strlen(charTemp2), 1,oldlog);
					fwrite("\n", strlen("\n"), 1,oldlog);
//					PA_Print(1,"new files are more than 8\n");
				}			
				else
				{
					fileDetector.newNdsCounter++;
					fwrite(charTemp2, strlen(charTemp2), 1,newlog);
					fwrite("\n", strlen("\n"), 1,newlog);
				}			
//				PA_Print(0,"\n%s",charTemp2);

         }

         if ((st.st_mode & S_IFDIR) && depth > 1)
         {
            strcpy(temp, start);
            if (start[strlen(start)-1] != '/')
               strcat(temp, "/");

            strcat(temp, child);
            strcat(temp, "/");
            
				generateNewNdsList(newlog,oldlog,temp, depth-1);

         }
      }
   }
   
   dirclose(dir);
   return false;
}

bool generateOldNdsList(FILE* filelog, char *start, int depth)
{
   struct stat st;
   
   DIR_ITER *dir = diropen(start);
//   DIR_ITER *dir = diropen("/");
   static char child[256];
   char temp[256];
//   char result[600];
//st.st_mode & S_IFDIR  == directory   
   if (dir)
   {
      while (dirnext(dir, child, &st) == 0)
      {
         if (child[0] == '_')
            continue;
         if (strlen(child) == 1 && child[0] == '.')
            continue;
                  
         if (strlen(child) == 2 && child[0] == '.' && child[1] == '.')
            continue;
         
         if (!(st.st_mode & S_IFDIR))
        	if (child[strlen(child)-1]   == 's' || child[strlen(child)-1]   == 'S')  
        	if (child[strlen(child)-2]   == 'd' || child[strlen(child)-2]   == 'D')  
        	if (child[strlen(child)-3]   == 'n' || child[strlen(child)-3]   == 'N')  
        	if (child[strlen(child)-4]   == '.')  
         {

				fwrite(start, strlen(start), 1,filelog);
				fwrite(child, strlen(child), 1,filelog);
				fwrite("\n", strlen("\n"), 1,filelog);

         }
            
         if ((st.st_mode & S_IFDIR) && depth > 1)
         {
            strcpy(temp, start);
            if (start[strlen(start)-1] != '/')
               strcat(temp, "/");

            strcat(temp, child);
            strcat(temp, "/");
            
				generateOldNdsList(filelog,temp, depth-1);
         }
      }
   }
   
   dirclose(dir);
   return false;
}
void clearNewNDSItem(u8 item)
{
	u8 i;

	FILE* newIndexNDS = fopen ("fat:/_menudo/logs/INDEX.NEWNDS", "wb");
	for (i=0;i<fileDetector.amountNewNDS;i++)
	{
	   if (i==item)
	   continue;
		fwrite("\n", strlen("\n"), 1, newIndexNDS);
		fwrite(fileDetector.newNDS[i].path, strlen(fileDetector.newNDS[i].path), 1, newIndexNDS);
	}	
	fclose(newIndexNDS);	

	FILE* oldIndexNDS = fopen ("fat:/_menudo/logs/INDEX.OLDNDS", "ab");   
   fseek (oldIndexNDS, 0, SEEK_END);
	fwrite("\n", strlen("\n"), 1, oldIndexNDS);
	fwrite(fileDetector.newNDS[item].path, strlen(fileDetector.newNDS[item].path), 1, oldIndexNDS);	
	
	fclose(oldIndexNDS);
}   
void getNewNDSList()
{
//	char *charTemp = malloc(256*sizeof (char));
	char charTemp[256];
	u8 i;
	FILE* newIndexNDS = fopen ("fat:/_menudo/logs/INDEX.NEWNDS", "rb");

//	FILE* newIndexNDS = fopen ("fat:/INDEX.NEWNDS", "rb");

	fileDetector.amountNewNDS=0;
	if (!newIndexNDS)
	{
	   fclose(newIndexNDS);
	   newIndexNDS = fopen ("fat:/_menudo/logs/INDEX.NEWNDS", "wb");
	   fclose(newIndexNDS);
	   return;
	}   
   memset(charTemp, 0, 200);
	FILE* filechecker;
   while(fgets(charTemp, 200, newIndexNDS)!=NULL)
   {
      if ((charTemp[0] == 'f' || charTemp[0] == 'F'))
      if ((charTemp[1] == 'a' || charTemp[1] == 'A'))
      if ((charTemp[2] == 't' || charTemp[2] == 'T'))
      {


        	sprintf(fileDetector.newNDS[fileDetector.amountNewNDS].path,"%s",charTemp);
        	for (i=200; i>0;i--)
        	if (fileDetector.newNDS[fileDetector.amountNewNDS].path[i]     == 's' || fileDetector.newNDS[fileDetector.amountNewNDS].path[i]   == 'S')  
        	if (fileDetector.newNDS[fileDetector.amountNewNDS].path[i-1]   == 'd' || fileDetector.newNDS[fileDetector.amountNewNDS].path[i-1]   == 'D')  
        	if (fileDetector.newNDS[fileDetector.amountNewNDS].path[i-2]   == 'n' || fileDetector.newNDS[fileDetector.amountNewNDS].path[i-2]   == 'N')  
        	if (fileDetector.newNDS[fileDetector.amountNewNDS].path[i-3]   == '.')  
			  {
			     fileDetector.newNDS[fileDetector.amountNewNDS].path[i+1] = '\0';
			     break;
			  }
	       filechecker = fopen (fileDetector.newNDS[fileDetector.amountNewNDS].path, "rb"); //rb = read
	       if (!filechecker)
	       {
	          fclose (filechecker);
		      // continue;
		    }   
		    else
             fclose (filechecker);
			  
			if (i==0)
			{
		      memset(charTemp, 0, 200);
				continue;
			}			
			
			fileDetector.amountNewNDS++;
			if (fileDetector.amountNewNDS==MAX_NEWNDS) break;
		}			
      memset(charTemp, 0, 200);

   }
   memset(charTemp, 0, 200);

  	fclose(newIndexNDS);
}  	

void verifyList(char* filename)
{
   FILE* list = fopen (filename, "rb");

   //verify all old files
   fseek (list, 0, SEEK_END);

	int size =ftell(list);
	char temp[size+500]; //+500 to make sure
   memset(temp, 0, size+500);
   fseek (list, 0, SEEK_SET);

   FILE *filechecker;
   char charTemp[256];
   memset(charTemp, 0, 256);
   if (list)
   while(fgets(charTemp, 256, list)!=NULL)
   {
		if (charTemp[strlen(charTemp)-1] == 10) charTemp[strlen(charTemp)-1]=0;
      filechecker = fopen (charTemp, "rb");

      if (filechecker)
         sprintf(temp,"%s%s\n",temp,charTemp);
//		else
//	   	PA_Print(1,"%s is missing\n",charTemp);
		fclose(filechecker);
	   memset(charTemp, 0, 256);
	}  
	else
//	PA_Print(0,"List not found\n");
	fclose(list);
//	PA_Print(0, "Saving output\n");	
	list = fopen (filename, "wb");
	fwrite(temp, strlen(temp), 1,list	);
	fclose(list);
}   
// Function: main()

void clearNewNDSIndex()
{
	u8 i;

	FILE* newIndexNDS = fopen ("fat:/_menudo/logs/INDEX.NEWNDS", "wb");
	fclose(newIndexNDS);	

	FILE* oldIndexNDS = fopen ("fat:/_menudo/logs/INDEX.OLDNDS", "ab");   
   fseek (oldIndexNDS, 0, SEEK_END);
	for (i=0;i<fileDetector.amountNewNDS;i++)
	{
		fwrite("\n", strlen("\n"), 1, oldIndexNDS);
		fwrite(fileDetector.newNDS[i].path, strlen(fileDetector.newNDS[i].path), 1, oldIndexNDS);
	}	
	
	fclose(oldIndexNDS);
}   

void generateFullList()
{
	   bool oldIndexAmount=0;
	   FILE* oldIndexLog = fopen ("fat:/_menudo/logs/INDEX.OLDNDS", "r+b");
		
		if (oldIndexLog)
		{
//			PA_Print(0,"Reading index.oldnds\n");
         char charTemp[256];
		   while(fgets(charTemp, 200, oldIndexLog)!=NULL)
	      if ((charTemp[0] == 'f' || charTemp[0] == 'F'))
	      if ((charTemp[1] == 'a' || charTemp[1] == 'A'))
	      if ((charTemp[2] == 't' || charTemp[2] == 'T'))
	      {
			 oldIndexAmount=1;
//			 PA_Print(0,"List is not empty\n");
			 break;
			}  	
	   	
	   	if (oldIndexAmount>0)
	   	{
//			   PA_Print(0,"List found\nGenerating New List\n");
			   FILE* newIndexLog = fopen ("fat:/_menudo/logs/INDEX.NEWNDS", "r+b");
			   if (!newIndexLog)
			   {
			      fclose(newIndexLog);
				   newIndexLog = fopen ("fat:/_menudo/logs/INDEX.NEWNDS", "ab");
				}   
				fileDetector.newNdsCounter=0;
				generateNewNdsList(newIndexLog, oldIndexLog,"fat:/",5);
//			   PA_Print(0,"New List Saved\n");
				fclose(oldIndexLog);			   
		      fclose(newIndexLog);
		   }
			   
		}   
		if (oldIndexAmount==0)
		{
//		   PA_Print(0,"No list found\nGenerating List\n");
			fclose(oldIndexLog);
		   oldIndexLog = fopen ("fat:/_menudo/logs/INDEX.OLDNDS", "wb");
			generateOldNdsList(oldIndexLog,"fat:/",3);
			fclose(oldIndexLog);
//		   PA_Print(0,"List Saved\n");
		}			
}
bool isNewNDSFound()
{
	if (getAmountOfNewNDS()>0)
		return true;
	else   
		return false;
}   
void begin_DetectNewFile()
{
//	PA_Print(1, "Generating / Listing");	
	generateFullList();
//	verifyList("fat:/_menudo/logs/INDEX.OLDNDS");
	getNewNDSList();
}	
			
int getAmountOfNewNDS()
{
   return fileDetector.amountNewNDS;
}   
char* getPathOfNewNDS(int num)
{
   if (num>MAX_NEWNDS) num=MAX_NEWNDS;
   if (num<0) num=0;
   return fileDetector.newNDS[num].path;
}   
