#include <PA9.h>       // Include for PA_Lib
#include "fat.h"
#include "network.h"
#include "errno.h"
#include "mwifi.h" 
//#define REPEATIF rtn==0
#define REPEATIF FALSE
extern bool bootFile;
int parseRawPostPacket(char* tBuf, char* buf2)
{
   int i;
   int x;
	for (i=0;i<256;i++) {if (buf2[i]=='\r' && buf2[i+1]=='\n' && buf2[i+2]=='\r' && buf2[i+3]=='\n') break;}
   
   if (i==256) return -1;
   i+=4;   
   i+=0;
   for(x=0;buf2[i]!=0;x++)
	{
	   tBuf[x]=buf2[i];
	   i++;
	}  
	tBuf[x]=0; 
	return x;
   
}   
void urlencode(unsigned char *s, unsigned char *t) {
	unsigned char *p, *tp;
	if ( t == NULL ) { return; }
	
	tp = t;
	for( p = s; *p; p++ ) {
	   if ((*p > 0x00 && *p < ',') || (*p > '9' && *p < 'A') || (*p > 'Z' && *p < '_') || (*p > '_' && *p < 'a') || (*p > 'z' && *p < 0xA1) ) {
	   	sprintf(tp, "%%%02X", *p);
			tp += 3;   
	   } else {
	      *tp = *p;
	      tp++;	
	   }   
	}
	*tp = '\0';
	return;   
}   

int myInitSocket(int *sock, char *host, int port, int mode)
{
	int i = 0;
	struct hostent * tcp_he;
	struct sockaddr_in tcp_sain;
    
	tcp_he = gethostbyname(host);
    
	*sock = socket(AF_INET,SOCK_STREAM,0);
	tcp_sain.sin_addr.s_addr = *((unsigned long *)(tcp_he->h_addr_list[0]));
	tcp_sain.sin_family = AF_INET;
	tcp_sain.sin_port = htons(port);
    
	if ( mode == PA_NORMAL_TCP ) { i = 0; }
	if ( mode == PA_NONBLOCKING_TCP ) { i = 1; }
	ioctl(*sock, FIONBIO, &i); // set blocking or non-blocking
	if ( connect(*sock, (struct sockaddr *) &tcp_sain, sizeof(tcp_sain)) == 0 ) return 1;
        
	return 0;
}

int sendAll(int s, char *buf, int len) {
   int total = 0;
   int bytesleft = len;
   int n = 0;
   
	while(total < len) {
		n = send(s, buf+total, bytesleft, 0);
		if (n == -1) { 
		   debugTxt("error sending ");
		   break; 
			}
		total += n;
		bytesleft -= n;
	}

	len = total; // return number actually sent here

	return n==-1?-1:0; // return -1 on failure, 0 on success
}   
int sendAllByParts(int s, char *buf, int len,int bufsize) {
   int total = 0;
   int totalInCurrentBuf = 0;
   int bytesleft = len;
   int n = 0;
   int i=0;
   int len2=len;
   int currentlen=0;
   int bytesToSend=0;
   int currentpos=0;
   char debug[100];
   do{
      if (bufsize<len2) 
			bytesleft=bufsize;
		else
			bytesleft=len2;
			
		currentlen=bytesleft;
		totalInCurrentBuf=0;
		if (bytesleft==0) break;
		sprintf(debug,"bytesleft: %d",bytesleft);
		debugTxt(debug);
		while(totalInCurrentBuf < currentlen) {
			n = send(s, buf+total, bytesleft, 0);
			if (n == -1) { 
			   debugTxt("error sending ");
			   break; 
				}
			total += n;
			totalInCurrentBuf += n;
			bytesleft -= n;
		}
      len2-=bufsize;
      PA_WaitForVBL();
	}while(len2>0);


	return n==-1?-1:0; // return -1 on failure, 0 on success
}   
bool waitForReply=1;
void mWifi_setWaitForReply(bool i) { waitForReply = i;}
int mwifisock=0;
bool server_loaded=0;
struct hostent * server_tcp_he;
struct sockaddr_in server_tcp_sain;
int getServerSocket(int *sock, char*server, char *address)
{
	strcpy(server, "");
	debugTxt("get_HTTP_serveur()");
	debugTxt("initsocket()");
   int port=80;
   int mode = PA_NONBLOCKING_TCP;
	int i = 0;
	int pos=0;
	if (!server_loaded)
   {
		pos = get_HTTP_serveur(server, address);
		server_tcp_he = gethostbyname(server);
		*sock = socket(AF_INET,SOCK_STREAM,0);
		server_tcp_sain.sin_addr.s_addr = *((unsigned long *)(server_tcp_he->h_addr_list[0]));
		server_tcp_sain.sin_family = AF_INET;
		server_tcp_sain.sin_port = htons(port);
	   server_loaded=1;	    
	}	
	if ( mode == PA_NORMAL_TCP ) { i = 0; }
	if ( mode == PA_NONBLOCKING_TCP ) { i = 1; }
	ioctl(*sock, FIONBIO, &i); // set blocking or non-blocking
	if ( connect(*sock, (struct sockaddr *) &server_tcp_sain, sizeof(server_tcp_sain)) == 0 )
	{
	   return 1;
	}   
        
	return 0;
}   
int myPostHTTP(char *tBuf, char *address, char *postData)
{
   int sock=mwifisock;
   char server[256];
   char buf2[256 + strlen(postData)];
	char chrTmp[256];

	s16 rtn, pos, i;
	s16 len = 0;
	
  do{
	if (bootFile)
	{
		PA_16cErase(1);
		sprintf(chrTmp,"initializing sock");
	   display16cText(1,0,0,256,192,chrTmp,1,5);
	}   
		strcpy(buf2, "");
		strcpy(tBuf, "");
		getServerSocket(&sock, server,address);
//	if (sock==0) 
	{

		if ( rtn == 0 ) {
			closesocket(sock);         
			return 0;
		}		
		else
		mwifisock = sock;
	}		
	sprintf(buf2, "POST %s HTTP/1.0\r\nHost: %s\r\nUser-Agent: MENUdo\r\nAccept: */*\r\nContent-Length: %d\r\nContent-Type: application/x-www-form-urlencoded\r\n\r\n%s", address+pos, server, (int)strlen(postData),postData);
	if (bootFile)
	{
		PA_16cErase(1);
	   display16cText(1,0,0,256,192,postData,1,5);
	}   
   bool firstPacket=1;
	int timer=0;
	len = 0;
	while(1)
	{
	   if (timer==0)
	   {
	     	rtn = sendAllByParts(sock, buf2, strlen(buf2),256);
			if ( rtn < 0 ) break;
//			PA_WaitForVBL();
		}			
		if (Pad.Held.B) break;		
		rtn = recv(sock, buf2, 256, 0);
		buf2[rtn]=0;
		if ( rtn == 0) 
		{
		   debugTxt("rtn zero");
			if(len==0)	continue;
			if(len>0) 	break;
		}			
		if ( rtn < 0 && errno != 11 )
		{
		   debugTxt("rtn error");
			break;
		}			
		if ( rtn > 0 ) {
		   timer=10;
			if (firstPacket)
			{
			   i = parseRawPostPacket(tBuf, buf2);
			  	if (i==-1) continue; 
				len = i;
				firstPacket=0;
			}					
		   else
		   {
				for ( i = 0; i < rtn; i++ ) tBuf[len+i] = buf2[i];
				len += rtn;
			}			
			if (bootFile)
			{
				PA_16cErase(1);
				sprintf(chrTmp,"recv \n %d byte \n%s (Press B to Stop)",len,buf2);
			   display16cText(1,0,0,256,192,chrTmp,1,5);
			}   
		}		

	}
  	}while(REPEATIF);
closesocket(sock);
PA_WaitForVBL();
	return len;
}

int myUploadHTTP(char *tBuf, char *address, char* fileToUpload)
{
   int sock;
   char server[256];
	char chrTmp[256];
	char buf3[300];
	s16 rtn, pos, i;
	s16 len = 0;
	bool repeatLoop=0;
	do
	{
		if (bootFile)
		{
			PA_16cErase(1);
			sprintf(chrTmp,"1");
		   display16cText(1,0,0,256,192,chrTmp,1,5);
		}   
	   repeatLoop=1;
		strcpy(server, "");
		strcpy(buf3, "");
		strcpy(tBuf, "");
		FILE * file = fopen(fileToUpload,"rb");
		fseek (file, 0 , SEEK_END);
		u16 imgSize = ftell(file);
		rewind (file);
		pos = get_HTTP_serveur(server, address);

		rtn = myInitSocket(&sock, server, 80, PA_NONBLOCKING_TCP);
		if ( rtn == 0 ) {
			closesocket(sock);         
			return 0;
		}		

		sprintf(buf3, "POST %s HTTP/1.0\r\nHost: %s\r\nUser-Agent: Nintendo DS\r\nAccept: */*\r\nContent-Length: %d\r\nContent-Type: application/octet-stream\r\n\r\n", address+pos, server, /*(int)strlen(postData)*/imgSize );
		rtn = sendAll(sock, buf3, strlen(buf3));

		int sizeSent=0;
		char chrTmp[300];
		while(!feof(file))
		{
	
			i = fread (chrTmp , 1, 256, file);	   
			rtn = sendAll(sock, chrTmp, i);
			sizeSent+=rtn;
			if (bootFile)
			{
				PA_16cErase(1);
				sprintf(chrTmp,"Sending SAV backup\n %d byte / %d byte ",sizeSent,imgSize);
			   display16cText(1,0,0,256,192,chrTmp,1,5);
			}   
//		   PA_WaitForVBL();
			if ( rtn < 0 )
			{
				closesocket(sock);         
				return 0;
			}
		}	
	strcpy(buf3, "");
   bool firstPacket=1;
	int sizeRcv=0;
	len = 0;
	while(1)
	{
	   if (bootFile)
		{
			PA_16cErase(1);
			sprintf(chrTmp,"Receiving Response\n %d byte (Press B to Cancel)",sizeRcv);
		   display16cText(1,0,0,256,192,chrTmp,1,5);
		}   
		memset(buf3,0,sizeof(buf3));
		rtn = recv(sock, buf3, 256, 0);
		sizeRcv+=rtn;
		if (Pad.Held.B) break;
		if ( rtn == 0) 
		{
		  debugTxt("rtn zero");
/*			if(len==0)
			{
			   repeatLoop=1;
				break;
			}			*/
			if(len>0) break;
		}			
		
		if ( rtn < 0 && errno != 11 )  break;
		if ( rtn > 0 )
		{
			if (firstPacket)
			{
			   i = parseRawPostPacket(tBuf, buf3);
			  	if (i==-1) continue; 
				len = i;
				firstPacket=0;
			}									
		   else
		   {
		   
				for ( i = 0; i < rtn; i++ ) tBuf[len+i] = buf3[i];
				len += rtn;
			}			
		}		
		PA_WaitForVBL();
	}
	}while(repeatLoop);
	closesocket(sock);

/*	while(!Pad.Newpress.A)
	{
		PA_WaitForVBL();        
	}*/		
	PA_WaitForVBL();
	return len;
}

int myGetHTTP(char *tBuf, char *address)
{
   int sock;
   char server[256];
   char buf2[256];
	char buf3[256];
	s16 rtn, pos, i;
	s16 len = 0;
  do{
closesocket(sock);
	strcpy(server, "");
	strcpy(buf2, "");
	strcpy(buf3, "");
	strcpy(tBuf, "");
	
	pos = get_HTTP_serveur(server, address);

	rtn = myInitSocket(&sock, server, 80, PA_NONBLOCKING_TCP);
	if ( rtn == 0 ) {
		closesocket(sock);         
		return 0;
	}		
    
	sprintf(buf2, "GET %s HTTP/1.0\r\nHost: %s\r\nUser-Agent: Nintendo DS\r\nAccept: */*\r\n\r\n", address+pos, server );
	rtn = sendAll(sock, buf2, strlen(buf2));
	if ( rtn < 0 ) {	// SEND ERROR
		closesocket(sock);         
		return 0;
	}   

      bool firstPacket=1;
	while(1)
	{
		memset(buf3,0,sizeof(buf3));
		rtn = recv(sock, buf3, 256, 0);
		if ( rtn == 0) break;
		if ( rtn < 0 && errno != 11 ) { 		// READ ERROR
			closesocket(sock);         
			return 0;
      } 
		if ( rtn > 0 ) {
			if (firstPacket)
			{

			   int x;
				for (i=0;i<256;i++)
			   {
			      if (buf3[i]=='\r' &&
						buf3[i+1]=='\n' &&
						buf3[i+2]=='\r' &&
						buf3[i+3]=='\n') break;
			   }
			   
			   if (i==256) 
				{
				   PA_SetBrightness(1,1);
				   PA_WaitForVBL();
				   continue;
				}
			   i+=4;   
			   i+=0;
			   for(x=0;buf3[i]!=0;x++	)
				{
				   tBuf[x]=buf3[i];
				   i++;
				}  
				tBuf[x]=0; 
				len = x;
			   firstPacket=0;
			}					
		   else
		   {
				for ( i = 0; i < rtn; i++ ) tBuf[len+i] = buf3[i];
				len += rtn;
			}			
		}		
		PA_WaitForVBL();
	}
    
	}while(REPEATIF);
	closesocket(sock);
PA_WaitForVBL();
	return len;
}

int myDownloadHTTP(const char *file, char *address)
{
   int sock;
   char tBuf[257];
   char server[257];
   char buf2[257];
	char buf3[257];
	s16 rtn, pos, i;
	s16 len = 0;
	FILE *fp;
	do
	{
closesocket(sock);
	fp = fopen(file, "wb");
	rewind(fp);
  
	strcpy(server, "");
	strcpy(buf2, "");
	strcpy(buf3, "");
	
	pos = get_HTTP_serveur(server, address);

	rtn = myInitSocket(&sock, server, 80, PA_NONBLOCKING_TCP);
	if ( rtn == 0 ) {
		closesocket(sock);         
		return 0;
	}		
    
	sprintf(buf2, "GET %s HTTP/1.0\r\nHost: %s\r\nUser-Agent: Nintendo DS\r\nAccept: */*\r\n\r\n", address+pos, server );
	rtn = sendAll(sock, buf2, strlen(buf2));
	if ( rtn < 0 ) {	// SEND ERROR
		closesocket(sock);         
		return 0;
	}   

      bool firstPacket=1;
	while(1)
	{
		memset(buf3,0,sizeof(buf3));
		rtn = recv(sock, buf3, 256, 0);
		if ( rtn == 0) break;
		if ( rtn < 0 && errno != 11 ) { 		// READ ERROR
			closesocket(sock);         
			return 0;
      } 
		if ( rtn > 0 ) {
			if (firstPacket)
			{

			   int x;
				for (i=0;i<256;i++)
			   {
			      if (buf3[i]=='\r' &&
						buf3[i+1]=='\n' &&
						buf3[i+2]=='\r' &&
						buf3[i+3]=='\n') break;
			   }
			   
			   if (i==256) 
				{
				   PA_SetBrightness(1,1);
				   PA_WaitForVBL();
				   continue;
				}
			   i+=4;   
			   i+=0;
			   for(x=0;buf3[i]!=0;x++	)
				{
				   tBuf[x]=buf3[i];
				   i++;
				}  
				tBuf[x]=0; 
				len = x;
			   firstPacket=0;
			}					
		   else
		   {
				for ( i = 0; i < rtn; i++ ) tBuf[len+i] = buf3[i];
				len += rtn;
			}			
		}		
		PA_WaitForVBL();
	}
        

	}while(REPEATIF);
	closesocket(sock);
	fclose( fp );
PA_WaitForVBL();        
	return len;
}
void initWifiService()
{
if (wifi.APnotFound) return;
if (wifi.SID[0]==0) return;
	char* result = NULL;
	
//do{
   PA_WaitForVBL();
//	if (result!=NULL) free(result);
DNS_setTimeOut(50);
DNS_setMaxRetry(1);
DNS_setMaxServerRetry(1);

	result = BB_loginSID(wifi.SID);
//	result[strlen("LOGIN FAILED")+1]=0;
/*	if (stricmp (result,"LOGIN FAILED")==0) break;
	result[strlen("LOGIN FAILED")]=0;
if (stricmp (result,"LOGIN FAILED")==0) break;
*/	
//}while(strlen(result)<5);
	if (result!=NULL) free(result);
}	
void cancellWifiConnect()
{
   if (!wifi.connecting) return;
   wifi.APnotFound = 1;
	Wifi_DisableWifi();
	wifi.connecting = 0;
}  	
