#include <PA9.h>
#include <fat.h>
#include <sys/dir.h>
#include "../../engine/engine.h"
#include "../../userConfigFunctions.h"
u32 screenSaverCounter=0;
void resetScreenSaverCounter()
{
   screenSaverCounter=0;
}   
bool checkForScreenSaver()
{
   if ((Pad.Held.Anykey || Pad.Held.Y || Stylus.Held)) screenSaverCounter=0;
   
   if (screenSaverCounter<system.ScreenSaverDelay)
		screenSaverCounter++;
	else
	{
	   int i=0;
	   for(i=0;i<15;i++)
	   {
		   PA_SetBrightness(0,0-i);
	  	   PA_SetBrightness(1,0-i);
			updateAmbience(); 
		   if ((Pad.Held.Anykey || Pad.Held.Y || Stylus.Held)) 
		   {
		      setBrightness(1,0);
		      setBrightness(0,0);
		      return 1;
		   }   
			Soul_waitForVBL();
		}			


		screensaverMode();
		screenSaverCounter=0;
      setBrightness(1,0);
      setBrightness(0,0);
      return 1;
	}		
    return 0;
}	
void sleepMENUdo()
{
  while(true)
  {
     if (Pad.Newpress.Anykey|| Pad.Newpress.Y || Stylus.Held) return;
		ZoomXY_3DProcess(128,0,0);  		
		updateAmbience();  //Update Ambience / Animated Background
     Soul_waitForVBL();
  }   
}	  
void screensaverMode()
{
   
	struct stat st;
	char filename[256]; 
	char charTemp[256];
	char * resourcepath = malloc(256);//returnThemeResourcePath("screensavers/",1);
	sprintf(resourcepath,"fat:/_menudo/default/screensavers/");
	if (resourcepath !=NULL) 
	{
	   DIR_ITER* dir = diropen(resourcepath);
		int filecounter=0;
		int randomNumber=0;
		randomNumber=0;
		while (dirnext(dir, filename, &st) == 0) 
		{
		   if (stricmp(&filename[strlen(filename)-4],".smf") != 0) continue;
			filecounter++;
			logMessage(filename);
		}   
		if (filecounter==0)	{sleepMENUdo(); 	if (resourcepath !=NULL) free(resourcepath); return;}	  
		PA_16cErase(1);
		PA_16cErase(0);
		int i;
		bool loopfile=0;
			PA_SetSpriteY(1,0,205);
		   PA_SetSpriteY(1,11,205); 

		hideAll2dSprites();
		int lastrandomNumber=-1;
		while(true)
		{
		   do{
				randomNumber=PA_RandMax(filecounter);
			}while (lastrandomNumber==randomNumber);
			lastrandomNumber=randomNumber;
		   i=0;
		   dirreset(dir);
		   loopfile=0;
			while (dirnext(dir, filename, &st) == 0) 
			{
			   if (stricmp(&filename[strlen(filename)-4],".smf") != 0) continue;
			   if (randomNumber==i)
			   {
			      if ( stricmp(&filename[strlen(filename)-9],".loop.smf") == 0)loopfile=1;
			      sprintf(charTemp,"%s%s",resourcepath,filename);
			      logMessage(charTemp);
			      setBrightness(1,0);
			      do
			      {
//					   initSMF(1, charTemp);
					   if (initSMF(1, charTemp))
					   {
					     while(updateSMF())
						  {
						     if (Pad.Newpress.Anykey|| Pad.Newpress.Y || Stylus.Held) 
							  {
							     deinitSMF();
									free(resourcepath);
									showAll2dSprites();
								  return;
								}	  
						     Soul_waitForVBL();
						  }   
					     deinitSMF();
					   }   
					}   while (loopfile || filecounter==1);
					break;
			   }   
			   i++;
			}   
		}	
		showAll2dSprites();
		free(resourcepath);	 
	}		
	else
	{
  	   PA_SetBrightness(1,31);
		sleepMENUdo();
		if (resourcepath !=NULL) free(resourcepath); 
	}	  

	
}	

