#include <PA9.h>
#include "../../engine/engine.h"
#include "../shrink.h"
#include "../../misc/clock.h"
#include "../../misc/misc.h"
#include "../../misc/transition.h"
#include "mWifi.h"

extern unsigned short pal_16c[16] __attribute__ ((aligned (4)));


void connectToWifi_Gui(char * username, char* password)
{
   PA_16cErase(1);
	if (wifi.APnotFound || Wifi_CheckInit()==0)
	{
	   display16cText(1,10,0,200,0,"Initializing Wifi....",PLAIN_TEXTCOLOR,1);
		if (Wifi_CheckInit()==0) PA_InitWifi();
		wifi.APnotFound = 0;
	   display16cText(1,10,10,200,0,"Searching for AP....",PLAIN_TEXTCOLOR,1);
		if (!PA_ConnectWifiWFC())
		{
		   wifi.APnotFound = 1;
		   PA_WaitForVBL();PA_WaitForVBL();PA_WaitForVBL();PA_WaitForVBL();PA_WaitForVBL();
//		   PA_SetLedBlink(0,0);
		   display16cText(1,10,30,200,0,"Access Point not found....",PLAIN_TEXTCOLOR,1);
		   PA_WaitForVBL();
		   return;
		}   
	}		
   sprintf(wifi.username,"%s",username);
   sprintf(wifi.password,"%s",password);
   display16cText(1,10,10,200,0,"Connecting to....",PLAIN_TEXTCOLOR,1);
   display16cText(1,20,20,200,0,"Gamenow.Asia",PLAIN_TEXTCOLOR,1);
   display16cText(1,10,30,200,0,"Username....",PLAIN_TEXTCOLOR,1);
   display16cText(1,20,40,200,0,username,PLAIN_TEXTCOLOR,1);
   display16cText(1,10,50,200,0,"Password....",PLAIN_TEXTCOLOR,1);
   display16cText(1,20,60,200,0,password,PLAIN_TEXTCOLOR,1);

//   display16cText(1,10,30,200,10,"Connecting....",PLAIN_TEXTCOLOR,1);
	char *result = NULL;
	result = BB_loginUser(username,password);

//	BB_loginSID(wifi.SID);
   display16cText(1,10,70,200,0,result,PLAIN_TEXTCOLOR,1);
   if (result!=NULL) free(result);
	int timeout_Timer=100;
	   PA_WaitForVBL();
/*   while (true)   
   {
      PA_WaitForVBL();
      timeout_Timer--;
      if (timeout_Timer==0) break;
      if (Pad.Newpress.A) break;
      
   }*/   
   return;/*
   int transition=0;
   PA_16cErase(1);
   while (transition<=40)
   {
      PA_EnableSpecialFx(1, SFX_BRIGHTDEC, SFX_BG3 , 0);
     	REG_BLDY(1) = transition/3;
      setBrightness(0,transition/-3);
      PA_WaitForVBL();
      transition++;
   }   
   PA_LoadJpeg(1,(void*)connectingWifi);

   PA_EnableSpecialFx(1, SFX_NONE, SFX_BG3 , 0);
   	
	int ajaxFrame=0;
	PA_EnableSpecialFx(1, SFX_ALPHA, SFX_BG2 , SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
	PA_SetSFXAlpha(1, 31, 20);
	createAjaxCircles(13);
	updateAjaxSprite(ajaxFrame);
	

   while (true)   
   {
      if (timeout_Timer==0) break;
      if (PA_RTC.Frames%5==0)
      {
			updateAjaxSprite(ajaxFrame%8);
			ajaxFrame++;
		}			
      PA_SetLedBlink(1,0);
      PA_WaitForVBL();
      timeout_Timer--;
   }   
   PA_SetLedBlink(0,0);
   PA_16cErase(1);

   transition=50;
  	PA_SetBgRot(1,3,transition/2,transition/2,0,0,0,256-transition);   
   PA_LoadJpeg(1,(void*)failedToConnect);
   while (transition>0)
   {
   	PA_SetBgRot(1,3,transition/2,transition/2,0,0,0,256-transition);   
		PA_WaitForVBL();
		if (transition>0) transition--;
		if (transition>10) transition--;
		if (transition>30) transition--;
   }   
   timeout_Timer=200;
   while (true)   
   {
      if (timeout_Timer==0 || Stylus.Newpress) break;
      PA_WaitForVBL();
      timeout_Timer--;
   }
	PA_LoadBmp(1,(void*)whiteBoardText);
	
	changeWhiteBoard();


   transition=40;
   while (transition>0)
   {
      PA_EnableSpecialFx(1, SFX_BRIGHTDEC, SFX_BG3 , 0);
     	REG_BLDY(1) = transition/3;
      setBrightness(0,transition/-3);
      PA_WaitForVBL();
      transition--;
   }   */
}   

void displayLoginText(char * username, char* password)
{
   spaceLetteringForDefault();
   if (username[0] == 0)
		display16cText(0,62,69,150+58,69,"Username",15,4);
	else
		display16cText(0,62,69,150+58,69,username,15,4);

   if (password[0] == 0)
		display16cText(0,62,94,150+58,94,"Password",15,4);
	else
		display16cText(0,62,94,150+58,94,password,15,4);
}			
void showWifiLoginScreen()
{
   char username[256];
   char password[256];
   memset (username,0,256);
   memset (password,0,256);
   sprintf(username,"%s",wifi.username);
   sprintf(password,"%s",wifi.password);
   PA_16cErase(0);

   PA_EnableSpecialFx(0, SFX_NONE, SFX_BG1 , SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
   
   load16cBMPWithResource(0,0,0,"shrink/WifiLogin.16c.bmp");

	initAntiAliasedText(1,2,1);
	PA_SetSFXAlpha(1, 12, 2); 
	spaceLetteringForDefault();
	char* charReturn=NULL;
   while(1)
   {

		updateShrinkClock(0);
		displayLoginText(username,password);

      if ((Stylus.Newpress && PA_StylusInZone(62,69,150+58,69+16))) 
		{
		   PA_SwitchScreens();
		   loadBMPWithResource(1,0,0,"shrink/EmptyScreen.bmp");
		   PA_SwitchScreens();
		   spaceLetteringForAAText();
		   charReturn=inputKeyboard(0, username,62,69,150+58,69, 11, 15, 0, 15,4, 0, 1,0);
		   sprintf(username,"%s",charReturn);
		   if (charReturn!=NULL) free(charReturn);
		   spaceLetteringForDefault();
		   displayLoginText(username,password);
			initAntiAliasedText(1,2,1);
			PA_SetSFXAlpha(1, 12, 2); 
			if (!inputKeyboard_EndedWithEnter()) 
			{
				loadBMPWithResource(1,0,0,"shrink/whiteBoardTxt.bmp");		   	
				changeWhiteBoard();
			}			
		}   
      if ((Stylus.Newpress && PA_StylusInZone(62,94,150+58,94+16)) || inputKeyboard_EndedWithEnter()) 
		{
		   PA_SwitchScreens();
			if (!inputKeyboard_EndedWithEnter()) loadBMPWithResource(1,0,0,"shrink/EmptyScreen.bmp");
		   PA_SwitchScreens();
		   spaceLetteringForAAText();
		   charReturn=inputKeyboard(0, password,62,94,150+58,94, 11, 15, 0, 15,4, 0, 1,0);
		   sprintf(password,"%s",charReturn);
		   if (charReturn!=NULL) free(charReturn);
		   spaceLetteringForDefault();
		   displayLoginText(username,password);
			initAntiAliasedText(1,2,1);
			PA_SetSFXAlpha(1, 12, 2); 
	   	loadBMPWithResource(1,0,0,"shrink/whiteBoardTxt.bmp");
	   	
			changeWhiteBoard();
		}   
      if ((Stylus.Newpress && PA_StylusInZone(85,119,85+50,119+15)) || Pad.Newpress.Start || inputKeyboard_EndedWithEnter()) 
      {
			connectToWifi_Gui(username,password);
			initAntiAliasedText(1,2,1);
			PA_SetSFXAlpha(1, 12, 2); 
			reset_inputKeyboard_EndedWithEnter();
			if (wifi.online) break;
	   }   						
		updateAmbience();  //Update Ambience / Animated Background
		ZoomXY_3DProcess(112,(shrinkX+3)*-1,(shrinkY)*-1);
      PA_WaitForVBL();

      if (Pad.Newpress.L || (Stylus.Newpress && (PA_StylusInZone(138,119,138+50,119+15)||(!PA_StylusInZone(49,60,49+170,60+80)&& !PA_StylusInZone(49,0,256,20))))) break;
      //PA_16cErase(1);      
   }   
//   if (charReturn!=NULL) free(charReturn);
	Stylus.Newpress=false;
	Stylus.Held=false;
}   
