-- phpMyAdmin SQL Dump
-- version 3.2.1
-- http://www.phpmyadmin.net
--
-- Host: localhost
-- Generation Time: Sep 13, 2009 at 11:53 PM
-- Server version: 5.0.81
-- PHP Version: 5.2.9

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";

--
-- Database: `dokiheav_bbp02`
--

-- --------------------------------------------------------

--
-- Table structure for table `menudo_achievements`
--

CREATE TABLE IF NOT EXISTS `menudo_achievements` (
  `AchievementID` int(255) NOT NULL auto_increment,
  `AchievementName` varchar(255) NOT NULL,
  `AchievementInfo` varchar(255) NOT NULL,
  `AchievementIcon` varchar(255) NOT NULL,
  `AchievementPoints` int(255) NOT NULL,
  PRIMARY KEY  (`AchievementID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=15 ;

--
-- Dumping data for table `menudo_achievements`
--

INSERT INTO `menudo_achievements` (`AchievementID`, `AchievementName`, `AchievementInfo`, `AchievementIcon`, `AchievementPoints`) VALUES
(1, 'Gamer Unvirginized', '1 Game Played', 'Achievement1', 0),
(2, 'Gaming Whore', '10 Games Played', 'Achievement2', 0),
(3, 'Classic Gamer', '50 Games Played', 'Achievement3', 0),
(4, 'Casual Gamer', '100 Games Played', 'Achievement4', 0),
(5, 'Handheld Gamer', '200 Games Played', 'Achievement5', 0),
(6, 'Fata1ty''s Pet', '300 Games Played', 'Achievement6', 0),
(7, 'Hardcore Gamer', '1000 Games Played', 'Achievement7', 0),
(8, 'Gaming God', '100000 Games Played', 'Achievement7', 0),
(9, 'You made a purty one', 'First ever theme created', 'Achievement8', 0),
(10, 'Sharing is Caring', '1 Theme Submitted to Gamenow.asia', 'Achievement7', 0),
(11, 'You''ve found a secret!', 'MENUdo Easter Egg 1 Found', 'Achievement8', 0),
(12, 'Are you sure you didn''t ask help for this one?', 'MENUdo Easter Egg 3 Found', 'Achievement9', 0),
(13, 'You have jumped into the Frey!', 'First login at Gamenow.asia', 'Achievement10', 0),
(14, 'IT WENT IN!', 'First Connection to FTP', 'Achievement10', 0);

-- --------------------------------------------------------

--
-- Table structure for table `menudo_friendcodes`
--

CREATE TABLE IF NOT EXISTS `menudo_friendcodes` (
  `FC_ID` int(255) NOT NULL auto_increment,
  `MENUdo_UserID` int(255) NOT NULL,
  `FriendCode` bigint(255) NOT NULL,
  `GameAssociated` varchar(255) NOT NULL,
  `Name` varchar(255) NOT NULL,
  `Town` varchar(255) NOT NULL COMMENT 'For Animal Crossing',
  `Platform` varchar(255) NOT NULL,
  PRIMARY KEY  (`FC_ID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=11 ;

--
-- Dumping data for table `menudo_friendcodes`
--

INSERT INTO `menudo_friendcodes` (`FC_ID`, `MENUdo_UserID`, `FriendCode`, `GameAssociated`, `Name`, `Town`, `Platform`) VALUES
(1, 1, 102920392029, 'Metroid Prime: Hunters', 'ShadowEO', '', 'DS'),
(9, 1, 192093829102, 'Starfox Command', 'ShadowX', '', 'DS');

-- --------------------------------------------------------

--
-- Table structure for table `menudo_games`
--

CREATE TABLE IF NOT EXISTS `menudo_games` (
  `GameEntry` int(255) NOT NULL auto_increment,
  `GameID` varchar(255) NOT NULL,
  `GameTitle1` varchar(255) NOT NULL,
  `GameTitle2` varchar(255) NOT NULL,
  `GameTitle3` varchar(255) NOT NULL,
  PRIMARY KEY  (`GameEntry`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=21 ;

--
-- Dumping data for table `menudo_games`
--

INSERT INTO `menudo_games` (`GameEntry`, `GameID`, `GameTitle1`, `GameTitle2`, `GameTitle3`) VALUES
(1, '1044', 'Final Fantasy III', '', ''),
(2, '1161', 'Transformers: Autobots', '', ''),
(3, '1162', 'Transformers: Decepticons', '', ''),
(4, '1444', 'Sonic Rush Adventure', '', ''),
(5, '2276', 'Iron Man', '', ''),
(6, '0688', 'Bionicle Heroes', '', ''),
(7, '0177', 'Sonic Rush', '', ''),
(8, '0479', 'New Super Mario Bros.', '', ''),
(9, '0765', 'Fullmetal Alchemist: Dual Sympathy', '', ''),
(10, '0037', 'Super Mario 64 DS', '', ''),
(11, '2252', 'The World Ends With You', '', ''),
(13, '4143', 'Love Plus', '', ''),
(14, '0662', 'Digimon World DS', '', ''),
(15, '1420', 'Digimon World: Dusk', '', ''),
(16, '1421', 'Digimon World: Dawn', '', ''),
(17, '0655', 'Elite Beat Agents', '', ''),
(18, '2002', 'Professor Layton and the Curious Village', '', ''),
(19, '0083', 'Osu! Tatakae! Ouendan', '', ''),
(20, '1081', 'Moero! Nekketsu Rhythm Damashii Osu! Tatakae! Ouendan 2', '', '');

-- --------------------------------------------------------

--
-- Table structure for table `menudo_homebrew`
--

CREATE TABLE IF NOT EXISTS `menudo_homebrew` (
  `HomebrewID` int(255) NOT NULL auto_increment,
  `GameTitle1` varchar(255) NOT NULL,
  `GameTitle2` varchar(255) NOT NULL,
  `GameTitle3` varchar(255) NOT NULL,
  PRIMARY KEY  (`HomebrewID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `menudo_homebrew`
--


-- --------------------------------------------------------

--
-- Table structure for table `menudo_messages`
--

CREATE TABLE IF NOT EXISTS `menudo_messages` (
  `MessageID` int(255) NOT NULL auto_increment,
  `MsgToID` int(255) NOT NULL,
  `MsgFromID` int(255) NOT NULL,
  `MsgSubject` varchar(255) NOT NULL,
  `MsgBody` varchar(255) NOT NULL,
  `MsgPriority` int(1) NOT NULL,
  `MsgNew` int(1) NOT NULL default '1',
  PRIMARY KEY  (`MessageID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=80 ;

--
-- Dumping data for table `menudo_messages`
--

INSERT INTO `menudo_messages` (`MessageID`, `MsgToID`, `MsgFromID`, `MsgSubject`, `MsgBody`, `MsgPriority`, `MsgNew`) VALUES
(59, 1, 1, 'Hi', 'Hey Man', 2, 0),
(58, 1, 1, 'Hi', 'Hey Man', 2, 0),
(57, 1, 1, 'Hi', 'Hey Man', 2, 0),
(56, 1, 1, 'Hi', 'Hey Man', 2, 0),
(55, 1, 1, 'Hi', 'Hey Man', 2, 0),
(54, 1, 1, 'Hi', 'Hey Man', 2, 0),
(53, 1, 1, 'Hi', 'Hey Man', 2, 0),
(52, 1, 1, 'Hi', 'Hey Man', 2, 0),
(51, 1, 1, 'Hi', 'Hey Man', 2, 0),
(50, 1, 1, 'Hi', 'Hey Man', 2, 0),
(49, 1, 1, 'Hi', 'Hey Man', 2, 0),
(48, 1, 1, 'Hi', 'Hey Man', 2, 0),
(60, 1, 1, 'Hi', 'Hey Man', 2, 0),
(61, 1, 1, 'Hi', 'Hey Man', 2, 0),
(62, 1, 1, 'Hi', 'Hey Man', 2, 0),
(63, 1, 1, 'Hi', 'Hey Man', 2, 0),
(64, 1, 1, 'Hi', 'Hey Man', 2, 0),
(65, 1, 1, 'Hi', 'Hey Man', 2, 0),
(66, 1, 1, 'Hi', 'Hey Man', 2, 0),
(67, 1, 1, 'Hi', 'Hey Man', 2, 0),
(68, 1, 1, 'Hi', 'Hey Man', 2, 0),
(69, 1, 1, 'Hi', 'Hey Man', 2, 0),
(70, 1, 1, 'Hi', 'Hey Man', 2, 0),
(71, 1, 1, 'Hi', 'Hey Man', 2, 0),
(72, 1, 1, 'Hi', 'Hey Man', 2, 0),
(73, 1, 1, 'Hi', 'Hey Man', 2, 0),
(74, 1, 1, 'Hi', 'Hey Man', 2, 0),
(75, 1, 1, 'Hi', 'Hey Man', 2, 0),
(76, 1, 1, 'Hi', 'Hey Man', 2, 0),
(77, 1, 1, 'Hi', 'Hey Man', 2, 0),
(78, 1, 1, 'Hi', 'Hey Man', 2, 0),
(79, 1, 1, 'Hi', 'Hey Man', 2, 0);

-- --------------------------------------------------------

--
-- Table structure for table `menudo_system`
--

CREATE TABLE IF NOT EXISTS `menudo_system` (
  `Setting` varchar(255) NOT NULL,
  `Value` varchar(255) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `menudo_system`
--

INSERT INTO `menudo_system` (`Setting`, `Value`) VALUES
('CurrentVersionID', '1000'),
('CurrentVersion', '1.0a');

-- --------------------------------------------------------

--
-- Table structure for table `menudo_themes`
--

CREATE TABLE IF NOT EXISTS `menudo_themes` (
  `ThemeID` int(255) NOT NULL auto_increment,
  `ThemeName` varchar(255) NOT NULL,
  `ThemeDescription` varchar(255) NOT NULL,
  `ThemeAuthor` varchar(255) NOT NULL,
  `ThemeShot` varchar(255) NOT NULL,
  `ThemeDiscussion` varchar(255) default NULL,
  PRIMARY KEY  (`ThemeID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `menudo_themes`
--


-- --------------------------------------------------------

--
-- Table structure for table `menudo_users`
--

CREATE TABLE IF NOT EXISTS `menudo_users` (
  `UserID` int(255) NOT NULL auto_increment,
  `UserSID` varchar(255) NOT NULL,
  `Username` varchar(255) NOT NULL,
  `Password` varchar(255) NOT NULL,
  `DisplayName` varchar(255) NOT NULL,
  `CustomTitle` varchar(255) NOT NULL,
  `SiteAvatar` varchar(255) NOT NULL,
  `Points` int(255) NOT NULL,
  `TeamID` int(255) default NULL,
  `FavoriteGame` varchar(255) NOT NULL,
  `RecentGameIDs` varchar(255) default NULL,
  `AchievementIDs` varchar(255) NOT NULL,
  `BrotherIDs` varchar(255) NOT NULL,
  `GamerIDTheme` varchar(255) NOT NULL,
  `LastDatePlayed` varchar(255) NOT NULL,
  `UserIsAdmin` tinyint(1) NOT NULL,
  `bbPressUserID` int(255) NOT NULL,
  `bbPressUsername` int(11) NOT NULL,
  PRIMARY KEY  (`UserID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=8 ;

--
-- Dumping data for table `menudo_users`
--

INSERT INTO `menudo_users` (`UserID`, `UserSID`, `Username`, `Password`, `DisplayName`, `CustomTitle`, `SiteAvatar`, `Points`, `TeamID`, `FavoriteGame`, `RecentGameIDs`, `AchievementIDs`, `BrotherIDs`, `GamerIDTheme`, `LastDatePlayed`, `UserIsAdmin`, `bbPressUserID`, `bbPressUsername`) VALUES
(1, '70683cf275a791515c87bc77d44c7ff3', 'ShadowEO', '5beb4cd65f6e2a78925cfc1599d97868', 'Shadow of the Dark', 'Ninja Programmer', 'dreamcaster23@gmail.com', 0, 0, 'Megaman Starforce 3: Black Ace', '2252,0037,0037,0037', '0', '0', 'xbox', '2 Days Ago', 1, 0, 0),
(4, 'e9c378c7e1e9b1ec70f067695c762e1c', 'Soulanger', '0cbc6611f5540bd0809a388dc95a615b', 'Soulanger', 'Chicken God', 'Soulanger.png', 0, 0, 'MENUdo', '2252,2252', '0', '0', 'xbox', '3 Days Ago', 1, 0, 0),
(5, '', 'fgghjjkll', '9b6c64ccc2e0a65ba33093108eabc945', 'fgghjjkll', 'Megaman of Gamenow', '', 0, 0, 'Megaman Starforce 3: Black Ace', '2252', '0', '0', 'xbox', 'Today', 0, 0, 0),
(6, '', 'mercluke', '', 'mercluke', 'nul', 'mercluke@gmail.com', 0, 0, 'Unspecified', '2252', '', '', 'xbox', '2 days ago', 0, 0, 0),
(7, 'b4e7097e097eab7a360d9943f03fe959', 'ShadowX', '5beb4cd65f6e2a78925cfc1599d97868', 'ShadowX', 'MENUdo User', 'dreamcaster23@gmail.com', 0, 0, '', '0037', '1', '', 'xbox', '', 0, 0, 0);
