<?php
  header("Content-Type: Image/png");
  require("../BrotherBand/Brotherband.class.php");
  function getThemeBackground($themeName)
  {
    return 'themes/'. $themeName . '/card.png';
  }
  function getUserName()
  {
    return $_GET["username"];
  }
  function getUserAvatar()
  {
    return 'userdata/'. getUserName() . "/avatar.png";
  }
  function getGameIcon($num)
  {
    if(file_exists('../gameicons/'. $num .".png"))
      return '../gameicons/'. $num .".png";
    else
    {
      if(file_exists('../gameicons/'. $num ."i.gif"))
        return '../gameicons/'. $num ."i.gif";
      else
        return '../gameicons/not_found.png';
    }
  }  
  function getIconX($icon)
  {
    switch($icon)
    {
      case 0: return 7;
      case 1: return 71;
      case 2: return 122;
      case 3: return 163;
      case 4: return 196;
    }
  }
  function getIconY($icon)
  {
    switch($icon)
    {
      case 0: return 36;
      case 1: return 43;
      case 2: return 49;
      case 3: return 52;
      case 4: return 56;
    }
  }
  function getIconSize($icon)
  {
    switch($icon)
    {
      case 0: return 64;
      case 1: return 51;
      case 2: return 40;
      case 3: return 33;
      case 4: return 25;
    }
  }

	require_once(dirname(__FILE__) . '/../libs/wiImage/demos/helpers/common.inc.php');
	$BrotherBandAPI = new Brotherband;
	$theme = $BrotherBandAPI->GetUserInfo(array("Field"=>"GamerIDTheme","Username"=>$_GET['username']));
	$LastDatePlayed = $BrotherBandAPI->GetUserInfo(array("Field"=>"LastDatePlayed","Username"=>$_GET['username']));
	$result = wiImage::load(getThemeBackground($theme));
	$RecentGameIDs = $BrotherBandAPI->GetUserInfo(array("Field"=>"RecentGames","Username"=>$_GET['username']));
		$Points = $BrotherBandAPI->GetUserInfo(array("Field"=>"Points","Username"=>$_GET['username']));
	$SiteAvatar = $BrotherBandAPI->GetUserInfo(array("Field"=>"avatar","Username"=>$_GET['username']));
	$RecentCount = count(explode(",",$RecentGameIDs));
	$RecentList = explode(",",$RecentGameIDs);
;
  $i = 0;
  $duplicateAlpha = wiImage::load("themes/$theme/iconduplicate.alpha.png");
  
  while ($i != $RecentCount)
  {
    $overlay = wiImage::load(getGameIcon($RecentList[$i]));
    $overlay = $overlay->resize(getIconSize($i));
    $result = $result->merge($overlay, getIconX($i), getIconY($i));

    $overlay = wiImage::load("themes/$theme/overlay.png");
    $overlay = $overlay->resize(getIconSize($i));
    $result = $result->merge($overlay, getIconX($i), getIconY($i));
    
    $overlay = wiImage::load(getGameIcon($RecentList[$i]));
    $overlay = $overlay->flip();
    if ($i==0)
    {
      $overlay = $overlay->crop(0,0,32,6);
    }
    $overlay = $overlay->applyMask($duplicateAlpha);
    $overlay = $overlay->resize(getIconSize($i));
    $result = $result->merge($overlay, getIconX($i), getIconY($i)+(getIconSize($i)));
    
    $i++;
    if ($i==5) break;
  }
  $pointsimage = wiImage::load("themes/".$theme."/points.png");
  if($SiteAvatar != "Soulanger.png") {
  $avatarFile= file_get_contents('http://www.gravatar.com/avatar/'.md5($SiteAvatar).'.jpg?d=identicon&s=100');
file_put_contents('userdata/avatars/'.$_GET['username'].'.jpg',$avatarFile);
    $avatar = wiImage::load('userdata/avatars/'.$_GET['username'].'.jpg');
	$result = $result->merge($avatar, 195, 9);
} else {
	if(file_exists('userdata/avatars/Soulanger.png'))
		{
	$avatar = wiImage::load('userdata/avatars/Soulanger.png');
	$result = $result->merge($avatar, 185, 0);
		}
}
  
  $canvas = $result->getCanvas();

  $color = $result->allocateColor(244, 244, 244);
  $font = new wiFont_TTF("arial.ttf", 10, $color);
  $canvas->setFont($font);
  $canvas->writeText(8, 126, getUserName());
  //$canvas->writeText(136, 126, $Points);
  //$result = $result->merge($pointsimage, 195, 113);
  
  $GameInfo = $BrotherBandAPI->GetGameInfoObject($RecentList[0]);
  $color = $result->allocateColor(174, 184, 209);
  $font = new wiFont_TTF("arial.ttf", 8, $color);
  $canvas->setFont($font);
  $canvas->writeText(6, 14, 'Last Game Played: ' . $GameInfo->GameTitle1);
  


	echo $result->asString('png');
?>