<?php
  
  require("../BrotherBand/Brotherband.class.php");
  function getThemeBackground($themeName)
  {
    return 'themes/'. $themeName . '/card.png';
  }
  function getUserName()
  {
    return $_GET["username"];
  }
  function getUserAvatar()
  {
    return 'userdata/'. getUserName() . "/avatar.png";
  }
  function getGameIcon($num)
  {
    return '../gameicons/'. $num ."i.gif";
  }  
  function getIconX($icon)
  {
    switch($icon)
    {
      case 0: return 7;
      case 1: return 71;
      case 2: return 122;
      case 3: return 163;
      case 4: return 196;
    }
  }
  function getIconY($icon)
  {
    switch($icon)
    {
      case 0: return 36;
      case 1: return 43;
      case 2: return 49;
      case 3: return 52;
      case 4: return 56;
    }
  }
  function getIconSize($icon)
  {
    switch($icon)
    {
      case 0: return 64;
      case 1: return 51;
      case 2: return 40;
      case 3: return 33;
      case 4: return 25;
    }
  }

	require_once(dirname(__FILE__) . '/../libs/wiImage/demos/helpers/common.inc.php');
	$BrotherBandAPI = new Brotherband;
	$theme = $BrotherBandAPI->GetUserInfo(array("Field"=>"GamerIDTheme","Username"=>$_GET['username']));
	$LastDatePlayed = $BrotherBandAPI->GetUserInfo(array("Field"=>"LastDatePlayed","Username"=>$_GET['username']));
	$result = wiImage::load(getThemeBackground($theme));
	$RecentGameIDs = $BrotherBandAPI->GetUserInfo(array("Field"=>"RecentGames","Username"=>$_GET['username']));
	$RecentCount = count(explode(",",$RecentGameIDs));
	$RecentList = explode(",",$RecentGameIDs);
  $i = 0;
  $duplicateAlpha = wiImage::load("themes/$theme/iconduplicate.alpha.png");
  
  while ($i != $RecentCount)
  {
    $overlay = wiImage::load(getGameIcon($RecentList[$i]));
    $overlay = $overlay->resize(getIconSize($i));
    $result = $result->merge($overlay, getIconX($i), getIconY($i));

    $overlay = wiImage::load("themes/$theme/overlay.png");
    $overlay = $overlay->resize(getIconSize($i));
    $result = $result->merge($overlay, getIconX($i), getIconY($i));
    
    $overlay = wiImage::load(getGameIcon($RecentList[$i]));
    $overlay = $overlay->flip();
    if ($i==0)
    {
      $overlay = $overlay->crop(0,0,32,6);
    }
    $overlay = $overlay->applyMask($duplicateAlpha);
    $overlay = $overlay->resize(getIconSize($i));
    $result = $result->merge($overlay, getIconX($i), getIconY($i)+(getIconSize($i)));
    
    $i++;
    if ($i==5) break;
  }
  if (file_exists(getUserAvatar()))
  {
    $avatar = wiImage::load(getUserAvatar());
    $result = $result->merge($avatar, 181, 0);
  }
  $canvas = $result->getCanvas();

  $color = $result->allocateColor(244, 244, 244);
  $font = new wiFont_TTF("arial.ttf", 10, $color);
  $canvas->setFont($font);
  $canvas->writeText(8, 126, getUserName());

  $color = $result->allocateColor(174, 184, 209);
  $font = new wiFont_TTF("arial.ttf", 8, $color);
  $canvas->setFont($font);
  $canvas->writeText(6, 14, 'Last Game Played: '.$LastDatePlayed);


	echo $result->asString('png');
?>